/*
 * This file is part of the LibreOffice project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * This file incorporates work covered by the following license notice:
 *
 *   Licensed to the Apache Software Foundation (ASF) under one or more
 *   contributor license agreements. See the NOTICE file distributed
 *   with this work for additional information regarding copyright
 *   ownership. The ASF licenses this file to you under the Apache
 *   License, Version 2.0 (the "License"); you may not use this file
 *   except in compliance with the License. You may obtain a copy of
 *   the License at http://www.apache.org/licenses/LICENSE-2.0 .
 */

// This file has been automatically generated.  Do not hand-edit this!


// French language locale (automatically generated)

static const lang::Locale aFr("fr", "", "");

// pre instantiations of localized function names
static const sal_Unicode cell_address_fr[] = {
    0x0041, 0x0044, 0x0052, 0x0045, 0x0053, 0x0053, 0x0045, 0x0000};
static const sal_Unicode cell_col_fr[] = {
    0x0043, 0x004F, 0x004C, 0x004F, 0x004E, 0x004E, 0x0045, 0x0000};
static const sal_Unicode cell_contents_fr[] = {
    0x0043, 0x004F, 0x004E, 0x0054, 0x0045, 0x004E, 0x0055, 0x0000};
static const sal_Unicode cell_color_fr[] = {
    0x0043, 0x004F, 0x0055, 0x004C, 0x0045, 0x0055, 0x0052, 0x0000};
static const sal_Unicode cell_width_fr[] = {
    0x004C, 0x0041, 0x0052, 0x0047, 0x0045, 0x0055, 0x0052, 0x0000};
static const sal_Unicode cell_row_fr[] = {
    0x004C, 0x0049, 0x0047, 0x004E, 0x0045, 0x0000};
static const sal_Unicode cell_filename_fr[] = {
    0x004E, 0x004F, 0x004D, 0x0046, 0x0049, 0x0043, 0x0048, 0x0049, 0x0045, 0x0052, 0x0000};
static const sal_Unicode cell_prefix_fr[] = {
    0x0050, 0x0052, 0x0045, 0x0046, 0x0049, 0x0058, 0x0045, 0x0000};
static const sal_Unicode cell_protect_fr[] = {
    0x0050, 0x0052, 0x004F, 0x0054, 0x0045, 0x0047, 0x0045, 0x0000};
static const sal_Unicode info_numfile_fr[] = {
    0x004E, 0x0042, 0x0046, 0x0049, 0x0043, 0x0048, 0x0000};
static const sal_Unicode info_recalc_fr[] = {
    0x0052, 0x0045, 0x0043, 0x0041, 0x004C, 0x0043, 0x0055, 0x004C, 0x0000};
static const sal_Unicode info_system_fr[] = {
    0x0053, 0x0059, 0x0053, 0x0054, 0x0045, 0x0058, 0x0050, 0x004C, 0x0000};
static const sal_Unicode info_release_fr[] = {
    0x0056, 0x0045, 0x0052, 0x0053, 0x0049, 0x004F, 0x004E, 0x0000};
static const sal_Unicode info_osversion_fr[] = {
    0x0056, 0x0045, 0x0052, 0x0053, 0x0049, 0x004F, 0x004E, 0x0053, 0x0045, 0x0000};

static const TransItem pFr[] = {
    {cell_address_fr, "ADDRESS", ocCell},
    {cell_col_fr, "COL", ocCell},
    {cell_contents_fr, "CONTENTS", ocCell},
    {cell_color_fr, "COLOR", ocCell},
    {cell_width_fr, "WIDTH", ocCell},
    {cell_row_fr, "ROW", ocCell},
    {cell_filename_fr, "FILENAME", ocCell},
    {cell_prefix_fr, "PREFIX", ocCell},
    {cell_protect_fr, "PROTECT", ocCell},
    {info_numfile_fr, "NUMFILE", ocInfo},
    {info_recalc_fr, "RECALC", ocInfo},
    {info_system_fr, "SYSTEM", ocInfo},
    {info_release_fr, "RELEASE", ocInfo},
    {info_osversion_fr, "OSVERSION", ocInfo},
    {nullptr, nullptr, ocNone}
};

addToMap(pFr, aFr);


// Hungarian language locale (automatically generated)

static const lang::Locale aHu("hu", "", "");

// pre instantiations of localized function names
static const sal_Unicode cell_address_hu[] = {
    0x0043, 0x00CD, 0x004D, 0x0000};
static const sal_Unicode cell_col_hu[] = {
    0x004F, 0x0053, 0x005A, 0x004C, 0x004F, 0x0050, 0x0000};
static const sal_Unicode cell_color_hu[] = {
    0x0053, 0x005A, 0x00CD, 0x004E, 0x0000};
static const sal_Unicode cell_contents_hu[] = {
    0x0054, 0x0041, 0x0052, 0x0054, 0x0041, 0x004C, 0x004F, 0x004D, 0x0000};
static const sal_Unicode cell_width_hu[] = {
    0x0053, 0x005A, 0x00C9, 0x004C, 0x0045, 0x0053, 0x0000};
static const sal_Unicode cell_row_hu[] = {
    0x0053, 0x004F, 0x0052, 0x0000};
static const sal_Unicode cell_filename_hu[] = {
    0x0046, 0x0049, 0x004C, 0x0045, 0x004E, 0x00C9, 0x0056, 0x0000};
static const sal_Unicode cell_prefix_hu[] = {
    0x0050, 0x0052, 0x0045, 0x0046, 0x0049, 0x0058, 0x0000};
static const sal_Unicode cell_protect_hu[] = {
    0x0056, 0x00C9, 0x0044, 0x0045, 0x0054, 0x0054, 0x0000};
static const sal_Unicode cell_coord_hu[] = {
    0x004B, 0x004F, 0x004F, 0x0052, 0x0044, 0x0000};
static const sal_Unicode cell_format_hu[] = {
    0x0046, 0x004F, 0x0052, 0x004D, 0x0041, 0x0000};
static const sal_Unicode cell_parentheses_hu[] = {
    0x005A, 0x00C1, 0x0052, 0x00D3, 0x004A, 0x0045, 0x004C, 0x0045, 0x004B, 0x0000};
static const sal_Unicode cell_sheet_hu[] = {
    0x004C, 0x0041, 0x0050, 0x0000};
static const sal_Unicode cell_type_hu[] = {
    0x0054, 0x00CD, 0x0050, 0x0055, 0x0053, 0x0000};
static const sal_Unicode info_numfile_hu[] = {
    0x0046, 0x0049, 0x004C, 0x0045, 0x0053, 0x005A, 0x00C1, 0x004D, 0x0000};
static const sal_Unicode info_recalc_hu[] = {
    0x0053, 0x005A, 0x00C1, 0x004D, 0x004F, 0x004C, 0x00C1, 0x0053, 0x0000};
static const sal_Unicode info_system_hu[] = {
    0x0052, 0x0045, 0x004E, 0x0044, 0x0053, 0x005A, 0x0045, 0x0052, 0x0000};
static const sal_Unicode info_release_hu[] = {
    0x0056, 0x0045, 0x0052, 0x005A, 0x0049, 0x00D3, 0x0000};
static const sal_Unicode info_osversion_hu[] = {
    0x004F, 0x0050, 0x0052, 0x0045, 0x004E, 0x0044, 0x0053, 0x005A, 0x0045, 0x0052, 0x0000};

static const TransItem pHu[] = {
    {cell_address_hu, "ADDRESS", ocCell},
    {cell_col_hu, "COL", ocCell},
    {cell_color_hu, "COLOR", ocCell},
    {cell_contents_hu, "CONTENTS", ocCell},
    {cell_width_hu, "WIDTH", ocCell},
    {cell_row_hu, "ROW", ocCell},
    {cell_filename_hu, "FILENAME", ocCell},
    {cell_prefix_hu, "PREFIX", ocCell},
    {cell_protect_hu, "PROTECT", ocCell},
    {cell_coord_hu, "COORD", ocCell},
    {cell_format_hu, "FORMAT", ocCell},
    {cell_parentheses_hu, "PARENTHESES", ocCell},
    {cell_sheet_hu, "SHEET", ocCell},
    {cell_type_hu, "TYPE", ocCell},
    {info_numfile_hu, "NUMFILE", ocInfo},
    {info_recalc_hu, "RECALC", ocInfo},
    {info_system_hu, "SYSTEM", ocInfo},
    {info_release_hu, "RELEASE", ocInfo},
    {info_osversion_hu, "OSVERSION", ocInfo},
    {nullptr, nullptr, ocNone}
};

addToMap(pHu, aHu);


// German language locale (automatically generated)

static const lang::Locale aDe("de", "", "");

// pre instantiations of localized function names
static const sal_Unicode cell_row_de[] = {
    0x005A, 0x0045, 0x0049, 0x004C, 0x0045, 0x0000};
static const sal_Unicode cell_col_de[] = {
    0x0053, 0x0050, 0x0041, 0x004C, 0x0054, 0x0045, 0x0000};
static const sal_Unicode cell_width_de[] = {
    0x0042, 0x0052, 0x0045, 0x0049, 0x0054, 0x0045, 0x0000};
static const sal_Unicode cell_address_de[] = {
    0x0041, 0x0044, 0x0052, 0x0045, 0x0053, 0x0053, 0x0045, 0x0000};
static const sal_Unicode cell_filename_de[] = {
    0x0044, 0x0041, 0x0054, 0x0045, 0x0049, 0x004E, 0x0041, 0x004D, 0x0045, 0x0000};
static const sal_Unicode cell_color_de[] = {
    0x0046, 0x0041, 0x0052, 0x0042, 0x0045, 0x0000};
static const sal_Unicode cell_format_de[] = {
    0x0046, 0x004F, 0x0052, 0x004D, 0x0041, 0x0054, 0x0000};
static const sal_Unicode cell_contents_de[] = {
    0x0049, 0x004E, 0x0048, 0x0041, 0x004C, 0x0054, 0x0000};
static const sal_Unicode cell_parentheses_de[] = {
    0x004B, 0x004C, 0x0041, 0x004D, 0x004D, 0x0045, 0x0052, 0x004E, 0x0000};
static const sal_Unicode cell_protect_de[] = {
    0x0053, 0x0043, 0x0048, 0x0055, 0x0054, 0x005A, 0x0000};
static const sal_Unicode cell_type_de[] = {
    0x0054, 0x0059, 0x0050, 0x0000};
static const sal_Unicode cell_prefix_de[] = {
    0x0050, 0x0052, 0x00C4, 0x0046, 0x0049, 0x0058, 0x0000};
static const sal_Unicode cell_sheet_de[] = {
    0x0042, 0x004C, 0x0041, 0x0054, 0x0054, 0x0000};
static const sal_Unicode cell_coord_de[] = {
    0x004B, 0x004F, 0x004F, 0x0052, 0x0044, 0x0000};

static const TransItem pDe[] = {
    {cell_row_de, "ROW", ocCell},
    {cell_col_de, "COL", ocCell},
    {cell_width_de, "WIDTH", ocCell},
    {cell_address_de, "ADDRESS", ocCell},
    {cell_filename_de, "FILENAME", ocCell},
    {cell_color_de, "COLOR", ocCell},
    {cell_format_de, "FORMAT", ocCell},
    {cell_contents_de, "CONTENTS", ocCell},
    {cell_parentheses_de, "PARENTHESES", ocCell},
    {cell_protect_de, "PROTECT", ocCell},
    {cell_type_de, "TYPE", ocCell},
    {cell_prefix_de, "PREFIX", ocCell},
    {cell_sheet_de, "SHEET", ocCell},
    {cell_coord_de, "COORD", ocCell},
    {nullptr, nullptr, ocNone}
};

addToMap(pDe, aDe);
