#ifndef INCLUDED_OFFICECFG_OFFICE_CANVAS_HXX
#define INCLUDED_OFFICECFG_OFFICE_CANVAS_HXX

#include "sal/config.h"

#include "com/sun/star/uno/Sequence.hxx"
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace Canvas {

struct DXCanvas: public comphelper::ConfigurationGroup< DXCanvas> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/DXCanvas"); }

struct DeviceBlacklist: public comphelper::ConfigurationProperty<DeviceBlacklist, com::sun::star::uno::Sequence<sal_Int32> > {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/DXCanvas/DeviceBlacklist"); }
private:
    DeviceBlacklist(); // not defined
    ~DeviceBlacklist(); // not defined
};

struct BlacklistCurrentDevice: public comphelper::ConfigurationProperty<BlacklistCurrentDevice, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/DXCanvas/BlacklistCurrentDevice"); }
private:
    BlacklistCurrentDevice(); // not defined
    ~BlacklistCurrentDevice(); // not defined
};

struct MaxTextureSize: public comphelper::ConfigurationProperty<MaxTextureSize, sal_Int32> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/DXCanvas/MaxTextureSize"); }
private:
    MaxTextureSize(); // not defined
    ~MaxTextureSize(); // not defined
};

private:
    DXCanvas(); // not defined
    ~DXCanvas(); // not defined
};

struct CanvasServiceList: public comphelper::ConfigurationSet< CanvasServiceList> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/CanvasServiceList"); }
private:
    CanvasServiceList(); // not defined
    ~CanvasServiceList(); // not defined
};

struct ForceSafeServiceImpl: public comphelper::ConfigurationProperty<ForceSafeServiceImpl, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/ForceSafeServiceImpl"); }
private:
    ForceSafeServiceImpl(); // not defined
    ~ForceSafeServiceImpl(); // not defined
};

struct UseAcceleratedCanvas: public comphelper::ConfigurationProperty<UseAcceleratedCanvas, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/UseAcceleratedCanvas"); }
private:
    UseAcceleratedCanvas(); // not defined
    ~UseAcceleratedCanvas(); // not defined
};

struct UseAntialiasingCanvas: public comphelper::ConfigurationProperty<UseAntialiasingCanvas, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.Canvas/UseAntialiasingCanvas"); }
private:
    UseAntialiasingCanvas(); // not defined
    ~UseAntialiasingCanvas(); // not defined
};

} } }

#endif
