#ifndef INCLUDED_OFFICECFG_OFFICE_DATAACCESS_HXX
#define INCLUDED_OFFICECFG_OFFICE_DATAACCESS_HXX

#include "sal/config.h"

#include <optional>
#include "com/sun/star/uno/Sequence.hxx"
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace DataAccess {

struct Policies: public comphelper::ConfigurationGroup< Policies> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies"); }

struct Features: public comphelper::ConfigurationGroup< Features> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features"); }

struct Base: public comphelper::ConfigurationGroup< Base> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features/Base"); }

struct CreateLocalDatabase: public comphelper::ConfigurationProperty<CreateLocalDatabase, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features/Base/CreateLocalDatabase"); }
private:
    CreateLocalDatabase(); // not defined
    ~CreateLocalDatabase(); // not defined
};

private:
    Base(); // not defined
    ~Base(); // not defined
};

struct Writer: public comphelper::ConfigurationGroup< Writer> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features/Writer"); }

struct DatabaseFields: public comphelper::ConfigurationProperty<DatabaseFields, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features/Writer/DatabaseFields"); }
private:
    DatabaseFields(); // not defined
    ~DatabaseFields(); // not defined
};

private:
    Writer(); // not defined
    ~Writer(); // not defined
};

struct Common: public comphelper::ConfigurationGroup< Common> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features/Common"); }

struct EditDatabaseFromDataSourceView: public comphelper::ConfigurationProperty<EditDatabaseFromDataSourceView, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Policies/Features/Common/EditDatabaseFromDataSourceView"); }
private:
    EditDatabaseFromDataSourceView(); // not defined
    ~EditDatabaseFromDataSourceView(); // not defined
};

private:
    Common(); // not defined
    ~Common(); // not defined
};

private:
    Features(); // not defined
    ~Features(); // not defined
};

private:
    Policies(); // not defined
    ~Policies(); // not defined
};

struct ReportEngines: public comphelper::ConfigurationGroup< ReportEngines> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/ReportEngines"); }

struct DefaultReportEngine: public comphelper::ConfigurationProperty<DefaultReportEngine, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/ReportEngines/DefaultReportEngine"); }
private:
    DefaultReportEngine(); // not defined
    ~DefaultReportEngine(); // not defined
};

struct ReportEngineNames: public comphelper::ConfigurationSet< ReportEngineNames> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/ReportEngines/ReportEngineNames"); }
private:
    ReportEngineNames(); // not defined
    ~ReportEngineNames(); // not defined
};

private:
    ReportEngines(); // not defined
    ~ReportEngines(); // not defined
};

struct DriverManager: public comphelper::ConfigurationGroup< DriverManager> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverManager"); }

struct DriverPrecedence: public comphelper::ConfigurationProperty<DriverPrecedence, com::sun::star::uno::Sequence<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverManager/DriverPrecedence"); }
private:
    DriverPrecedence(); // not defined
    ~DriverPrecedence(); // not defined
};

private:
    DriverManager(); // not defined
    ~DriverManager(); // not defined
};

struct ConnectionPool: public comphelper::ConfigurationGroup< ConnectionPool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/ConnectionPool"); }

struct EnablePooling: public comphelper::ConfigurationProperty<EnablePooling, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/ConnectionPool/EnablePooling"); }
private:
    EnablePooling(); // not defined
    ~EnablePooling(); // not defined
};

struct DriverSettings: public comphelper::ConfigurationSet< DriverSettings> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/ConnectionPool/DriverSettings"); }
private:
    DriverSettings(); // not defined
    ~DriverSettings(); // not defined
};

private:
    ConnectionPool(); // not defined
    ~ConnectionPool(); // not defined
};

struct JDBC: public comphelper::ConfigurationGroup< JDBC> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/JDBC"); }

struct DriverClassPaths: public comphelper::ConfigurationSet< DriverClassPaths> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/JDBC/DriverClassPaths"); }
private:
    DriverClassPaths(); // not defined
    ~DriverClassPaths(); // not defined
};

private:
    JDBC(); // not defined
    ~JDBC(); // not defined
};

struct RegisteredNames: public comphelper::ConfigurationSet< RegisteredNames> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/RegisteredNames"); }
private:
    RegisteredNames(); // not defined
    ~RegisteredNames(); // not defined
};

struct UserDefinedDriverSettings: public comphelper::ConfigurationSet< UserDefinedDriverSettings> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/UserDefinedDriverSettings"); }
private:
    UserDefinedDriverSettings(); // not defined
    ~UserDefinedDriverSettings(); // not defined
};

struct AddressBook: public comphelper::ConfigurationGroup< AddressBook> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/AddressBook"); }

struct DataSourceName: public comphelper::ConfigurationProperty<DataSourceName, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/AddressBook/DataSourceName"); }
private:
    DataSourceName(); // not defined
    ~DataSourceName(); // not defined
};

struct Command: public comphelper::ConfigurationProperty<Command, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/AddressBook/Command"); }
private:
    Command(); // not defined
    ~Command(); // not defined
};

struct CommandType: public comphelper::ConfigurationProperty<CommandType, std::optional<sal_Int16> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/AddressBook/CommandType"); }
private:
    CommandType(); // not defined
    ~CommandType(); // not defined
};

struct AutoPilotCompleted: public comphelper::ConfigurationProperty<AutoPilotCompleted, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/AddressBook/AutoPilotCompleted"); }
private:
    AutoPilotCompleted(); // not defined
    ~AutoPilotCompleted(); // not defined
};

struct Fields: public comphelper::ConfigurationSet< Fields> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/AddressBook/Fields"); }
private:
    Fields(); // not defined
    ~Fields(); // not defined
};

private:
    AddressBook(); // not defined
    ~AddressBook(); // not defined
};

struct Bibliography: public comphelper::ConfigurationGroup< Bibliography> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography"); }

struct BeamerHeight: public comphelper::ConfigurationProperty<BeamerHeight, std::optional<sal_Int32> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography/BeamerHeight"); }
private:
    BeamerHeight(); // not defined
    ~BeamerHeight(); // not defined
};

struct ViewHeight: public comphelper::ConfigurationProperty<ViewHeight, std::optional<sal_Int32> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography/ViewHeight"); }
private:
    ViewHeight(); // not defined
    ~ViewHeight(); // not defined
};

struct QueryText: public comphelper::ConfigurationProperty<QueryText, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography/QueryText"); }
private:
    QueryText(); // not defined
    ~QueryText(); // not defined
};

struct QueryField: public comphelper::ConfigurationProperty<QueryField, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography/QueryField"); }
private:
    QueryField(); // not defined
    ~QueryField(); // not defined
};

struct ShowColumnAssignmentWarning: public comphelper::ConfigurationProperty<ShowColumnAssignmentWarning, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography/ShowColumnAssignmentWarning"); }
private:
    ShowColumnAssignmentWarning(); // not defined
    ~ShowColumnAssignmentWarning(); // not defined
};

struct DataSourceHistory: public comphelper::ConfigurationSet< DataSourceHistory> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/Bibliography/DataSourceHistory"); }
private:
    DataSourceHistory(); // not defined
    ~DataSourceHistory(); // not defined
};

private:
    Bibliography(); // not defined
    ~Bibliography(); // not defined
};

struct DriverSettings: public comphelper::ConfigurationGroup< DriverSettings> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings"); }

struct com_sun_star_comp_sdbc_MozabDriver: public comphelper::ConfigurationGroup< com_sun_star_comp_sdbc_MozabDriver> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver"); }

struct MozillaPreferences: public comphelper::ConfigurationGroup< MozillaPreferences> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/MozillaPreferences"); }

struct ProfileName: public comphelper::ConfigurationProperty<ProfileName, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/MozillaPreferences/ProfileName"); }
private:
    ProfileName(); // not defined
    ~ProfileName(); // not defined
};

struct PabDescription: public comphelper::ConfigurationLocalizedProperty<PabDescription, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/MozillaPreferences/PabDescription"); }
private:
    PabDescription(); // not defined
    ~PabDescription(); // not defined
};

struct HisDescription: public comphelper::ConfigurationLocalizedProperty<HisDescription, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/MozillaPreferences/HisDescription"); }
private:
    HisDescription(); // not defined
    ~HisDescription(); // not defined
};

private:
    MozillaPreferences(); // not defined
    ~MozillaPreferences(); // not defined
};

struct ColumnAliases: public comphelper::ConfigurationGroup< ColumnAliases> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases"); }

struct FirstName: public comphelper::ConfigurationLocalizedProperty<FirstName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/FirstName"); }
private:
    FirstName(); // not defined
    ~FirstName(); // not defined
};

struct LastName: public comphelper::ConfigurationLocalizedProperty<LastName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/LastName"); }
private:
    LastName(); // not defined
    ~LastName(); // not defined
};

struct DisplayName: public comphelper::ConfigurationLocalizedProperty<DisplayName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/DisplayName"); }
private:
    DisplayName(); // not defined
    ~DisplayName(); // not defined
};

struct NickName: public comphelper::ConfigurationLocalizedProperty<NickName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/NickName"); }
private:
    NickName(); // not defined
    ~NickName(); // not defined
};

struct PrimaryEmail: public comphelper::ConfigurationLocalizedProperty<PrimaryEmail, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/PrimaryEmail"); }
private:
    PrimaryEmail(); // not defined
    ~PrimaryEmail(); // not defined
};

struct SecondEmail: public comphelper::ConfigurationLocalizedProperty<SecondEmail, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/SecondEmail"); }
private:
    SecondEmail(); // not defined
    ~SecondEmail(); // not defined
};

struct PreferMailFormat: public comphelper::ConfigurationLocalizedProperty<PreferMailFormat, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/PreferMailFormat"); }
private:
    PreferMailFormat(); // not defined
    ~PreferMailFormat(); // not defined
};

struct WorkPhone: public comphelper::ConfigurationLocalizedProperty<WorkPhone, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkPhone"); }
private:
    WorkPhone(); // not defined
    ~WorkPhone(); // not defined
};

struct HomePhone: public comphelper::ConfigurationLocalizedProperty<HomePhone, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomePhone"); }
private:
    HomePhone(); // not defined
    ~HomePhone(); // not defined
};

struct FaxNumber: public comphelper::ConfigurationLocalizedProperty<FaxNumber, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/FaxNumber"); }
private:
    FaxNumber(); // not defined
    ~FaxNumber(); // not defined
};

struct PagerNumber: public comphelper::ConfigurationLocalizedProperty<PagerNumber, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/PagerNumber"); }
private:
    PagerNumber(); // not defined
    ~PagerNumber(); // not defined
};

struct CellularNumber: public comphelper::ConfigurationLocalizedProperty<CellularNumber, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/CellularNumber"); }
private:
    CellularNumber(); // not defined
    ~CellularNumber(); // not defined
};

struct HomeAddress: public comphelper::ConfigurationLocalizedProperty<HomeAddress, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomeAddress"); }
private:
    HomeAddress(); // not defined
    ~HomeAddress(); // not defined
};

struct HomeAddress2: public comphelper::ConfigurationLocalizedProperty<HomeAddress2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomeAddress2"); }
private:
    HomeAddress2(); // not defined
    ~HomeAddress2(); // not defined
};

struct HomeCity: public comphelper::ConfigurationLocalizedProperty<HomeCity, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomeCity"); }
private:
    HomeCity(); // not defined
    ~HomeCity(); // not defined
};

struct HomeState: public comphelper::ConfigurationLocalizedProperty<HomeState, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomeState"); }
private:
    HomeState(); // not defined
    ~HomeState(); // not defined
};

struct HomeZipCode: public comphelper::ConfigurationLocalizedProperty<HomeZipCode, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomeZipCode"); }
private:
    HomeZipCode(); // not defined
    ~HomeZipCode(); // not defined
};

struct HomeCountry: public comphelper::ConfigurationLocalizedProperty<HomeCountry, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/HomeCountry"); }
private:
    HomeCountry(); // not defined
    ~HomeCountry(); // not defined
};

struct WorkAddress: public comphelper::ConfigurationLocalizedProperty<WorkAddress, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkAddress"); }
private:
    WorkAddress(); // not defined
    ~WorkAddress(); // not defined
};

struct WorkAddress2: public comphelper::ConfigurationLocalizedProperty<WorkAddress2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkAddress2"); }
private:
    WorkAddress2(); // not defined
    ~WorkAddress2(); // not defined
};

struct WorkCity: public comphelper::ConfigurationLocalizedProperty<WorkCity, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkCity"); }
private:
    WorkCity(); // not defined
    ~WorkCity(); // not defined
};

struct WorkState: public comphelper::ConfigurationLocalizedProperty<WorkState, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkState"); }
private:
    WorkState(); // not defined
    ~WorkState(); // not defined
};

struct WorkZipCode: public comphelper::ConfigurationLocalizedProperty<WorkZipCode, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkZipCode"); }
private:
    WorkZipCode(); // not defined
    ~WorkZipCode(); // not defined
};

struct WorkCountry: public comphelper::ConfigurationLocalizedProperty<WorkCountry, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WorkCountry"); }
private:
    WorkCountry(); // not defined
    ~WorkCountry(); // not defined
};

struct JobTitle: public comphelper::ConfigurationLocalizedProperty<JobTitle, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/JobTitle"); }
private:
    JobTitle(); // not defined
    ~JobTitle(); // not defined
};

struct Department: public comphelper::ConfigurationLocalizedProperty<Department, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Department"); }
private:
    Department(); // not defined
    ~Department(); // not defined
};

struct Company: public comphelper::ConfigurationLocalizedProperty<Company, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Company"); }
private:
    Company(); // not defined
    ~Company(); // not defined
};

struct WebPage1: public comphelper::ConfigurationLocalizedProperty<WebPage1, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WebPage1"); }
private:
    WebPage1(); // not defined
    ~WebPage1(); // not defined
};

struct WebPage2: public comphelper::ConfigurationLocalizedProperty<WebPage2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/WebPage2"); }
private:
    WebPage2(); // not defined
    ~WebPage2(); // not defined
};

struct BirthYear: public comphelper::ConfigurationLocalizedProperty<BirthYear, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/BirthYear"); }
private:
    BirthYear(); // not defined
    ~BirthYear(); // not defined
};

struct BirthMonth: public comphelper::ConfigurationLocalizedProperty<BirthMonth, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/BirthMonth"); }
private:
    BirthMonth(); // not defined
    ~BirthMonth(); // not defined
};

struct BirthDay: public comphelper::ConfigurationLocalizedProperty<BirthDay, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/BirthDay"); }
private:
    BirthDay(); // not defined
    ~BirthDay(); // not defined
};

struct Custom1: public comphelper::ConfigurationLocalizedProperty<Custom1, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Custom1"); }
private:
    Custom1(); // not defined
    ~Custom1(); // not defined
};

struct Custom2: public comphelper::ConfigurationLocalizedProperty<Custom2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Custom2"); }
private:
    Custom2(); // not defined
    ~Custom2(); // not defined
};

struct Custom3: public comphelper::ConfigurationLocalizedProperty<Custom3, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Custom3"); }
private:
    Custom3(); // not defined
    ~Custom3(); // not defined
};

struct Custom4: public comphelper::ConfigurationLocalizedProperty<Custom4, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Custom4"); }
private:
    Custom4(); // not defined
    ~Custom4(); // not defined
};

struct Notes: public comphelper::ConfigurationLocalizedProperty<Notes, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.MozabDriver/ColumnAliases/Notes"); }
private:
    Notes(); // not defined
    ~Notes(); // not defined
};

private:
    ColumnAliases(); // not defined
    ~ColumnAliases(); // not defined
};

private:
    com_sun_star_comp_sdbc_MozabDriver(); // not defined
    ~com_sun_star_comp_sdbc_MozabDriver(); // not defined
};

struct com_sun_star_comp_sdbc_evoab_OEvoabDriver: public comphelper::ConfigurationGroup< com_sun_star_comp_sdbc_evoab_OEvoabDriver> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver"); }

struct EvolutionPreferences: public comphelper::ConfigurationGroup< EvolutionPreferences> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/EvolutionPreferences"); }

struct FullPathExportingCommand: public comphelper::ConfigurationProperty<FullPathExportingCommand, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/EvolutionPreferences/FullPathExportingCommand"); }
private:
    FullPathExportingCommand(); // not defined
    ~FullPathExportingCommand(); // not defined
};

private:
    EvolutionPreferences(); // not defined
    ~EvolutionPreferences(); // not defined
};

struct ColumnAliases: public comphelper::ConfigurationGroup< ColumnAliases> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases"); }

struct FirstName: public comphelper::ConfigurationProperty<FirstName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/FirstName"); }
private:
    FirstName(); // not defined
    ~FirstName(); // not defined
};

struct LastName: public comphelper::ConfigurationProperty<LastName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/LastName"); }
private:
    LastName(); // not defined
    ~LastName(); // not defined
};

struct DisplayName: public comphelper::ConfigurationProperty<DisplayName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/DisplayName"); }
private:
    DisplayName(); // not defined
    ~DisplayName(); // not defined
};

struct NickName: public comphelper::ConfigurationProperty<NickName, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/NickName"); }
private:
    NickName(); // not defined
    ~NickName(); // not defined
};

struct PrimaryEmail: public comphelper::ConfigurationProperty<PrimaryEmail, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/PrimaryEmail"); }
private:
    PrimaryEmail(); // not defined
    ~PrimaryEmail(); // not defined
};

struct SecondEmail: public comphelper::ConfigurationProperty<SecondEmail, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/SecondEmail"); }
private:
    SecondEmail(); // not defined
    ~SecondEmail(); // not defined
};

struct PreferMailFormat: public comphelper::ConfigurationProperty<PreferMailFormat, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/PreferMailFormat"); }
private:
    PreferMailFormat(); // not defined
    ~PreferMailFormat(); // not defined
};

struct WorkPhone: public comphelper::ConfigurationProperty<WorkPhone, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkPhone"); }
private:
    WorkPhone(); // not defined
    ~WorkPhone(); // not defined
};

struct HomePhone: public comphelper::ConfigurationProperty<HomePhone, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomePhone"); }
private:
    HomePhone(); // not defined
    ~HomePhone(); // not defined
};

struct FaxNumber: public comphelper::ConfigurationProperty<FaxNumber, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/FaxNumber"); }
private:
    FaxNumber(); // not defined
    ~FaxNumber(); // not defined
};

struct PagerNumber: public comphelper::ConfigurationProperty<PagerNumber, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/PagerNumber"); }
private:
    PagerNumber(); // not defined
    ~PagerNumber(); // not defined
};

struct CellularNumber: public comphelper::ConfigurationProperty<CellularNumber, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/CellularNumber"); }
private:
    CellularNumber(); // not defined
    ~CellularNumber(); // not defined
};

struct HomeAddress: public comphelper::ConfigurationProperty<HomeAddress, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomeAddress"); }
private:
    HomeAddress(); // not defined
    ~HomeAddress(); // not defined
};

struct HomeAddress2: public comphelper::ConfigurationProperty<HomeAddress2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomeAddress2"); }
private:
    HomeAddress2(); // not defined
    ~HomeAddress2(); // not defined
};

struct HomeCity: public comphelper::ConfigurationProperty<HomeCity, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomeCity"); }
private:
    HomeCity(); // not defined
    ~HomeCity(); // not defined
};

struct HomeState: public comphelper::ConfigurationProperty<HomeState, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomeState"); }
private:
    HomeState(); // not defined
    ~HomeState(); // not defined
};

struct HomeZipCode: public comphelper::ConfigurationProperty<HomeZipCode, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomeZipCode"); }
private:
    HomeZipCode(); // not defined
    ~HomeZipCode(); // not defined
};

struct HomeCountry: public comphelper::ConfigurationProperty<HomeCountry, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/HomeCountry"); }
private:
    HomeCountry(); // not defined
    ~HomeCountry(); // not defined
};

struct WorkAddress: public comphelper::ConfigurationProperty<WorkAddress, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkAddress"); }
private:
    WorkAddress(); // not defined
    ~WorkAddress(); // not defined
};

struct WorkAddress2: public comphelper::ConfigurationProperty<WorkAddress2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkAddress2"); }
private:
    WorkAddress2(); // not defined
    ~WorkAddress2(); // not defined
};

struct WorkCity: public comphelper::ConfigurationProperty<WorkCity, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkCity"); }
private:
    WorkCity(); // not defined
    ~WorkCity(); // not defined
};

struct WorkState: public comphelper::ConfigurationProperty<WorkState, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkState"); }
private:
    WorkState(); // not defined
    ~WorkState(); // not defined
};

struct WorkZipCode: public comphelper::ConfigurationProperty<WorkZipCode, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkZipCode"); }
private:
    WorkZipCode(); // not defined
    ~WorkZipCode(); // not defined
};

struct WorkCountry: public comphelper::ConfigurationProperty<WorkCountry, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WorkCountry"); }
private:
    WorkCountry(); // not defined
    ~WorkCountry(); // not defined
};

struct JobTitle: public comphelper::ConfigurationProperty<JobTitle, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/JobTitle"); }
private:
    JobTitle(); // not defined
    ~JobTitle(); // not defined
};

struct Department: public comphelper::ConfigurationProperty<Department, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/Department"); }
private:
    Department(); // not defined
    ~Department(); // not defined
};

struct Company: public comphelper::ConfigurationProperty<Company, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/Company"); }
private:
    Company(); // not defined
    ~Company(); // not defined
};

struct WebPage1: public comphelper::ConfigurationProperty<WebPage1, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WebPage1"); }
private:
    WebPage1(); // not defined
    ~WebPage1(); // not defined
};

struct WebPage2: public comphelper::ConfigurationProperty<WebPage2, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/WebPage2"); }
private:
    WebPage2(); // not defined
    ~WebPage2(); // not defined
};

struct BirthYear: public comphelper::ConfigurationProperty<BirthYear, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/BirthYear"); }
private:
    BirthYear(); // not defined
    ~BirthYear(); // not defined
};

struct BirthMonth: public comphelper::ConfigurationProperty<BirthMonth, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/BirthMonth"); }
private:
    BirthMonth(); // not defined
    ~BirthMonth(); // not defined
};

struct BirthDay: public comphelper::ConfigurationProperty<BirthDay, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/BirthDay"); }
private:
    BirthDay(); // not defined
    ~BirthDay(); // not defined
};

struct Notes: public comphelper::ConfigurationProperty<Notes, std::optional<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.evoab.OEvoabDriver/ColumnAliases/Notes"); }
private:
    Notes(); // not defined
    ~Notes(); // not defined
};

private:
    ColumnAliases(); // not defined
    ~ColumnAliases(); // not defined
};

private:
    com_sun_star_comp_sdbc_evoab_OEvoabDriver(); // not defined
    ~com_sun_star_comp_sdbc_evoab_OEvoabDriver(); // not defined
};

struct com_sun_star_comp_sdbc_kab_Driver: public comphelper::ConfigurationGroup< com_sun_star_comp_sdbc_kab_Driver> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.kab.Driver"); }

struct DisableKDEMaximumVersionCheck: public comphelper::ConfigurationProperty<DisableKDEMaximumVersionCheck, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/DriverSettings/com.sun.star.comp.sdbc.kab.Driver/DisableKDEMaximumVersionCheck"); }
private:
    DisableKDEMaximumVersionCheck(); // not defined
    ~DisableKDEMaximumVersionCheck(); // not defined
};

private:
    com_sun_star_comp_sdbc_kab_Driver(); // not defined
    ~com_sun_star_comp_sdbc_kab_Driver(); // not defined
};

private:
    DriverSettings(); // not defined
    ~DriverSettings(); // not defined
};

struct FormSearchOptions: public comphelper::ConfigurationGroup< FormSearchOptions> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions"); }

struct SearchType: public comphelper::ConfigurationProperty<SearchType, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/SearchType"); }
private:
    SearchType(); // not defined
    ~SearchType(); // not defined
};

struct SearchPosition: public comphelper::ConfigurationProperty<SearchPosition, OUString> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/SearchPosition"); }
private:
    SearchPosition(); // not defined
    ~SearchPosition(); // not defined
};

struct SearchHistory: public comphelper::ConfigurationProperty<SearchHistory, std::optional<com::sun::star::uno::Sequence<OUString> > > {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/SearchHistory"); }
private:
    SearchHistory(); // not defined
    ~SearchHistory(); // not defined
};

struct IsSearchAllFields: public comphelper::ConfigurationProperty<IsSearchAllFields, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsSearchAllFields"); }
private:
    IsSearchAllFields(); // not defined
    ~IsSearchAllFields(); // not defined
};

struct IsUseFormatter: public comphelper::ConfigurationProperty<IsUseFormatter, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsUseFormatter"); }
private:
    IsUseFormatter(); // not defined
    ~IsUseFormatter(); // not defined
};

struct IsBackwards: public comphelper::ConfigurationProperty<IsBackwards, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsBackwards"); }
private:
    IsBackwards(); // not defined
    ~IsBackwards(); // not defined
};

struct IsWildcardSearch: public comphelper::ConfigurationProperty<IsWildcardSearch, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsWildcardSearch"); }
private:
    IsWildcardSearch(); // not defined
    ~IsWildcardSearch(); // not defined
};

struct IsUseRegularExpression: public comphelper::ConfigurationProperty<IsUseRegularExpression, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsUseRegularExpression"); }
private:
    IsUseRegularExpression(); // not defined
    ~IsUseRegularExpression(); // not defined
};

struct IsSimilaritySearch: public comphelper::ConfigurationProperty<IsSimilaritySearch, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsSimilaritySearch"); }
private:
    IsSimilaritySearch(); // not defined
    ~IsSimilaritySearch(); // not defined
};

struct IsLevenshteinRelaxed: public comphelper::ConfigurationProperty<IsLevenshteinRelaxed, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsLevenshteinRelaxed"); }
private:
    IsLevenshteinRelaxed(); // not defined
    ~IsLevenshteinRelaxed(); // not defined
};

struct LevenshteinOther: public comphelper::ConfigurationProperty<LevenshteinOther, sal_Int16> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/LevenshteinOther"); }
private:
    LevenshteinOther(); // not defined
    ~LevenshteinOther(); // not defined
};

struct LevenshteinShorter: public comphelper::ConfigurationProperty<LevenshteinShorter, sal_Int16> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/LevenshteinShorter"); }
private:
    LevenshteinShorter(); // not defined
    ~LevenshteinShorter(); // not defined
};

struct LevenshteinLonger: public comphelper::ConfigurationProperty<LevenshteinLonger, sal_Int16> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/LevenshteinLonger"); }
private:
    LevenshteinLonger(); // not defined
    ~LevenshteinLonger(); // not defined
};

struct IsMatchCase: public comphelper::ConfigurationProperty<IsMatchCase, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsMatchCase"); }
private:
    IsMatchCase(); // not defined
    ~IsMatchCase(); // not defined
};

struct IsIgnoreDiacritics_CTL: public comphelper::ConfigurationProperty<IsIgnoreDiacritics_CTL, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsIgnoreDiacritics_CTL"); }
private:
    IsIgnoreDiacritics_CTL(); // not defined
    ~IsIgnoreDiacritics_CTL(); // not defined
};

struct IsIgnoreKashida_CTL: public comphelper::ConfigurationProperty<IsIgnoreKashida_CTL, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsIgnoreKashida_CTL"); }
private:
    IsIgnoreKashida_CTL(); // not defined
    ~IsIgnoreKashida_CTL(); // not defined
};

struct IsUseAsianOptions: public comphelper::ConfigurationProperty<IsUseAsianOptions, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/IsUseAsianOptions"); }
private:
    IsUseAsianOptions(); // not defined
    ~IsUseAsianOptions(); // not defined
};

struct Japanese: public comphelper::ConfigurationGroup< Japanese> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese"); }

struct IsMatchFullHalfWidthForms: public comphelper::ConfigurationProperty<IsMatchFullHalfWidthForms, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchFullHalfWidthForms"); }
private:
    IsMatchFullHalfWidthForms(); // not defined
    ~IsMatchFullHalfWidthForms(); // not defined
};

struct IsMatchHiraganaKatakana: public comphelper::ConfigurationProperty<IsMatchHiraganaKatakana, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchHiraganaKatakana"); }
private:
    IsMatchHiraganaKatakana(); // not defined
    ~IsMatchHiraganaKatakana(); // not defined
};

struct IsMatchContractions: public comphelper::ConfigurationProperty<IsMatchContractions, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchContractions"); }
private:
    IsMatchContractions(); // not defined
    ~IsMatchContractions(); // not defined
};

struct IsMatchMinusDashCho_on: public comphelper::ConfigurationProperty<IsMatchMinusDashCho_on, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchMinusDashCho-on"); }
private:
    IsMatchMinusDashCho_on(); // not defined
    ~IsMatchMinusDashCho_on(); // not defined
};

struct IsMatchRepeatCharMarks: public comphelper::ConfigurationProperty<IsMatchRepeatCharMarks, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchRepeatCharMarks"); }
private:
    IsMatchRepeatCharMarks(); // not defined
    ~IsMatchRepeatCharMarks(); // not defined
};

struct IsMatchVariantFormKanji: public comphelper::ConfigurationProperty<IsMatchVariantFormKanji, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchVariantFormKanji"); }
private:
    IsMatchVariantFormKanji(); // not defined
    ~IsMatchVariantFormKanji(); // not defined
};

struct IsMatchOldKanaForms: public comphelper::ConfigurationProperty<IsMatchOldKanaForms, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatchOldKanaForms"); }
private:
    IsMatchOldKanaForms(); // not defined
    ~IsMatchOldKanaForms(); // not defined
};

struct IsMatch_DiZi_DuZu: public comphelper::ConfigurationProperty<IsMatch_DiZi_DuZu, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_DiZi_DuZu"); }
private:
    IsMatch_DiZi_DuZu(); // not defined
    ~IsMatch_DiZi_DuZu(); // not defined
};

struct IsMatch_BaVa_HaFa: public comphelper::ConfigurationProperty<IsMatch_BaVa_HaFa, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_BaVa_HaFa"); }
private:
    IsMatch_BaVa_HaFa(); // not defined
    ~IsMatch_BaVa_HaFa(); // not defined
};

struct IsMatch_TsiThiChi_DhiZi: public comphelper::ConfigurationProperty<IsMatch_TsiThiChi_DhiZi, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_TsiThiChi_DhiZi"); }
private:
    IsMatch_TsiThiChi_DhiZi(); // not defined
    ~IsMatch_TsiThiChi_DhiZi(); // not defined
};

struct IsMatch_HyuIyu_ByuVyu: public comphelper::ConfigurationProperty<IsMatch_HyuIyu_ByuVyu, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_HyuIyu_ByuVyu"); }
private:
    IsMatch_HyuIyu_ByuVyu(); // not defined
    ~IsMatch_HyuIyu_ByuVyu(); // not defined
};

struct IsMatch_SeShe_ZeJe: public comphelper::ConfigurationProperty<IsMatch_SeShe_ZeJe, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_SeShe_ZeJe"); }
private:
    IsMatch_SeShe_ZeJe(); // not defined
    ~IsMatch_SeShe_ZeJe(); // not defined
};

struct IsMatch_IaIya: public comphelper::ConfigurationProperty<IsMatch_IaIya, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_IaIya"); }
private:
    IsMatch_IaIya(); // not defined
    ~IsMatch_IaIya(); // not defined
};

struct IsMatch_KiKu: public comphelper::ConfigurationProperty<IsMatch_KiKu, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsMatch_KiKu"); }
private:
    IsMatch_KiKu(); // not defined
    ~IsMatch_KiKu(); // not defined
};

struct IsIgnorePunctuation: public comphelper::ConfigurationProperty<IsIgnorePunctuation, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsIgnorePunctuation"); }
private:
    IsIgnorePunctuation(); // not defined
    ~IsIgnorePunctuation(); // not defined
};

struct IsIgnoreWhitespace: public comphelper::ConfigurationProperty<IsIgnoreWhitespace, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsIgnoreWhitespace"); }
private:
    IsIgnoreWhitespace(); // not defined
    ~IsIgnoreWhitespace(); // not defined
};

struct IsIgnoreProlongedSoundMark: public comphelper::ConfigurationProperty<IsIgnoreProlongedSoundMark, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsIgnoreProlongedSoundMark"); }
private:
    IsIgnoreProlongedSoundMark(); // not defined
    ~IsIgnoreProlongedSoundMark(); // not defined
};

struct IsIgnoreMiddleDot: public comphelper::ConfigurationProperty<IsIgnoreMiddleDot, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.DataAccess/FormSearchOptions/Japanese/IsIgnoreMiddleDot"); }
private:
    IsIgnoreMiddleDot(); // not defined
    ~IsIgnoreMiddleDot(); // not defined
};

private:
    Japanese(); // not defined
    ~Japanese(); // not defined
};

private:
    FormSearchOptions(); // not defined
    ~FormSearchOptions(); // not defined
};

} } }

#endif
