#ifndef INCLUDED_OFFICECFG_OFFICE_SECURITY_HXX
#define INCLUDED_OFFICECFG_OFFICE_SECURITY_HXX

#include "sal/config.h"

#include <optional>
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace Security {

struct SecureExtensions: public comphelper::ConfigurationSet< SecureExtensions> {
    static OUString path() { return OUString("/org.openoffice.Office.Security/SecureExtensions"); }
private:
    SecureExtensions(); // not defined
    ~SecureExtensions(); // not defined
};

struct Hyperlinks: public comphelper::ConfigurationGroup< Hyperlinks> {
    static OUString path() { return OUString("/org.openoffice.Office.Security/Hyperlinks"); }

struct Open: public comphelper::ConfigurationProperty<Open, std::optional<sal_Int32> > {
    static OUString path() { return OUString("/org.openoffice.Office.Security/Hyperlinks/Open"); }
private:
    Open(); // not defined
    ~Open(); // not defined
};

private:
    Hyperlinks(); // not defined
    ~Hyperlinks(); // not defined
};

struct HiddenContent: public comphelper::ConfigurationGroup< HiddenContent> {
    static OUString path() { return OUString("/org.openoffice.Office.Security/HiddenContent"); }

struct RemoveHiddenContent: public comphelper::ConfigurationProperty<RemoveHiddenContent, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.Security/HiddenContent/RemoveHiddenContent"); }
private:
    RemoveHiddenContent(); // not defined
    ~RemoveHiddenContent(); // not defined
};

private:
    HiddenContent(); // not defined
    ~HiddenContent(); // not defined
};

} } }

#endif
