#ifndef INCLUDED_OFFICECFG_OFFICE_UI_EFFECTS_HXX
#define INCLUDED_OFFICECFG_OFFICE_UI_EFFECTS_HXX

#include "sal/config.h"

#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace UI { namespace Effects {

struct UserInterface: public comphelper::ConfigurationGroup< UserInterface> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface"); }

struct Effects: public comphelper::ConfigurationSet< Effects> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface/Effects"); }
private:
    Effects(); // not defined
    ~Effects(); // not defined
};

struct TransitionGroups: public comphelper::ConfigurationSet< TransitionGroups> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface/TransitionGroups"); }
private:
    TransitionGroups(); // not defined
    ~TransitionGroups(); // not defined
};

struct TransitionSets: public comphelper::ConfigurationSet< TransitionSets> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface/TransitionSets"); }
private:
    TransitionSets(); // not defined
    ~TransitionSets(); // not defined
};

struct TransitionVariants: public comphelper::ConfigurationSet< TransitionVariants> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface/TransitionVariants"); }
private:
    TransitionVariants(); // not defined
    ~TransitionVariants(); // not defined
};

struct Transitions: public comphelper::ConfigurationSet< Transitions> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface/Transitions"); }
private:
    Transitions(); // not defined
    ~Transitions(); // not defined
};

struct Properties: public comphelper::ConfigurationSet< Properties> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/UserInterface/Properties"); }
private:
    Properties(); // not defined
    ~Properties(); // not defined
};

private:
    UserInterface(); // not defined
    ~UserInterface(); // not defined
};

struct Presets: public comphelper::ConfigurationGroup< Presets> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/Presets"); }

struct Entrance: public comphelper::ConfigurationSet< Entrance> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/Presets/Entrance"); }
private:
    Entrance(); // not defined
    ~Entrance(); // not defined
};

struct Emphasis: public comphelper::ConfigurationSet< Emphasis> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/Presets/Emphasis"); }
private:
    Emphasis(); // not defined
    ~Emphasis(); // not defined
};

struct Exit: public comphelper::ConfigurationSet< Exit> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/Presets/Exit"); }
private:
    Exit(); // not defined
    ~Exit(); // not defined
};

struct MotionPaths: public comphelper::ConfigurationSet< MotionPaths> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/Presets/MotionPaths"); }
private:
    MotionPaths(); // not defined
    ~MotionPaths(); // not defined
};

struct Misc: public comphelper::ConfigurationSet< Misc> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Effects/Presets/Misc"); }
private:
    Misc(); // not defined
    ~Misc(); // not defined
};

private:
    Presets(); // not defined
    ~Presets(); // not defined
};

} } } }

#endif
