#ifndef INCLUDED_OFFICECFG_OFFICE_UI_INFOBAR_HXX
#define INCLUDED_OFFICECFG_OFFICE_UI_INFOBAR_HXX

#include "sal/config.h"

#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace UI { namespace Infobar {

struct Enabled: public comphelper::ConfigurationGroup< Enabled> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Infobar/Enabled"); }

struct Readonly: public comphelper::ConfigurationProperty<Readonly, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Infobar/Enabled/Readonly"); }
private:
    Readonly(); // not defined
    ~Readonly(); // not defined
};

struct Signature: public comphelper::ConfigurationProperty<Signature, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Infobar/Enabled/Signature"); }
private:
    Signature(); // not defined
    ~Signature(); // not defined
};

struct Donate: public comphelper::ConfigurationProperty<Donate, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Infobar/Enabled/Donate"); }
private:
    Donate(); // not defined
    ~Donate(); // not defined
};

struct GetInvolved: public comphelper::ConfigurationProperty<GetInvolved, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Infobar/Enabled/GetInvolved"); }
private:
    GetInvolved(); // not defined
    ~GetInvolved(); // not defined
};

struct HyphenationMissing: public comphelper::ConfigurationProperty<HyphenationMissing, bool> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Infobar/Enabled/HyphenationMissing"); }
private:
    HyphenationMissing(); // not defined
    ~HyphenationMissing(); // not defined
};

private:
    Enabled(); // not defined
    ~Enabled(); // not defined
};

} } } }

#endif
