#ifndef INCLUDED_OFFICECFG_OFFICE_UI_SIDEBAR_HXX
#define INCLUDED_OFFICECFG_OFFICE_UI_SIDEBAR_HXX

#include "sal/config.h"

#include "com/sun/star/uno/Sequence.hxx"
#include "rtl/ustring.h"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "comphelper/configuration.hxx"

namespace officecfg { namespace Office { namespace UI { namespace Sidebar {

struct General: public comphelper::ConfigurationGroup< General> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Sidebar/General"); }

struct MaximumWidth: public comphelper::ConfigurationProperty<MaximumWidth, sal_Int32> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Sidebar/General/MaximumWidth"); }
private:
    MaximumWidth(); // not defined
    ~MaximumWidth(); // not defined
};

private:
    General(); // not defined
    ~General(); // not defined
};

struct Content: public comphelper::ConfigurationGroup< Content> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Sidebar/Content"); }

struct DeckList: public comphelper::ConfigurationSet< DeckList> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Sidebar/Content/DeckList"); }
private:
    DeckList(); // not defined
    ~DeckList(); // not defined
};

struct PanelList: public comphelper::ConfigurationSet< PanelList> {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Sidebar/Content/PanelList"); }
private:
    PanelList(); // not defined
    ~PanelList(); // not defined
};

struct LastActiveDeck: public comphelper::ConfigurationProperty<LastActiveDeck, com::sun::star::uno::Sequence<OUString> > {
    static OUString path() { return OUString("/org.openoffice.Office.UI.Sidebar/Content/LastActiveDeck"); }
private:
    LastActiveDeck(); // not defined
    ~LastActiveDeck(); // not defined
};

private:
    Content(); // not defined
    ~Content(); // not defined
};

} } } }

#endif
