
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-baseStylesheet.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_baseStylesheet> OOXMLFactory_dml_baseStylesheet_Mutex;

OOXMLFactory_dml_baseStylesheet::OOXMLFactory_dml_baseStylesheet()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_baseStylesheet_Mutex::get());
}

OOXMLFactory_dml_baseStylesheet::~OOXMLFactory_dml_baseStylesheet()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_baseStylesheet::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_baseStylesheet::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_baseStylesheet();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_baseStylesheet::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_baseStylesheet|DEFINE_CT_ColorScheme:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_CustomColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_SupplementalFont:
        {
            const static AttributeInfo info[] = {
                { oox::XML_script, ResourceType::String, 0 },
                { oox::XML_typeface, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_FontScheme:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_StyleMatrix:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_baseStylesheet::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_dml_baseStylesheet|DEFINE_ST_ColorSchemeIndex:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'a':
            if (rValue == "accent1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_accent1; }
            else if (rValue == "accent2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_accent2; }
            else if (rValue == "accent3") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_accent3; }
            else if (rValue == "accent4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_accent4; }
            else if (rValue == "accent5") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_accent5; }
            else if (rValue == "accent6") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_accent6; }
            else { return false; }
            return true;
        case 'd':
            if (rValue == "dk1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_dk1; }
            else if (rValue == "dk2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_dk2; }
            else { return false; }
            return true;
        case 'f':
            if (rValue == "folHlink") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_folHlink; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "hlink") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_hlink; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "lt1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_lt1; }
            else if (rValue == "lt2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_ColorSchemeIndex_lt2; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_baseStylesheet::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_baseStylesheet|DEFINE_CT_ColorScheme:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_accent1: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_accent2: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_accent3: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_accent4: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_accent5: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_accent6: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_dk1: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_dk2: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_folHlink: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_hlink: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_lt1: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_lt2: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_CustomColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_FontCollection:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_cs: rOutResource = ResourceType::Properties; rOutElement = NN_dml_textCharacter|DEFINE_CT_TextFont; break;
        case oox::NMSP_dml|oox::XML_ea: rOutResource = ResourceType::Properties; rOutElement = NN_dml_textCharacter|DEFINE_CT_TextFont; break;
        case oox::NMSP_dml|oox::XML_font: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_SupplementalFont; break;
        case oox::NMSP_dml|oox::XML_latin: rOutResource = ResourceType::Properties; rOutElement = NN_dml_textCharacter|DEFINE_CT_TextFont; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_EffectStyleItem:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_effectDag: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        case oox::NMSP_dml|oox::XML_scene3d: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shape3DScene|DEFINE_CT_Scene3D; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_FontScheme:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_majorFont: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_FontCollection; break;
        case oox::NMSP_dml|oox::XML_minorFont: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_FontCollection; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_FillStyleList:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        case oox::NMSP_w14|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_w14|oox::XML_noFill: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_Empty; break;
        case oox::NMSP_w14|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_LineStyleList:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_ln: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_LineProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_BackgroundFillStyleList:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        case oox::NMSP_w14|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_w14|oox::XML_noFill: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_Empty; break;
        case oox::NMSP_w14|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_StyleMatrix:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_bgFillStyleLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_BackgroundFillStyleList; break;
        case oox::NMSP_dml|oox::XML_effectStyleLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_EffectStyleList; break;
        case oox::NMSP_dml|oox::XML_fillStyleLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_FillStyleList; break;
        case oox::NMSP_dml|oox::XML_lnStyleLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_LineStyleList; break;
        default: return false;
        }
        return true;
    case NN_dml_baseStylesheet|DEFINE_CT_BaseStyles:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_clrScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_ColorScheme; break;
        case oox::NMSP_dml|oox::XML_fmtScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_StyleMatrix; break;
        case oox::NMSP_dml|oox::XML_fontScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_FontScheme; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_baseStylesheet::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_baseStylesheet::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_baseStylesheet|DEFINE_CT_ColorScheme:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_accent1: return NS_ooxml::LN_CT_ColorScheme_accent1;
        case oox::NMSP_dml|oox::XML_accent2: return NS_ooxml::LN_CT_ColorScheme_accent2;
        case oox::NMSP_dml|oox::XML_accent3: return NS_ooxml::LN_CT_ColorScheme_accent3;
        case oox::NMSP_dml|oox::XML_accent4: return NS_ooxml::LN_CT_ColorScheme_accent4;
        case oox::NMSP_dml|oox::XML_accent5: return NS_ooxml::LN_CT_ColorScheme_accent5;
        case oox::NMSP_dml|oox::XML_accent6: return NS_ooxml::LN_CT_ColorScheme_accent6;
        case oox::NMSP_dml|oox::XML_dk1: return NS_ooxml::LN_CT_ColorScheme_dk1;
        case oox::NMSP_dml|oox::XML_dk2: return NS_ooxml::LN_CT_ColorScheme_dk2;
        case oox::NMSP_dml|oox::XML_extLst: return NS_ooxml::LN_CT_ColorScheme_extLst;
        case oox::NMSP_dml|oox::XML_folHlink: return NS_ooxml::LN_CT_ColorScheme_folHlink;
        case oox::NMSP_dml|oox::XML_hlink: return NS_ooxml::LN_CT_ColorScheme_hlink;
        case oox::NMSP_dml|oox::XML_lt1: return NS_ooxml::LN_CT_ColorScheme_lt1;
        case oox::NMSP_dml|oox::XML_lt2: return NS_ooxml::LN_CT_ColorScheme_lt2;
        case oox::XML_name: return NS_ooxml::LN_CT_ColorScheme_name;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_CustomColor:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_SupplementalFont:
        switch (nToken)
        {
        case oox::XML_script: return NS_ooxml::LN_CT_SupplementalFont_script;
        case oox::XML_typeface: return NS_ooxml::LN_CT_SupplementalFont_typeface;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_FontCollection:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_cs: return NS_ooxml::LN_CT_FontCollection_cs;
        case oox::NMSP_dml|oox::XML_ea: return NS_ooxml::LN_CT_FontCollection_ea;
        case oox::NMSP_dml|oox::XML_extLst: return NS_ooxml::LN_CT_FontCollection_extLst;
        case oox::NMSP_dml|oox::XML_font: return NS_ooxml::LN_CT_FontCollection_font;
        case oox::NMSP_dml|oox::XML_latin: return NS_ooxml::LN_CT_FontCollection_latin;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_FontScheme:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_extLst: return NS_ooxml::LN_CT_FontScheme_extLst;
        case oox::NMSP_dml|oox::XML_majorFont: return NS_ooxml::LN_CT_FontScheme_majorFont;
        case oox::NMSP_dml|oox::XML_minorFont: return NS_ooxml::LN_CT_FontScheme_minorFont;
        case oox::XML_name: return NS_ooxml::LN_CT_FontScheme_name;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_FillStyleList:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_gradFill: return NS_ooxml::LN_EG_FillProperties_gradFill;
        case oox::NMSP_w14|oox::XML_noFill: return NS_ooxml::LN_EG_FillProperties_noFill;
        case oox::NMSP_w14|oox::XML_solidFill: return NS_ooxml::LN_EG_FillProperties_solidFill;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_LineStyleList:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_ln: return NS_ooxml::LN_CT_LineStyleList_ln;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_EffectStyleList:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_effectStyle: return NS_ooxml::LN_CT_EffectStyleList_effectStyle;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_BackgroundFillStyleList:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_gradFill: return NS_ooxml::LN_EG_FillProperties_gradFill;
        case oox::NMSP_w14|oox::XML_noFill: return NS_ooxml::LN_EG_FillProperties_noFill;
        case oox::NMSP_w14|oox::XML_solidFill: return NS_ooxml::LN_EG_FillProperties_solidFill;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_StyleMatrix:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_bgFillStyleLst: return NS_ooxml::LN_CT_StyleMatrix_bgFillStyleLst;
        case oox::NMSP_dml|oox::XML_effectStyleLst: return NS_ooxml::LN_CT_StyleMatrix_effectStyleLst;
        case oox::NMSP_dml|oox::XML_fillStyleLst: return NS_ooxml::LN_CT_StyleMatrix_fillStyleLst;
        case oox::NMSP_dml|oox::XML_lnStyleLst: return NS_ooxml::LN_CT_StyleMatrix_lnStyleLst;
        case oox::XML_name: return NS_ooxml::LN_CT_StyleMatrix_name;
        }
        break;
    case NN_dml_baseStylesheet|DEFINE_CT_BaseStyles:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_clrScheme: return NS_ooxml::LN_CT_BaseStyles_clrScheme;
        case oox::NMSP_dml|oox::XML_extLst: return NS_ooxml::LN_CT_BaseStyles_extLst;
        case oox::NMSP_dml|oox::XML_fmtScheme: return NS_ooxml::LN_CT_BaseStyles_fmtScheme;
        case oox::NMSP_dml|oox::XML_fontScheme: return NS_ooxml::LN_CT_BaseStyles_fontScheme;
        }
        break;
    default:
        switch (nToken)
        {
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_baseStylesheet::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
