
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-baseTypes.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_baseTypes> OOXMLFactory_dml_baseTypes_Mutex;

OOXMLFactory_dml_baseTypes::OOXMLFactory_dml_baseTypes()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_baseTypes_Mutex::get());
}

OOXMLFactory_dml_baseTypes::~OOXMLFactory_dml_baseTypes()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_baseTypes::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_baseTypes::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_baseTypes();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_baseTypes::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_baseTypes|DEFINE_CT_Angle:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Angle },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Percentage:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositivePercentage:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::Value, NN_dml_baseTypes|DEFINE_ST_PositivePercentage },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Point2D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_x, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { oox::XML_y, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositiveSize2D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_cx, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_PositiveCoordinate },
                { oox::XML_cy, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_PositiveCoordinate },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_ScRgbColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_r, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { oox::XML_g, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { oox::XML_b, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_SRgbColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::Hex, NN_dml_baseTypes|DEFINE_ST_HexBinary3 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_HslColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_sat, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { oox::XML_lum, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_SystemColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::List, NN_dml_baseTypes|DEFINE_ST_SystemColorVal },
                { oox::XML_lastClr, ResourceType::Hex, NN_dml_baseTypes|DEFINE_ST_HexBinary3 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_SchemeColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::List, NN_dml_baseTypes|DEFINE_ST_SchemeColorVal },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PresetColor:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::List, NN_dml_baseTypes|DEFINE_ST_PresetColorVal },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Transform2D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_rot, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Angle },
                { oox::XML_flipH, ResourceType::Boolean, 0 },
                { oox::XML_flipV, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_GroupTransform2D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_rot, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Angle },
                { oox::XML_flipH, ResourceType::Boolean, 0 },
                { oox::XML_flipV, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Point3D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_x, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { oox::XML_y, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { oox::XML_z, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Vector3D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_dx, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { oox::XML_dy, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { oox::XML_dz, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Coordinate },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_RelativeRect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_l, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { oox::XML_t, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { oox::XML_r, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { oox::XML_b, ResourceType::Integer, NN_dml_baseTypes|DEFINE_ST_Percentage },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_AG_Blob:
        {
            const static AttributeInfo info[] = {
                { oox::NMSP_officeRel|oox::XML_embed, ResourceType::String, 0 },
                { oox::NMSP_officeRel|oox::XML_link, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_EmbeddedWAVAudioFile:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, 0 },
                { oox::XML_builtIn, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Hyperlink:
        {
            const static AttributeInfo info[] = {
                { oox::XML_invalidUrl, ResourceType::String, 0 },
                { oox::XML_action, ResourceType::String, 0 },
                { oox::XML_tgtFrame, ResourceType::String, 0 },
                { oox::XML_tooltip, ResourceType::String, 0 },
                { oox::XML_history, ResourceType::Boolean, 0 },
                { oox::XML_highlightClick, ResourceType::Boolean, 0 },
                { oox::XML_endSnd, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_baseTypes::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_dml_baseTypes|DEFINE_ST_SystemColorVal:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case '3':
            if (rValue == "3dDkShadow") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_3dDkShadow; }
            else if (rValue == "3dLight") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_3dLight; }
            else { return false; }
            return true;
        case 'a':
            if (rValue == "activeCaption") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_activeCaption; }
            else if (rValue == "activeBorder") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_activeBorder; }
            else if (rValue == "appWorkspace") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_appWorkspace; }
            else { return false; }
            return true;
        case 'b':
            if (rValue == "background") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_background; }
            else if (rValue == "btnFace") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_btnFace; }
            else if (rValue == "btnShadow") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_btnShadow; }
            else if (rValue == "btnText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_btnText; }
            else if (rValue == "btnHighlight") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_btnHighlight; }
            else { return false; }
            return true;
        case 'c':
            if (rValue == "captionText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_captionText; }
            else { return false; }
            return true;
        case 'g':
            if (rValue == "grayText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_grayText; }
            else if (rValue == "gradientActiveCaption") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_gradientActiveCaption; }
            else if (rValue == "gradientInactiveCaption") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_gradientInactiveCaption; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "highlight") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_highlight; }
            else if (rValue == "highlightText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_highlightText; }
            else if (rValue == "hotLight") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_hotLight; }
            else { return false; }
            return true;
        case 'i':
            if (rValue == "inactiveCaption") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_inactiveCaption; }
            else if (rValue == "inactiveBorder") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_inactiveBorder; }
            else if (rValue == "inactiveCaptionText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_inactiveCaptionText; }
            else if (rValue == "infoText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_infoText; }
            else if (rValue == "infoBk") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_infoBk; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "menu") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_menu; }
            else if (rValue == "menuText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_menuText; }
            else if (rValue == "menuHighlight") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_menuHighlight; }
            else if (rValue == "menuBar") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_menuBar; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "scrollBar") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_scrollBar; }
            else { return false; }
            return true;
        case 'w':
            if (rValue == "window") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_window; }
            else if (rValue == "windowFrame") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_windowFrame; }
            else if (rValue == "windowText") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SystemColorVal_windowText; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_baseTypes|DEFINE_ST_SchemeColorVal:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'a':
            if (rValue == "accent1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_accent1; }
            else if (rValue == "accent2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_accent2; }
            else if (rValue == "accent3") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_accent3; }
            else if (rValue == "accent4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_accent4; }
            else if (rValue == "accent5") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_accent5; }
            else if (rValue == "accent6") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_accent6; }
            else { return false; }
            return true;
        case 'b':
            if (rValue == "bg1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_bg1; }
            else if (rValue == "bg2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_bg2; }
            else { return false; }
            return true;
        case 'd':
            if (rValue == "dk1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_dk1; }
            else if (rValue == "dk2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_dk2; }
            else { return false; }
            return true;
        case 'f':
            if (rValue == "folHlink") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_folHlink; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "hlink") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_hlink; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "lt1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_lt1; }
            else if (rValue == "lt2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_lt2; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "phClr") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_phClr; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "tx1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_tx1; }
            else if (rValue == "tx2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_SchemeColorVal_tx2; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_baseTypes|DEFINE_ST_PresetColorVal:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'a':
            if (rValue == "aliceBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_aliceBlue; }
            else if (rValue == "antiqueWhite") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_antiqueWhite; }
            else if (rValue == "aqua") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_aqua; }
            else if (rValue == "aquamarine") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_aquamarine; }
            else if (rValue == "azure") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_azure; }
            else { return false; }
            return true;
        case 'b':
            if (rValue == "beige") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_beige; }
            else if (rValue == "bisque") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_bisque; }
            else if (rValue == "black") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_black; }
            else if (rValue == "blanchedAlmond") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_blanchedAlmond; }
            else if (rValue == "blue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_blue; }
            else if (rValue == "blueViolet") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_blueViolet; }
            else if (rValue == "brown") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_brown; }
            else if (rValue == "burlyWood") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_burlyWood; }
            else { return false; }
            return true;
        case 'c':
            if (rValue == "cadetBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_cadetBlue; }
            else if (rValue == "chartreuse") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_chartreuse; }
            else if (rValue == "chocolate") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_chocolate; }
            else if (rValue == "coral") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_coral; }
            else if (rValue == "cornflowerBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_cornflowerBlue; }
            else if (rValue == "cornsilk") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_cornsilk; }
            else if (rValue == "crimson") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_crimson; }
            else if (rValue == "cyan") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_cyan; }
            else { return false; }
            return true;
        case 'd':
            if (rValue == "deepPink") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_deepPink; }
            else if (rValue == "deepSkyBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_deepSkyBlue; }
            else if (rValue == "dimGray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dimGray; }
            else if (rValue == "dkBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkBlue; }
            else if (rValue == "dkCyan") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkCyan; }
            else if (rValue == "dkGoldenrod") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkGoldenrod; }
            else if (rValue == "dkGray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkGray; }
            else if (rValue == "dkGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkGreen; }
            else if (rValue == "dkKhaki") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkKhaki; }
            else if (rValue == "dkMagenta") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkMagenta; }
            else if (rValue == "dkOliveGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkOliveGreen; }
            else if (rValue == "dkOrange") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkOrange; }
            else if (rValue == "dkOrchid") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkOrchid; }
            else if (rValue == "dkRed") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkRed; }
            else if (rValue == "dkSalmon") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkSalmon; }
            else if (rValue == "dkSeaGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkSeaGreen; }
            else if (rValue == "dkSlateBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkSlateBlue; }
            else if (rValue == "dkSlateGray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkSlateGray; }
            else if (rValue == "dkTurquoise") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkTurquoise; }
            else if (rValue == "dkViolet") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dkViolet; }
            else if (rValue == "dodgerBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_dodgerBlue; }
            else { return false; }
            return true;
        case 'f':
            if (rValue == "firebrick") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_firebrick; }
            else if (rValue == "floralWhite") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_floralWhite; }
            else if (rValue == "forestGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_forestGreen; }
            else if (rValue == "fuchsia") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_fuchsia; }
            else { return false; }
            return true;
        case 'g':
            if (rValue == "gainsboro") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_gainsboro; }
            else if (rValue == "ghostWhite") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ghostWhite; }
            else if (rValue == "gold") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_gold; }
            else if (rValue == "goldenrod") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_goldenrod; }
            else if (rValue == "gray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_gray; }
            else if (rValue == "green") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_green; }
            else if (rValue == "greenYellow") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_greenYellow; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "honeydew") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_honeydew; }
            else if (rValue == "hotPink") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_hotPink; }
            else { return false; }
            return true;
        case 'i':
            if (rValue == "indianRed") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_indianRed; }
            else if (rValue == "indigo") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_indigo; }
            else if (rValue == "ivory") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ivory; }
            else { return false; }
            return true;
        case 'k':
            if (rValue == "khaki") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_khaki; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "lavender") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_lavender; }
            else if (rValue == "lavenderBlush") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_lavenderBlush; }
            else if (rValue == "lawnGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_lawnGreen; }
            else if (rValue == "lemonChiffon") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_lemonChiffon; }
            else if (rValue == "lime") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_lime; }
            else if (rValue == "limeGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_limeGreen; }
            else if (rValue == "linen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_linen; }
            else if (rValue == "ltBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltBlue; }
            else if (rValue == "ltCoral") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltCoral; }
            else if (rValue == "ltCyan") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltCyan; }
            else if (rValue == "ltGoldenrodYellow") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltGoldenrodYellow; }
            else if (rValue == "ltGray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltGray; }
            else if (rValue == "ltGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltGreen; }
            else if (rValue == "ltPink") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltPink; }
            else if (rValue == "ltSalmon") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltSalmon; }
            else if (rValue == "ltSeaGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltSeaGreen; }
            else if (rValue == "ltSkyBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltSkyBlue; }
            else if (rValue == "ltSlateGray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltSlateGray; }
            else if (rValue == "ltSteelBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltSteelBlue; }
            else if (rValue == "ltYellow") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_ltYellow; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "magenta") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_magenta; }
            else if (rValue == "maroon") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_maroon; }
            else if (rValue == "medAquamarine") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medAquamarine; }
            else if (rValue == "medBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medBlue; }
            else if (rValue == "medOrchid") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medOrchid; }
            else if (rValue == "medPurple") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medPurple; }
            else if (rValue == "medSeaGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medSeaGreen; }
            else if (rValue == "medSlateBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medSlateBlue; }
            else if (rValue == "medSpringGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medSpringGreen; }
            else if (rValue == "medTurquoise") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medTurquoise; }
            else if (rValue == "medVioletRed") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_medVioletRed; }
            else if (rValue == "midnightBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_midnightBlue; }
            else if (rValue == "mintCream") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_mintCream; }
            else if (rValue == "mistyRose") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_mistyRose; }
            else if (rValue == "moccasin") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_moccasin; }
            else { return false; }
            return true;
        case 'n':
            if (rValue == "navajoWhite") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_navajoWhite; }
            else if (rValue == "navy") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_navy; }
            else { return false; }
            return true;
        case 'o':
            if (rValue == "oldLace") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_oldLace; }
            else if (rValue == "olive") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_olive; }
            else if (rValue == "oliveDrab") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_oliveDrab; }
            else if (rValue == "orange") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_orange; }
            else if (rValue == "orangeRed") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_orangeRed; }
            else if (rValue == "orchid") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_orchid; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "paleGoldenrod") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_paleGoldenrod; }
            else if (rValue == "paleGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_paleGreen; }
            else if (rValue == "paleTurquoise") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_paleTurquoise; }
            else if (rValue == "paleVioletRed") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_paleVioletRed; }
            else if (rValue == "papayaWhip") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_papayaWhip; }
            else if (rValue == "peachPuff") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_peachPuff; }
            else if (rValue == "peru") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_peru; }
            else if (rValue == "pink") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_pink; }
            else if (rValue == "plum") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_plum; }
            else if (rValue == "powderBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_powderBlue; }
            else if (rValue == "purple") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_purple; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "red") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_red; }
            else if (rValue == "rosyBrown") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_rosyBrown; }
            else if (rValue == "royalBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_royalBlue; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "saddleBrown") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_saddleBrown; }
            else if (rValue == "salmon") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_salmon; }
            else if (rValue == "sandyBrown") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_sandyBrown; }
            else if (rValue == "seaGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_seaGreen; }
            else if (rValue == "seaShell") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_seaShell; }
            else if (rValue == "sienna") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_sienna; }
            else if (rValue == "silver") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_silver; }
            else if (rValue == "skyBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_skyBlue; }
            else if (rValue == "slateBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_slateBlue; }
            else if (rValue == "slateGray") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_slateGray; }
            else if (rValue == "snow") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_snow; }
            else if (rValue == "springGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_springGreen; }
            else if (rValue == "steelBlue") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_steelBlue; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "tan") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_tan; }
            else if (rValue == "teal") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_teal; }
            else if (rValue == "thistle") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_thistle; }
            else if (rValue == "tomato") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_tomato; }
            else if (rValue == "turquoise") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_turquoise; }
            else { return false; }
            return true;
        case 'v':
            if (rValue == "violet") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_violet; }
            else { return false; }
            return true;
        case 'w':
            if (rValue == "wheat") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_wheat; }
            else if (rValue == "white") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_white; }
            else if (rValue == "whiteSmoke") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_whiteSmoke; }
            else { return false; }
            return true;
        case 'y':
            if (rValue == "yellow") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_yellow; }
            else if (rValue == "yellowGreen") { rOutValue = NS_ooxml::LN_Value_ST_PresetColorVal_yellowGreen; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_baseTypes|DEFINE_ST_RectAlignment:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'b':
            if (rValue == "bl") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_bl; }
            else if (rValue == "b") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_b; }
            else if (rValue == "br") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_br; }
            else { return false; }
            return true;
        case 'c':
            if (rValue == "ctr") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_ctr; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "l") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_l; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "r") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_r; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "tl") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_tl; }
            else if (rValue == "t") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_t; }
            else if (rValue == "tr") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_RectAlignment_tr; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_baseTypes|DEFINE_ST_BlackWhiteMode:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'a':
            if (rValue == "auto") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_auto; }
            else { return false; }
            return true;
        case 'b':
            if (rValue == "blackGray") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_blackGray; }
            else if (rValue == "blackWhite") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_blackWhite; }
            else if (rValue == "black") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_black; }
            else { return false; }
            return true;
        case 'c':
            if (rValue == "clr") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_clr; }
            else { return false; }
            return true;
        case 'g':
            if (rValue == "gray") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_gray; }
            else if (rValue == "grayWhite") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_grayWhite; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "hidden") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_hidden; }
            else { return false; }
            return true;
        case 'i':
            if (rValue == "invGray") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_invGray; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "ltGray") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_ltGray; }
            else { return false; }
            return true;
        case 'w':
            if (rValue == "white") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlackWhiteMode_white; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_baseTypes::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_baseTypes|DEFINE_CT_OfficeArtExtension:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_TOKEN_COUNT: rOutResource = ResourceType::Any; rOutElement = 0; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_EG_ColorTransform:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_ScRgbColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_SRgbColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_HslColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_SystemColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_SchemeColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_PresetColor:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_alpha: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_alphaMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_alphaOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_FixedPercentage; break;
        case oox::NMSP_dml|oox::XML_blue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_blueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_green: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_greenOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_hue: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle; break;
        case oox::NMSP_dml|oox::XML_hueMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositivePercentage; break;
        case oox::NMSP_dml|oox::XML_hueOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Angle; break;
        case oox::NMSP_dml|oox::XML_lum: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_lumOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_red: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_redOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_sat: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satMod: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_satOff: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_Percentage; break;
        case oox::NMSP_dml|oox::XML_shade: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        case oox::NMSP_dml|oox::XML_tint: rOutResource = ResourceType::Value; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_Transform2D:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_ext: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveSize2D; break;
        case oox::NMSP_dml|oox::XML_off: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Point2D; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_GroupTransform2D:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_chExt: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveSize2D; break;
        case oox::NMSP_dml|oox::XML_chOff: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Point2D; break;
        case oox::NMSP_dml|oox::XML_ext: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PositiveSize2D; break;
        case oox::NMSP_dml|oox::XML_off: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Point2D; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_EG_ColorChoice:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_Color:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        default: return false;
        }
        return true;
    case NN_dml_baseTypes|DEFINE_CT_ColorMRU:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_baseTypes::startAction(OOXMLFastContextHandler* pHandler)
{
    sal_uInt32 nDefine = pHandler->getDefine();
    switch (nDefine)
    {
    case NN_dml_baseTypes|DEFINE_CT_Angle:
        pHandler->setDefaultIntegerValue();
        break;
    
    case NN_dml_baseTypes|DEFINE_CT_Percentage:
        pHandler->setDefaultIntegerValue();
        break;

    default:
        break;
    }
}

void OOXMLFactory_dml_baseTypes::charactersAction(OOXMLFastContextHandler* pHandler, const OUString& sText)
{
    sal_uInt32 nDefine = pHandler->getDefine();
    switch (nDefine)
    {
    case NN_dml_baseTypes|DEFINE_ST_PositivePercentage:
        pHandler->positivePercentage(sText);
        break;

    default:
        break;
    }
    switch (nDefine)
    {
case NN_dml_baseTypes|DEFINE_ST_PositivePercentage:
        break;

    default:
        break;
    }
}

Id OOXMLFactory_dml_baseTypes::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_baseTypes|DEFINE_CT_Angle:
        switch (nToken)
        {
        case oox::XML_val: return NS_ooxml::LN_CT_Angle_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle:
        switch (nToken)
        {
        case oox::XML_val: return NS_ooxml::LN_CT_PositiveFixedAngle_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Percentage:
        switch (nToken)
        {
        case oox::XML_val: return NS_ooxml::LN_CT_Percentage_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositivePercentage:
        switch (nToken)
        {
        case oox::XML_val: return NS_ooxml::LN_CT_PositivePercentage_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_FixedPercentage:
        switch (nToken)
        {
        case oox::XML_val: return NS_ooxml::LN_CT_FixedPercentage_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage:
        switch (nToken)
        {
        case oox::XML_val: return NS_ooxml::LN_CT_PositiveFixedPercentage_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Point2D:
        switch (nToken)
        {
        case oox::XML_x: return NS_ooxml::LN_CT_Point2D_x;
        case oox::XML_y: return NS_ooxml::LN_CT_Point2D_y;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositiveSize2D:
        switch (nToken)
        {
        case oox::XML_cx: return NS_ooxml::LN_CT_PositiveSize2D_cx;
        case oox::XML_cy: return NS_ooxml::LN_CT_PositiveSize2D_cy;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_ScRgbColor:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_alpha: return NS_ooxml::LN_EG_ColorTransform_alpha;
        case oox::NMSP_w14|oox::XML_hueMod: return NS_ooxml::LN_EG_ColorTransform_hueMod;
        case oox::NMSP_w14|oox::XML_lum: return NS_ooxml::LN_EG_ColorTransform_lum;
        case oox::NMSP_w14|oox::XML_lumMod: return NS_ooxml::LN_EG_ColorTransform_lumMod;
        case oox::NMSP_w14|oox::XML_lumOff: return NS_ooxml::LN_EG_ColorTransform_lumOff;
        case oox::NMSP_w14|oox::XML_sat: return NS_ooxml::LN_EG_ColorTransform_sat;
        case oox::NMSP_w14|oox::XML_satMod: return NS_ooxml::LN_EG_ColorTransform_satMod;
        case oox::NMSP_w14|oox::XML_satOff: return NS_ooxml::LN_EG_ColorTransform_satOff;
        case oox::NMSP_w14|oox::XML_shade: return NS_ooxml::LN_EG_ColorTransform_shade;
        case oox::NMSP_w14|oox::XML_tint: return NS_ooxml::LN_EG_ColorTransform_tint;
        case oox::XML_b: return NS_ooxml::LN_CT_ScRgbColor_b;
        case oox::XML_g: return NS_ooxml::LN_CT_ScRgbColor_g;
        case oox::XML_r: return NS_ooxml::LN_CT_ScRgbColor_r;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_SRgbColor:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_alpha: return NS_ooxml::LN_EG_ColorTransform_alpha;
        case oox::NMSP_w14|oox::XML_hueMod: return NS_ooxml::LN_EG_ColorTransform_hueMod;
        case oox::NMSP_w14|oox::XML_lum: return NS_ooxml::LN_EG_ColorTransform_lum;
        case oox::NMSP_w14|oox::XML_lumMod: return NS_ooxml::LN_EG_ColorTransform_lumMod;
        case oox::NMSP_w14|oox::XML_lumOff: return NS_ooxml::LN_EG_ColorTransform_lumOff;
        case oox::NMSP_w14|oox::XML_sat: return NS_ooxml::LN_EG_ColorTransform_sat;
        case oox::NMSP_w14|oox::XML_satMod: return NS_ooxml::LN_EG_ColorTransform_satMod;
        case oox::NMSP_w14|oox::XML_satOff: return NS_ooxml::LN_EG_ColorTransform_satOff;
        case oox::NMSP_w14|oox::XML_shade: return NS_ooxml::LN_EG_ColorTransform_shade;
        case oox::NMSP_w14|oox::XML_tint: return NS_ooxml::LN_EG_ColorTransform_tint;
        case oox::XML_val: return NS_ooxml::LN_CT_SRgbColor_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_HslColor:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_alpha: return NS_ooxml::LN_EG_ColorTransform_alpha;
        case oox::NMSP_w14|oox::XML_hueMod: return NS_ooxml::LN_EG_ColorTransform_hueMod;
        case oox::NMSP_w14|oox::XML_lum: return NS_ooxml::LN_EG_ColorTransform_lum;
        case oox::NMSP_w14|oox::XML_lumMod: return NS_ooxml::LN_EG_ColorTransform_lumMod;
        case oox::NMSP_w14|oox::XML_lumOff: return NS_ooxml::LN_EG_ColorTransform_lumOff;
        case oox::NMSP_w14|oox::XML_sat: return NS_ooxml::LN_EG_ColorTransform_sat;
        case oox::NMSP_w14|oox::XML_satMod: return NS_ooxml::LN_EG_ColorTransform_satMod;
        case oox::NMSP_w14|oox::XML_satOff: return NS_ooxml::LN_EG_ColorTransform_satOff;
        case oox::NMSP_w14|oox::XML_shade: return NS_ooxml::LN_EG_ColorTransform_shade;
        case oox::NMSP_w14|oox::XML_tint: return NS_ooxml::LN_EG_ColorTransform_tint;
        case oox::XML_hue: return NS_ooxml::LN_CT_HslColor_hue;
        case oox::XML_lum: return NS_ooxml::LN_CT_HslColor_lum;
        case oox::XML_sat: return NS_ooxml::LN_CT_HslColor_sat;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_SystemColor:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_alpha: return NS_ooxml::LN_EG_ColorTransform_alpha;
        case oox::NMSP_w14|oox::XML_hueMod: return NS_ooxml::LN_EG_ColorTransform_hueMod;
        case oox::NMSP_w14|oox::XML_lum: return NS_ooxml::LN_EG_ColorTransform_lum;
        case oox::NMSP_w14|oox::XML_lumMod: return NS_ooxml::LN_EG_ColorTransform_lumMod;
        case oox::NMSP_w14|oox::XML_lumOff: return NS_ooxml::LN_EG_ColorTransform_lumOff;
        case oox::NMSP_w14|oox::XML_sat: return NS_ooxml::LN_EG_ColorTransform_sat;
        case oox::NMSP_w14|oox::XML_satMod: return NS_ooxml::LN_EG_ColorTransform_satMod;
        case oox::NMSP_w14|oox::XML_satOff: return NS_ooxml::LN_EG_ColorTransform_satOff;
        case oox::NMSP_w14|oox::XML_shade: return NS_ooxml::LN_EG_ColorTransform_shade;
        case oox::NMSP_w14|oox::XML_tint: return NS_ooxml::LN_EG_ColorTransform_tint;
        case oox::XML_lastClr: return NS_ooxml::LN_CT_SytemColor_lastClr;
        case oox::XML_val: return NS_ooxml::LN_CT_SystemColor_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_SchemeColor:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_alpha: return NS_ooxml::LN_EG_ColorTransform_alpha;
        case oox::NMSP_w14|oox::XML_hueMod: return NS_ooxml::LN_EG_ColorTransform_hueMod;
        case oox::NMSP_w14|oox::XML_lum: return NS_ooxml::LN_EG_ColorTransform_lum;
        case oox::NMSP_w14|oox::XML_lumMod: return NS_ooxml::LN_EG_ColorTransform_lumMod;
        case oox::NMSP_w14|oox::XML_lumOff: return NS_ooxml::LN_EG_ColorTransform_lumOff;
        case oox::NMSP_w14|oox::XML_sat: return NS_ooxml::LN_EG_ColorTransform_sat;
        case oox::NMSP_w14|oox::XML_satMod: return NS_ooxml::LN_EG_ColorTransform_satMod;
        case oox::NMSP_w14|oox::XML_satOff: return NS_ooxml::LN_EG_ColorTransform_satOff;
        case oox::NMSP_w14|oox::XML_shade: return NS_ooxml::LN_EG_ColorTransform_shade;
        case oox::NMSP_w14|oox::XML_tint: return NS_ooxml::LN_EG_ColorTransform_tint;
        case oox::XML_val: return NS_ooxml::LN_CT_SchemeColor_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PresetColor:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_alpha: return NS_ooxml::LN_EG_ColorTransform_alpha;
        case oox::NMSP_w14|oox::XML_hueMod: return NS_ooxml::LN_EG_ColorTransform_hueMod;
        case oox::NMSP_w14|oox::XML_lum: return NS_ooxml::LN_EG_ColorTransform_lum;
        case oox::NMSP_w14|oox::XML_lumMod: return NS_ooxml::LN_EG_ColorTransform_lumMod;
        case oox::NMSP_w14|oox::XML_lumOff: return NS_ooxml::LN_EG_ColorTransform_lumOff;
        case oox::NMSP_w14|oox::XML_sat: return NS_ooxml::LN_EG_ColorTransform_sat;
        case oox::NMSP_w14|oox::XML_satMod: return NS_ooxml::LN_EG_ColorTransform_satMod;
        case oox::NMSP_w14|oox::XML_satOff: return NS_ooxml::LN_EG_ColorTransform_satOff;
        case oox::NMSP_w14|oox::XML_shade: return NS_ooxml::LN_EG_ColorTransform_shade;
        case oox::NMSP_w14|oox::XML_tint: return NS_ooxml::LN_EG_ColorTransform_tint;
        case oox::XML_val: return NS_ooxml::LN_CT_PresetColor_val;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Transform2D:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_ext: return NS_ooxml::LN_CT_Transform2D_ext;
        case oox::NMSP_dml|oox::XML_off: return NS_ooxml::LN_CT_Transform2D_off;
        case oox::XML_flipH: return NS_ooxml::LN_CT_Transform2D_flipH;
        case oox::XML_flipV: return NS_ooxml::LN_CT_Transform2D_flipV;
        case oox::XML_rot: return NS_ooxml::LN_CT_Transform2D_rot;
        }
        break;
    case NN_dml_baseTypes|DEFINE_EG_ColorChoice:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Color:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_ColorMRU:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        }
        break;
    case NN_dml_baseTypes|DEFINE_AG_Blob:
        switch (nToken)
        {
        case oox::NMSP_officeRel|oox::XML_embed: return NS_ooxml::LN_AG_Blob_r_embed;
        case oox::NMSP_officeRel|oox::XML_link: return NS_ooxml::LN_AG_Blob_r_link;
        }
        break;
    default:
        switch (nToken)
        {
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_baseTypes::attributeAction(OOXMLFastContextHandler* _pHandler, Token_t nToken, const OOXMLValue::Pointer_t& pValue)
{
    switch (_pHandler->getDefine())
    {
    case NN_dml_baseTypes|DEFINE_CT_Angle:
        if (OOXMLFastContextHandlerValue* pHandler = dynamic_cast<OOXMLFastContextHandlerValue*>(_pHandler))
        {
            if (nToken == static_cast<Token_t>(oox::XML_val))
                pHandler->setValue(pValue);
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositiveFixedAngle:
        if (OOXMLFastContextHandlerValue* pHandler = dynamic_cast<OOXMLFastContextHandlerValue*>(_pHandler))
        {
            if (nToken == static_cast<Token_t>(oox::XML_val))
                pHandler->setValue(pValue);
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_Percentage:
        if (OOXMLFastContextHandlerValue* pHandler = dynamic_cast<OOXMLFastContextHandlerValue*>(_pHandler))
        {
            if (nToken == static_cast<Token_t>(oox::XML_val))
                pHandler->setValue(pValue);
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositivePercentage:
        if (OOXMLFastContextHandlerValue* pHandler = dynamic_cast<OOXMLFastContextHandlerValue*>(_pHandler))
        {
            if (nToken == static_cast<Token_t>(oox::XML_val))
                pHandler->setValue(pValue);
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_FixedPercentage:
        if (OOXMLFastContextHandlerValue* pHandler = dynamic_cast<OOXMLFastContextHandlerValue*>(_pHandler))
        {
            if (nToken == static_cast<Token_t>(oox::XML_val))
                pHandler->setValue(pValue);
        }
        break;
    case NN_dml_baseTypes|DEFINE_CT_PositiveFixedPercentage:
        if (OOXMLFastContextHandlerValue* pHandler = dynamic_cast<OOXMLFastContextHandlerValue*>(_pHandler))
        {
            if (nToken == static_cast<Token_t>(oox::XML_val))
                pHandler->setValue(pValue);
        }
        break;
    default:
        break;
    }
}

/// @endcond
}}
