
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-chartDrawing.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_chartDrawing> OOXMLFactory_dml_chartDrawing_Mutex;

OOXMLFactory_dml_chartDrawing::OOXMLFactory_dml_chartDrawing()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_chartDrawing_Mutex::get());
}

OOXMLFactory_dml_chartDrawing::~OOXMLFactory_dml_chartDrawing()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_chartDrawing::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_chartDrawing::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_chartDrawing();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_chartDrawing::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_chartDrawing|DEFINE_CT_RelIds:
        {
            const static AttributeInfo info[] = {
                { oox::NMSP_officeRel|oox::XML_dm, ResourceType::String, 0 },
                { oox::NMSP_officeRel|oox::XML_lo, ResourceType::String, 0 },
                { oox::NMSP_officeRel|oox::XML_qs, ResourceType::String, 0 },
                { oox::NMSP_officeRel|oox::XML_cs, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_Chart:
        {
            const static AttributeInfo info[] = {
                { oox::NMSP_officeRel|oox::XML_id, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_chartDrawing::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_chartDrawing::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_chartDrawing|DEFINE_CT_PictureNonVisual:
        switch (nId)
        {
        case oox::NMSP_dmlPicture|oox::XML_cNvPicPr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_documentProperties|DEFINE_CT_NonVisualPictureProperties; break;
        case oox::NMSP_dmlPicture|oox::XML_cNvPr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_documentProperties|DEFINE_CT_NonVisualDrawingProps; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_CT_Picture:
        switch (nId)
        {
        case oox::NMSP_dmlPicture|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dmlPicture|oox::XML_nvPicPr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_chartDrawing|DEFINE_CT_PictureNonVisual; break;
        case oox::NMSP_dmlPicture|oox::XML_spPr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeProperties|DEFINE_CT_ShapeProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_pic:
        switch (nId)
        {
        case oox::NMSP_dmlPicture|oox::XML_pic: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_Picture; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_relIds:
        switch (nId)
        {
        case oox::NMSP_dmlDiagram|oox::XML_relIds: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_RelIds; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_lockedCanvas:
        switch (nId)
        {
        case oox::NMSP_dmlLockedCanvas|oox::XML_lockedCanvas: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_GvmlGroupShape; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_chart:
        switch (nId)
        {
        case oox::NMSP_dmlChart|oox::XML_chart: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_Chart; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_CT_WordprocessingShape:
        switch (nId)
        {
        case oox::NMSP_dmlPicture|oox::XML_spPr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeProperties|DEFINE_CT_ShapeProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_wsp:
        switch (nId)
        {
        case oox::NMSP_wps|oox::XML_wsp: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_WordprocessingShape; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_CT_WordprocessingGroup:
        switch (nId)
        {
        case oox::NMSP_dmlPicture|oox::XML_grpSpPr: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_WordprocessingGroup; break;
        default: return false;
        }
        return true;
    case NN_dml_chartDrawing|DEFINE_wgp:
        switch (nId)
        {
        case oox::NMSP_wpg|oox::XML_wgp: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_WordprocessingGroup; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        /* start: pic*/
        case oox::NMSP_dmlPicture|oox::XML_pic: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_Picture; break;
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_chartDrawing::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_chartDrawing::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_chartDrawing|DEFINE_CT_PictureNonVisual:
        switch (nToken)
        {
        case oox::NMSP_dmlPicture|oox::XML_cNvPicPr: return NS_ooxml::LN_CT_PictureNonVisual_cNvPicPr;
        case oox::NMSP_dmlPicture|oox::XML_cNvPr: return NS_ooxml::LN_CT_PictureNonVisual_cNvPr;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_Picture:
        switch (nToken)
        {
        case oox::NMSP_dmlPicture|oox::XML_blipFill: return NS_ooxml::LN_CT_Picture_blipFill;
        case oox::NMSP_dmlPicture|oox::XML_nvPicPr: return NS_ooxml::LN_CT_Picture_nvPicPr;
        case oox::NMSP_dmlPicture|oox::XML_spPr: return NS_ooxml::LN_CT_Picture_spPr;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_pic:
        switch (nToken)
        {
        case oox::NMSP_dmlPicture|oox::XML_pic: return NS_ooxml::LN_pic_pic;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_RelIds:
        switch (nToken)
        {
        case oox::NMSP_officeRel|oox::XML_cs: return NS_ooxml::LN_CT_RelIds_cs;
        case oox::NMSP_officeRel|oox::XML_dm: return NS_ooxml::LN_CT_RelIds_dm;
        case oox::NMSP_officeRel|oox::XML_lo: return NS_ooxml::LN_CT_RelIds_lo;
        case oox::NMSP_officeRel|oox::XML_qs: return NS_ooxml::LN_CT_RelIds_qs;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_relIds:
        switch (nToken)
        {
        case oox::NMSP_dmlDiagram|oox::XML_relIds: return NS_ooxml::LN_dgm_relIds;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_GvmlGroupShape:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_grpSpPr: return NS_ooxml::LN_CT_GvmlGroupShape_grpSpPr;
        case oox::NMSP_dml|oox::XML_nvGrpSpPr: return NS_ooxml::LN_CT_GvmlGroupShape_nvGrpSpPr;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_lockedCanvas:
        switch (nToken)
        {
        case oox::NMSP_dmlLockedCanvas|oox::XML_lockedCanvas: return NS_ooxml::LN_lc_lockedCanvas;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_Chart:
        switch (nToken)
        {
        case oox::NMSP_officeRel|oox::XML_id: return NS_ooxml::LN_CT_RelId_chart;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_chart:
        switch (nToken)
        {
        case oox::NMSP_dmlChart|oox::XML_chart: return NS_ooxml::LN_c_chart;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_WordprocessingShape:
        switch (nToken)
        {
        case oox::NMSP_wps|oox::XML_cNvSpPr: return NS_ooxml::LN_CT_WordprocessingShape_cNvSpPr;
        case oox::NMSP_wps|oox::XML_spPr: return NS_ooxml::LN_CT_WordprocessingShape_spPr;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_wsp:
        switch (nToken)
        {
        case oox::NMSP_wps|oox::XML_wsp: return NS_ooxml::LN_wps_wsp;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_CT_WordprocessingGroup:
        switch (nToken)
        {
        case oox::NMSP_wpg|oox::XML_cNvGrpSpPr: return NS_ooxml::LN_CT_WordprocessingGroup_cNvGrpSpPr;
        case oox::NMSP_wpg|oox::XML_grpSpPr: return NS_ooxml::LN_CT_WordprocessingGroup_grpSpPr;
        }
        break;
    case NN_dml_chartDrawing|DEFINE_wgp:
        switch (nToken)
        {
        case oox::NMSP_wpg|oox::XML_wgp: return NS_ooxml::LN_wpg_wgp;
        }
        break;
    default:
        switch (nToken)
        {
        case oox::NMSP_dmlPicture|oox::XML_pic: return NS_ooxml::LN_pic_pic;
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_chartDrawing::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
