
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-graphicalObject.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_graphicalObject> OOXMLFactory_dml_graphicalObject_Mutex;

OOXMLFactory_dml_graphicalObject::OOXMLFactory_dml_graphicalObject()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_graphicalObject_Mutex::get());
}

OOXMLFactory_dml_graphicalObject::~OOXMLFactory_dml_graphicalObject()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_graphicalObject::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_graphicalObject::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_graphicalObject();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_graphicalObject::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_graphicalObject::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_graphicalObject::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_graphicalObject|DEFINE_CT_GraphicalObjectData:
        switch (nId)
        {
        case oox::NMSP_dmlChart|oox::XML_chart: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_Chart; break;
        case oox::NMSP_dmlDiagram|oox::XML_relIds: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_RelIds; break;
        case oox::NMSP_dmlLockedCanvas|oox::XML_lockedCanvas: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_GvmlGroupShape; break;
        case oox::NMSP_dmlPicture|oox::XML_pic: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_Picture; break;
        case oox::NMSP_dml|oox::XML_TOKEN_COUNT: rOutResource = ResourceType::Any; rOutElement = 0; break;
        case oox::NMSP_wpg|oox::XML_wgp: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_WordprocessingGroup; break;
        case oox::NMSP_wps|oox::XML_wsp: rOutResource = ResourceType::Shape; rOutElement = NN_dml_chartDrawing|DEFINE_CT_WordprocessingShape; break;
        default: return false;
        }
        return true;
    case NN_dml_graphicalObject|DEFINE_CT_GraphicalObject:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_graphicData: rOutResource = ResourceType::Properties; rOutElement = NN_dml_graphicalObject|DEFINE_CT_GraphicalObjectData; break;
        default: return false;
        }
        return true;
    case NN_dml_graphicalObject|DEFINE_graphic:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_graphic: rOutResource = ResourceType::Properties; rOutElement = NN_dml_graphicalObject|DEFINE_CT_GraphicalObject; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        /* start: graphic*/
        case oox::NMSP_dml|oox::XML_graphic: rOutResource = ResourceType::Properties; rOutElement = NN_dml_graphicalObject|DEFINE_CT_GraphicalObject; break;
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_graphicalObject::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_graphicalObject::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_graphicalObject|DEFINE_CT_GraphicalObjectData:
        switch (nToken)
        {
        case oox::NMSP_dmlChart|oox::XML_chart: return NS_ooxml::LN_c_chart;
        case oox::NMSP_dmlDiagram|oox::XML_relIds: return NS_ooxml::LN_dgm_relIds;
        case oox::NMSP_dmlLockedCanvas|oox::XML_lockedCanvas: return NS_ooxml::LN_lc_lockedCanvas;
        case oox::NMSP_dmlPicture|oox::XML_pic: return NS_ooxml::LN_pic_pic;
        case oox::NMSP_dml|oox::XML_chart: return NS_ooxml::LN_CT_GraphicalObjectData_chart;
        case oox::NMSP_dml|oox::XML_lockedCanvas: return NS_ooxml::LN_CT_GraphicalObjectData_lockedCanvas;
        case oox::NMSP_dml|oox::XML_pic: return NS_ooxml::LN_CT_GraphicalObjectData_pic;
        case oox::NMSP_dml|oox::XML_relIds: return NS_ooxml::LN_CT_GraphicalObjectData_relIds;
        case oox::NMSP_dml|oox::XML_wgp: return NS_ooxml::LN_CT_GraphicalObjectData_wgp;
        case oox::NMSP_dml|oox::XML_wsp: return NS_ooxml::LN_CT_GraphicalObjectData_wsp;
        case oox::NMSP_wpg|oox::XML_wgp: return NS_ooxml::LN_wpg_wgp;
        case oox::NMSP_wps|oox::XML_wsp: return NS_ooxml::LN_wps_wsp;
        case oox::XML_uri: return NS_ooxml::LN_CT_GraphicalObjectData_uri;
        }
        break;
    case NN_dml_graphicalObject|DEFINE_CT_GraphicalObject:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_graphicData: return NS_ooxml::LN_CT_GraphicalObject_graphicData;
        }
        break;
    case NN_dml_graphicalObject|DEFINE_graphic:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_graphic: return NS_ooxml::LN_graphic_graphic;
        }
        break;
    default:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_graphic: return NS_ooxml::LN_graphic_graphic;
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_graphicalObject::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
