
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-shape3DLighting.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_shape3DLighting> OOXMLFactory_dml_shape3DLighting_Mutex;

OOXMLFactory_dml_shape3DLighting::OOXMLFactory_dml_shape3DLighting()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_shape3DLighting_Mutex::get());
}

OOXMLFactory_dml_shape3DLighting::~OOXMLFactory_dml_shape3DLighting()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shape3DLighting::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shape3DLighting::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_shape3DLighting();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_shape3DLighting::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_shape3DLighting|DEFINE_CT_LightRig:
        {
            const static AttributeInfo info[] = {
                { oox::XML_rig, ResourceType::List, NN_dml_shape3DLighting|DEFINE_ST_LightRigType },
                { oox::XML_dir, ResourceType::List, NN_dml_shape3DLighting|DEFINE_ST_LightRigDirection },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_shape3DLighting::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_dml_shape3DLighting|DEFINE_ST_LightRigDirection:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'b':
            if (rValue == "bl") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_bl; }
            else if (rValue == "b") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_b; }
            else if (rValue == "br") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_br; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "l") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_l; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "r") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_r; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "tl") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_tl; }
            else if (rValue == "t") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_t; }
            else if (rValue == "tr") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigDirection_tr; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shape3DLighting|DEFINE_ST_LightRigType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'b':
            if (rValue == "balanced") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_balanced; }
            else if (rValue == "brightRoom") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_brightRoom; }
            else { return false; }
            return true;
        case 'c':
            if (rValue == "contrasting") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_contrasting; }
            else if (rValue == "chilly") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_chilly; }
            else { return false; }
            return true;
        case 'f':
            if (rValue == "flood") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_flood; }
            else if (rValue == "freezing") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_freezing; }
            else if (rValue == "flat") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_flat; }
            else { return false; }
            return true;
        case 'g':
            if (rValue == "glow") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_glow; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "harsh") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_harsh; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "legacyFlat1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyFlat1; }
            else if (rValue == "legacyFlat2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyFlat2; }
            else if (rValue == "legacyFlat3") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyFlat3; }
            else if (rValue == "legacyFlat4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyFlat4; }
            else if (rValue == "legacyNormal1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyNormal1; }
            else if (rValue == "legacyNormal2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyNormal2; }
            else if (rValue == "legacyNormal3") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyNormal3; }
            else if (rValue == "legacyNormal4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyNormal4; }
            else if (rValue == "legacyHarsh1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyHarsh1; }
            else if (rValue == "legacyHarsh2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyHarsh2; }
            else if (rValue == "legacyHarsh3") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyHarsh3; }
            else if (rValue == "legacyHarsh4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_legacyHarsh4; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "morning") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_morning; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "soft") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_soft; }
            else if (rValue == "sunrise") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_sunrise; }
            else if (rValue == "sunset") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_sunset; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "threePt") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_threePt; }
            else if (rValue == "twoPt") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LightRigType_twoPt; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_shape3DLighting::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_shape3DLighting|DEFINE_CT_LightRig:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_rot: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SphereCoords; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_shape3DLighting::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_shape3DLighting::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    default:
        switch (nToken)
        {
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_shape3DLighting::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
