
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-shapeEffects.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_shapeEffects> OOXMLFactory_dml_shapeEffects_Mutex;

OOXMLFactory_dml_shapeEffects::OOXMLFactory_dml_shapeEffects()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_shapeEffects_Mutex::get());
}

OOXMLFactory_dml_shapeEffects::~OOXMLFactory_dml_shapeEffects()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shapeEffects::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shapeEffects::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_shapeEffects();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_shapeEffects::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_shapeEffects|DEFINE_CT_BlurEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_grow, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_ColorChangeEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_useA, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_OuterShadowEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_rotWithShape, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_PresetShadowEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_prst, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_PresetShadowVal },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_ReflectionEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_rotWithShape, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_LinearShadeProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_scaled, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_PathShadeProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_path, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_PathShadeType },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_flip, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_TileFlipMode },
                { oox::XML_rotWithShape, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_TileInfoProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_flip, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_TileFlipMode },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_Blip:
        {
            const static AttributeInfo info[] = {
                { oox::XML_cstate, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_BlipCompression },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_dpi, ResourceType::Integer, 0 },
                { oox::XML_rotWithShape, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_PatternFillProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_prst, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_PresetPatternVal },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_FillOverlayEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_blend, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_BlendMode },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_EffectContainer:
        {
            const static AttributeInfo info[] = {
                { oox::XML_type, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_EffectContainerType },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_BlendEffect:
        {
            const static AttributeInfo info[] = {
                { oox::XML_blend, ResourceType::List, NN_dml_shapeEffects|DEFINE_ST_BlendMode },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_shapeEffects::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_dml_shapeEffects|DEFINE_ST_PresetShadowVal:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 's':
            if (rValue == "shdw1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw1; }
            else if (rValue == "shdw2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw2; }
            else if (rValue == "shdw3") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw3; }
            else if (rValue == "shdw4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw4; }
            else if (rValue == "shdw5") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw5; }
            else if (rValue == "shdw6") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw6; }
            else if (rValue == "shdw7") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw7; }
            else if (rValue == "shdw8") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw8; }
            else if (rValue == "shdw9") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw9; }
            else if (rValue == "shdw10") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw10; }
            else if (rValue == "shdw11") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw11; }
            else if (rValue == "shdw12") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw12; }
            else if (rValue == "shdw13") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw13; }
            else if (rValue == "shdw14") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw14; }
            else if (rValue == "shdw15") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw15; }
            else if (rValue == "shdw16") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw16; }
            else if (rValue == "shdw17") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw17; }
            else if (rValue == "shdw18") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw18; }
            else if (rValue == "shdw19") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw19; }
            else if (rValue == "shdw20") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetShadowVal_shdw20; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeEffects|DEFINE_ST_PathShadeType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'c':
            if (rValue == "circle") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathShadeType_circle; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "rect") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathShadeType_rect; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "shape") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathShadeType_shape; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeEffects|DEFINE_ST_TileFlipMode:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'n':
            if (rValue == "none") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TileFlipMode_none; }
            else { return false; }
            return true;
        case 'x':
            if (rValue == "x") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TileFlipMode_x; }
            else if (rValue == "xy") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TileFlipMode_xy; }
            else { return false; }
            return true;
        case 'y':
            if (rValue == "y") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TileFlipMode_y; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeEffects|DEFINE_ST_BlipCompression:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'e':
            if (rValue == "email") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlipCompression_email; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "hqprint") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlipCompression_hqprint; }
            else { return false; }
            return true;
        case 'n':
            if (rValue == "none") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlipCompression_none; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "print") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlipCompression_print; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "screen") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlipCompression_screen; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeEffects|DEFINE_ST_PresetPatternVal:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'c':
            if (rValue == "cross") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_cross; }
            else { return false; }
            return true;
        case 'd':
            if (rValue == "dkHorz") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dkHorz; }
            else if (rValue == "dkVert") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dkVert; }
            else if (rValue == "dashHorz") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dashHorz; }
            else if (rValue == "dashVert") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dashVert; }
            else if (rValue == "dnDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dnDiag; }
            else if (rValue == "dkDnDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dkDnDiag; }
            else if (rValue == "dkUpDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dkUpDiag; }
            else if (rValue == "dashDnDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dashDnDiag; }
            else if (rValue == "dashUpDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dashUpDiag; }
            else if (rValue == "diagCross") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_diagCross; }
            else if (rValue == "dotGrid") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dotGrid; }
            else if (rValue == "diagBrick") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_diagBrick; }
            else if (rValue == "dotDmnd") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_dotDmnd; }
            else if (rValue == "divot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_divot; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "horz") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_horz; }
            else if (rValue == "horzBrick") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_horzBrick; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "ltHorz") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_ltHorz; }
            else if (rValue == "ltVert") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_ltVert; }
            else if (rValue == "ltDnDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_ltDnDiag; }
            else if (rValue == "ltUpDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_ltUpDiag; }
            else if (rValue == "lgCheck") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_lgCheck; }
            else if (rValue == "lgGrid") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_lgGrid; }
            else if (rValue == "lgConfetti") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_lgConfetti; }
            else { return false; }
            return true;
        case 'n':
            if (rValue == "narHorz") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_narHorz; }
            else if (rValue == "narVert") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_narVert; }
            else { return false; }
            return true;
        case 'o':
            if (rValue == "openDmnd") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_openDmnd; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "pct5") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct5; }
            else if (rValue == "pct10") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct10; }
            else if (rValue == "pct20") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct20; }
            else if (rValue == "pct25") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct25; }
            else if (rValue == "pct30") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct30; }
            else if (rValue == "pct40") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct40; }
            else if (rValue == "pct50") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct50; }
            else if (rValue == "pct60") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct60; }
            else if (rValue == "pct70") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct70; }
            else if (rValue == "pct75") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct75; }
            else if (rValue == "pct80") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct80; }
            else if (rValue == "pct90") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_pct90; }
            else if (rValue == "plaid") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_plaid; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "smCheck") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_smCheck; }
            else if (rValue == "smGrid") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_smGrid; }
            else if (rValue == "smConfetti") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_smConfetti; }
            else if (rValue == "solidDmnd") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_solidDmnd; }
            else if (rValue == "sphere") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_sphere; }
            else if (rValue == "shingle") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_shingle; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "trellis") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_trellis; }
            else { return false; }
            return true;
        case 'u':
            if (rValue == "upDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_upDiag; }
            else { return false; }
            return true;
        case 'v':
            if (rValue == "vert") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_vert; }
            else { return false; }
            return true;
        case 'w':
            if (rValue == "wdDnDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_wdDnDiag; }
            else if (rValue == "wdUpDiag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_wdUpDiag; }
            else if (rValue == "weave") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_weave; }
            else if (rValue == "wave") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_wave; }
            else { return false; }
            return true;
        case 'z':
            if (rValue == "zigZag") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetPatternVal_zigZag; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeEffects|DEFINE_ST_BlendMode:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'd':
            if (rValue == "darken") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlendMode_darken; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "lighten") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlendMode_lighten; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "mult") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlendMode_mult; }
            else { return false; }
            return true;
        case 'o':
            if (rValue == "over") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlendMode_over; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "screen") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_BlendMode_screen; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeEffects|DEFINE_ST_EffectContainerType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 's':
            if (rValue == "sib") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_EffectContainerType_sib; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "tree") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_EffectContainerType_tree; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_shapeEffects::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_shapeEffects|DEFINE_CT_AlphaInverseEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_ColorChangeEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_clrFrom: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_clrTo: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_ColorReplaceEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_DuotoneEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_GlowEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_InnerShadowEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_OuterShadowEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_PresetShadowEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_PathShadeProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_fillToRect: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_RelativeRect; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_EG_ShadeProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_lin: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_LinearShadeProperties; break;
        case oox::NMSP_dml|oox::XML_path: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_PathShadeProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_GradientStop:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hslClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_HslColor; break;
        case oox::NMSP_dml|oox::XML_prstClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_PresetColor; break;
        case oox::NMSP_dml|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_dml|oox::XML_scrgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_ScRgbColor; break;
        case oox::NMSP_dml|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SRgbColor; break;
        case oox::NMSP_dml|oox::XML_sysClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_SystemColor; break;
        case oox::NMSP_w14|oox::XML_schemeClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SchemeColor; break;
        case oox::NMSP_w14|oox::XML_srgbClr: rOutResource = ResourceType::Properties; rOutElement = NN_w14|DEFINE_CT_SRgbColor; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_GradientStopList:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_gs: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientStop; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_gsLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientStopList; break;
        case oox::NMSP_dml|oox::XML_lin: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_LinearShadeProperties; break;
        case oox::NMSP_dml|oox::XML_path: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_PathShadeProperties; break;
        case oox::NMSP_dml|oox::XML_tileRect: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_RelativeRect; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_StretchInfoProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_fillRect: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_RelativeRect; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_EG_FillModeProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_stretch: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_StretchInfoProperties; break;
        case oox::NMSP_dml|oox::XML_tile: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_TileInfoProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blip: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_Blip; break;
        case oox::NMSP_dml|oox::XML_srcRect: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_RelativeRect; break;
        case oox::NMSP_dml|oox::XML_stretch: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_StretchInfoProperties; break;
        case oox::NMSP_dml|oox::XML_tile: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_TileInfoProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_PatternFillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_bgClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        case oox::NMSP_dml|oox::XML_fgClr: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseTypes|DEFINE_CT_Color; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_EG_FillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_FillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_FillEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_FillOverlayEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blipFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties; break;
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_EG_Effect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_cont: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_EffectContainer:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_cont: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_AlphaModulateEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_cont: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_BlendEffect:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_cont: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_EG_EffectProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_effectDag: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_CT_EffectProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_effectDag: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_EffectContainer; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeEffects|DEFINE_blip:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_blip: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_Blip; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_shapeEffects::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_shapeEffects::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_shapeEffects|DEFINE_CT_AlphaInverseEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_ColorReplaceEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_DuotoneEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_GlowEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_InnerShadowEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_OuterShadowEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_PresetShadowEffect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_GradientStop:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hslClr: return NS_ooxml::LN_EG_ColorChoice_hslClr;
        case oox::NMSP_dml|oox::XML_prstClr: return NS_ooxml::LN_EG_ColorChoice_prstClr;
        case oox::NMSP_dml|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_dml|oox::XML_scrgbClr: return NS_ooxml::LN_EG_ColorChoice_scrgbClr;
        case oox::NMSP_dml|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::NMSP_dml|oox::XML_sysClr: return NS_ooxml::LN_EG_ColorChoice_sysClr;
        case oox::NMSP_w14|oox::XML_schemeClr: return NS_ooxml::LN_EG_ColorChoice_schemeClr;
        case oox::NMSP_w14|oox::XML_srgbClr: return NS_ooxml::LN_EG_ColorChoice_srgbClr;
        case oox::XML_pos: return NS_ooxml::LN_CT_GradientStop_pos;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_lin: return NS_ooxml::LN_EG_ShadeProperties_lin;
        case oox::NMSP_w14|oox::XML_path: return NS_ooxml::LN_EG_ShadeProperties_path;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_TileInfoProperties:
        switch (nToken)
        {
        case oox::XML_algn: return NS_ooxml::LN_CT_TileInfoProperties_algn;
        case oox::XML_flip: return NS_ooxml::LN_CT_TileInfoProperties_flip;
        case oox::XML_sx: return NS_ooxml::LN_CT_TileInfoProperties_sx;
        case oox::XML_sy: return NS_ooxml::LN_CT_TileInfoProperties_sy;
        case oox::XML_tx: return NS_ooxml::LN_CT_TileInfoProperties_tx;
        case oox::XML_ty: return NS_ooxml::LN_CT_TileInfoProperties_ty;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_StretchInfoProperties:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_fillRect: return NS_ooxml::LN_CT_StretchInfoProperties_fillRect;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_EG_FillModeProperties:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_stretch: return NS_ooxml::LN_EG_FillModeProperties_stretch;
        case oox::NMSP_dml|oox::XML_tile: return NS_ooxml::LN_EG_FillModeProperties_tile;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_Blip:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_alphaBiLevel: return NS_ooxml::LN_CT_Blip_alphaBiLevel;
        case oox::NMSP_dml|oox::XML_alphaCeiling: return NS_ooxml::LN_CT_Blip_alphaCeiling;
        case oox::NMSP_dml|oox::XML_alphaFloor: return NS_ooxml::LN_CT_Blip_alphaFloor;
        case oox::NMSP_dml|oox::XML_alphaInv: return NS_ooxml::LN_CT_Blip_alphaInv;
        case oox::NMSP_dml|oox::XML_alphaMod: return NS_ooxml::LN_CT_Blip_alphaMod;
        case oox::NMSP_dml|oox::XML_alphaModFix: return NS_ooxml::LN_CT_Blip_alphaModFix;
        case oox::NMSP_dml|oox::XML_alphaRepl: return NS_ooxml::LN_CT_Blip_alphaRepl;
        case oox::NMSP_dml|oox::XML_biLevel: return NS_ooxml::LN_CT_Blip_biLevel;
        case oox::NMSP_dml|oox::XML_blur: return NS_ooxml::LN_CT_Blip_blur;
        case oox::NMSP_dml|oox::XML_clrChange: return NS_ooxml::LN_CT_Blip_clrChange;
        case oox::NMSP_dml|oox::XML_clrRepl: return NS_ooxml::LN_CT_Blip_clrRepl;
        case oox::NMSP_dml|oox::XML_duotone: return NS_ooxml::LN_CT_Blip_duotone;
        case oox::NMSP_dml|oox::XML_extLst: return NS_ooxml::LN_CT_Blip_extLst;
        case oox::NMSP_dml|oox::XML_fillOverlay: return NS_ooxml::LN_CT_Blip_fillOverlay;
        case oox::NMSP_dml|oox::XML_grayscl: return NS_ooxml::LN_CT_Blip_grayscl;
        case oox::NMSP_dml|oox::XML_hsl: return NS_ooxml::LN_CT_Blip_hsl;
        case oox::NMSP_dml|oox::XML_lum: return NS_ooxml::LN_CT_Blip_lum;
        case oox::NMSP_dml|oox::XML_tint: return NS_ooxml::LN_CT_Blip_tint;
        case oox::NMSP_officeRel|oox::XML_embed: return NS_ooxml::LN_AG_Blob_r_embed;
        case oox::NMSP_officeRel|oox::XML_link: return NS_ooxml::LN_AG_Blob_r_link;
        case oox::XML_cstate: return NS_ooxml::LN_CT_Blip_cstate;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_BlipFillProperties:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_blip: return NS_ooxml::LN_CT_BlipFillProperties_blip;
        case oox::NMSP_dml|oox::XML_srcRect: return NS_ooxml::LN_CT_BlipFillProperties_srcRect;
        case oox::NMSP_dml|oox::XML_stretch: return NS_ooxml::LN_EG_FillModeProperties_stretch;
        case oox::NMSP_dml|oox::XML_tile: return NS_ooxml::LN_EG_FillModeProperties_tile;
        case oox::XML_dpi: return NS_ooxml::LN_CT_BlipFillProperties_dpi;
        case oox::XML_rotWithShape: return NS_ooxml::LN_CT_BlipFillProperties_rotWithShape;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_FillProperties:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_gradFill: return NS_ooxml::LN_EG_FillProperties_gradFill;
        case oox::NMSP_w14|oox::XML_noFill: return NS_ooxml::LN_EG_FillProperties_noFill;
        case oox::NMSP_w14|oox::XML_solidFill: return NS_ooxml::LN_EG_FillProperties_solidFill;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_FillEffect:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_gradFill: return NS_ooxml::LN_EG_FillProperties_gradFill;
        case oox::NMSP_w14|oox::XML_noFill: return NS_ooxml::LN_EG_FillProperties_noFill;
        case oox::NMSP_w14|oox::XML_solidFill: return NS_ooxml::LN_EG_FillProperties_solidFill;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_FillOverlayEffect:
        switch (nToken)
        {
        case oox::NMSP_w14|oox::XML_gradFill: return NS_ooxml::LN_EG_FillProperties_gradFill;
        case oox::NMSP_w14|oox::XML_noFill: return NS_ooxml::LN_EG_FillProperties_noFill;
        case oox::NMSP_w14|oox::XML_solidFill: return NS_ooxml::LN_EG_FillProperties_solidFill;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_EG_Effect:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_alphaBiLevel: return NS_ooxml::LN_EG_Effect_alphaBiLevel;
        case oox::NMSP_dml|oox::XML_alphaCeiling: return NS_ooxml::LN_EG_Effect_alphaCeiling;
        case oox::NMSP_dml|oox::XML_alphaFloor: return NS_ooxml::LN_EG_Effect_alphaFloor;
        case oox::NMSP_dml|oox::XML_alphaInv: return NS_ooxml::LN_EG_Effect_alphaInv;
        case oox::NMSP_dml|oox::XML_alphaMod: return NS_ooxml::LN_EG_Effect_alphaMod;
        case oox::NMSP_dml|oox::XML_alphaModFix: return NS_ooxml::LN_EG_Effect_alphaModFix;
        case oox::NMSP_dml|oox::XML_alphaOutset: return NS_ooxml::LN_EG_Effect_alphaOutset;
        case oox::NMSP_dml|oox::XML_alphaRepl: return NS_ooxml::LN_EG_Effect_alphaRepl;
        case oox::NMSP_dml|oox::XML_biLevel: return NS_ooxml::LN_EG_Effect_biLevel;
        case oox::NMSP_dml|oox::XML_blend: return NS_ooxml::LN_EG_Effect_blend;
        case oox::NMSP_dml|oox::XML_blur: return NS_ooxml::LN_EG_Effect_blur;
        case oox::NMSP_dml|oox::XML_clrChange: return NS_ooxml::LN_EG_Effect_clrChange;
        case oox::NMSP_dml|oox::XML_clrRepl: return NS_ooxml::LN_EG_Effect_clrRepl;
        case oox::NMSP_dml|oox::XML_cont: return NS_ooxml::LN_EG_Effect_cont;
        case oox::NMSP_dml|oox::XML_duotone: return NS_ooxml::LN_EG_Effect_duotone;
        case oox::NMSP_dml|oox::XML_effect: return NS_ooxml::LN_EG_Effect_effect;
        case oox::NMSP_dml|oox::XML_fill: return NS_ooxml::LN_EG_Effect_fill;
        case oox::NMSP_dml|oox::XML_fillOverlay: return NS_ooxml::LN_EG_Effect_fillOverlay;
        case oox::NMSP_dml|oox::XML_glow: return NS_ooxml::LN_EG_Effect_glow;
        case oox::NMSP_dml|oox::XML_grayscl: return NS_ooxml::LN_EG_Effect_grayscl;
        case oox::NMSP_dml|oox::XML_hsl: return NS_ooxml::LN_EG_Effect_hsl;
        case oox::NMSP_dml|oox::XML_innerShdw: return NS_ooxml::LN_EG_Effect_innerShdw;
        case oox::NMSP_dml|oox::XML_lum: return NS_ooxml::LN_EG_Effect_lum;
        case oox::NMSP_dml|oox::XML_outerShdw: return NS_ooxml::LN_EG_Effect_outerShdw;
        case oox::NMSP_dml|oox::XML_prstShdw: return NS_ooxml::LN_EG_Effect_prstShdw;
        case oox::NMSP_dml|oox::XML_reflection: return NS_ooxml::LN_EG_Effect_reflection;
        case oox::NMSP_dml|oox::XML_relOff: return NS_ooxml::LN_EG_Effect_relOff;
        case oox::NMSP_dml|oox::XML_softEdge: return NS_ooxml::LN_EG_Effect_softEdge;
        case oox::NMSP_dml|oox::XML_tint: return NS_ooxml::LN_EG_Effect_tint;
        case oox::NMSP_dml|oox::XML_xfrm: return NS_ooxml::LN_EG_Effect_xfrm;
        }
        break;
    case NN_dml_shapeEffects|DEFINE_CT_EffectContainer:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_alphaBiLevel: return NS_ooxml::LN_EG_Effect_alphaBiLevel;
        case oox::NMSP_dml|oox::XML_alphaCeiling: return NS_ooxml::LN_EG_Effect_alphaCeiling;
        case oox::NMSP_dml|oox::XML_alphaFloor: return NS_ooxml::LN_EG_Effect_alphaFloor;
        case oox::NMSP_dml|oox::XML_alphaInv: return NS_ooxml::LN_EG_Effect_alphaInv;
        case oox::NMSP_dml|oox::XML_alphaMod: return NS_ooxml::LN_EG_Effect_alphaMod;
        case oox::NMSP_dml|oox::XML_alphaModFix: return NS_ooxml::LN_EG_Effect_alphaModFix;
        case oox::NMSP_dml|oox::XML_alphaOutset: return NS_ooxml::LN_EG_Effect_alphaOutset;
        case oox::NMSP_dml|oox::XML_alphaRepl: return NS_ooxml::LN_EG_Effect_alphaRepl;
        case oox::NMSP_dml|oox::XML_biLevel: return NS_ooxml::LN_EG_Effect_biLevel;
        case oox::NMSP_dml|oox::XML_blend: return NS_ooxml::LN_EG_Effect_blend;
        case oox::NMSP_dml|oox::XML_blur: return NS_ooxml::LN_EG_Effect_blur;
        case oox::NMSP_dml|oox::XML_clrChange: return NS_ooxml::LN_EG_Effect_clrChange;
        case oox::NMSP_dml|oox::XML_clrRepl: return NS_ooxml::LN_EG_Effect_clrRepl;
        case oox::NMSP_dml|oox::XML_cont: return NS_ooxml::LN_EG_Effect_cont;
        case oox::NMSP_dml|oox::XML_duotone: return NS_ooxml::LN_EG_Effect_duotone;
        case oox::NMSP_dml|oox::XML_effect: return NS_ooxml::LN_EG_Effect_effect;
        case oox::NMSP_dml|oox::XML_fill: return NS_ooxml::LN_EG_Effect_fill;
        case oox::NMSP_dml|oox::XML_fillOverlay: return NS_ooxml::LN_EG_Effect_fillOverlay;
        case oox::NMSP_dml|oox::XML_glow: return NS_ooxml::LN_EG_Effect_glow;
        case oox::NMSP_dml|oox::XML_grayscl: return NS_ooxml::LN_EG_Effect_grayscl;
        case oox::NMSP_dml|oox::XML_hsl: return NS_ooxml::LN_EG_Effect_hsl;
        case oox::NMSP_dml|oox::XML_innerShdw: return NS_ooxml::LN_EG_Effect_innerShdw;
        case oox::NMSP_dml|oox::XML_lum: return NS_ooxml::LN_EG_Effect_lum;
        case oox::NMSP_dml|oox::XML_outerShdw: return NS_ooxml::LN_EG_Effect_outerShdw;
        case oox::NMSP_dml|oox::XML_prstShdw: return NS_ooxml::LN_EG_Effect_prstShdw;
        case oox::NMSP_dml|oox::XML_reflection: return NS_ooxml::LN_EG_Effect_reflection;
        case oox::NMSP_dml|oox::XML_relOff: return NS_ooxml::LN_EG_Effect_relOff;
        case oox::NMSP_dml|oox::XML_softEdge: return NS_ooxml::LN_EG_Effect_softEdge;
        case oox::NMSP_dml|oox::XML_tint: return NS_ooxml::LN_EG_Effect_tint;
        case oox::NMSP_dml|oox::XML_xfrm: return NS_ooxml::LN_EG_Effect_xfrm;
        case oox::XML_name: return NS_ooxml::LN_CT_EffectContainer_name;
        case oox::XML_type: return NS_ooxml::LN_CT_EffectContainer_type;
        }
        break;
    default:
        switch (nToken)
        {
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_shapeEffects::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
