
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-shapeGeometry.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_shapeGeometry> OOXMLFactory_dml_shapeGeometry_Mutex;

OOXMLFactory_dml_shapeGeometry::OOXMLFactory_dml_shapeGeometry()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_shapeGeometry_Mutex::get());
}

OOXMLFactory_dml_shapeGeometry::~OOXMLFactory_dml_shapeGeometry()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shapeGeometry::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shapeGeometry::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_shapeGeometry();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_shapeGeometry::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_shapeGeometry|DEFINE_CT_GeomGuide:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, NN_dml_shapeGeometry|DEFINE_ST_GeomGuideName },
                { oox::XML_fmla, ResourceType::String, NN_dml_shapeGeometry|DEFINE_ST_GeomGuideFormula },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_XYAdjustHandle:
        {
            const static AttributeInfo info[] = {
                { oox::XML_gdRefX, ResourceType::String, NN_dml_shapeGeometry|DEFINE_ST_GeomGuideName },
                { oox::XML_gdRefY, ResourceType::String, NN_dml_shapeGeometry|DEFINE_ST_GeomGuideName },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_PolarAdjustHandle:
        {
            const static AttributeInfo info[] = {
                { oox::XML_gdRefR, ResourceType::String, NN_dml_shapeGeometry|DEFINE_ST_GeomGuideName },
                { oox::XML_gdRefAng, ResourceType::String, NN_dml_shapeGeometry|DEFINE_ST_GeomGuideName },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_Connection:
        {
            const static AttributeInfo info[] = {
                { oox::XML_idx, ResourceType::Integer, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_Path2D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_fill, ResourceType::List, NN_dml_shapeGeometry|DEFINE_ST_PathFillMode },
                { oox::XML_stroke, ResourceType::Boolean, 0 },
                { oox::XML_extrusionOk, ResourceType::Boolean, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_PresetGeometry2D:
        {
            const static AttributeInfo info[] = {
                { oox::XML_prst, ResourceType::List, NN_dml_shapeGeometry|DEFINE_ST_ShapeType },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_PresetTextShape:
        {
            const static AttributeInfo info[] = {
                { oox::XML_prst, ResourceType::List, NN_dml_shapeGeometry|DEFINE_ST_TextShapeType },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_shapeGeometry::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_dml_shapeGeometry|DEFINE_ST_ShapeType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'a':
            if (rValue == "arc") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_arc; }
            else if (rValue == "accentCallout1") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_accentCallout1; }
            else if (rValue == "accentCallout2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_accentCallout2; }
            else if (rValue == "accentCallout3") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_accentCallout3; }
            else if (rValue == "accentBorderCallout1") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_accentBorderCallout1; }
            else if (rValue == "accentBorderCallout2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_accentBorderCallout2; }
            else if (rValue == "accentBorderCallout3") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_accentBorderCallout3; }
            else if (rValue == "actionButtonBlank") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonBlank; }
            else if (rValue == "actionButtonHome") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonHome; }
            else if (rValue == "actionButtonHelp") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonHelp; }
            else if (rValue == "actionButtonInformation") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonInformation; }
            else if (rValue == "actionButtonForwardNext") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonForwardNext; }
            else if (rValue == "actionButtonBackPrevious") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonBackPrevious; }
            else if (rValue == "actionButtonEnd") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonEnd; }
            else if (rValue == "actionButtonBeginning") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonBeginning; }
            else if (rValue == "actionButtonReturn") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonReturn; }
            else if (rValue == "actionButtonDocument") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonDocument; }
            else if (rValue == "actionButtonSound") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonSound; }
            else if (rValue == "actionButtonMovie") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_actionButtonMovie; }
            else { return false; }
            return true;
        case 'b':
            if (rValue == "blockArc") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_blockArc; }
            else if (rValue == "bentUpArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bentUpArrow; }
            else if (rValue == "bentArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bentArrow; }
            else if (rValue == "bevel") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bevel; }
            else if (rValue == "bracketPair") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bracketPair; }
            else if (rValue == "bracePair") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bracePair; }
            else if (rValue == "bentConnector2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bentConnector2; }
            else if (rValue == "bentConnector3") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bentConnector3; }
            else if (rValue == "bentConnector4") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bentConnector4; }
            else if (rValue == "bentConnector5") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_bentConnector5; }
            else if (rValue == "borderCallout1") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_borderCallout1; }
            else if (rValue == "borderCallout2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_borderCallout2; }
            else if (rValue == "borderCallout3") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_borderCallout3; }
            else { return false; }
            return true;
        case 'c':
            if (rValue == "chevron") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_chevron; }
            else if (rValue == "circularArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_circularArrow; }
            else if (rValue == "curvedRightArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedRightArrow; }
            else if (rValue == "curvedLeftArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedLeftArrow; }
            else if (rValue == "curvedUpArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedUpArrow; }
            else if (rValue == "curvedDownArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedDownArrow; }
            else if (rValue == "cube") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_cube; }
            else if (rValue == "can") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_can; }
            else if (rValue == "corner") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_corner; }
            else if (rValue == "chord") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_chord; }
            else if (rValue == "curvedConnector2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedConnector2; }
            else if (rValue == "curvedConnector3") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedConnector3; }
            else if (rValue == "curvedConnector4") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedConnector4; }
            else if (rValue == "curvedConnector5") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_curvedConnector5; }
            else if (rValue == "callout1") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_callout1; }
            else if (rValue == "callout2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_callout2; }
            else if (rValue == "callout3") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_callout3; }
            else if (rValue == "cloudCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_cloudCallout; }
            else if (rValue == "cloud") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_cloud; }
            else if (rValue == "cornerTabs") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_cornerTabs; }
            else if (rValue == "chartX") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_chartX; }
            else if (rValue == "chartStar") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_chartStar; }
            else if (rValue == "chartPlus") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_chartPlus; }
            else { return false; }
            return true;
        case 'd':
            if (rValue == "diamond") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_diamond; }
            else if (rValue == "decagon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_decagon; }
            else if (rValue == "dodecagon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_dodecagon; }
            else if (rValue == "donut") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_donut; }
            else if (rValue == "downArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_downArrow; }
            else if (rValue == "downArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_downArrowCallout; }
            else if (rValue == "diagStripe") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_diagStripe; }
            else if (rValue == "doubleWave") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_doubleWave; }
            else { return false; }
            return true;
        case 'e':
            if (rValue == "ellipse") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_ellipse; }
            else if (rValue == "ellipseRibbon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_ellipseRibbon; }
            else if (rValue == "ellipseRibbon2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_ellipseRibbon2; }
            else { return false; }
            return true;
        case 'f':
            if (rValue == "foldedCorner") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_foldedCorner; }
            else if (rValue == "frame") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_frame; }
            else if (rValue == "flowChartProcess") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartProcess; }
            else if (rValue == "flowChartDecision") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartDecision; }
            else if (rValue == "flowChartInputOutput") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartInputOutput; }
            else if (rValue == "flowChartPredefinedProcess") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartPredefinedProcess; }
            else if (rValue == "flowChartInternalStorage") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartInternalStorage; }
            else if (rValue == "flowChartDocument") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartDocument; }
            else if (rValue == "flowChartMultidocument") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartMultidocument; }
            else if (rValue == "flowChartTerminator") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartTerminator; }
            else if (rValue == "flowChartPreparation") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartPreparation; }
            else if (rValue == "flowChartManualInput") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartManualInput; }
            else if (rValue == "flowChartManualOperation") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartManualOperation; }
            else if (rValue == "flowChartConnector") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartConnector; }
            else if (rValue == "flowChartPunchedCard") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartPunchedCard; }
            else if (rValue == "flowChartPunchedTape") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartPunchedTape; }
            else if (rValue == "flowChartSummingJunction") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartSummingJunction; }
            else if (rValue == "flowChartOr") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartOr; }
            else if (rValue == "flowChartCollate") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartCollate; }
            else if (rValue == "flowChartSort") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartSort; }
            else if (rValue == "flowChartExtract") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartExtract; }
            else if (rValue == "flowChartMerge") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartMerge; }
            else if (rValue == "flowChartOfflineStorage") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartOfflineStorage; }
            else if (rValue == "flowChartOnlineStorage") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartOnlineStorage; }
            else if (rValue == "flowChartMagneticTape") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartMagneticTape; }
            else if (rValue == "flowChartMagneticDisk") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartMagneticDisk; }
            else if (rValue == "flowChartMagneticDrum") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartMagneticDrum; }
            else if (rValue == "flowChartDisplay") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartDisplay; }
            else if (rValue == "flowChartDelay") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartDelay; }
            else if (rValue == "flowChartAlternateProcess") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartAlternateProcess; }
            else if (rValue == "flowChartOffpageConnector") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_flowChartOffpageConnector; }
            else if (rValue == "funnel") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_funnel; }
            else { return false; }
            return true;
        case 'g':
            if (rValue == "gear6") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_gear6; }
            else if (rValue == "gear9") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_gear9; }
            else { return false; }
            return true;
        case 'h':
            if (rValue == "hexagon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_hexagon; }
            else if (rValue == "heptagon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_heptagon; }
            else if (rValue == "homePlate") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_homePlate; }
            else if (rValue == "heart") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_heart; }
            else if (rValue == "halfFrame") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_halfFrame; }
            else if (rValue == "horizontalScroll") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_horizontalScroll; }
            else { return false; }
            return true;
        case 'i':
            if (rValue == "irregularSeal1") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_irregularSeal1; }
            else if (rValue == "irregularSeal2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_irregularSeal2; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "line") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_line; }
            else if (rValue == "lineInv") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_lineInv; }
            else if (rValue == "leftArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftArrow; }
            else if (rValue == "leftRightArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftRightArrow; }
            else if (rValue == "leftUpArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftUpArrow; }
            else if (rValue == "leftRightUpArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftRightUpArrow; }
            else if (rValue == "leftArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftArrowCallout; }
            else if (rValue == "leftRightArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftRightArrowCallout; }
            else if (rValue == "leftCircularArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftCircularArrow; }
            else if (rValue == "leftRightCircularArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftRightCircularArrow; }
            else if (rValue == "lightningBolt") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_lightningBolt; }
            else if (rValue == "leftBracket") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftBracket; }
            else if (rValue == "leftBrace") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftBrace; }
            else if (rValue == "leftRightRibbon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_leftRightRibbon; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "moon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_moon; }
            else if (rValue == "mathPlus") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_mathPlus; }
            else if (rValue == "mathMinus") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_mathMinus; }
            else if (rValue == "mathMultiply") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_mathMultiply; }
            else if (rValue == "mathDivide") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_mathDivide; }
            else if (rValue == "mathEqual") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_mathEqual; }
            else if (rValue == "mathNotEqual") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_mathNotEqual; }
            else { return false; }
            return true;
        case 'n':
            if (rValue == "nonIsoscelesTrapezoid") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_nonIsoscelesTrapezoid; }
            else if (rValue == "noSmoking") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_noSmoking; }
            else if (rValue == "notchedRightArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_notchedRightArrow; }
            else { return false; }
            return true;
        case 'o':
            if (rValue == "octagon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_octagon; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "parallelogram") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_parallelogram; }
            else if (rValue == "pentagon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_pentagon; }
            else if (rValue == "plaque") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_plaque; }
            else if (rValue == "pieWedge") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_pieWedge; }
            else if (rValue == "pie") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_pie; }
            else if (rValue == "plus") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_plus; }
            else if (rValue == "plaqueTabs") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_plaqueTabs; }
            else { return false; }
            return true;
        case 'q':
            if (rValue == "quadArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_quadArrow; }
            else if (rValue == "quadArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_quadArrowCallout; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "rtTriangle") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_rtTriangle; }
            else if (rValue == "rect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_rect; }
            else if (rValue == "roundRect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_roundRect; }
            else if (rValue == "round1Rect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_round1Rect; }
            else if (rValue == "round2SameRect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_round2SameRect; }
            else if (rValue == "round2DiagRect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_round2DiagRect; }
            else if (rValue == "rightArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_rightArrow; }
            else if (rValue == "rightArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_rightArrowCallout; }
            else if (rValue == "rightBracket") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_rightBracket; }
            else if (rValue == "rightBrace") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_rightBrace; }
            else if (rValue == "ribbon") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_ribbon; }
            else if (rValue == "ribbon2") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_ribbon2; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "star4") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star4; }
            else if (rValue == "star5") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star5; }
            else if (rValue == "star6") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star6; }
            else if (rValue == "star7") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star7; }
            else if (rValue == "star8") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star8; }
            else if (rValue == "star10") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star10; }
            else if (rValue == "star12") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star12; }
            else if (rValue == "star16") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star16; }
            else if (rValue == "star24") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star24; }
            else if (rValue == "star32") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_star32; }
            else if (rValue == "snipRoundRect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_snipRoundRect; }
            else if (rValue == "snip1Rect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_snip1Rect; }
            else if (rValue == "snip2SameRect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_snip2SameRect; }
            else if (rValue == "snip2DiagRect") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_snip2DiagRect; }
            else if (rValue == "stripedRightArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_stripedRightArrow; }
            else if (rValue == "swooshArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_swooshArrow; }
            else if (rValue == "sun") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_sun; }
            else if (rValue == "smileyFace") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_smileyFace; }
            else if (rValue == "straightConnector1") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_straightConnector1; }
            else if (rValue == "squareTabs") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_squareTabs; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "triangle") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_triangle; }
            else if (rValue == "trapezoid") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_trapezoid; }
            else if (rValue == "teardrop") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_teardrop; }
            else { return false; }
            return true;
        case 'u':
            if (rValue == "upArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_upArrow; }
            else if (rValue == "upDownArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_upDownArrow; }
            else if (rValue == "upArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_upArrowCallout; }
            else if (rValue == "upDownArrowCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_upDownArrowCallout; }
            else if (rValue == "uturnArrow") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_uturnArrow; }
            else { return false; }
            return true;
        case 'v':
            if (rValue == "verticalScroll") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_verticalScroll; }
            else { return false; }
            return true;
        case 'w':
            if (rValue == "wedgeRectCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_wedgeRectCallout; }
            else if (rValue == "wedgeRoundRectCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_wedgeRoundRectCallout; }
            else if (rValue == "wedgeEllipseCallout") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_wedgeEllipseCallout; }
            else if (rValue == "wave") { rOutValue = NS_ooxml::LN_Value_ST_ShapeType_wave; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeGeometry|DEFINE_ST_TextShapeType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 't':
            if (rValue == "textNoShape") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textNoShape; }
            else if (rValue == "textPlain") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textPlain; }
            else if (rValue == "textStop") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textStop; }
            else if (rValue == "textTriangle") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textTriangle; }
            else if (rValue == "textTriangleInverted") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textTriangleInverted; }
            else if (rValue == "textChevron") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textChevron; }
            else if (rValue == "textChevronInverted") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textChevronInverted; }
            else if (rValue == "textRingInside") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textRingInside; }
            else if (rValue == "textRingOutside") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textRingOutside; }
            else if (rValue == "textArchUp") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textArchUp; }
            else if (rValue == "textArchDown") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textArchDown; }
            else if (rValue == "textCircle") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCircle; }
            else if (rValue == "textButton") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textButton; }
            else if (rValue == "textArchUpPour") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textArchUpPour; }
            else if (rValue == "textArchDownPour") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textArchDownPour; }
            else if (rValue == "textCirclePour") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCirclePour; }
            else if (rValue == "textButtonPour") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textButtonPour; }
            else if (rValue == "textCurveUp") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCurveUp; }
            else if (rValue == "textCurveDown") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCurveDown; }
            else if (rValue == "textCanUp") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCanUp; }
            else if (rValue == "textCanDown") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCanDown; }
            else if (rValue == "textWave1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textWave1; }
            else if (rValue == "textWave2") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textWave2; }
            else if (rValue == "textDoubleWave1") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textDoubleWave1; }
            else if (rValue == "textWave4") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textWave4; }
            else if (rValue == "textInflate") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textInflate; }
            else if (rValue == "textDeflate") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textDeflate; }
            else if (rValue == "textInflateBottom") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textInflateBottom; }
            else if (rValue == "textDeflateBottom") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textDeflateBottom; }
            else if (rValue == "textInflateTop") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textInflateTop; }
            else if (rValue == "textDeflateTop") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textDeflateTop; }
            else if (rValue == "textDeflateInflate") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textDeflateInflate; }
            else if (rValue == "textDeflateInflateDeflate") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textDeflateInflateDeflate; }
            else if (rValue == "textFadeRight") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textFadeRight; }
            else if (rValue == "textFadeLeft") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textFadeLeft; }
            else if (rValue == "textFadeUp") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textFadeUp; }
            else if (rValue == "textFadeDown") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textFadeDown; }
            else if (rValue == "textSlantUp") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textSlantUp; }
            else if (rValue == "textSlantDown") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textSlantDown; }
            else if (rValue == "textCascadeUp") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCascadeUp; }
            else if (rValue == "textCascadeDown") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_TextShapeType_textCascadeDown; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeGeometry|DEFINE_ST_PathFillMode:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'd':
            if (rValue == "darken") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathFillMode_darken; }
            else if (rValue == "darkenLess") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathFillMode_darkenLess; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "lighten") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathFillMode_lighten; }
            else if (rValue == "lightenLess") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathFillMode_lightenLess; }
            else { return false; }
            return true;
        case 'n':
            if (rValue == "none") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathFillMode_none; }
            else if (rValue == "norm") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PathFillMode_norm; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_shapeGeometry::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_shapeGeometry|DEFINE_CT_PresetGeometry2D:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_avLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_GeomGuideList; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeGeometry|DEFINE_CT_PresetTextShape:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_avLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_GeomGuideList; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeGeometry|DEFINE_CT_CustomGeometry2D:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_avLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_GeomGuideList; break;
        case oox::NMSP_dml|oox::XML_gdLst: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_GeomGuideList; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeGeometry|DEFINE_EG_Geometry:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_custGeom: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_CustomGeometry2D; break;
        case oox::NMSP_dml|oox::XML_prstGeom: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_PresetGeometry2D; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeGeometry|DEFINE_EG_TextGeometry:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_custGeom: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeGeometry|DEFINE_CT_CustomGeometry2D; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_shapeGeometry::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_shapeGeometry::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_shapeGeometry|DEFINE_CT_GeomGuideList:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_gd: return NS_ooxml::LN_CT_GeomGuideList_gd;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_PresetGeometry2D:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_avLst: return NS_ooxml::LN_CT_PresetGeometry2D_avLst;
        case oox::XML_prst: return NS_ooxml::LN_CT_PresetGeometry2D_prst;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_CT_CustomGeometry2D:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_ahLst: return NS_ooxml::LN_CT_CustomGeometry2D_ahLst;
        case oox::NMSP_dml|oox::XML_avLst: return NS_ooxml::LN_CT_CustomGeometry2D_avLst;
        case oox::NMSP_dml|oox::XML_cxnLst: return NS_ooxml::LN_CT_CustomGeometry2D_cxnLst;
        case oox::NMSP_dml|oox::XML_gdLst: return NS_ooxml::LN_CT_CustomGeometry2D_gdLst;
        case oox::NMSP_dml|oox::XML_pathLst: return NS_ooxml::LN_CT_CustomGeometry2D_pathLst;
        case oox::NMSP_dml|oox::XML_rect: return NS_ooxml::LN_CT_CustomGeometry2D_rect;
        }
        break;
    case NN_dml_shapeGeometry|DEFINE_EG_Geometry:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_custGeom: return NS_ooxml::LN_EG_Geometry_custGeom;
        case oox::NMSP_dml|oox::XML_prstGeom: return NS_ooxml::LN_EG_Geometry_prstGeom;
        }
        break;
    default:
        switch (nToken)
        {
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_shapeGeometry::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
