
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-shapeLineProperties.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_shapeLineProperties> OOXMLFactory_dml_shapeLineProperties_Mutex;

OOXMLFactory_dml_shapeLineProperties::OOXMLFactory_dml_shapeLineProperties()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_shapeLineProperties_Mutex::get());
}

OOXMLFactory_dml_shapeLineProperties::~OOXMLFactory_dml_shapeLineProperties()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shapeLineProperties::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_shapeLineProperties::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_shapeLineProperties();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_shapeLineProperties::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_shapeLineProperties|DEFINE_CT_LineEndProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_type, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_LineEndType },
                { oox::XML_w, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_LineEndWidth },
                { oox::XML_len, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_LineEndLength },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeLineProperties|DEFINE_CT_PresetLineDashProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_val, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_PresetLineDashVal },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_shapeLineProperties|DEFINE_CT_LineProperties:
        {
            const static AttributeInfo info[] = {
                { oox::XML_cap, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_LineCap },
                { oox::XML_cmpd, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_CompoundLine },
                { oox::XML_algn, ResourceType::List, NN_dml_shapeLineProperties|DEFINE_ST_PenAlignment },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_shapeLineProperties::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_dml_shapeLineProperties|DEFINE_ST_LineEndType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'a':
            if (rValue == "arrow") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndType_arrow; }
            else { return false; }
            return true;
        case 'd':
            if (rValue == "diamond") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndType_diamond; }
            else { return false; }
            return true;
        case 'n':
            if (rValue == "none") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndType_none; }
            else { return false; }
            return true;
        case 'o':
            if (rValue == "oval") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndType_oval; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "stealth") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndType_stealth; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "triangle") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndType_triangle; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeLineProperties|DEFINE_ST_LineEndWidth:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'l':
            if (rValue == "lg") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndWidth_lg; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "med") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndWidth_med; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "sm") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndWidth_sm; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeLineProperties|DEFINE_ST_LineEndLength:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'l':
            if (rValue == "lg") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndLength_lg; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "med") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndLength_med; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "sm") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineEndLength_sm; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeLineProperties|DEFINE_ST_PresetLineDashVal:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'd':
            if (rValue == "dot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_dot; }
            else if (rValue == "dash") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_dash; }
            else if (rValue == "dashDot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_dashDot; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "lgDash") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_lgDash; }
            else if (rValue == "lgDashDot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_lgDashDot; }
            else if (rValue == "lgDashDotDot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_lgDashDotDot; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "solid") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_solid; }
            else if (rValue == "sysDash") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_sysDash; }
            else if (rValue == "sysDot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_sysDot; }
            else if (rValue == "sysDashDot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_sysDashDot; }
            else if (rValue == "sysDashDotDot") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PresetLineDashVal_sysDashDotDot; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeLineProperties|DEFINE_ST_LineCap:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'f':
            if (rValue == "flat") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineCap_flat; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "rnd") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineCap_rnd; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "sq") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_LineCap_sq; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeLineProperties|DEFINE_ST_PenAlignment:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'c':
            if (rValue == "ctr") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PenAlignment_ctr; }
            else { return false; }
            return true;
        case 'i':
            if (rValue == "in") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_PenAlignment_in; }
            else { return false; }
            return true;
        }
        return false;
    case NN_dml_shapeLineProperties|DEFINE_ST_CompoundLine:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'd':
            if (rValue == "dbl") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_CompoundLine_dbl; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "sng") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_CompoundLine_sng; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "thickThin") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_CompoundLine_thickThin; }
            else if (rValue == "thinThick") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_CompoundLine_thinThick; }
            else if (rValue == "tri") { rOutValue = NS_ooxml::LN_Value_drawingml_ST_CompoundLine_tri; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_shapeLineProperties::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_shapeLineProperties|DEFINE_EG_LineFillProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeLineProperties|DEFINE_EG_LineJoinProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_miter: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_LineJoinMiterProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeLineProperties|DEFINE_EG_LineDashProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_prstDash: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_PresetLineDashProperties; break;
        default: return false;
        }
        return true;
    case NN_dml_shapeLineProperties|DEFINE_CT_LineProperties:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_gradFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_GradientFillProperties; break;
        case oox::NMSP_dml|oox::XML_headEnd: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_LineEndProperties; break;
        case oox::NMSP_dml|oox::XML_miter: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_LineJoinMiterProperties; break;
        case oox::NMSP_dml|oox::XML_prstDash: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_PresetLineDashProperties; break;
        case oox::NMSP_dml|oox::XML_solidFill: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeEffects|DEFINE_CT_SolidColorFillProperties; break;
        case oox::NMSP_dml|oox::XML_tailEnd: rOutResource = ResourceType::Properties; rOutElement = NN_dml_shapeLineProperties|DEFINE_CT_LineEndProperties; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_shapeLineProperties::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_shapeLineProperties::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_shapeLineProperties|DEFINE_CT_LineEndProperties:
        switch (nToken)
        {
        case oox::XML_len: return NS_ooxml::LN_CT_LineEndProperties_len;
        case oox::XML_type: return NS_ooxml::LN_CT_LineEndProperties_type;
        case oox::XML_w: return NS_ooxml::LN_CT_LineEndProperties_w;
        }
        break;
    case NN_dml_shapeLineProperties|DEFINE_EG_LineFillProperties:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_gradFill: return NS_ooxml::LN_EG_LineFillProperties_gradFill;
        case oox::NMSP_dml|oox::XML_noFill: return NS_ooxml::LN_EG_LineFillProperties_noFill;
        case oox::NMSP_dml|oox::XML_pattFill: return NS_ooxml::LN_EG_LineFillProperties_pattFill;
        case oox::NMSP_dml|oox::XML_solidFill: return NS_ooxml::LN_EG_LineFillProperties_solidFill;
        }
        break;
    case NN_dml_shapeLineProperties|DEFINE_CT_LineProperties:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_extLst: return NS_ooxml::LN_CT_LineProperties_extLst;
        case oox::NMSP_dml|oox::XML_gradFill: return NS_ooxml::LN_EG_LineFillProperties_gradFill;
        case oox::NMSP_dml|oox::XML_headEnd: return NS_ooxml::LN_CT_LineProperties_headEnd;
        case oox::NMSP_dml|oox::XML_noFill: return NS_ooxml::LN_EG_LineFillProperties_noFill;
        case oox::NMSP_dml|oox::XML_pattFill: return NS_ooxml::LN_EG_LineFillProperties_pattFill;
        case oox::NMSP_dml|oox::XML_solidFill: return NS_ooxml::LN_EG_LineFillProperties_solidFill;
        case oox::NMSP_dml|oox::XML_tailEnd: return NS_ooxml::LN_CT_LineProperties_tailEnd;
        case oox::NMSP_w14|oox::XML_bevel: return NS_ooxml::LN_EG_LineJoinProperties_bevel;
        case oox::NMSP_w14|oox::XML_miter: return NS_ooxml::LN_EG_LineJoinProperties_miter;
        case oox::NMSP_w14|oox::XML_prstDash: return NS_ooxml::LN_EG_LineDashProperties_prstDash;
        case oox::NMSP_w14|oox::XML_round: return NS_ooxml::LN_EG_LineJoinProperties_round;
        case oox::XML_algn: return NS_ooxml::LN_CT_LineProperties_algn;
        case oox::XML_cap: return NS_ooxml::LN_CT_LineProperties_cap;
        case oox::XML_cmpd: return NS_ooxml::LN_CT_LineProperties_cmpd;
        case oox::XML_w: return NS_ooxml::LN_CT_LineProperties_w;
        }
        break;
    default:
        switch (nToken)
        {
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_shapeLineProperties::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
