
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_dml-stylesheet.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_dml_stylesheet> OOXMLFactory_dml_stylesheet_Mutex;

OOXMLFactory_dml_stylesheet::OOXMLFactory_dml_stylesheet()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_dml_stylesheet_Mutex::get());
}

OOXMLFactory_dml_stylesheet::~OOXMLFactory_dml_stylesheet()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_stylesheet::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_dml_stylesheet::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_dml_stylesheet();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_dml_stylesheet::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_dml_stylesheet|DEFINE_CT_OfficeStyleSheet:
        {
            const static AttributeInfo info[] = {
                { oox::XML_name, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_dml_stylesheet|DEFINE_CT_Hyperlink:
        {
            const static AttributeInfo info[] = {
                { oox::NMSP_officeRel|oox::XML_id, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_dml_stylesheet::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_dml_stylesheet::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_dml_stylesheet|DEFINE_CT_ColorSchemeAndMapping:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_clrScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_ColorScheme; break;
        default: return false;
        }
        return true;
    case NN_dml_stylesheet|DEFINE_CT_OfficeStyleSheet:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_themeElements: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_BaseStyles; break;
        default: return false;
        }
        return true;
    case NN_dml_stylesheet|DEFINE_CT_BaseStylesOverride:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_clrScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_ColorScheme; break;
        case oox::NMSP_dml|oox::XML_fmtScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_StyleMatrix; break;
        case oox::NMSP_dml|oox::XML_fontScheme: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_FontScheme; break;
        default: return false;
        }
        return true;
    case NN_dml_stylesheet|DEFINE_CT_ClipboardStyleSheet:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_themeElements: rOutResource = ResourceType::Properties; rOutElement = NN_dml_baseStylesheet|DEFINE_CT_BaseStyles; break;
        default: return false;
        }
        return true;
    case NN_dml_stylesheet|DEFINE_theme:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_theme: rOutResource = ResourceType::Table; rOutElement = NN_dml_stylesheet|DEFINE_CT_OfficeStyleSheet; break;
        default: return false;
        }
        return true;
    case NN_dml_stylesheet|DEFINE_hlinkClick:
        switch (nId)
        {
        case oox::NMSP_dml|oox::XML_hlinkClick: rOutResource = ResourceType::Properties; rOutElement = NN_dml_stylesheet|DEFINE_CT_Hyperlink; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        /* start: theme*/
        case oox::NMSP_dml|oox::XML_theme: rOutResource = ResourceType::Table; rOutElement = NN_dml_stylesheet|DEFINE_CT_OfficeStyleSheet; break;
        /* start: themeOverride*/
        /* start: themeManager*/
        /* start: hlinkClick*/
        case oox::NMSP_dml|oox::XML_hlinkClick: rOutResource = ResourceType::Properties; rOutElement = NN_dml_stylesheet|DEFINE_CT_Hyperlink; break;
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_dml_stylesheet::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_dml_stylesheet::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_dml_stylesheet|DEFINE_CT_Hyperlink:
        switch (nToken)
        {
        case oox::NMSP_officeRel|oox::XML_id: return NS_ooxml::LN_CT_Hyperlink_r_id;
        }
        break;
    case NN_dml_stylesheet|DEFINE_theme:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_theme: return NS_ooxml::LN_THEMETABLE;
        }
        break;
    case NN_dml_stylesheet|DEFINE_hlinkClick:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_hlinkClick: return NS_ooxml::LN_hlinkClick_hlinkClick;
        }
        break;
    default:
        switch (nToken)
        {
        case oox::NMSP_dml|oox::XML_theme: return NS_ooxml::LN_THEMETABLE;
        case oox::NMSP_dml|oox::XML_hlinkClick: return NS_ooxml::LN_hlinkClick_hlinkClick;
        }
        break;
    }
    return 0;
}

void OOXMLFactory_dml_stylesheet::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
