
#include "ooxml/resourceids.hxx"
#include "OOXMLFactory_vml-wordprocessingDrawing.hxx"
#include "ooxml/OOXMLFastHelper.hxx"
#include "oox/token/tokens.hxx"

#ifdef _MSC_VER
#pragma warning(disable:4060) // switch statement contains no 'case' or 'default' labels
#pragma warning(disable:4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable:4702) // unreachable code
#endif

namespace writerfilter {
namespace ooxml {

using namespace com::sun::star;

/// @cond GENERATED

typedef rtl::Static<osl::Mutex, OOXMLFactory_vml_wordprocessingDrawing> OOXMLFactory_vml_wordprocessingDrawing_Mutex;

OOXMLFactory_vml_wordprocessingDrawing::OOXMLFactory_vml_wordprocessingDrawing()
{
    // multi-thread-safe mutex for all platforms

    osl::MutexGuard aGuard(OOXMLFactory_vml_wordprocessingDrawing_Mutex::get());
}

OOXMLFactory_vml_wordprocessingDrawing::~OOXMLFactory_vml_wordprocessingDrawing()
{
}

OOXMLFactory_ns::Pointer_t OOXMLFactory_vml_wordprocessingDrawing::m_pInstance;

OOXMLFactory_ns::Pointer_t OOXMLFactory_vml_wordprocessingDrawing::getInstance()
{
    if (!m_pInstance)
        m_pInstance = new OOXMLFactory_vml_wordprocessingDrawing();

    return m_pInstance;
}

const AttributeInfo* OOXMLFactory_vml_wordprocessingDrawing::getAttributeInfoArray(Id nId)
{
    switch (nId)
    {
    case NN_vml_wordprocessingDrawing|DEFINE_CT_Border:
        {
            const static AttributeInfo info[] = {
                { oox::XML_type, ResourceType::String, 0 },
                { oox::XML_shadow, ResourceType::String, 0 },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    case NN_vml_wordprocessingDrawing|DEFINE_CT_Wrap:
        {
            const static AttributeInfo info[] = {
                { oox::XML_type, ResourceType::List, NN_vml_wordprocessingDrawing|DEFINE_ST_WrapType },
                { oox::XML_side, ResourceType::List, NN_vml_wordprocessingDrawing|DEFINE_ST_WrapSide },
                { oox::XML_anchorx, ResourceType::List, NN_vml_wordprocessingDrawing|DEFINE_ST_HorizontalAnchor },
                { oox::XML_anchory, ResourceType::List, NN_vml_wordprocessingDrawing|DEFINE_ST_VerticalAnchor },
                { -1, ResourceType::NoResource, 0 }
            };
            return info;
        }
        break;
    default:
        break;
    }

    return NULL;
}

bool OOXMLFactory_vml_wordprocessingDrawing::getListValue(Id nId, const OUString& rValue, sal_uInt32& rOutValue)
{
    (void) rValue;
    (void) rOutValue;

    switch (nId)
    {
    case NN_vml_wordprocessingDrawing|DEFINE_ST_WrapType:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'n':
            if (rValue == "none") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapType_none; }
            else { return false; }
            return true;
        case 's':
            if (rValue == "square") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapType_square; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "topAndBottom") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapType_topAndBottom; }
            else if (rValue == "tight") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapType_tight; }
            else if (rValue == "through") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapType_through; }
            else { return false; }
            return true;
        }
        return false;
    case NN_vml_wordprocessingDrawing|DEFINE_ST_WrapSide:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'b':
            if (rValue == "both") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapSide_both; }
            else { return false; }
            return true;
        case 'l':
            if (rValue == "left") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapSide_left; }
            else if (rValue == "largest") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapSide_largest; }
            else { return false; }
            return true;
        case 'r':
            if (rValue == "right") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_WrapSide_right; }
            else { return false; }
            return true;
        }
        return false;
    case NN_vml_wordprocessingDrawing|DEFINE_ST_HorizontalAnchor:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'c':
            if (rValue == "char") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_HorizontalAnchor_char; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "margin") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_HorizontalAnchor_margin; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "page") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_HorizontalAnchor_page; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "text") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_HorizontalAnchor_text; }
            else { return false; }
            return true;
        }
        return false;
    case NN_vml_wordprocessingDrawing|DEFINE_ST_VerticalAnchor:
        if (rValue.isEmpty())
            return false;
        switch (rValue[0])
        {
        case 'l':
            if (rValue == "line") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_VerticalAnchor_line; }
            else { return false; }
            return true;
        case 'm':
            if (rValue == "margin") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_VerticalAnchor_margin; }
            else { return false; }
            return true;
        case 'p':
            if (rValue == "page") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_VerticalAnchor_page; }
            else { return false; }
            return true;
        case 't':
            if (rValue == "text") { rOutValue = NS_ooxml::LN_Value_vml_wordprocessingDrawing_ST_VerticalAnchor_text; }
            else { return false; }
            return true;
        }
        return false;
    default:
        break;
    }

    return false;
}

bool OOXMLFactory_vml_wordprocessingDrawing::getElementId(Id nDefine, Id nId, ResourceType& rOutResource, Id& rOutElement)
{
    (void) rOutResource;
    (void) rOutElement;

    switch (nDefine)
    {
    case NN_vml_wordprocessingDrawing|DEFINE_bordertop:
        switch (nId)
        {
        case oox::NMSP_vmlWord|oox::XML_bordertop: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        default: return false;
        }
        return true;
    case NN_vml_wordprocessingDrawing|DEFINE_borderleft:
        switch (nId)
        {
        case oox::NMSP_vmlWord|oox::XML_borderleft: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        default: return false;
        }
        return true;
    case NN_vml_wordprocessingDrawing|DEFINE_borderright:
        switch (nId)
        {
        case oox::NMSP_vmlWord|oox::XML_borderright: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        default: return false;
        }
        return true;
    case NN_vml_wordprocessingDrawing|DEFINE_borderbottom:
        switch (nId)
        {
        case oox::NMSP_vmlWord|oox::XML_borderbottom: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        default: return false;
        }
        return true;
    case NN_vml_wordprocessingDrawing|DEFINE_wrap:
        switch (nId)
        {
        case oox::NMSP_vmlWord|oox::XML_wrap: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Wrap; break;
        default: return false;
        }
        return true;
    default:
        switch (nId)
        {
        /* start: bordertop*/
        case oox::NMSP_vmlWord|oox::XML_bordertop: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        /* start: borderleft*/
        case oox::NMSP_vmlWord|oox::XML_borderleft: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        /* start: borderright*/
        case oox::NMSP_vmlWord|oox::XML_borderright: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        /* start: borderbottom*/
        case oox::NMSP_vmlWord|oox::XML_borderbottom: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Border; break;
        /* start: wrap*/
        case oox::NMSP_vmlWord|oox::XML_wrap: rOutResource = ResourceType::Properties; rOutElement = NN_vml_wordprocessingDrawing|DEFINE_CT_Wrap; break;
        /* start: anchorlock*/
        default: return false;
        }
        return true;
    }
}

void OOXMLFactory_vml_wordprocessingDrawing::charactersAction(OOXMLFastContextHandler*, const OUString&)
{
}

Id OOXMLFactory_vml_wordprocessingDrawing::getResourceId(Id nDefine, sal_Int32 nToken)
{
    (void) nDefine;
    (void) nToken;

    switch (nDefine)
    {
    case NN_vml_wordprocessingDrawing|DEFINE_wrap:
        switch (nToken)
        {
        case oox::NMSP_vmlWord|oox::XML_wrap: return NS_ooxml::LN_wrap_wrap;
        }
        break;
    case NN_vml_wordprocessingDrawing|DEFINE_CT_Wrap:
        switch (nToken)
        {
        case oox::XML_anchorx: return NS_ooxml::LN_CT_Wrap_anchorx;
        case oox::XML_anchory: return NS_ooxml::LN_CT_Wrap_anchory;
        case oox::XML_side: return NS_ooxml::LN_CT_Wrap_side;
        case oox::XML_type: return NS_ooxml::LN_CT_Wrap_type;
        }
        break;
    default:
        switch (nToken)
        {
        case oox::NMSP_vmlWord|oox::XML_wrap: return NS_ooxml::LN_wrap_wrap;
        }
        break;
    }
    return 0;
}

void OOXMLFactory_vml_wordprocessingDrawing::attributeAction(OOXMLFastContextHandler*, Token_t, const OOXMLValue::Pointer_t&)
{
}

/// @endcond
}}
