/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * This file is part of the LibreOffice project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * This file incorporates work covered by the following license notice:
 *
 *   Licensed to the Apache Software Foundation (ASF) under one or more
 *   contributor license agreements. See the NOTICE file distributed
 *   with this work for additional information regarding copyright
 *   ownership. The ASF licenses this file to you under the Apache
 *   License, Version 2.0 (the "License"); you may not use this file
 *   except in compliance with the License. You may obtain a copy of
 *   the License at http://www.apache.org/licenses/LICENSE-2.0 .
 */

#ifndef INCLUDED_XMLOFF_SOURCE_TRANSFORM_ACTIONMAPTYPESOASIS_HXX
#define INCLUDED_XMLOFF_SOURCE_TRANSFORM_ACTIONMAPTYPESOASIS_HXX

enum ActionMapTypesOOo
{
    PROP_OASIS_GRAPHIC_ATTR_ACTIONS,
    PROP_OASIS_DRAWING_PAGE_ATTR_ACTIONS,
    PROP_OASIS_PAGE_LAYOUT_ATTR_ACTIONS,
    PROP_OASIS_HEADER_FOOTER_ATTR_ACTIONS,
    PROP_OASIS_TEXT_ATTR_ACTIONS,
    PROP_OASIS_PARAGRAPH_ATTR_ACTIONS,
    PROP_OASIS_SECTION_ATTR_ACTIONS,
    PROP_OASIS_TABLE_ATTR_ACTIONS,
    PROP_OASIS_TABLE_COLUMN_ATTR_ACTIONS,
    PROP_OASIS_TABLE_ROW_ATTR_ACTIONS,
    PROP_OASIS_TABLE_CELL_ATTR_ACTIONS,
    PROP_OASIS_LIST_LEVEL_ATTR_ACTIONS,
    PROP_OASIS_CHART_ATTR_ACTIONS,
    MAX_OASIS_PROP_ACTIONS,
    OASIS_STYLE_ACTIONS = MAX_OASIS_PROP_ACTIONS,
    OASIS_FONT_FACE_ACTIONS,
    OASIS_SHAPE_ACTIONS,
    OASIS_CONNECTOR_ACTIONS,
    OASIS_INDEX_ENTRY_TAB_STOP_ACTIONS,
    OASIS_TAB_STOP_ACTIONS,
    OASIS_LINENUMBERING_ACTIONS,
    OASIS_FOOTNOTE_SEP_ACTIONS,
    OASIS_DROP_CAP_ACTIONS,
    OASIS_COLUMNS_ACTIONS,
    OASIS_TEXT_VALUE_TYPE_ACTIONS,
    OASIS_TABLE_VALUE_TYPE_ACTIONS,
    OASIS_PARA_ACTIONS,
    OASIS_LIST_STYLE_REF_ACTIONS,
    OASIS_TEXT_STYLE_REF_ACTIONS,
    OASIS_PARA_STYLE_REF_ACTIONS,
    OASIS_MASTER_PAGE_REF_ACTIONS,
    OASIS_MAP_STYLE_REF_ACTIONS,
    OASIS_MASTER_PAGE_ACTIONS,
    OASIS_NOTES_ACTIONS,
    OASIS_ANNOTATION_ACTIONS,
    OASIS_CHANGE_INFO_ACTIONS,
    OASIS_FRAME_ELEM_ACTIONS,
    OASIS_BACKGROUND_IMAGE_ACTIONS,
    OASIS_DDE_CONNECTION_DECL_ACTIONS,
    OASIS_EVENT_ACTIONS,
    OASIS_DLG_ACTIONS,
    OASIS_FORM_CONTROL_ACTIONS,
    OASIS_FORM_COLUMN_ACTIONS,
    OASIS_FORM_PROP_ACTIONS,
    OASIS_XLINK_ACTIONS,
    OASIS_CONFIG_ITEM_SET_ACTIONS,
    OASIS_FORMULA_ACTIONS,
    OASIS_CHART_ACTIONS,
    OASIS_FORM_ACTIONS,
    OASIS_ALPHABETICAL_INDEX_MARK_ACTIONS,
    OASIS_CONTENT_VALIDATION_ACTIONS,
    OASIS_DDE_CONV_MODE_ACTIONS,
    OASIS_DATAPILOT_MEMBER_ACTIONS,
    OASIS_DATAPILOT_LEVEL_ACTIONS,
    OASIS_SOURCE_SERVICE_ACTIONS,
    OASIS_DRAW_AREA_POLYGON_ACTIONS,
    OASIS_SCRIPT_ACTIONS,
    OASIS_DATETIME_ACTIONS,
    OASIS_TABLE_STYLE_REF_ACTIONS,
    OASIS_ANIMATION_ACTIONS,
    MAX_OASIS_ACTIONS
};

#endif // INCLUDED_XMLOFF_SOURCE_TRANSFORM_ACTIONMAPTYPESOASIS_HXX

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
