/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * This file is part of the LibreOffice project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * This file incorporates work covered by the following license notice:
 *
 *   Licensed to the Apache Software Foundation (ASF) under one or more
 *   contributor license agreements. See the NOTICE file distributed
 *   with this work for additional information regarding copyright
 *   ownership. The ASF licenses this file to you under the Apache
 *   License, Version 2.0 (the "License"); you may not use this file
 *   except in compliance with the License. You may obtain a copy of
 *   the License at http://www.apache.org/licenses/LICENSE-2.0 .
 */

#ifndef INCLUDED_XMLOFF_SOURCE_TRANSFORM_ACTIONMAPTYPESOOO_HXX
#define INCLUDED_XMLOFF_SOURCE_TRANSFORM_ACTIONMAPTYPESOOO_HXX

enum ActionMapTypesOOo
{
    PROP_OOO_GRAPHIC_ATTR_ACTIONS,
    PROP_OOO_GRAPHIC_ELEM_ACTIONS,
    PROP_OOO_DRAWING_PAGE_ATTR_ACTIONS,
    PROP_OOO_PAGE_LAYOUT_ATTR_ACTIONS,
    PROP_OOO_HEADER_FOOTER_ATTR_ACTIONS,
    PROP_OOO_TEXT_ATTR_ACTIONS,
    PROP_OOO_TEXT_ELEM_ACTIONS,
    PROP_OOO_PARAGRAPH_ATTR_ACTIONS,
    PROP_OOO_PARAGRAPH_ELEM_ACTIONS,
    PROP_OOO_SECTION_ATTR_ACTIONS,
    PROP_OOO_TABLE_ATTR_ACTIONS,
    PROP_OOO_TABLE_COLUMN_ATTR_ACTIONS,
    PROP_OOO_TABLE_ROW_ATTR_ACTIONS,
    PROP_OOO_TABLE_CELL_ATTR_ACTIONS,
    PROP_OOO_TABLE_CELL_ELEM_ACTIONS,
    PROP_OOO_LIST_LEVEL_ATTR_ACTIONS,
    PROP_OOO_CHART_ATTR_ACTIONS,
    PROP_OOO_CHART_ELEM_ACTIONS,
    MAX_OOO_PROP_ACTIONS,
    OOO_STYLE_ACTIONS = MAX_OOO_PROP_ACTIONS,
    OOO_FONT_DECL_ACTIONS,
    OOO_SHAPE_ACTIONS,
    OOO_CONNECTOR_ACTIONS,
    OOO_INDEX_ENTRY_TAB_STOP_ACTIONS,
    OOO_TAB_STOP_ACTIONS,
    OOO_LINENUMBERING_ACTIONS,
    OOO_FOOTNOTE_SEP_ACTIONS,
    OOO_DROP_CAP_ACTIONS,
    OOO_COLUMNS_ACTIONS,
    OOO_TEXT_VALUE_TYPE_ACTIONS,
    OOO_TABLE_VALUE_TYPE_ACTIONS,
    OOO_PARA_ACTIONS,
    OOO_STYLE_REF_ACTIONS,
    OOO_MASTER_PAGE_ACTIONS,
    OOO_ANNOTATION_ACTIONS,
    OOO_CHANGE_INFO_ACTIONS,
    OOO_FRAME_ELEM_ACTIONS,
    OOO_FRAME_ATTR_ACTIONS,
    OOO_BACKGROUND_IMAGE_ACTIONS,
    OOO_DDE_CONNECTION_DECL_ACTIONS,
    OOO_EVENT_ACTIONS,
    OOO_FORM_CONTROL_ACTIONS,
    OOO_FORM_COLUMN_ACTIONS,
    OOO_FORM_PROP_ACTIONS,
    OOO_XLINK_ACTIONS,
    OOO_CONFIG_ITEM_SET_ACTIONS,
    OOO_FORMULA_ACTIONS,
    OOO_CHART_ACTIONS,
    OOO_ERROR_MACRO_ACTIONS,
    OOO_DDE_CONV_MODE_ACTIONS,
    OOO_ALPHABETICAL_INDEX_MARK_ACTIONS,
    OOO_DATAPILOT_MEMBER_ACTIONS,
    OOO_DATAPILOT_LEVEL_ACTIONS,
    OOO_SOURCE_SERVICE_ACTIONS,
    OOO_DRAW_AREA_POLYGON_ACTIONS,
    OOO_SCRIPT_ACTIONS,
    OOO_ANIMATION_ACTIONS,
    MAX_OOO_ACTIONS
};

#endif // INCLUDED_XMLOFF_SOURCE_TRANSFORM_ACTIONMAPTYPESOOO_HXX

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
