/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Skeleton implementation for Bison GLR parsers in C

   Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C GLR parser skeleton written by Paul Hilfinger.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 0




/* Substitute the variable and function names.  */
#define yyparse SQLyyparse
#define yylex   SQLyylex
#define yyerror SQLyyerror
#define yydebug SQLyydebug
#define yylval  SQLyylval
#define yychar  SQLyychar
#define yynerrs SQLyynerrs

/* First part of user prologue.  */

/*
 * This file is part of the LibreOffice project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * This file incorporates work covered by the following license notice:
 *
 *   Licensed to the Apache Software Foundation (ASF) under one or more
 *   contributor license agreements. See the NOTICE file distributed
 *   with this work for additional information regarding copyright
 *   ownership. The ASF licenses this file to you under the Apache
 *   License, Version 2.0 (the "License"); you may not use this file
 *   except in compliance with the License. You may obtain a copy of
 *   the License at http://www.apache.org/licenses/LICENSE-2.0 .
 */

#include <vector>
#include <string.h>

#include <connectivity/sqlnode.hxx>
#include <connectivity/sqlparse.hxx>
#include <connectivity/sqlbison_exports.hxx>
#include <connectivity/sqlscan.hxx>
#include <connectivity/internalnode.hxx>
#include <com/sun/star/lang/Locale.hpp>
#include <com/sun/star/sdbc/DataType.hpp>
#include <com/sun/star/util/Date.hpp>
#include <com/sun/star/util/DateTime.hpp>
#include <com/sun/star/util/Time.hpp>
#include <com/sun/star/util/XNumberFormatter.hpp>
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#include <com/sun/star/util/XNumberFormats.hpp>
#include <com/sun/star/util/NumberFormat.hpp>
#include <com/sun/star/util/XNumberFormatTypes.hpp>
#include <com/sun/star/beans/XPropertySet.hpp>
#include <com/sun/star/i18n/KParseType.hpp>
#include <com/sun/star/i18n/KParseTokens.hpp>

#include <osl/diagnose.h>
#include "connectivity/dbconversion.hxx"
#include <rtl/ustrbuf.hxx>
#include <sal/macros.h>
#include <sal/log.hxx>

#if defined _MSC_VER
#pragma warning(push)
#pragma warning(disable: 4324) // structure was padded due to alignment specifier
#pragma warning(disable: 4065) // switch statement contains 'default' but no 'case' labels
#pragma warning(disable: 4702) // unreachable code
#endif

#ifdef __GNUC__
# pragma GCC diagnostic ignored "-Wwrite-strings"
# pragma GCC diagnostic ignored "-Wunused-function"
#endif

inline connectivity::OSQLInternalNode* newNode(const char* pNewValue,
        const connectivity::SQLNodeType eNodeType,
        const sal_uInt32 nNodeID = 0);

inline connectivity::OSQLInternalNode* newNode(const OString& _newValue,
        const connectivity::SQLNodeType eNodeType,
        const sal_uInt32 nNodeID = 0);

inline connectivity::OSQLInternalNode* newNode(const OUString& _newValue,
        const connectivity::SQLNodeType eNodeType,
        const sal_uInt32 nNodeID = 0);


// yyi is the internal number of the rule that is currently being reduced
// This can be mapped to external rule number via the yyrmap.
#define SQL_NEW_RULE 			newNode("", SQLNodeType::Rule, yyr1[yyn])
#define SQL_NEW_LISTRULE 		newNode("", SQLNodeType::ListRule, yyr1[yyn])
#define SQL_NEW_COMMALISTRULE   newNode("", SQLNodeType::CommaListRule, yyr1[yyn])


extern connectivity::OSQLParser* xxx_pGLOBAL_SQLPARSER;

#define YYERROR_VERBOSE

#define SQLyyerror(s)						\
{											\
	xxx_pGLOBAL_SQLPARSER->error(s);		\
}

using namespace connectivity;
#define SQLyylex xxx_pGLOBAL_SQLPARSER->SQLlex


# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sqlbison.hxx"

/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_3_ = 3,                         /* '('  */
  YYSYMBOL_4_ = 4,                         /* ')'  */
  YYSYMBOL_5_ = 5,                         /* ','  */
  YYSYMBOL_6_ = 6,                         /* ':'  */
  YYSYMBOL_7_ = 7,                         /* ';'  */
  YYSYMBOL_8_ = 8,                         /* '?'  */
  YYSYMBOL_9_ = 9,                         /* '['  */
  YYSYMBOL_10_ = 10,                       /* ']'  */
  YYSYMBOL_11_ = 11,                       /* '{'  */
  YYSYMBOL_12_ = 12,                       /* '}'  */
  YYSYMBOL_13_ = 13,                       /* '.'  */
  YYSYMBOL_14_K_ = 14,                     /* 'K'  */
  YYSYMBOL_15_M_ = 15,                     /* 'M'  */
  YYSYMBOL_16_G_ = 16,                     /* 'G'  */
  YYSYMBOL_17_T_ = 17,                     /* 'T'  */
  YYSYMBOL_18_P_ = 18,                     /* 'P'  */
  YYSYMBOL_SQL_TOKEN_STRING = 19,          /* SQL_TOKEN_STRING  */
  YYSYMBOL_SQL_TOKEN_ACCESS_DATE = 20,     /* SQL_TOKEN_ACCESS_DATE  */
  YYSYMBOL_SQL_TOKEN_INT = 21,             /* SQL_TOKEN_INT  */
  YYSYMBOL_SQL_TOKEN_REAL_NUM = 22,        /* SQL_TOKEN_REAL_NUM  */
  YYSYMBOL_SQL_TOKEN_INTNUM = 23,          /* SQL_TOKEN_INTNUM  */
  YYSYMBOL_SQL_TOKEN_APPROXNUM = 24,       /* SQL_TOKEN_APPROXNUM  */
  YYSYMBOL_SQL_TOKEN_NOT = 25,             /* SQL_TOKEN_NOT  */
  YYSYMBOL_SQL_TOKEN_NAME = 26,            /* SQL_TOKEN_NAME  */
  YYSYMBOL_SQL_TOKEN_UMINUS = 27,          /* SQL_TOKEN_UMINUS  */
  YYSYMBOL_SQL_TOKEN_ALL = 28,             /* SQL_TOKEN_ALL  */
  YYSYMBOL_SQL_TOKEN_ALTER = 29,           /* SQL_TOKEN_ALTER  */
  YYSYMBOL_SQL_TOKEN_AMMSC = 30,           /* SQL_TOKEN_AMMSC  */
  YYSYMBOL_SQL_TOKEN_ANY = 31,             /* SQL_TOKEN_ANY  */
  YYSYMBOL_SQL_TOKEN_AS = 32,              /* SQL_TOKEN_AS  */
  YYSYMBOL_SQL_TOKEN_ASC = 33,             /* SQL_TOKEN_ASC  */
  YYSYMBOL_SQL_TOKEN_AT = 34,              /* SQL_TOKEN_AT  */
  YYSYMBOL_SQL_TOKEN_AUTHORIZATION = 35,   /* SQL_TOKEN_AUTHORIZATION  */
  YYSYMBOL_SQL_TOKEN_AVG = 36,             /* SQL_TOKEN_AVG  */
  YYSYMBOL_SQL_TOKEN_BETWEEN = 37,         /* SQL_TOKEN_BETWEEN  */
  YYSYMBOL_SQL_TOKEN_BIT = 38,             /* SQL_TOKEN_BIT  */
  YYSYMBOL_SQL_TOKEN_BOTH = 39,            /* SQL_TOKEN_BOTH  */
  YYSYMBOL_SQL_TOKEN_BY = 40,              /* SQL_TOKEN_BY  */
  YYSYMBOL_SQL_TOKEN_CAST = 41,            /* SQL_TOKEN_CAST  */
  YYSYMBOL_SQL_TOKEN_CHARACTER = 42,       /* SQL_TOKEN_CHARACTER  */
  YYSYMBOL_SQL_TOKEN_CHECK = 43,           /* SQL_TOKEN_CHECK  */
  YYSYMBOL_SQL_TOKEN_COLLATE = 44,         /* SQL_TOKEN_COLLATE  */
  YYSYMBOL_SQL_TOKEN_COMMIT = 45,          /* SQL_TOKEN_COMMIT  */
  YYSYMBOL_SQL_TOKEN_CONTINUE = 46,        /* SQL_TOKEN_CONTINUE  */
  YYSYMBOL_SQL_TOKEN_CONVERT = 47,         /* SQL_TOKEN_CONVERT  */
  YYSYMBOL_SQL_TOKEN_COUNT = 48,           /* SQL_TOKEN_COUNT  */
  YYSYMBOL_SQL_TOKEN_CREATE = 49,          /* SQL_TOKEN_CREATE  */
  YYSYMBOL_SQL_TOKEN_CROSS = 50,           /* SQL_TOKEN_CROSS  */
  YYSYMBOL_SQL_TOKEN_CURRENT = 51,         /* SQL_TOKEN_CURRENT  */
  YYSYMBOL_SQL_TOKEN_CURSOR = 52,          /* SQL_TOKEN_CURSOR  */
  YYSYMBOL_SQL_TOKEN_DATE = 53,            /* SQL_TOKEN_DATE  */
  YYSYMBOL_SQL_TOKEN_DATEVALUE = 54,       /* SQL_TOKEN_DATEVALUE  */
  YYSYMBOL_SQL_TOKEN_DAY = 55,             /* SQL_TOKEN_DAY  */
  YYSYMBOL_SQL_TOKEN_DEC = 56,             /* SQL_TOKEN_DEC  */
  YYSYMBOL_SQL_TOKEN_DECIMAL = 57,         /* SQL_TOKEN_DECIMAL  */
  YYSYMBOL_SQL_TOKEN_DECLARE = 58,         /* SQL_TOKEN_DECLARE  */
  YYSYMBOL_SQL_TOKEN_DEFAULT = 59,         /* SQL_TOKEN_DEFAULT  */
  YYSYMBOL_SQL_TOKEN_DELETE = 60,          /* SQL_TOKEN_DELETE  */
  YYSYMBOL_SQL_TOKEN_DESC = 61,            /* SQL_TOKEN_DESC  */
  YYSYMBOL_SQL_TOKEN_DISTINCT = 62,        /* SQL_TOKEN_DISTINCT  */
  YYSYMBOL_SQL_TOKEN_DOUBLE = 63,          /* SQL_TOKEN_DOUBLE  */
  YYSYMBOL_SQL_TOKEN_DROP = 64,            /* SQL_TOKEN_DROP  */
  YYSYMBOL_SQL_TOKEN_ESCAPE = 65,          /* SQL_TOKEN_ESCAPE  */
  YYSYMBOL_SQL_TOKEN_EXCEPT = 66,          /* SQL_TOKEN_EXCEPT  */
  YYSYMBOL_SQL_TOKEN_EXISTS = 67,          /* SQL_TOKEN_EXISTS  */
  YYSYMBOL_SQL_TOKEN_FALSE = 68,           /* SQL_TOKEN_FALSE  */
  YYSYMBOL_SQL_TOKEN_FETCH = 69,           /* SQL_TOKEN_FETCH  */
  YYSYMBOL_SQL_TOKEN_FLOAT = 70,           /* SQL_TOKEN_FLOAT  */
  YYSYMBOL_SQL_TOKEN_FOR = 71,             /* SQL_TOKEN_FOR  */
  YYSYMBOL_SQL_TOKEN_FOREIGN = 72,         /* SQL_TOKEN_FOREIGN  */
  YYSYMBOL_SQL_TOKEN_FOUND = 73,           /* SQL_TOKEN_FOUND  */
  YYSYMBOL_SQL_TOKEN_FROM = 74,            /* SQL_TOKEN_FROM  */
  YYSYMBOL_SQL_TOKEN_FULL = 75,            /* SQL_TOKEN_FULL  */
  YYSYMBOL_SQL_TOKEN_GRANT = 76,           /* SQL_TOKEN_GRANT  */
  YYSYMBOL_SQL_TOKEN_GROUP = 77,           /* SQL_TOKEN_GROUP  */
  YYSYMBOL_SQL_TOKEN_HAVING = 78,          /* SQL_TOKEN_HAVING  */
  YYSYMBOL_SQL_TOKEN_IN = 79,              /* SQL_TOKEN_IN  */
  YYSYMBOL_SQL_TOKEN_INDICATOR = 80,       /* SQL_TOKEN_INDICATOR  */
  YYSYMBOL_SQL_TOKEN_INNER = 81,           /* SQL_TOKEN_INNER  */
  YYSYMBOL_SQL_TOKEN_INTEGER = 82,         /* SQL_TOKEN_INTEGER  */
  YYSYMBOL_SQL_TOKEN_INTO = 83,            /* SQL_TOKEN_INTO  */
  YYSYMBOL_SQL_TOKEN_IS = 84,              /* SQL_TOKEN_IS  */
  YYSYMBOL_SQL_TOKEN_INTERSECT = 85,       /* SQL_TOKEN_INTERSECT  */
  YYSYMBOL_SQL_TOKEN_JOIN = 86,            /* SQL_TOKEN_JOIN  */
  YYSYMBOL_SQL_TOKEN_KEY = 87,             /* SQL_TOKEN_KEY  */
  YYSYMBOL_SQL_TOKEN_LEADING = 88,         /* SQL_TOKEN_LEADING  */
  YYSYMBOL_SQL_TOKEN_LIKE = 89,            /* SQL_TOKEN_LIKE  */
  YYSYMBOL_SQL_TOKEN_LOCAL = 90,           /* SQL_TOKEN_LOCAL  */
  YYSYMBOL_SQL_TOKEN_LOWER = 91,           /* SQL_TOKEN_LOWER  */
  YYSYMBOL_SQL_TOKEN_MAX = 92,             /* SQL_TOKEN_MAX  */
  YYSYMBOL_SQL_TOKEN_MIN = 93,             /* SQL_TOKEN_MIN  */
  YYSYMBOL_SQL_TOKEN_NATURAL = 94,         /* SQL_TOKEN_NATURAL  */
  YYSYMBOL_SQL_TOKEN_NCHAR = 95,           /* SQL_TOKEN_NCHAR  */
  YYSYMBOL_SQL_TOKEN_NULL = 96,            /* SQL_TOKEN_NULL  */
  YYSYMBOL_SQL_TOKEN_NUMERIC = 97,         /* SQL_TOKEN_NUMERIC  */
  YYSYMBOL_SQL_TOKEN_OCTET_LENGTH = 98,    /* SQL_TOKEN_OCTET_LENGTH  */
  YYSYMBOL_SQL_TOKEN_OF = 99,              /* SQL_TOKEN_OF  */
  YYSYMBOL_SQL_TOKEN_ON = 100,             /* SQL_TOKEN_ON  */
  YYSYMBOL_SQL_TOKEN_OPTION = 101,         /* SQL_TOKEN_OPTION  */
  YYSYMBOL_SQL_TOKEN_ORDER = 102,          /* SQL_TOKEN_ORDER  */
  YYSYMBOL_SQL_TOKEN_OUTER = 103,          /* SQL_TOKEN_OUTER  */
  YYSYMBOL_SQL_TOKEN_PRECISION = 104,      /* SQL_TOKEN_PRECISION  */
  YYSYMBOL_SQL_TOKEN_PRIMARY = 105,        /* SQL_TOKEN_PRIMARY  */
  YYSYMBOL_SQL_TOKEN_PRIVILEGES = 106,     /* SQL_TOKEN_PRIVILEGES  */
  YYSYMBOL_SQL_TOKEN_PROCEDURE = 107,      /* SQL_TOKEN_PROCEDURE  */
  YYSYMBOL_SQL_TOKEN_PUBLIC = 108,         /* SQL_TOKEN_PUBLIC  */
  YYSYMBOL_SQL_TOKEN_REAL = 109,           /* SQL_TOKEN_REAL  */
  YYSYMBOL_SQL_TOKEN_REFERENCES = 110,     /* SQL_TOKEN_REFERENCES  */
  YYSYMBOL_SQL_TOKEN_ROLLBACK = 111,       /* SQL_TOKEN_ROLLBACK  */
  YYSYMBOL_SQL_TOKEN_SCHEMA = 112,         /* SQL_TOKEN_SCHEMA  */
  YYSYMBOL_SQL_TOKEN_SELECT = 113,         /* SQL_TOKEN_SELECT  */
  YYSYMBOL_SQL_TOKEN_SET = 114,            /* SQL_TOKEN_SET  */
  YYSYMBOL_SQL_TOKEN_SIZE = 115,           /* SQL_TOKEN_SIZE  */
  YYSYMBOL_SQL_TOKEN_SMALLINT = 116,       /* SQL_TOKEN_SMALLINT  */
  YYSYMBOL_SQL_TOKEN_SOME = 117,           /* SQL_TOKEN_SOME  */
  YYSYMBOL_SQL_TOKEN_SQLCODE = 118,        /* SQL_TOKEN_SQLCODE  */
  YYSYMBOL_SQL_TOKEN_SQLERROR = 119,       /* SQL_TOKEN_SQLERROR  */
  YYSYMBOL_SQL_TOKEN_SUM = 120,            /* SQL_TOKEN_SUM  */
  YYSYMBOL_SQL_TOKEN_TABLE = 121,          /* SQL_TOKEN_TABLE  */
  YYSYMBOL_SQL_TOKEN_TIME = 122,           /* SQL_TOKEN_TIME  */
  YYSYMBOL_SQL_TOKEN_TIMESTAMP = 123,      /* SQL_TOKEN_TIMESTAMP  */
  YYSYMBOL_SQL_TOKEN_TIMEZONE_HOUR = 124,  /* SQL_TOKEN_TIMEZONE_HOUR  */
  YYSYMBOL_SQL_TOKEN_TIMEZONE_MINUTE = 125, /* SQL_TOKEN_TIMEZONE_MINUTE  */
  YYSYMBOL_SQL_TOKEN_TO = 126,             /* SQL_TOKEN_TO  */
  YYSYMBOL_SQL_TOKEN_TRAILING = 127,       /* SQL_TOKEN_TRAILING  */
  YYSYMBOL_SQL_TOKEN_TRANSLATE = 128,      /* SQL_TOKEN_TRANSLATE  */
  YYSYMBOL_SQL_TOKEN_TRIM = 129,           /* SQL_TOKEN_TRIM  */
  YYSYMBOL_SQL_TOKEN_TRUE = 130,           /* SQL_TOKEN_TRUE  */
  YYSYMBOL_SQL_TOKEN_UNION = 131,          /* SQL_TOKEN_UNION  */
  YYSYMBOL_SQL_TOKEN_UNIQUE = 132,         /* SQL_TOKEN_UNIQUE  */
  YYSYMBOL_SQL_TOKEN_UNKNOWN = 133,        /* SQL_TOKEN_UNKNOWN  */
  YYSYMBOL_SQL_TOKEN_UPDATE = 134,         /* SQL_TOKEN_UPDATE  */
  YYSYMBOL_SQL_TOKEN_UPPER = 135,          /* SQL_TOKEN_UPPER  */
  YYSYMBOL_SQL_TOKEN_USAGE = 136,          /* SQL_TOKEN_USAGE  */
  YYSYMBOL_SQL_TOKEN_USER = 137,           /* SQL_TOKEN_USER  */
  YYSYMBOL_SQL_TOKEN_USING = 138,          /* SQL_TOKEN_USING  */
  YYSYMBOL_SQL_TOKEN_VALUES = 139,         /* SQL_TOKEN_VALUES  */
  YYSYMBOL_SQL_TOKEN_VIEW = 140,           /* SQL_TOKEN_VIEW  */
  YYSYMBOL_SQL_TOKEN_WHERE = 141,          /* SQL_TOKEN_WHERE  */
  YYSYMBOL_SQL_TOKEN_WITH = 142,           /* SQL_TOKEN_WITH  */
  YYSYMBOL_SQL_TOKEN_WORK = 143,           /* SQL_TOKEN_WORK  */
  YYSYMBOL_SQL_TOKEN_ZONE = 144,           /* SQL_TOKEN_ZONE  */
  YYSYMBOL_SQL_TOKEN_CALL = 145,           /* SQL_TOKEN_CALL  */
  YYSYMBOL_SQL_TOKEN_D = 146,              /* SQL_TOKEN_D  */
  YYSYMBOL_SQL_TOKEN_FN = 147,             /* SQL_TOKEN_FN  */
  YYSYMBOL_SQL_TOKEN_T = 148,              /* SQL_TOKEN_T  */
  YYSYMBOL_SQL_TOKEN_TS = 149,             /* SQL_TOKEN_TS  */
  YYSYMBOL_SQL_TOKEN_OJ = 150,             /* SQL_TOKEN_OJ  */
  YYSYMBOL_SQL_TOKEN_ASCII = 151,          /* SQL_TOKEN_ASCII  */
  YYSYMBOL_SQL_TOKEN_BIT_LENGTH = 152,     /* SQL_TOKEN_BIT_LENGTH  */
  YYSYMBOL_SQL_TOKEN_CHAR = 153,           /* SQL_TOKEN_CHAR  */
  YYSYMBOL_SQL_TOKEN_CHAR_LENGTH = 154,    /* SQL_TOKEN_CHAR_LENGTH  */
  YYSYMBOL_SQL_TOKEN_SQL_TOKEN_INTNUM = 155, /* SQL_TOKEN_SQL_TOKEN_INTNUM  */
  YYSYMBOL_SQL_TOKEN_CONCAT = 156,         /* SQL_TOKEN_CONCAT  */
  YYSYMBOL_SQL_TOKEN_DIFFERENCE = 157,     /* SQL_TOKEN_DIFFERENCE  */
  YYSYMBOL_SQL_TOKEN_INSERT = 158,         /* SQL_TOKEN_INSERT  */
  YYSYMBOL_SQL_TOKEN_LCASE = 159,          /* SQL_TOKEN_LCASE  */
  YYSYMBOL_SQL_TOKEN_LEFT = 160,           /* SQL_TOKEN_LEFT  */
  YYSYMBOL_SQL_TOKEN_LENGTH = 161,         /* SQL_TOKEN_LENGTH  */
  YYSYMBOL_SQL_TOKEN_LOCATE = 162,         /* SQL_TOKEN_LOCATE  */
  YYSYMBOL_SQL_TOKEN_LOCATE_2 = 163,       /* SQL_TOKEN_LOCATE_2  */
  YYSYMBOL_SQL_TOKEN_LTRIM = 164,          /* SQL_TOKEN_LTRIM  */
  YYSYMBOL_SQL_TOKEN_POSITION = 165,       /* SQL_TOKEN_POSITION  */
  YYSYMBOL_SQL_TOKEN_REPEAT = 166,         /* SQL_TOKEN_REPEAT  */
  YYSYMBOL_SQL_TOKEN_REPLACE = 167,        /* SQL_TOKEN_REPLACE  */
  YYSYMBOL_SQL_TOKEN_RIGHT = 168,          /* SQL_TOKEN_RIGHT  */
  YYSYMBOL_SQL_TOKEN_RTRIM = 169,          /* SQL_TOKEN_RTRIM  */
  YYSYMBOL_SQL_TOKEN_SOUNDEX = 170,        /* SQL_TOKEN_SOUNDEX  */
  YYSYMBOL_SQL_TOKEN_SPACE = 171,          /* SQL_TOKEN_SPACE  */
  YYSYMBOL_SQL_TOKEN_SUBSTRING = 172,      /* SQL_TOKEN_SUBSTRING  */
  YYSYMBOL_SQL_TOKEN_UCASE = 173,          /* SQL_TOKEN_UCASE  */
  YYSYMBOL_SQL_TOKEN_CURRENT_DATE = 174,   /* SQL_TOKEN_CURRENT_DATE  */
  YYSYMBOL_SQL_TOKEN_CURRENT_TIME = 175,   /* SQL_TOKEN_CURRENT_TIME  */
  YYSYMBOL_SQL_TOKEN_CURRENT_TIMESTAMP = 176, /* SQL_TOKEN_CURRENT_TIMESTAMP  */
  YYSYMBOL_SQL_TOKEN_CURDATE = 177,        /* SQL_TOKEN_CURDATE  */
  YYSYMBOL_SQL_TOKEN_CURTIME = 178,        /* SQL_TOKEN_CURTIME  */
  YYSYMBOL_SQL_TOKEN_DAYNAME = 179,        /* SQL_TOKEN_DAYNAME  */
  YYSYMBOL_SQL_TOKEN_DAYOFMONTH = 180,     /* SQL_TOKEN_DAYOFMONTH  */
  YYSYMBOL_SQL_TOKEN_DAYOFWEEK = 181,      /* SQL_TOKEN_DAYOFWEEK  */
  YYSYMBOL_SQL_TOKEN_DAYOFYEAR = 182,      /* SQL_TOKEN_DAYOFYEAR  */
  YYSYMBOL_SQL_TOKEN_EXTRACT = 183,        /* SQL_TOKEN_EXTRACT  */
  YYSYMBOL_SQL_TOKEN_HOUR = 184,           /* SQL_TOKEN_HOUR  */
  YYSYMBOL_SQL_TOKEN_MILLISECOND = 185,    /* SQL_TOKEN_MILLISECOND  */
  YYSYMBOL_SQL_TOKEN_MINUTE = 186,         /* SQL_TOKEN_MINUTE  */
  YYSYMBOL_SQL_TOKEN_MONTH = 187,          /* SQL_TOKEN_MONTH  */
  YYSYMBOL_SQL_TOKEN_MONTHNAME = 188,      /* SQL_TOKEN_MONTHNAME  */
  YYSYMBOL_SQL_TOKEN_NOW = 189,            /* SQL_TOKEN_NOW  */
  YYSYMBOL_SQL_TOKEN_QUARTER = 190,        /* SQL_TOKEN_QUARTER  */
  YYSYMBOL_SQL_TOKEN_DATEDIFF = 191,       /* SQL_TOKEN_DATEDIFF  */
  YYSYMBOL_SQL_TOKEN_SECOND = 192,         /* SQL_TOKEN_SECOND  */
  YYSYMBOL_SQL_TOKEN_TIMESTAMPADD = 193,   /* SQL_TOKEN_TIMESTAMPADD  */
  YYSYMBOL_SQL_TOKEN_TIMESTAMPDIFF = 194,  /* SQL_TOKEN_TIMESTAMPDIFF  */
  YYSYMBOL_SQL_TOKEN_TIMEVALUE = 195,      /* SQL_TOKEN_TIMEVALUE  */
  YYSYMBOL_SQL_TOKEN_WEEK = 196,           /* SQL_TOKEN_WEEK  */
  YYSYMBOL_SQL_TOKEN_WEEKDAY = 197,        /* SQL_TOKEN_WEEKDAY  */
  YYSYMBOL_SQL_TOKEN_YEAR = 198,           /* SQL_TOKEN_YEAR  */
  YYSYMBOL_SQL_TOKEN_YEARDAY = 199,        /* SQL_TOKEN_YEARDAY  */
  YYSYMBOL_SQL_TOKEN_ABS = 200,            /* SQL_TOKEN_ABS  */
  YYSYMBOL_SQL_TOKEN_ACOS = 201,           /* SQL_TOKEN_ACOS  */
  YYSYMBOL_SQL_TOKEN_ASIN = 202,           /* SQL_TOKEN_ASIN  */
  YYSYMBOL_SQL_TOKEN_ATAN = 203,           /* SQL_TOKEN_ATAN  */
  YYSYMBOL_SQL_TOKEN_ATAN2 = 204,          /* SQL_TOKEN_ATAN2  */
  YYSYMBOL_SQL_TOKEN_CEILING = 205,        /* SQL_TOKEN_CEILING  */
  YYSYMBOL_SQL_TOKEN_COS = 206,            /* SQL_TOKEN_COS  */
  YYSYMBOL_SQL_TOKEN_COT = 207,            /* SQL_TOKEN_COT  */
  YYSYMBOL_SQL_TOKEN_DEGREES = 208,        /* SQL_TOKEN_DEGREES  */
  YYSYMBOL_SQL_TOKEN_EXP = 209,            /* SQL_TOKEN_EXP  */
  YYSYMBOL_SQL_TOKEN_FLOOR = 210,          /* SQL_TOKEN_FLOOR  */
  YYSYMBOL_SQL_TOKEN_LOGF = 211,           /* SQL_TOKEN_LOGF  */
  YYSYMBOL_SQL_TOKEN_LOG = 212,            /* SQL_TOKEN_LOG  */
  YYSYMBOL_SQL_TOKEN_LN = 213,             /* SQL_TOKEN_LN  */
  YYSYMBOL_SQL_TOKEN_LOG10 = 214,          /* SQL_TOKEN_LOG10  */
  YYSYMBOL_SQL_TOKEN_MOD = 215,            /* SQL_TOKEN_MOD  */
  YYSYMBOL_SQL_TOKEN_PI = 216,             /* SQL_TOKEN_PI  */
  YYSYMBOL_SQL_TOKEN_POWER = 217,          /* SQL_TOKEN_POWER  */
  YYSYMBOL_SQL_TOKEN_RADIANS = 218,        /* SQL_TOKEN_RADIANS  */
  YYSYMBOL_SQL_TOKEN_RAND = 219,           /* SQL_TOKEN_RAND  */
  YYSYMBOL_SQL_TOKEN_ROUNDMAGIC = 220,     /* SQL_TOKEN_ROUNDMAGIC  */
  YYSYMBOL_SQL_TOKEN_ROUND = 221,          /* SQL_TOKEN_ROUND  */
  YYSYMBOL_SQL_TOKEN_SIGN = 222,           /* SQL_TOKEN_SIGN  */
  YYSYMBOL_SQL_TOKEN_SIN = 223,            /* SQL_TOKEN_SIN  */
  YYSYMBOL_SQL_TOKEN_SQRT = 224,           /* SQL_TOKEN_SQRT  */
  YYSYMBOL_SQL_TOKEN_TAN = 225,            /* SQL_TOKEN_TAN  */
  YYSYMBOL_SQL_TOKEN_TRUNCATE = 226,       /* SQL_TOKEN_TRUNCATE  */
  YYSYMBOL_SQL_TOKEN_EVERY = 227,          /* SQL_TOKEN_EVERY  */
  YYSYMBOL_SQL_TOKEN_INTERSECTION = 228,   /* SQL_TOKEN_INTERSECTION  */
  YYSYMBOL_SQL_TOKEN_FUSION = 229,         /* SQL_TOKEN_FUSION  */
  YYSYMBOL_SQL_TOKEN_COLLECT = 230,        /* SQL_TOKEN_COLLECT  */
  YYSYMBOL_SQL_TOKEN_VAR_POP = 231,        /* SQL_TOKEN_VAR_POP  */
  YYSYMBOL_SQL_TOKEN_VAR_SAMP = 232,       /* SQL_TOKEN_VAR_SAMP  */
  YYSYMBOL_SQL_TOKEN_STDDEV_SAMP = 233,    /* SQL_TOKEN_STDDEV_SAMP  */
  YYSYMBOL_SQL_TOKEN_STDDEV_POP = 234,     /* SQL_TOKEN_STDDEV_POP  */
  YYSYMBOL_SQL_TOKEN_RANK = 235,           /* SQL_TOKEN_RANK  */
  YYSYMBOL_SQL_TOKEN_DENSE_RANK = 236,     /* SQL_TOKEN_DENSE_RANK  */
  YYSYMBOL_SQL_TOKEN_PERCENT_RANK = 237,   /* SQL_TOKEN_PERCENT_RANK  */
  YYSYMBOL_SQL_TOKEN_CUME_DIST = 238,      /* SQL_TOKEN_CUME_DIST  */
  YYSYMBOL_SQL_TOKEN_PERCENTILE_CONT = 239, /* SQL_TOKEN_PERCENTILE_CONT  */
  YYSYMBOL_SQL_TOKEN_PERCENTILE_DISC = 240, /* SQL_TOKEN_PERCENTILE_DISC  */
  YYSYMBOL_SQL_TOKEN_WITHIN = 241,         /* SQL_TOKEN_WITHIN  */
  YYSYMBOL_SQL_TOKEN_ARRAY_AGG = 242,      /* SQL_TOKEN_ARRAY_AGG  */
  YYSYMBOL_SQL_TOKEN_CASE = 243,           /* SQL_TOKEN_CASE  */
  YYSYMBOL_SQL_TOKEN_THEN = 244,           /* SQL_TOKEN_THEN  */
  YYSYMBOL_SQL_TOKEN_END = 245,            /* SQL_TOKEN_END  */
  YYSYMBOL_SQL_TOKEN_NULLIF = 246,         /* SQL_TOKEN_NULLIF  */
  YYSYMBOL_SQL_TOKEN_COALESCE = 247,       /* SQL_TOKEN_COALESCE  */
  YYSYMBOL_SQL_TOKEN_WHEN = 248,           /* SQL_TOKEN_WHEN  */
  YYSYMBOL_SQL_TOKEN_ELSE = 249,           /* SQL_TOKEN_ELSE  */
  YYSYMBOL_SQL_TOKEN_BEFORE = 250,         /* SQL_TOKEN_BEFORE  */
  YYSYMBOL_SQL_TOKEN_AFTER = 251,          /* SQL_TOKEN_AFTER  */
  YYSYMBOL_SQL_TOKEN_INSTEAD = 252,        /* SQL_TOKEN_INSTEAD  */
  YYSYMBOL_SQL_TOKEN_EACH = 253,           /* SQL_TOKEN_EACH  */
  YYSYMBOL_SQL_TOKEN_REFERENCING = 254,    /* SQL_TOKEN_REFERENCING  */
  YYSYMBOL_SQL_TOKEN_BEGIN = 255,          /* SQL_TOKEN_BEGIN  */
  YYSYMBOL_SQL_TOKEN_ATOMIC = 256,         /* SQL_TOKEN_ATOMIC  */
  YYSYMBOL_SQL_TOKEN_TRIGGER = 257,        /* SQL_TOKEN_TRIGGER  */
  YYSYMBOL_SQL_TOKEN_ROW = 258,            /* SQL_TOKEN_ROW  */
  YYSYMBOL_SQL_TOKEN_STATEMENT = 259,      /* SQL_TOKEN_STATEMENT  */
  YYSYMBOL_SQL_TOKEN_NEW = 260,            /* SQL_TOKEN_NEW  */
  YYSYMBOL_SQL_TOKEN_OLD = 261,            /* SQL_TOKEN_OLD  */
  YYSYMBOL_SQL_TOKEN_VALUE = 262,          /* SQL_TOKEN_VALUE  */
  YYSYMBOL_SQL_TOKEN_CURRENT_CATALOG = 263, /* SQL_TOKEN_CURRENT_CATALOG  */
  YYSYMBOL_SQL_TOKEN_CURRENT_DEFAULT_TRANSFORM_GROUP = 264, /* SQL_TOKEN_CURRENT_DEFAULT_TRANSFORM_GROUP  */
  YYSYMBOL_SQL_TOKEN_CURRENT_PATH = 265,   /* SQL_TOKEN_CURRENT_PATH  */
  YYSYMBOL_SQL_TOKEN_CURRENT_ROLE = 266,   /* SQL_TOKEN_CURRENT_ROLE  */
  YYSYMBOL_SQL_TOKEN_CURRENT_SCHEMA = 267, /* SQL_TOKEN_CURRENT_SCHEMA  */
  YYSYMBOL_SQL_TOKEN_CURRENT_USER = 268,   /* SQL_TOKEN_CURRENT_USER  */
  YYSYMBOL_SQL_TOKEN_SESSION_USER = 269,   /* SQL_TOKEN_SESSION_USER  */
  YYSYMBOL_SQL_TOKEN_SYSTEM_USER = 270,    /* SQL_TOKEN_SYSTEM_USER  */
  YYSYMBOL_SQL_TOKEN_VARCHAR = 271,        /* SQL_TOKEN_VARCHAR  */
  YYSYMBOL_SQL_TOKEN_VARBINARY = 272,      /* SQL_TOKEN_VARBINARY  */
  YYSYMBOL_SQL_TOKEN_VARYING = 273,        /* SQL_TOKEN_VARYING  */
  YYSYMBOL_SQL_TOKEN_OBJECT = 274,         /* SQL_TOKEN_OBJECT  */
  YYSYMBOL_SQL_TOKEN_NCLOB = 275,          /* SQL_TOKEN_NCLOB  */
  YYSYMBOL_SQL_TOKEN_NATIONAL = 276,       /* SQL_TOKEN_NATIONAL  */
  YYSYMBOL_SQL_TOKEN_LARGE = 277,          /* SQL_TOKEN_LARGE  */
  YYSYMBOL_SQL_TOKEN_CLOB = 278,           /* SQL_TOKEN_CLOB  */
  YYSYMBOL_SQL_TOKEN_BLOB = 279,           /* SQL_TOKEN_BLOB  */
  YYSYMBOL_SQL_TOKEN_BIGINT = 280,         /* SQL_TOKEN_BIGINT  */
  YYSYMBOL_SQL_TOKEN_BINARY = 281,         /* SQL_TOKEN_BINARY  */
  YYSYMBOL_SQL_TOKEN_WITHOUT = 282,        /* SQL_TOKEN_WITHOUT  */
  YYSYMBOL_SQL_TOKEN_BOOLEAN = 283,        /* SQL_TOKEN_BOOLEAN  */
  YYSYMBOL_SQL_TOKEN_INTERVAL = 284,       /* SQL_TOKEN_INTERVAL  */
  YYSYMBOL_SQL_TOKEN_OVER = 285,           /* SQL_TOKEN_OVER  */
  YYSYMBOL_SQL_TOKEN_ROW_NUMBER = 286,     /* SQL_TOKEN_ROW_NUMBER  */
  YYSYMBOL_SQL_TOKEN_NTILE = 287,          /* SQL_TOKEN_NTILE  */
  YYSYMBOL_SQL_TOKEN_LEAD = 288,           /* SQL_TOKEN_LEAD  */
  YYSYMBOL_SQL_TOKEN_LAG = 289,            /* SQL_TOKEN_LAG  */
  YYSYMBOL_SQL_TOKEN_RESPECT = 290,        /* SQL_TOKEN_RESPECT  */
  YYSYMBOL_SQL_TOKEN_IGNORE = 291,         /* SQL_TOKEN_IGNORE  */
  YYSYMBOL_SQL_TOKEN_NULLS = 292,          /* SQL_TOKEN_NULLS  */
  YYSYMBOL_SQL_TOKEN_FIRST_VALUE = 293,    /* SQL_TOKEN_FIRST_VALUE  */
  YYSYMBOL_SQL_TOKEN_LAST_VALUE = 294,     /* SQL_TOKEN_LAST_VALUE  */
  YYSYMBOL_SQL_TOKEN_NTH_VALUE = 295,      /* SQL_TOKEN_NTH_VALUE  */
  YYSYMBOL_SQL_TOKEN_FIRST = 296,          /* SQL_TOKEN_FIRST  */
  YYSYMBOL_SQL_TOKEN_LAST = 297,           /* SQL_TOKEN_LAST  */
  YYSYMBOL_SQL_TOKEN_EXCLUDE = 298,        /* SQL_TOKEN_EXCLUDE  */
  YYSYMBOL_SQL_TOKEN_OTHERS = 299,         /* SQL_TOKEN_OTHERS  */
  YYSYMBOL_SQL_TOKEN_TIES = 300,           /* SQL_TOKEN_TIES  */
  YYSYMBOL_SQL_TOKEN_FOLLOWING = 301,      /* SQL_TOKEN_FOLLOWING  */
  YYSYMBOL_SQL_TOKEN_UNBOUNDED = 302,      /* SQL_TOKEN_UNBOUNDED  */
  YYSYMBOL_SQL_TOKEN_PRECEDING = 303,      /* SQL_TOKEN_PRECEDING  */
  YYSYMBOL_SQL_TOKEN_RANGE = 304,          /* SQL_TOKEN_RANGE  */
  YYSYMBOL_SQL_TOKEN_ROWS = 305,           /* SQL_TOKEN_ROWS  */
  YYSYMBOL_SQL_TOKEN_PARTITION = 306,      /* SQL_TOKEN_PARTITION  */
  YYSYMBOL_SQL_TOKEN_WINDOW = 307,         /* SQL_TOKEN_WINDOW  */
  YYSYMBOL_SQL_TOKEN_NO = 308,             /* SQL_TOKEN_NO  */
  YYSYMBOL_SQL_TOKEN_LIMIT = 309,          /* SQL_TOKEN_LIMIT  */
  YYSYMBOL_SQL_TOKEN_OFFSET = 310,         /* SQL_TOKEN_OFFSET  */
  YYSYMBOL_SQL_TOKEN_NEXT = 311,           /* SQL_TOKEN_NEXT  */
  YYSYMBOL_SQL_TOKEN_ONLY = 312,           /* SQL_TOKEN_ONLY  */
  YYSYMBOL_SQL_TOKEN_OR = 313,             /* SQL_TOKEN_OR  */
  YYSYMBOL_SQL_TOKEN_AND = 314,            /* SQL_TOKEN_AND  */
  YYSYMBOL_SQL_LESSEQ = 315,               /* SQL_LESSEQ  */
  YYSYMBOL_SQL_GREATEQ = 316,              /* SQL_GREATEQ  */
  YYSYMBOL_SQL_NOTEQUAL = 317,             /* SQL_NOTEQUAL  */
  YYSYMBOL_SQL_LESS = 318,                 /* SQL_LESS  */
  YYSYMBOL_SQL_GREAT = 319,                /* SQL_GREAT  */
  YYSYMBOL_SQL_EQUAL = 320,                /* SQL_EQUAL  */
  YYSYMBOL_321_ = 321,                     /* '+'  */
  YYSYMBOL_322_ = 322,                     /* '-'  */
  YYSYMBOL_SQL_CONCAT = 323,               /* SQL_CONCAT  */
  YYSYMBOL_324_ = 324,                     /* '*'  */
  YYSYMBOL_325_ = 325,                     /* '/'  */
  YYSYMBOL_326_ = 326,                     /* '='  */
  YYSYMBOL_SQL_TOKEN_INVALIDSYMBOL = 327,  /* SQL_TOKEN_INVALIDSYMBOL  */
  YYSYMBOL_YYACCEPT = 328,                 /* $accept  */
  YYSYMBOL_sql_single_statement = 329,     /* sql_single_statement  */
  YYSYMBOL_sql = 330,                      /* sql  */
  YYSYMBOL_schema_element = 331,           /* schema_element  */
  YYSYMBOL_base_table_def = 332,           /* base_table_def  */
  YYSYMBOL_base_table_element_commalist = 333, /* base_table_element_commalist  */
  YYSYMBOL_base_table_element = 334,       /* base_table_element  */
  YYSYMBOL_column_def = 335,               /* column_def  */
  YYSYMBOL_column_def_opt_list = 336,      /* column_def_opt_list  */
  YYSYMBOL_nil_fkt = 337,                  /* nil_fkt  */
  YYSYMBOL_unique_spec = 338,              /* unique_spec  */
  YYSYMBOL_column_def_opt = 339,           /* column_def_opt  */
  YYSYMBOL_table_constraint_def = 340,     /* table_constraint_def  */
  YYSYMBOL_op_column_commalist = 341,      /* op_column_commalist  */
  YYSYMBOL_column_commalist = 342,         /* column_commalist  */
  YYSYMBOL_view_def = 343,                 /* view_def  */
  YYSYMBOL_opt_with_check_option = 344,    /* opt_with_check_option  */
  YYSYMBOL_opt_column_commalist = 345,     /* opt_column_commalist  */
  YYSYMBOL_privilege_def = 346,            /* privilege_def  */
  YYSYMBOL_opt_with_grant_option = 347,    /* opt_with_grant_option  */
  YYSYMBOL_privileges = 348,               /* privileges  */
  YYSYMBOL_operation_commalist = 349,      /* operation_commalist  */
  YYSYMBOL_operation = 350,                /* operation  */
  YYSYMBOL_grantee_commalist = 351,        /* grantee_commalist  */
  YYSYMBOL_grantee = 352,                  /* grantee  */
  YYSYMBOL_opt_order_by_clause = 353,      /* opt_order_by_clause  */
  YYSYMBOL_ordering_spec_commalist = 354,  /* ordering_spec_commalist  */
  YYSYMBOL_ordering_spec = 355,            /* ordering_spec  */
  YYSYMBOL_opt_asc_desc = 356,             /* opt_asc_desc  */
  YYSYMBOL_sql_not = 357,                  /* sql_not  */
  YYSYMBOL_manipulative_statement = 358,   /* manipulative_statement  */
  YYSYMBOL_union_statement = 359,          /* union_statement  */
  YYSYMBOL_commit_statement = 360,         /* commit_statement  */
  YYSYMBOL_delete_statement_searched = 361, /* delete_statement_searched  */
  YYSYMBOL_fetch_statement = 362,          /* fetch_statement  */
  YYSYMBOL_insert_statement = 363,         /* insert_statement  */
  YYSYMBOL_values_or_query_spec = 364,     /* values_or_query_spec  */
  YYSYMBOL_table_value_const_list = 365,   /* table_value_const_list  */
  YYSYMBOL_row_value_constructor = 366,    /* row_value_constructor  */
  YYSYMBOL_row_value_constructor_elem = 367, /* row_value_constructor_elem  */
  YYSYMBOL_rollback_statement = 368,       /* rollback_statement  */
  YYSYMBOL_select_statement_into = 369,    /* select_statement_into  */
  YYSYMBOL_opt_all_distinct = 370,         /* opt_all_distinct  */
  YYSYMBOL_assignment_commalist = 371,     /* assignment_commalist  */
  YYSYMBOL_assignment = 372,               /* assignment  */
  YYSYMBOL_update_source = 373,            /* update_source  */
  YYSYMBOL_update_statement_searched = 374, /* update_statement_searched  */
  YYSYMBOL_target_commalist = 375,         /* target_commalist  */
  YYSYMBOL_target = 376,                   /* target  */
  YYSYMBOL_opt_where_clause = 377,         /* opt_where_clause  */
  YYSYMBOL_query_term = 378,               /* query_term  */
  YYSYMBOL_select_statement = 379,         /* select_statement  */
  YYSYMBOL_selection = 380,                /* selection  */
  YYSYMBOL_opt_result_offset_clause = 381, /* opt_result_offset_clause  */
  YYSYMBOL_result_offset_clause = 382,     /* result_offset_clause  */
  YYSYMBOL_opt_fetch_first_row_count = 383, /* opt_fetch_first_row_count  */
  YYSYMBOL_first_or_next = 384,            /* first_or_next  */
  YYSYMBOL_row_or_rows = 385,              /* row_or_rows  */
  YYSYMBOL_opt_fetch_first_clause = 386,   /* opt_fetch_first_clause  */
  YYSYMBOL_fetch_first_clause = 387,       /* fetch_first_clause  */
  YYSYMBOL_offset_row_count = 388,         /* offset_row_count  */
  YYSYMBOL_fetch_first_row_count = 389,    /* fetch_first_row_count  */
  YYSYMBOL_opt_limit_offset_clause = 390,  /* opt_limit_offset_clause  */
  YYSYMBOL_opt_offset = 391,               /* opt_offset  */
  YYSYMBOL_limit_offset_clause = 392,      /* limit_offset_clause  */
  YYSYMBOL_table_exp = 393,                /* table_exp  */
  YYSYMBOL_from_clause = 394,              /* from_clause  */
  YYSYMBOL_table_ref_commalist = 395,      /* table_ref_commalist  */
  YYSYMBOL_opt_as = 396,                   /* opt_as  */
  YYSYMBOL_opt_row = 397,                  /* opt_row  */
  YYSYMBOL_table_primary_as_range_column = 398, /* table_primary_as_range_column  */
  YYSYMBOL_table_ref = 399,                /* table_ref  */
  YYSYMBOL_where_clause = 400,             /* where_clause  */
  YYSYMBOL_opt_group_by_clause = 401,      /* opt_group_by_clause  */
  YYSYMBOL_column_ref_commalist = 402,     /* column_ref_commalist  */
  YYSYMBOL_opt_having_clause = 403,        /* opt_having_clause  */
  YYSYMBOL_boolean_primary = 404,          /* boolean_primary  */
  YYSYMBOL_parenthesized_boolean_value_expression = 405, /* parenthesized_boolean_value_expression  */
  YYSYMBOL_boolean_factor = 406,           /* boolean_factor  */
  YYSYMBOL_boolean_term = 407,             /* boolean_term  */
  YYSYMBOL_search_condition = 408,         /* search_condition  */
  YYSYMBOL_predicate = 409,                /* predicate  */
  YYSYMBOL_comparison_predicate_part_2 = 410, /* comparison_predicate_part_2  */
  YYSYMBOL_comparison_predicate = 411,     /* comparison_predicate  */
  YYSYMBOL_comparison = 412,               /* comparison  */
  YYSYMBOL_between_predicate_part_2 = 413, /* between_predicate_part_2  */
  YYSYMBOL_between_predicate = 414,        /* between_predicate  */
  YYSYMBOL_character_like_predicate_part_2 = 415, /* character_like_predicate_part_2  */
  YYSYMBOL_other_like_predicate_part_2 = 416, /* other_like_predicate_part_2  */
  YYSYMBOL_like_predicate = 417,           /* like_predicate  */
  YYSYMBOL_opt_escape = 418,               /* opt_escape  */
  YYSYMBOL_null_predicate_part_2 = 419,    /* null_predicate_part_2  */
  YYSYMBOL_test_for_null = 420,            /* test_for_null  */
  YYSYMBOL_in_predicate_value = 421,       /* in_predicate_value  */
  YYSYMBOL_in_predicate_part_2 = 422,      /* in_predicate_part_2  */
  YYSYMBOL_in_predicate = 423,             /* in_predicate  */
  YYSYMBOL_quantified_comparison_predicate_part_2 = 424, /* quantified_comparison_predicate_part_2  */
  YYSYMBOL_all_or_any_predicate = 425,     /* all_or_any_predicate  */
  YYSYMBOL_any_all_some = 426,             /* any_all_some  */
  YYSYMBOL_existence_test = 427,           /* existence_test  */
  YYSYMBOL_unique_test = 428,              /* unique_test  */
  YYSYMBOL_subquery = 429,                 /* subquery  */
  YYSYMBOL_scalar_exp_commalist = 430,     /* scalar_exp_commalist  */
  YYSYMBOL_select_sublist = 431,           /* select_sublist  */
  YYSYMBOL_parameter_ref = 432,            /* parameter_ref  */
  YYSYMBOL_literal = 433,                  /* literal  */
  YYSYMBOL_as_clause = 434,                /* as_clause  */
  YYSYMBOL_position_exp = 435,             /* position_exp  */
  YYSYMBOL_num_value_fct = 436,            /* num_value_fct  */
  YYSYMBOL_char_length_exp = 437,          /* char_length_exp  */
  YYSYMBOL_octet_length_exp = 438,         /* octet_length_exp  */
  YYSYMBOL_bit_length_exp = 439,           /* bit_length_exp  */
  YYSYMBOL_length_exp = 440,               /* length_exp  */
  YYSYMBOL_datetime_field = 441,           /* datetime_field  */
  YYSYMBOL_extract_field = 442,            /* extract_field  */
  YYSYMBOL_time_zone_field = 443,          /* time_zone_field  */
  YYSYMBOL_extract_exp = 444,              /* extract_exp  */
  YYSYMBOL_unsigned_value_spec = 445,      /* unsigned_value_spec  */
  YYSYMBOL_general_value_spec = 446,       /* general_value_spec  */
  YYSYMBOL_set_fct_spec = 447,             /* set_fct_spec  */
  YYSYMBOL_function_name0 = 448,           /* function_name0  */
  YYSYMBOL_function_name1 = 449,           /* function_name1  */
  YYSYMBOL_function_name2 = 450,           /* function_name2  */
  YYSYMBOL_function_name12 = 451,          /* function_name12  */
  YYSYMBOL_function_name23 = 452,          /* function_name23  */
  YYSYMBOL_function_name3 = 453,           /* function_name3  */
  YYSYMBOL_function_name = 454,            /* function_name  */
  YYSYMBOL_string_function_1Argument = 455, /* string_function_1Argument  */
  YYSYMBOL_string_function_2Argument = 456, /* string_function_2Argument  */
  YYSYMBOL_string_function_3Argument = 457, /* string_function_3Argument  */
  YYSYMBOL_string_function_4Argument = 458, /* string_function_4Argument  */
  YYSYMBOL_string_function = 459,          /* string_function  */
  YYSYMBOL_date_function_0Argument = 460,  /* date_function_0Argument  */
  YYSYMBOL_date_function_1Argument = 461,  /* date_function_1Argument  */
  YYSYMBOL_date_function = 462,            /* date_function  */
  YYSYMBOL_numeric_function_0Argument = 463, /* numeric_function_0Argument  */
  YYSYMBOL_numeric_function_1Argument = 464, /* numeric_function_1Argument  */
  YYSYMBOL_numeric_function_2Argument = 465, /* numeric_function_2Argument  */
  YYSYMBOL_numeric_function = 466,         /* numeric_function  */
  YYSYMBOL_window_function = 467,          /* window_function  */
  YYSYMBOL_window_function_type = 468,     /* window_function_type  */
  YYSYMBOL_ntile_function = 469,           /* ntile_function  */
  YYSYMBOL_dynamic_parameter_specification = 470, /* dynamic_parameter_specification  */
  YYSYMBOL_simple_value_specification = 471, /* simple_value_specification  */
  YYSYMBOL_number_of_tiles = 472,          /* number_of_tiles  */
  YYSYMBOL_opt_lead_or_lag_function = 473, /* opt_lead_or_lag_function  */
  YYSYMBOL_opt_null_treatment = 474,       /* opt_null_treatment  */
  YYSYMBOL_lead_or_lag_function = 475,     /* lead_or_lag_function  */
  YYSYMBOL_lead_or_lag = 476,              /* lead_or_lag  */
  YYSYMBOL_lead_or_lag_extent = 477,       /* lead_or_lag_extent  */
  YYSYMBOL_offset = 478,                   /* offset  */
  YYSYMBOL_default_expression = 479,       /* default_expression  */
  YYSYMBOL_null_treatment = 480,           /* null_treatment  */
  YYSYMBOL_first_or_last_value_function = 481, /* first_or_last_value_function  */
  YYSYMBOL_first_or_last_value = 482,      /* first_or_last_value  */
  YYSYMBOL_opt_from_first_or_last = 483,   /* opt_from_first_or_last  */
  YYSYMBOL_nth_value_function = 484,       /* nth_value_function  */
  YYSYMBOL_nth_row = 485,                  /* nth_row  */
  YYSYMBOL_from_first_or_last = 486,       /* from_first_or_last  */
  YYSYMBOL_window_name = 487,              /* window_name  */
  YYSYMBOL_window_name_or_specification = 488, /* window_name_or_specification  */
  YYSYMBOL_in_line_window_specification = 489, /* in_line_window_specification  */
  YYSYMBOL_opt_window_clause = 490,        /* opt_window_clause  */
  YYSYMBOL_window_clause = 491,            /* window_clause  */
  YYSYMBOL_window_definition_list = 492,   /* window_definition_list  */
  YYSYMBOL_window_definition = 493,        /* window_definition  */
  YYSYMBOL_new_window_name = 494,          /* new_window_name  */
  YYSYMBOL_window_specification = 495,     /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 496, /* opt_existing_window_name  */
  YYSYMBOL_opt_window_partition_clause = 497, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_frame_clause = 498,  /* opt_window_frame_clause  */
  YYSYMBOL_existing_window_name = 499,     /* existing_window_name  */
  YYSYMBOL_window_partition_clause = 500,  /* window_partition_clause  */
  YYSYMBOL_window_partition_column_reference_list = 501, /* window_partition_column_reference_list  */
  YYSYMBOL_window_partition_column_reference = 502, /* window_partition_column_reference  */
  YYSYMBOL_opt_window_frame_exclusion = 503, /* opt_window_frame_exclusion  */
  YYSYMBOL_window_frame_clause = 504,      /* window_frame_clause  */
  YYSYMBOL_window_frame_units = 505,       /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 506,      /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 507,       /* window_frame_start  */
  YYSYMBOL_window_frame_preceding = 508,   /* window_frame_preceding  */
  YYSYMBOL_window_frame_between = 509,     /* window_frame_between  */
  YYSYMBOL_window_frame_bound_1 = 510,     /* window_frame_bound_1  */
  YYSYMBOL_window_frame_bound_2 = 511,     /* window_frame_bound_2  */
  YYSYMBOL_window_frame_bound = 512,       /* window_frame_bound  */
  YYSYMBOL_window_frame_following = 513,   /* window_frame_following  */
  YYSYMBOL_window_frame_exclusion = 514,   /* window_frame_exclusion  */
  YYSYMBOL_op_parameter = 515,             /* op_parameter  */
  YYSYMBOL_odbc_call_spec = 516,           /* odbc_call_spec  */
  YYSYMBOL_op_odbc_call_parameter = 517,   /* op_odbc_call_parameter  */
  YYSYMBOL_odbc_parameter_commalist = 518, /* odbc_parameter_commalist  */
  YYSYMBOL_odbc_parameter = 519,           /* odbc_parameter  */
  YYSYMBOL_odbc_fct_spec = 520,            /* odbc_fct_spec  */
  YYSYMBOL_odbc_fct_type = 521,            /* odbc_fct_type  */
  YYSYMBOL_general_set_fct = 522,          /* general_set_fct  */
  YYSYMBOL_set_fct_type = 523,             /* set_fct_type  */
  YYSYMBOL_ordered_set_function = 524,     /* ordered_set_function  */
  YYSYMBOL_hypothetical_set_function = 525, /* hypothetical_set_function  */
  YYSYMBOL_within_group_specification = 526, /* within_group_specification  */
  YYSYMBOL_hypothetical_set_function_value_expression_list = 527, /* hypothetical_set_function_value_expression_list  */
  YYSYMBOL_inverse_distribution_function = 528, /* inverse_distribution_function  */
  YYSYMBOL_inverse_distribution_function_argument = 529, /* inverse_distribution_function_argument  */
  YYSYMBOL_inverse_distribution_function_type = 530, /* inverse_distribution_function_type  */
  YYSYMBOL_array_aggregate_function = 531, /* array_aggregate_function  */
  YYSYMBOL_rank_function_type = 532,       /* rank_function_type  */
  YYSYMBOL_outer_join_type = 533,          /* outer_join_type  */
  YYSYMBOL_join_condition = 534,           /* join_condition  */
  YYSYMBOL_join_spec = 535,                /* join_spec  */
  YYSYMBOL_join_type = 536,                /* join_type  */
  YYSYMBOL_cross_union = 537,              /* cross_union  */
  YYSYMBOL_qualified_join = 538,           /* qualified_join  */
  YYSYMBOL_joined_table = 539,             /* joined_table  */
  YYSYMBOL_named_columns_join = 540,       /* named_columns_join  */
  YYSYMBOL_simple_table = 541,             /* simple_table  */
  YYSYMBOL_non_join_query_primary = 542,   /* non_join_query_primary  */
  YYSYMBOL_non_join_query_term = 543,      /* non_join_query_term  */
  YYSYMBOL_query_primary = 544,            /* query_primary  */
  YYSYMBOL_non_join_query_exp = 545,       /* non_join_query_exp  */
  YYSYMBOL_all = 546,                      /* all  */
  YYSYMBOL_query_exp = 547,                /* query_exp  */
  YYSYMBOL_scalar_subquery = 548,          /* scalar_subquery  */
  YYSYMBOL_cast_operand = 549,             /* cast_operand  */
  YYSYMBOL_cast_target = 550,              /* cast_target  */
  YYSYMBOL_cast_spec = 551,                /* cast_spec  */
  YYSYMBOL_value_exp_primary = 552,        /* value_exp_primary  */
  YYSYMBOL_num_primary = 553,              /* num_primary  */
  YYSYMBOL_factor = 554,                   /* factor  */
  YYSYMBOL_term = 555,                     /* term  */
  YYSYMBOL_num_value_exp = 556,            /* num_value_exp  */
  YYSYMBOL_datetime_primary = 557,         /* datetime_primary  */
  YYSYMBOL_datetime_value_fct = 558,       /* datetime_value_fct  */
  YYSYMBOL_time_zone = 559,                /* time_zone  */
  YYSYMBOL_time_zone_specifier = 560,      /* time_zone_specifier  */
  YYSYMBOL_datetime_factor = 561,          /* datetime_factor  */
  YYSYMBOL_datetime_term = 562,            /* datetime_term  */
  YYSYMBOL_datetime_value_exp = 563,       /* datetime_value_exp  */
  YYSYMBOL_non_second_datetime_field = 564, /* non_second_datetime_field  */
  YYSYMBOL_start_field = 565,              /* start_field  */
  YYSYMBOL_end_field = 566,                /* end_field  */
  YYSYMBOL_single_datetime_field = 567,    /* single_datetime_field  */
  YYSYMBOL_interval_qualifier = 568,       /* interval_qualifier  */
  YYSYMBOL_function_arg_commalist2 = 569,  /* function_arg_commalist2  */
  YYSYMBOL_function_arg_commalist3 = 570,  /* function_arg_commalist3  */
  YYSYMBOL_function_arg_commalist4 = 571,  /* function_arg_commalist4  */
  YYSYMBOL_value_exp_commalist = 572,      /* value_exp_commalist  */
  YYSYMBOL_function_arg = 573,             /* function_arg  */
  YYSYMBOL_function_args_commalist = 574,  /* function_args_commalist  */
  YYSYMBOL_value_exp = 575,                /* value_exp  */
  YYSYMBOL_string_value_exp = 576,         /* string_value_exp  */
  YYSYMBOL_char_value_exp = 577,           /* char_value_exp  */
  YYSYMBOL_concatenation = 578,            /* concatenation  */
  YYSYMBOL_char_primary = 579,             /* char_primary  */
  YYSYMBOL_collate_clause = 580,           /* collate_clause  */
  YYSYMBOL_char_factor = 581,              /* char_factor  */
  YYSYMBOL_string_value_fct = 582,         /* string_value_fct  */
  YYSYMBOL_bit_value_fct = 583,            /* bit_value_fct  */
  YYSYMBOL_bit_substring_fct = 584,        /* bit_substring_fct  */
  YYSYMBOL_bit_value_exp = 585,            /* bit_value_exp  */
  YYSYMBOL_bit_factor = 586,               /* bit_factor  */
  YYSYMBOL_bit_primary = 587,              /* bit_primary  */
  YYSYMBOL_char_value_fct = 588,           /* char_value_fct  */
  YYSYMBOL_for_length = 589,               /* for_length  */
  YYSYMBOL_char_substring_fct = 590,       /* char_substring_fct  */
  YYSYMBOL_upper_lower = 591,              /* upper_lower  */
  YYSYMBOL_fold = 592,                     /* fold  */
  YYSYMBOL_form_conversion = 593,          /* form_conversion  */
  YYSYMBOL_char_translation = 594,         /* char_translation  */
  YYSYMBOL_trim_fct = 595,                 /* trim_fct  */
  YYSYMBOL_trim_operands = 596,            /* trim_operands  */
  YYSYMBOL_trim_spec = 597,                /* trim_spec  */
  YYSYMBOL_derived_column = 598,           /* derived_column  */
  YYSYMBOL_table_node = 599,               /* table_node  */
  YYSYMBOL_catalog_name = 600,             /* catalog_name  */
  YYSYMBOL_schema_name = 601,              /* schema_name  */
  YYSYMBOL_table_name = 602,               /* table_name  */
  YYSYMBOL_column_ref = 603,               /* column_ref  */
  YYSYMBOL_column_val = 604,               /* column_val  */
  YYSYMBOL_data_type = 605,                /* data_type  */
  YYSYMBOL_opt_char_set_spec = 606,        /* opt_char_set_spec  */
  YYSYMBOL_opt_collate_clause = 607,       /* opt_collate_clause  */
  YYSYMBOL_predefined_type = 608,          /* predefined_type  */
  YYSYMBOL_character_string_type = 609,    /* character_string_type  */
  YYSYMBOL_opt_paren_precision = 610,      /* opt_paren_precision  */
  YYSYMBOL_paren_char_length = 611,        /* paren_char_length  */
  YYSYMBOL_opt_paren_char_large_length = 612, /* opt_paren_char_large_length  */
  YYSYMBOL_paren_character_large_object_length = 613, /* paren_character_large_object_length  */
  YYSYMBOL_large_object_length = 614,      /* large_object_length  */
  YYSYMBOL_opt_multiplier = 615,           /* opt_multiplier  */
  YYSYMBOL_character_large_object_type = 616, /* character_large_object_type  */
  YYSYMBOL_national_character_string_type = 617, /* national_character_string_type  */
  YYSYMBOL_national_character_large_object_type = 618, /* national_character_large_object_type  */
  YYSYMBOL_binary_string_type = 619,       /* binary_string_type  */
  YYSYMBOL_binary_large_object_string_type = 620, /* binary_large_object_string_type  */
  YYSYMBOL_numeric_type = 621,             /* numeric_type  */
  YYSYMBOL_opt_paren_precision_scale = 622, /* opt_paren_precision_scale  */
  YYSYMBOL_exact_numeric_type = 623,       /* exact_numeric_type  */
  YYSYMBOL_approximate_numeric_type = 624, /* approximate_numeric_type  */
  YYSYMBOL_boolean_type = 625,             /* boolean_type  */
  YYSYMBOL_datetime_type = 626,            /* datetime_type  */
  YYSYMBOL_opt_with_or_without_time_zone = 627, /* opt_with_or_without_time_zone  */
  YYSYMBOL_interval_type = 628,            /* interval_type  */
  YYSYMBOL_column = 629,                   /* column  */
  YYSYMBOL_case_expression = 630,          /* case_expression  */
  YYSYMBOL_case_abbreviation = 631,        /* case_abbreviation  */
  YYSYMBOL_case_specification = 632,       /* case_specification  */
  YYSYMBOL_simple_case = 633,              /* simple_case  */
  YYSYMBOL_searched_case = 634,            /* searched_case  */
  YYSYMBOL_simple_when_clause_list = 635,  /* simple_when_clause_list  */
  YYSYMBOL_simple_when_clause = 636,       /* simple_when_clause  */
  YYSYMBOL_when_operand_list = 637,        /* when_operand_list  */
  YYSYMBOL_when_operand = 638,             /* when_operand  */
  YYSYMBOL_searched_when_clause_list = 639, /* searched_when_clause_list  */
  YYSYMBOL_searched_when_clause = 640,     /* searched_when_clause  */
  YYSYMBOL_else_clause = 641,              /* else_clause  */
  YYSYMBOL_result = 642,                   /* result  */
  YYSYMBOL_result_expression = 643,        /* result_expression  */
  YYSYMBOL_case_operand = 644,             /* case_operand  */
  YYSYMBOL_cursor = 645,                   /* cursor  */
  YYSYMBOL_parameter = 646,                /* parameter  */
  YYSYMBOL_range_variable = 647,           /* range_variable  */
  YYSYMBOL_user = 648,                     /* user  */
  YYSYMBOL_trigger_definition = 649,       /* trigger_definition  */
  YYSYMBOL_op_referencing = 650,           /* op_referencing  */
  YYSYMBOL_trigger_action_time = 651,      /* trigger_action_time  */
  YYSYMBOL_trigger_event = 652,            /* trigger_event  */
  YYSYMBOL_op_trigger_columnlist = 653,    /* op_trigger_columnlist  */
  YYSYMBOL_trigger_column_list = 654,      /* trigger_column_list  */
  YYSYMBOL_triggered_action = 655,         /* triggered_action  */
  YYSYMBOL_op_triggered_action_for = 656,  /* op_triggered_action_for  */
  YYSYMBOL_trigger_for = 657,              /* trigger_for  */
  YYSYMBOL_triggered_when_clause = 658,    /* triggered_when_clause  */
  YYSYMBOL_triggered_SQL_statement = 659,  /* triggered_SQL_statement  */
  YYSYMBOL_SQL_procedure_statement_list = 660, /* SQL_procedure_statement_list  */
  YYSYMBOL_SQL_procedure_statement = 661,  /* SQL_procedure_statement  */
  YYSYMBOL_transition_table_or_variable_list = 662, /* transition_table_or_variable_list  */
  YYSYMBOL_transition_table_or_variable = 663, /* transition_table_or_variable  */
  YYSYMBOL_old_transition_table_name = 664, /* old_transition_table_name  */
  YYSYMBOL_new_transition_table_name = 665, /* new_transition_table_name  */
  YYSYMBOL_transition_table_name = 666,    /* transition_table_name  */
  YYSYMBOL_old_transition_variable_name = 667, /* old_transition_variable_name  */
  YYSYMBOL_new_transition_variable_name = 668, /* new_transition_variable_name  */
  YYSYMBOL_trigger_name = 669              /* trigger_name  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template, here we set
   the default value of $$ to a zeroed-out value.  Since the default
   value is undefined, this behavior is technically correct.  */
static YYSTYPE yyval_default;



#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif
#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#ifdef __cplusplus
  typedef bool yybool;
# define yytrue true
# define yyfalse false
#else
  /* When we move to stdbool, get rid of the various casts to yybool.  */
  typedef signed char yybool;
# define yytrue 1
# define yyfalse 0
#endif

#ifndef YYSETJMP
# include <setjmp.h>
# define YYJMP_BUF jmp_buf
# define YYSETJMP(Env) setjmp (Env)
/* Pacify Clang and ICC.  */
# define YYLONGJMP(Env, Val)                    \
 do {                                           \
   longjmp (Env, Val);                          \
   YY_ASSERT (0);                               \
 } while (yyfalse)
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* The _Noreturn keyword of C11.  */
#ifndef _Noreturn
# if (defined __cplusplus \
      && ((201103 <= __cplusplus && !(__GNUC__ == 4 && __GNUC_MINOR__ == 7)) \
          || (defined _MSC_VER && 1900 <= _MSC_VER)))
#  define _Noreturn [[noreturn]]
# elif ((!defined __cplusplus || defined __clang__) \
        && (201112 <= (defined __STDC_VERSION__ ? __STDC_VERSION__ : 0)  \
            || 4 < __GNUC__ + (7 <= __GNUC_MINOR__)))
   /* _Noreturn works as-is.  */
# elif 2 < __GNUC__ + (8 <= __GNUC_MINOR__) || 0x5110 <= __SUNPRO_C
#  define _Noreturn __attribute__ ((__noreturn__))
# elif 1200 <= (defined _MSC_VER ? _MSC_VER : 0)
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  372
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8707

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  328
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  342
/* YYNRULES -- Number of rules.  */
#define YYNRULES  785
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1302
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule.  */
#define YYMAXRHS 10
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule.  */
#define YYMAXLEFT 0

/* YYMAXUTOK -- Last valid token number (for yychar).  */
#define YYMAXUTOK   561

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     4,   324,   321,     5,   322,    13,   325,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     6,     7,
       2,   326,     2,     8,     2,     2,     2,     2,     2,     2,
       2,    16,     2,     2,     2,    14,     2,    15,     2,     2,
      18,     2,     2,     2,    17,     2,     2,     2,     2,     2,
       2,     9,     2,    10,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    11,     2,    12,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     323,   327
};

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   266,   266,   268,   276,   277,   335,   336,   337,   338,
     342,   353,   356,   362,   363,   367,   376,   377,   383,   386,
     387,   395,   399,   400,   404,   408,   412,   418,   419,   425,
     429,   439,   445,   454,   466,   474,   475,   483,   486,   492,
     504,   505,   513,   514,   522,   535,   536,   544,   548,   552,
     555,   561,   562,   566,   567,   571,   575,   580,   583,   589,
     590,   596,   597,   605,   608,   619,   624,   631,   632,   633,
     650,   651,   657,   659,   660,   661,   662,   663,   665,   666,
     667,   677,   678,   688,   707,   716,   725,   734,   744,   747,
     762,   773,   774,   779,   788,   799,   800,   801,   820,   823,
     829,   836,   837,   840,   850,   853,   859,   863,   864,   870,
     878,   889,   894,   897,   898,   901,   910,   911,   914,   915,
     918,   919,   922,   923,   926,   937,   940,   944,   945,   948,
     949,   957,   966,   982,   990,   993,   999,  1000,  1003,  1004,
    1007,  1008,  1017,  1023,  1030,  1031,  1039,  1048,  1055,  1056,
    1064,  1067,  1070,  1073,  1079,  1080,  1088,  1089,  1096,  1143,
    1152,  1153,  1161,  1162,  1171,  1172,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1191,  1198,  1205,  1230,  1231,  1232,
    1233,  1234,  1235,  1236,  1244,  1252,  1290,  1296,  1299,  1309,
    1319,  1325,  1331,  1353,  1378,  1379,  1383,  1394,  1401,  1410,
    1416,  1432,  1436,  1444,  1453,  1459,  1475,  1484,  1490,  1507,
    1508,  1509,  1513,  1519,  1525,  1534,  1539,  1554,  1559,  1591,
    1592,  1593,  1594,  1595,  1597,  1609,  1621,  1633,  1649,  1650,
    1656,  1659,  1669,  1679,  1680,  1681,  1684,  1692,  1703,  1713,
    1723,  1728,  1733,  1740,  1745,  1752,  1753,  1754,  1757,  1762,
    1769,  1781,  1782,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1801,  1802,  1809,
    1816,  1823,  1831,  1839,  1847,  1855,  1863,  1876,  1891,  1892,
    1895,  1896,  1897,  1900,  1901,  1904,  1905,  1906,  1907,  1910,
    1911,  1914,  1917,  1918,  1919,  1920,  1923,  1924,  1925,  1926,
    1927,  1928,  1929,  1933,  1934,  1935,  1938,  1941,  1945,  1946,
    1947,  1948,  1949,  1952,  1953,  1954,  1957,  1958,  1959,  1960,
    1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,
    1974,  1975,  1978,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  2001,  2002,  2003,  2006,  2007,  2011,  2020,  2027,  2034,
    2035,  2036,  2037,  2038,  2041,  2051,  2054,  2057,  2058,  2061,
    2062,  2068,  2078,  2079,  2083,  2095,  2096,  2099,  2102,  2105,
    2108,  2109,  2112,  2123,  2124,  2127,  2128,  2131,  2145,  2146,
    2149,  2155,  2163,  2166,  2167,  2170,  2173,  2174,  2177,  2185,
    2188,  2193,  2202,  2205,  2222,  2223,  2226,  2227,  2230,  2231,
    2234,  2237,  2246,  2249,  2254,  2262,  2263,  2266,  2275,  2276,
    2279,  2280,  2283,  2289,  2290,  2298,  2306,  2316,  2319,  2322,
    2323,  2329,  2332,  2340,  2347,  2353,  2359,  2368,  2369,  2377,
    2388,  2389,  2399,  2402,  2409,  2410,  2411,  2415,  2421,  2430,
    2431,  2432,  2436,  2445,  2453,  2462,  2463,  2466,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2483,  2484,  2487,  2496,  2510,  2513,  2524,  2528,  2538,
    2541,  2542,  2546,  2558,  2559,  2560,  2561,  2564,  2569,  2574,
    2581,  2589,  2590,  2593,  2594,  2599,  2600,  2608,  2620,  2629,
    2638,  2641,  2644,  2654,  2655,  2659,  2660,  2669,  2670,  2680,
    2683,  2684,  2692,  2702,  2703,  2706,  2709,  2712,  2715,  2716,
    2719,  2731,  2732,  2733,  2734,  2735,  2736,  2737,  2744,  2748,
    2749,  2752,  2753,  2759,  2768,  2769,  2776,  2786,  2787,  2794,
    2808,  2815,  2820,  2825,  2832,  2840,  2854,  2859,  2867,  2893,
    2954,  2955,  2956,  2957,  2958,  2961,  2969,  2970,  2979,  2985,
    2994,  3001,  3005,  3011,  3020,  3030,  3033,  3037,  3049,  3050,
    3057,  3065,  3074,  3077,  3081,  3094,  3095,  3096,  3103,  3111,
    3112,  3115,  3122,  3132,  3133,  3136,  3144,  3145,  3153,  3154,
    3157,  3164,  3177,  3201,  3208,  3221,  3222,  3223,  3228,  3233,
    3240,  3241,  3249,  3260,  3270,  3271,  3274,  3284,  3294,  3306,
    3318,  3328,  3336,  3343,  3350,  3356,  3360,  3361,  3362,  3366,
    3375,  3376,  3377,  3380,  3387,  3396,  3406,  3412,  3421,  3427,
    3434,  3444,  3468,  3471,  3478,  3481,  3482,  3491,  3492,  3495,
    3502,  3508,  3509,  3510,  3511,  3512,  3515,  3521,  3527,  3534,
    3541,  3547,  3550,  3551,  3554,  3563,  3564,  3567,  3577,  3585,
    3586,  3591,  3596,  3601,  3606,  3613,  3621,  3629,  3637,  3644,
    3651,  3657,  3665,  3673,  3680,  3683,  3692,  3700,  3708,  3714,
    3721,  3727,  3730,  3738,  3746,  3747,  3750,  3751,  3758,  3769,
    3775,  3781,  3787,  3788,  3789,  3790,  3793,  3801,  3802,  3803,
    3804,  3812,  3815,  3816,  3823,  3832,  3833,  3840,  3849,  3859,
    3860,  3866,  3872,  3880,  3881,  3884,  3892,  3900,  3910,  3911,
    3914,  3925,  3935,  3940,  3947,  3957,  3960,  3965,  3966,  3967,
    3968,  3969,  3970,  3973,  3978,  3985,  3995,  3996,  4004,  4007,
    4010,  4013,  4026,  4030,  4033,  4048,  4049,  4056,  4061,  4075,
    4078,  4093,  4096,  4104,  4105,  4106,  4114,  4115,  4116,  4124,
    4127,  4135,  4138,  4147,  4150,  4159,  4160,  4163,  4166,  4174,
    4175,  4186,  4191,  4198,  4202,  4207,  4215,  4223,  4231,  4239,
    4249,  4252,  4255,  4258,  4261,  4264
};
#endif

#define YYPACT_NINF (-1134)
#define YYTABLE_NINF (-733)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2404,  1444,   104, -1134,   115,   480, -1134, -1134, -1134, -1134,
   -1134, -1134,  2724,   275, -1134, -1134,   143,    17,   162,   194,
       3, -1134, -1134, -1134,   160,   201, -1134,   230,   423,   196,
   -1134, -1134, -1134, -1134,   268,   124,    91, -1134, -1134,   280,
     284, -1134,   201,   285, -1134, -1134, -1134,   291, -1134,   298,
     356, -1134, -1134,   313, -1134, -1134, -1134, -1134, -1134, -1134,
     467, -1134, -1134, -1134, -1134, -1134, -1134,   472, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,   482, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134,   536,  4617,   544,   552, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134,   555,   558, -1134, -1134,
   -1134, -1134,   561, -1134, -1134, -1134, -1134, -1134, -1134,  7851,
    7851,   571,   568, -1134, -1134, -1134, -1134,    65, -1134,   452,
   -1134, -1134, -1134, -1134,   139,   130, -1134, -1134, -1134, -1134,
   -1134, -1134,   289,   329, -1134, -1134,  4921, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134,   496, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134,   595,   642,   646,   650,   659,   669,   676, -1134,
   -1134, -1134,   679, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134,   399, -1134, -1134,   685, -1134,   699, -1134,   407,
     709, -1134, -1134, -1134,   716, -1134,   720, -1134, -1134, -1134,
   -1134, -1134,   169,   177,   691, -1134, -1134, -1134, -1134,   410,
   -1134,   416, -1134,   704, -1134, -1134, -1134, -1134, -1134, -1134,
     740, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134,  1444,   748,   750, -1134,   673,   456,
      95, -1134, -1134,   680, -1134,   145,    18, -1134,   763,   451,
   -1134,  8465, -1134, -1134,   640,   784,   792,   787,  3044,   403,
   -1134, -1134, -1134,   791,    34,  7265, -1134,  7265,   -11,   285,
     285,   794,   285,   120, -1134, -1134,   728,   736, -1134,   819,
   -1134,   819, -1134,   819,   724,   842, -1134,    41,  7265, -1134,
   -1134, -1134,  1150,  7265,  4324, -1134,   173,   735, -1134, -1134,
   -1134,  7265,  7265,  7265,   285,  7265,  7265,  5214,  7265,  5507,
    3364, -1134,   264, -1134,   622,  7265,  7265,   872,   924,  7265,
   -1134, -1134, -1134, -1134,  5800,   874,  7265,   850,  4921, -1134,
   -1134, -1134, -1134, -1134, -1134,  3364,  3364, -1134,   876,   877,
   -1134, -1134,   201, -1134, -1134, -1134, -1134,   879,  7265,  7265,
    7265,  7265,  7265,  6093,  7265,   122,  7265,  7265,    91,  7558,
    6386,  7558,  7558,  7558,  7558,   795, -1134,  7265,   509,   285,
   -1134,  7265,   880,  5800, -1134,   850, -1134, -1134,   850,   850,
   -1134, -1134, -1134, -1134, -1134, -1134,   883,   285, -1134, -1134,
   -1134,  3044,    91, -1134,   103,   882,   885, -1134, -1134, -1134,
   -1134, -1134, -1134,   855,   410,   884,   758,   895,  7265,   899,
     819, -1134,   274,   762,   120,   465, -1134,    83, -1134, -1134,
   -1134,   285,   671,   833, -1134, -1134,    20, -1134,    53,   901,
   -1134,   107, -1134,   410,   770, -1134,  7265, -1134, -1134,   -17,
     905,  6679,   890,   891,    83,    49,    52,    58,   907,   485,
     -21,   538,    -5,   837, -1134, -1134,   844, -1134, -1134,   846,
     852,   854,   921,   861, -1134,   862, -1134, -1134,   410,   -34,
    5507,    60,  -150,  7265, -1134,   692,  3364,   690, -1134,   622,
     581,   410,   597,    63, -1134,   496, -1134, -1134,   934, -1134,
      22,   628,  5507, -1134, -1134,    82,    24, -1134,   838, -1134,
   -1134,   289, -1134, -1134,   939,   161, -1134, -1134,   945,   947,
   -1134,   656,   689,   946,   948, -1134,   711,   950,   951,   929,
   -1134, -1134, -1134, -1134, -1134,   952,   410,    67,  7265,   954,
     258, -1134,   117,   188, -1134, -1134,   169,   169, -1134, -1134,
   -1134, -1134, -1134,    68, -1134,   592, -1134,   120,   120,   120,
    7265,   956,  1150,   935,    74,   818,   818,   285, -1134,   958,
      70,   928, -1134, -1134,   864,    55,  3364, -1134, -1134,    51,
     959, -1134, -1134, -1134, -1134,   605, -1134,   839, -1134, -1134,
   -1134,   518,   465, -1134,   762,  7265,    83, -1134, -1134,   285,
     410,  7265, -1134,  7265,     8,   953, -1134,   953, -1134, -1134,
     127, -1134,   648, -1134, -1134, -1134,   120, -1134,  7265,  7265,
    7265, -1134,  7265,  7265,  7265,   930,   965,  7265,   410, -1134,
   -1134,   113, -1134,  4921,    56,    61,    76,    78,    90, -1134,
     727, -1134, -1134, -1134, -1134, -1134,   924,  5800,   752,   908,
    7265, -1134, -1134, -1134, -1134,  7265,   196,  7265,  7265, -1134,
    7265, -1134,  7265,  7265, -1134, -1134,  7265, -1134, -1134,  7265,
   -1134,   668, -1134,   966,   971,   350,   972,   738,   738,  7265,
   -1134, -1134,  5800, -1134, -1134,   673, -1134,   673,   924, -1134,
     903,   977,   978, -1134, -1134,    71, -1134,   989,   989,   889,
     991, -1134,   163,   989, -1134, -1134,   992,   992,   166,   992,
     992,   993,    62,   993,   993, -1134,   195, -1134,   386,   996,
   -1134, -1134, -1134,   961, -1134,   704, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134,   997,  1000, -1134,  1002,   919,
     920, -1134,   694, -1134, -1134,  1005, -1134,  8101,   838, -1134,
   -1134,   910, -1134,   911,   329,   465, -1134,    83,    75,   493,
     860,  1007,   488,   412, -1134, -1134, -1134,   412,   133,   936,
   -1134, -1134,  1010,   410,   410,  7265,   990,    83, -1134,  6972,
      51,   410,   410,    69,    -6,   110,    72,  3684, -1134, -1134,
    -136,  4004,  7265, -1134, -1134, -1134,  1011, -1134, -1134,   998,
     695,   333,   957,   191,   410, -1134, -1134, -1134,  1016,  1017,
     983,   922, -1134, -1134,  1021,   350,   739,   741, -1134, -1134,
   -1134,   955, -1134, -1134,   759, -1134,   496,   717, -1134, -1134,
     109,   109,  1004,   992,   755, -1134, -1134,  1012, -1134, -1134,
   -1134,  1013,   992,   756, -1134, -1134,   -50,   -50,   992,   760,
   -1134, -1134, -1134,  1014, -1134, -1134,   209,    42, -1134, -1134,
     992,   764, -1134, -1134, -1134, -1134, -1134,   989, -1134,   992,
     913, -1134, -1134, -1134,   926,   704, -1134, -1134, -1134, -1134,
    3364,  1038, -1134, -1134,    70,    83, -1134,   900,    83, -1134,
     990, -1134, -1134, -1134, -1134,   100, -1134, -1134,   493,   744,
    1039,   518,   518,   960, -1134, -1134,   487, -1134, -1134,   941,
     962, -1134,  1019,  1044,  1023, -1134, -1134,  1015,   973, -1134,
     410, -1134, -1134, -1134, -1134,   410, -1134,  7265,  1046,  1048,
   -1134,  1051, -1134,   147,    89,   131, -1134,  5800, -1134, -1134,
   -1134, -1134, -1134, -1134,   979,  1045,  7265,  7265,  7265,   108,
     353,  7265, -1134, -1134, -1134,  1055,   738, -1134,   924, -1134,
   -1134,  1056, -1134,   993,   745,  1057, -1134,   993,   937,   940,
   -1134, -1134, -1134,   993,   761,  1059,   992,   790, -1134,   992,
   -1134, -1134,   993, -1134,   942,   499,  1040, -1134,   106,    83,
   -1134,   785,   600,  1022, -1134,  1062, -1134,   815,    75,   994,
   -1134, -1134,  1060,   488,   518,   985, -1134,   518, -1134,    83,
   -1134,  1044,  8235,  3364,   766,   410, -1134, -1134,  3684, -1134,
   -1134, -1134, -1134,  7265, -1134,   486,   350, -1134, -1134,   410,
   -1134,  1070,   216,  1072, -1134,   704, -1134, -1134,  1074, -1134,
     599, -1134,   410,   922, -1134, -1134, -1134, -1134, -1134,  1058,
   -1134, -1134,   938,   943, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134,   993, -1134, -1134,   992, -1134, -1134, -1134,
   -1134,   788, -1134,   984,  1076,   570,   285, -1134, -1134,   982,
     549,  1020, -1134,   987, -1134,   722,   518,   653,   823, -1134,
    1079, -1134, -1134,   329,   929,   922, -1134, -1134, -1134, -1134,
   -1134,  7265,   108, -1134, -1134,   718,   827,   783,   789,   797,
   -1134, -1134, -1134,  1096,  1099, -1134, -1134, -1134, -1134,   995,
   -1134,  3364, -1134, -1134, -1134,   496, -1134,  1101, -1134,   -15,
      -9,   549, -1134,   853, -1134,   863, -1134,   737,  3364,  1105,
   -1134, -1134, -1134, -1134,  8235, -1134,  1104, -1134,  1078,   803,
   -1134, -1134,   229,   234, -1134,   799, -1134, -1134, -1134, -1134,
   -1134,   187, -1134, -1134, -1134, -1134,   285,   112,    83,  1082,
   -1134,  1082,  1082,  1082, -1134,   574,  1112,  1764,   329,    83,
   -1134, -1134,   929,  1113,  1094,   808, -1134, -1134, -1134,   718,
     865, -1134, -1134,   820,  1117, -1134,   830,  1095,  1098,  1095,
    1100, -1134, -1134, -1134,  3364, -1134,   866, -1134, -1134, -1134,
     832, -1134, -1134,   817,   778,  1061, -1134, -1134, -1134, -1134,
   -1134,    83, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134,   116,  2404, -1134,  1102, -1134,  -147,   496,  -126,
   -1134, -1134,   836, -1134,  1121, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134,   778, -1134,  2084,  -147, -1134,   496, -1134, -1134,
     821, -1134
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
      70,    70,     0,   743,     0,   437,   583,   223,   219,   220,
     221,   222,    70,   709,   462,   457,     0,     0,     0,     0,
       0,   329,   327,    92,     0,     0,   256,     0,     0,    70,
     605,   458,   459,   255,     0,     0,    95,   463,   460,     0,
       0,   257,     0,     0,   604,   254,   297,     0,   308,   711,
       0,   309,   310,   307,   298,   304,   296,   289,   311,   299,
     710,   303,   306,   305,   300,   312,   301,     0,   302,   541,
     542,   543,   313,   314,   320,   317,   316,   318,   712,   323,
     324,   319,   321,   315,   322,   290,   325,   330,   331,   328,
     286,   326,   333,   334,   335,   336,   351,   337,   338,   339,
     340,   346,   341,   287,   288,   348,   347,   352,   332,   353,
     349,   354,   350,   285,   342,   343,   344,   345,   355,   461,
     470,   469,   468,   467,   466,   465,   464,   483,   484,   485,
     486,   480,   481,     0,     0,     0,     0,   258,   259,   260,
     261,   262,   263,   264,   265,   266,     0,     0,   375,   376,
     383,   384,     0,   181,   182,   178,   177,   180,   179,     0,
       0,     0,     2,     5,     6,     7,     8,     0,     4,    79,
      72,    73,    74,    75,    70,   158,    76,    77,    78,    81,
     160,   162,   164,   748,   156,   166,     0,   187,   167,   192,
     193,   173,   200,   171,   205,   172,   208,   168,   169,   170,
     516,   252,   233,   530,   240,   241,   242,   235,   234,   521,
     251,   523,     0,     0,     0,     0,     0,     0,     0,   280,
     283,   291,     0,   292,   278,   281,   293,   279,   282,   284,
     294,   526,     0,   360,   361,     0,   362,     0,   363,   267,
       0,   455,   471,   472,     0,   456,     0,   524,   528,   529,
     531,   534,   537,   575,   546,   540,   548,   549,   577,    91,
     576,   578,   580,   586,   579,   584,   589,   590,   588,   595,
       0,   596,   597,   598,   599,   522,   627,   525,   713,   714,
     718,   719,   253,     9,    70,     0,     0,   504,     0,    81,
       0,   505,   507,   510,   515,     0,    91,   742,     0,     0,
     449,     0,   450,   451,     0,     0,     0,     0,    70,     0,
      71,   307,   161,     0,     0,     0,    83,     0,    95,     0,
       0,     0,     0,     0,   212,   741,     0,     0,    53,    42,
      51,    42,    56,    42,     0,    48,    49,   184,     0,    93,
      96,    97,     0,     0,     0,   213,   626,     0,   622,   621,
     620,     0,     0,     0,     0,     0,   594,     0,     0,     0,
      70,   740,   736,   733,     0,     0,     0,     0,     0,     0,
     533,   532,     1,     3,     0,     0,     0,   513,     0,   186,
     190,   191,   199,   204,   207,    70,    70,   210,   209,   211,
     176,    90,     0,   224,   225,   226,   227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    95,     0,
       0,     0,     0,     0,     0,     0,   547,     0,     0,     0,
     587,     0,   515,     0,   749,   513,   157,   214,   513,   513,
     527,   744,   438,   295,   448,   267,     0,     0,    80,   268,
     447,    70,    95,   503,     0,     0,   709,   711,   710,   712,
     633,   628,   632,     0,   517,     0,   576,     0,     0,     0,
      42,   785,     0,   107,     0,     0,    47,     0,    55,    54,
      52,     0,     0,     0,   197,   198,     0,   111,     0,   112,
     215,   228,   217,     0,   576,   616,     0,   617,   618,   615,
       0,     0,     0,     0,     0,     0,     0,     0,    42,     0,
     565,     0,   565,     0,   592,   593,   327,   248,   249,   323,
     324,   319,   244,   326,   246,     0,   245,   243,   247,    61,
       0,     0,     0,     0,   734,     0,    70,   736,   722,     0,
       0,   565,     0,   565,   358,   366,   368,   367,     0,   365,
       0,     0,     0,   203,   201,   194,   194,   514,     0,   175,
     163,   165,   206,   270,     0,   739,   568,   738,     0,     0,
     572,     0,     0,     0,     0,   269,     0,     0,     0,   404,
     392,   393,   356,   394,   395,   369,   377,     0,     0,     0,
     479,   357,     0,   477,   535,   536,   538,   539,   545,   544,
     582,   581,   585,     0,   506,     0,    88,     0,     0,     0,
       0,   440,     0,     0,     0,     0,     0,     0,   453,     0,
       0,     0,   753,   754,     0,     0,    70,    84,   108,     0,
      85,   104,   106,   218,   709,     0,    38,     0,    50,   183,
     238,     0,     0,   110,   107,     0,     0,   619,   230,     0,
     614,     0,   610,     0,     0,     0,   624,   626,   623,   625,
     107,    98,     0,   239,   236,   237,     0,   232,     0,     0,
       0,   603,     0,     0,     0,     0,     0,     0,   739,   737,
     721,    90,   728,     0,   187,   192,   200,   205,     0,   725,
       0,   723,   715,   717,   716,   364,     0,     0,     0,     0,
       0,   189,   188,    82,   271,     0,    70,     0,     0,   272,
       0,   276,     0,     0,   277,   273,     0,   275,   274,     0,
     410,   406,   405,     0,     0,   372,     0,   475,   475,     0,
     606,    87,     0,   509,   508,   512,   109,   511,   444,   439,
       0,     0,   709,   629,   694,   652,   702,   686,   686,   699,
     697,   693,   652,   686,   698,   692,   652,   652,   652,     0,
       0,   655,     0,   655,   655,   695,   652,   701,     0,     0,
     518,   519,   634,   635,   651,   637,   674,   641,   681,   642,
     684,   685,   643,   644,   645,     0,     0,   454,     0,     0,
       0,    19,     0,    11,    13,     0,    14,     0,     0,   755,
     757,   759,   756,     0,   147,     0,    43,     0,     0,     0,
       0,   133,   134,   745,   500,   501,   144,   140,     0,   148,
     216,   229,     0,   613,   612,     0,     0,     0,   103,     0,
      86,   566,   567,     0,   600,   576,     0,    70,   482,   735,
     174,    70,     0,   720,   389,   388,     0,   185,   202,     0,
     195,   571,   184,     0,   569,   562,   573,   574,     0,     0,
       0,    61,   407,   378,   370,   372,     0,     0,   382,   373,
     452,     0,   478,   473,     0,    89,   445,     0,   442,   446,
       0,     0,     0,     0,     0,   646,   653,     0,   691,   690,
     700,     0,     0,     0,   670,   689,   705,   705,     0,     0,
     647,   650,   680,     0,   677,   656,   652,   652,   667,   683,
       0,     0,   678,   552,   553,   554,   551,   686,   550,   652,
       0,   561,   708,   520,     0,   637,   638,   640,   608,   607,
      70,     0,    20,    10,     0,     0,    16,    40,     0,   758,
       0,   105,    37,   747,    59,    45,    57,    60,     0,   493,
     144,     0,     0,     0,   489,   494,   493,   487,   488,   495,
       0,   137,     0,    35,     0,   142,    94,     0,   154,   609,
     611,   626,    99,   102,   100,   101,   231,     0,     0,     0,
     250,    62,    63,    67,    67,     0,   727,     0,   729,   731,
     732,   730,   726,   724,   385,     0,     0,     0,     0,     0,
     408,     0,   374,   380,   381,     0,   475,   441,   444,   631,
     630,     0,   648,   655,     0,     0,   673,   655,     0,     0,
     703,   704,   649,   655,   659,     0,     0,     0,   668,     0,
     669,   679,   655,   559,   558,     0,     0,   639,     0,     0,
      12,     0,    15,     0,    39,   761,   760,   751,     0,     0,
      44,   146,   144,   135,     0,     0,   496,     0,   746,     0,
     143,    35,     0,    70,   396,   601,   602,   591,    70,    68,
      69,    66,    65,     0,   174,     0,   372,   386,   196,   570,
     563,     0,   709,   411,   413,   637,   419,   418,     0,   409,
       0,   371,   379,    61,   474,   443,   654,   665,   687,     0,
     696,   676,     0,     0,   666,   660,   661,   662,   663,   664,
     658,   657,   671,   655,   672,   682,   652,   556,   560,   636,
      34,     0,    31,     0,    27,     0,     0,    22,    17,     0,
       0,   763,    58,     0,   145,   497,     0,   493,     0,   141,
     149,   151,   150,   155,     0,    61,   397,    64,   390,   391,
     387,     0,     0,   414,   403,     0,     0,     0,     0,   415,
     420,   423,   421,     0,     0,   706,   707,   675,   557,     0,
      21,    70,    24,    25,    26,    23,    18,    29,    41,   138,
     138,   752,   774,     0,   750,   767,    46,   498,    70,     0,
     491,   499,   492,    36,     0,   402,   398,   400,     0,   127,
     564,   412,     0,     0,   429,     0,   427,   431,   424,   422,
     425,     0,   417,   416,   476,   688,     0,     0,     0,   136,
     139,   136,   136,   136,   775,     0,     0,    70,   490,     0,
     153,   152,     0,     0,     0,   113,   128,   430,   432,     0,
       0,   434,   435,     0,    32,    28,     0,     0,     0,     0,
       0,   765,   766,   764,    70,   768,     0,   773,   762,   769,
       0,   399,   401,   129,     0,   122,   114,   426,   428,   433,
     436,     0,    30,   782,   779,   781,   784,   777,   778,   780,
     783,   776,     0,    70,   502,     0,   131,     0,   125,     0,
     132,   123,     0,   159,     0,   771,   130,   120,   121,   115,
     118,   119,   116,    33,    70,     0,   117,   126,   770,   772,
       0,   124
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1134, -1134,   151, -1134, -1134, -1134,   205, -1134, -1134, -1134,
      99, -1134, -1134,    81,  -873, -1134, -1134,  -254, -1134, -1134,
   -1134, -1134,   662, -1134,    97,  -814, -1134,    79,   164,   -16,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,  -182,  -127,
   -1134, -1134,  -190, -1134,   319, -1134, -1134,   507,   345,  -505,
     247,     0,   539, -1134, -1134, -1134, -1134,  -153, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134,   335, -1134, -1134,  -789,   -26,
   -1134,  -610, -1134, -1134, -1134, -1134,  1133, -1134,   765,   768,
       1,  -781, -1134, -1134,  -166,  -155, -1134,  -144,   974, -1134,
     601,  -142, -1134, -1134,  -141, -1134,   975, -1134, -1134, -1134,
   -1134,   -19, -1134,   511, -1134,  -363, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134,  -983, -1134,  -292,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134,   469,   471, -1134, -1134,  -780, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,  -315,
   -1134, -1134, -1134, -1134, -1134,   -71, -1134,   -63, -1134, -1134,
   -1134, -1134, -1134, -1134,    21, -1134, -1134, -1134, -1134,    84,
   -1134, -1134, -1134, -1134,   -64, -1134, -1134, -1134, -1134, -1134,
   -1134,   170, -1134, -1134,  -291, -1134, -1134, -1134,  -671, -1134,
   -1134, -1134, -1134, -1134,  -290, -1134, -1134, -1134,   221, -1134,
   -1134,  -711, -1134, -1134,   578,   253, -1134,  -270,  -121,  -386,
   -1134,   867,   572, -1134,   801,   697,   442,   445,   771, -1134,
      73, -1134, -1134, -1134, -1134, -1134,  -688, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134,  -317,  -373,   215,    11,  -289, -1134,
   -1134, -1134,   927,   767, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134,   357, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134,   -40, -1134,   380,  -477,  -926,  -520,   396, -1134,  -835,
   -1134, -1134,  -706,  -249,  -710, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1134,  -652, -1134, -1134, -1134, -1134,   300,
   -1134,  -294, -1134, -1134, -1134, -1134, -1134, -1134,   660, -1134,
     361,   829,  -264,   667,  -508, -1134, -1134, -1134,  -334, -1134,
   -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134, -1134,
   -1134, -1134, -1134, -1133, -1134,    25, -1134, -1134,   -44, -1134,
   -1134, -1134
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   161,  1247,   163,   164,   782,   783,   784,  1032,  1164,
     785,  1118,   786,  1050,   625,   165,  1034,   468,   166,  1040,
     334,   335,   336,   935,   936,   666,   971,   972,  1061,   167,
     168,   169,   170,   171,   172,   173,   287,   595,   174,   175,
     176,   177,   342,   650,   651,   964,   178,   620,   621,   617,
     288,   443,   478,  1255,  1256,  1295,  1292,  1289,  1280,  1281,
    1277,  1296,  1225,  1276,  1226,   633,   634,   801,   952,  1211,
     955,   939,   618,   958,  1130,  1054,   180,  1245,   181,   182,
     183,   184,   672,   185,   186,   187,   188,   189,   190,   191,
     691,   192,   193,   543,   194,   195,   196,   197,   392,   198,
     199,   200,   479,   480,   622,   201,   637,   202,   203,   204,
     205,   206,   207,   514,   515,   516,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   536,   537,   538,   714,   858,   234,   235,   575,
     854,  1081,   859,   236,   237,  1066,   238,   836,  1067,  1185,
     572,   573,  1135,  1136,  1186,  1187,  1188,   574,   711,   851,
    1078,   712,   852,  1073,  1074,  1202,  1079,  1080,  1149,  1194,
    1151,  1152,  1195,  1257,  1196,  1197,  1203,   304,   305,   729,
     867,   868,   306,   307,   239,   240,   241,   242,   862,   582,
     243,   579,   244,   245,   246,   949,  1180,  1181,   950,   804,
     805,   806,  1182,   291,   292,   293,   724,   294,   548,   295,
     247,   453,   759,   248,   249,   250,   251,   252,   253,   254,
     255,   416,   589,   256,   257,   258,   517,   910,  1108,   911,
     912,   558,   563,   567,   583,   560,   561,   259,   260,   261,
     262,   263,   916,   264,   265,   266,   267,   503,   504,   505,
     268,   968,   269,   270,   271,   272,   273,   274,   490,   491,
     482,   807,   348,   349,   350,   275,   451,   761,   915,   917,
     762,   763,   875,   876,   894,   895,  1015,  1100,   764,   765,
     766,   767,   768,   769,   878,   770,   771,   772,   773,  1010,
     774,   276,   277,   278,   279,   280,   281,   527,   528,   678,
     679,   362,   363,   525,   556,   557,   364,   326,   282,   953,
     937,   283,  1121,   615,   793,   929,  1036,  1174,  1175,  1243,
    1217,  1248,  1284,  1249,  1171,  1172,  1268,  1264,  1265,  1271,
    1267,   462
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     179,   289,   290,   347,   390,   535,   324,   361,   378,   434,
     435,   436,   296,   337,   422,   669,   649,   340,   954,   379,
     452,   802,   430,   345,   630,   554,   559,   686,   456,   564,
     380,   568,   382,   383,   539,   689,   884,   990,   499,   501,
     886,   887,   890,   898,   899,   872,   974,   863,   530,   532,
     902,   341,  1031,   653,   484,  1035,   654,   641,   660,   391,
     446,  -729,   655,  1075,   430,   967,  -731,   684,   665,   662,
     909,   715,   720,   966,   872,   992,   970,   469,   619,   470,
    1027,  -732,   815,  -730,   733,   609,   879,   546,   940,   690,
     571,   885,  1008,   689,   667,   831,   624,  1148,   524,   426,
     732,   933,   374,   473,   896,  1038,  1209,   426,  -174,   624,
    1110,  1287,  1212,   778,  -600,   790,  1235,   428,  -727,   340,
    1283,   718,  1059,   464,   319,   569,  1132,   631,   458,   809,
     297,   623,   817,   624,  1072,   624,   632,   474,   795,   636,
    1285,   298,   779,   320,   375,   818,   315,   690,   570,   427,
    1060,   162,   286,   341,   376,   -90,  1111,   719,  1288,   829,
     316,  1299,  1193,   386,   310,   317,   872,   -90,   374,   872,
    1290,   422,   -90,   626,   475,   780,  1128,  -176,  -176,   492,
    1059,   967,   429,   934,   -90,  1291,   493,   638,   447,   791,
    1018,  1020,   541,   658,   422,   659,   549,   318,   872,   448,
     652,   695,   781,  1024,   323,   716,   611,   631,  1060,   -90,
     375,   428,   872,   792,   -90,   897,  1075,   449,   578,   -90,
    1063,   310,   313,    29,   447,   688,   -90,   940,   447,   314,
    1042,   -90,  1009,   442,   322,   448,   -90,   447,  1230,   448,
    1143,   596,  1039,  1210,   656,   696,  1193,   391,   448,  1210,
     422,   391,   602,   449,   710,  1023,   325,   449,  1221,   285,
     321,   447,   447,   447,  1231,   524,   449,   339,   616,  1153,
     820,   338,   448,   448,   448,   696,   429,   974,  -295,   459,
     460,   313,   463,   343,   289,   290,  1140,   344,   314,   417,
     449,   449,   449,  1087,   351,   296,   391,  1091,   623,   697,
    -187,   352,   417,  1094,   597,  -192,   417,   598,   599,   444,
     452,   346,  1105,   457,   498,  1019,   787,   417,   417,   296,
    -200,  1189,  -205,   535,   983,  1084,   454,   845,   454,   846,
     847,   417,  1043,   848,   832,  1236,   849,  1107,   658,   649,
     659,   417,   811,   417,   873,   417,  1250,  -576,   874,   476,
     999,  1000,   539,   481,   483,   489,   544,  -158,   450,   353,
     673,   522,   495,   496,   497,   866,   500,   502,   518,   519,
     521,   674,   417,   552,   825,   417,   531,   533,   841,   592,
     540,   417,   675,   417,   676,   677,   417,   483,  1282,   698,
     417,   417,   417,  1157,   869,   417,   354,   601,   450,   671,
    1158,   840,   864,  -529,  -529,  -529,  -529,  -529,   386,   555,
     555,   555,   555,   555,   555,   555,   386,   576,   577,   386,
    1237,   531,  1238,  1239,  1240,   386,  -158,  -158,   590,   386,
     417,   627,   593,   450,  1125,   286,   882,  1127,  -136,   888,
     883,   903,   444,   889,   951,   -90,   -90,   -90,   -90,   -90,
     -90,   327,   296,  1037,   153,   154,   155,   156,   157,   158,
     -81,   623,   -90,   -90,   -90,   -90,   -90,   -90,   900,   555,
     355,     2,   901,     3,     4,   356,   153,   154,   155,   156,
     157,   158,  1016,   328,   417,   357,  1017,  1232,   299,   657,
     658,   830,   659,   411,   412,  1233,   938,   640,   413,   414,
     891,   892,   644,   932,   800,   837,   153,   154,   155,   156,
     157,   158,   360,   523,   417,   393,  1177,   394,   395,   346,
     396,   799,  -503,   652,   612,   613,   614,   522,     6,   800,
    1227,   521,  1199,   329,   668,  1228,   330,  1200,   943,   358,
     865,  -503,   661,   658,   346,   659,   391,   365,   693,   300,
     301,   302,   303,   531,   903,   366,    18,   331,   367,   332,
     391,   368,   944,   944,   369,   760,   760,   776,   945,   945,
     904,   372,   905,   906,  -493,   373,   452,   452,   907,   413,
     414,   333,   946,   377,   908,   682,   658,   -81,   659,   555,
       7,     8,     9,    10,    11,   391,   721,   722,   397,   812,
      30,   683,   658,   385,   659,     2,   442,     3,     4,   796,
     797,   531,   803,   481,  1070,  1071,   562,   794,   566,     7,
       8,     9,    10,    11,  1002,  1113,   300,   301,   302,   303,
     787,   626,   285,  1006,   626,   866,  1145,    39,    40,  1012,
     856,   857,   386,  1114,    44,   398,   481,   947,   947,   399,
    1146,  1021,   813,   400,   814,   948,   948,  1076,  1077,  1115,
     701,   702,   401,   703,   869,   977,  1162,    26,   422,   821,
     822,   823,   402,   824,   483,   826,   978,   986,   668,   403,
     842,    67,   404,   904,   405,   905,   906,   979,   406,   980,
     981,  1106,  -359,   704,   702,    33,   703,   908,   923,   924,
     973,   483,   407,   943,   976,   780,   531,  1163,   843,   844,
    1116,   555,   408,   555,   555,   707,   702,   555,   703,   409,
     555,   997,   998,   410,     2,   415,     3,     4,   944,    41,
     531,   328,   781,   417,   945,   626,    45,   418,     7,     8,
       9,    10,    11,   421,    69,    70,    71,   946,   419,  1088,
    1089,   423,  1165,  1178,   424,   626,   838,   658,   425,   659,
    1131,   435,   436,   996,   658,  -109,   659,  1102,  1190,  1146,
    1104,   432,   943,   431,   546,  1095,  1096,  1097,  1098,  1099,
     803,   329,  1138,  1139,   330,   437,    26,   943,   927,  1112,
     797,  1179,  1159,   797,   943,  1064,   438,   944,     7,     8,
       9,    10,    11,   945,   439,   331,   440,   332,  -493,  1169,
    1170,   465,   944,   947,    33,   975,   946,   445,   945,   944,
     461,   948,   467,  -493,   471,   945,   960,  1183,   797,   333,
     965,   946,  1241,  1242,  1262,   797,  1274,   797,   946,   734,
    1293,   797,   466,   668,   346,   725,   727,   472,    41,   494,
     391,   726,   726,   584,   585,    45,   370,   371,   586,   587,
     735,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     526,   736,   646,   648,   737,   738,   534,   542,   547,  -209,
    -211,   739,   947,   553,   594,   588,   600,   605,   740,   606,
     948,  1278,  1220,   435,   436,   603,   607,   947,   604,   608,
     741,  1147,   610,   616,   947,   948,   635,   629,   639,   642,
     467,   663,   948,   742,   626,   743,   645,   647,  -552,   803,
    -553,  1028,   803,   803,  -325,   626,  -554,   744,  -551,  1297,
       2,   973,     3,     4,   745,  -550,   664,   670,   685,   523,
     746,   747,   687,   694,     7,     8,     9,    10,    11,   699,
     705,   442,   700,   706,   708,   570,   709,   713,   717,   728,
     788,   731,   777,   789,   795,   798,   816,   626,   819,   828,
     827,   748,   833,   839,   850,   855,   860,   631,  1055,   861,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   853,
     870,   871,   877,   880,   881,   872,   893,  1069,   555,   555,
     913,   918,  1082,   914,   919,   920,   921,   922,   925,   928,
     941,   930,   942,   957,   959,   984,   961,   985,  -576,   473,
    1192,   987,   988,   989,   665,   803,   991,  1001,   803,  1003,
    1007,   993,   995,   994,  1013,  1004,  1005,  1014,  1022,  1025,
    1026,  1029,  1033,  1041,  1046,  1048,  1044,  1049,  1047,  1051,
    1056,  1053,  1057,  1065,  1133,  1052,  1058,  1068,  1083,  1092,
    1086,  1090,  1093,  1101,  1103,  1119,  1109,   797,  -555,  1120,
    1123,  1126,  1124,  1134,   483,  1141,  1167,  1142,  1144,  1161,
    1160,  1154,  1155,  1168,  1184,  1198,  1199,  1156,  1176,   749,
     750,  1173,  1200,   751,   752,  1201,   753,   754,   755,   756,
    1204,   757,   758,  1205,  1208,  1206,  1215,   803,  1219,  1222,
    1223,  1216,  1224,  1229,   951,  1244,   569,  1253,  1254,  1260,
    1261,  1263,  1273,  1259,  1266,  1286,  1270,  1275,  1294,  1030,
    1279,  1117,  1129,  1301,   628,  1122,   962,  1137,  1062,   808,
     931,   730,  1300,   956,  1213,   312,   810,   692,   381,   384,
     550,  1251,   555,   359,   551,   834,     2,   835,     3,     4,
    1252,   309,  1207,  1191,  1150,  1258,  1234,  1045,  1085,     6,
       7,     8,     9,    10,    11,   723,    13,   545,   775,  1218,
     580,    14,   969,   926,   455,   591,    15,  1011,  1166,   681,
     420,    16,   982,   529,   680,  1269,  1214,    18,    19,     0,
       0,     0,     0,     0,    21,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   179,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,    31,    32,     0,  1272,    33,     0,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,     0,
      38,     0,     0,   179,     0,     0,     0,     0,    39,    40,
      41,     0,     0,     0,     0,    44,     0,    45,     0,     0,
       0,     0,     0,     0,   179,     0,     0,     0,     0,     0,
       0,    46,    47,    48,    49,    50,    51,    52,   311,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,     0,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,     0,   133,   134,     0,     0,   135,   136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   137,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   146,   147,   148,   149,
       0,     0,     0,   150,   151,   152,     0,   284,     0,     0,
       2,     0,     3,     4,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,    12,
      13,   159,   160,     0,   477,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,    17,
       0,    18,    19,    20,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,    24,     0,     0,     0,     0,     0,
       0,    25,    26,    27,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,    36,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,    43,    44,
       0,    45,     0,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,     1,     0,     0,
       2,     0,     3,     4,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,    17,
       0,    18,    19,    20,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,    24,     0,     0,     0,     0,     0,
       0,    25,    26,    27,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,    36,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,    43,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,  1246,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,     1,     0,     0,
       2,     0,     3,     4,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,    17,
       0,    18,    19,    20,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,    24,     0,     0,     0,     0,     0,
       0,    25,    26,    27,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,    36,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,    43,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,  1298,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,     1,     0,     0,
       2,     0,     3,     4,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,    17,
       0,    18,    19,    20,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,    24,     0,     0,     0,     0,     0,
       0,    25,    26,    27,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,    36,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,    43,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   308,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,   310,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,   -70,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
       0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   -70,     0,     0,     0,     0,    29,     0,
       0,     0,     0,   -70,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,     0,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   441,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
       0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   442,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,     0,    44,
       0,    45,     0,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   308,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,    12,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
       0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,     0,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   359,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,   310,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
       0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,    42,     0,     0,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   359,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,   310,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,    22,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,     0,    39,    40,    41,     0,     0,     0,     0,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   359,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,     0,
      13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
      15,     0,     0,   485,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,   486,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   487,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,     0,     0,
       0,   488,    39,    40,    41,     0,     0,     0,     0,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
     359,     0,     0,     2,     0,     3,     4,     0,   309,     0,
       0,     0,     0,     0,     0,     0,     6,     7,     8,     9,
      10,    11,     0,    13,     0,   159,   160,     0,    14,     0,
       0,     0,     0,    15,     0,     0,     0,     0,    16,     0,
       0,     0,     0,     0,    18,    19,     0,     0,     0,     0,
       0,    21,    22,     0,     0,     0,    23,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,    31,
      32,     0,     0,    33,     0,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    37,     0,     0,    38,     0,     0,
       0,     0,     0,     0,     0,    39,    40,    41,     0,     0,
       0,     0,    44,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    47,
      48,    49,    50,    51,    52,   311,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,     0,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,    91,     0,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
     134,     0,     0,   135,   136,   360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   137,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   146,   147,   148,   149,     0,     0,     0,
     150,   151,   152,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   359,     0,     0,     2,     0,     3,
       4,     0,   309,     0,     0,     0,     0,     0,   159,   160,
       6,     7,     8,     9,    10,    11,     0,    13,     0,   387,
       0,     0,   388,     0,     0,     0,     0,    15,     0,     0,
       0,     0,    16,     0,     0,     0,     0,     0,    18,    19,
       0,     0,     0,     0,     0,    21,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,    32,     0,     0,    33,     0,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   389,     0,
       0,    38,     0,     0,     0,     0,     0,     0,     0,    39,
      40,    41,     0,     0,     0,     0,    44,     0,    45,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,    47,    48,    49,    50,    51,    52,   311,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,    91,
       0,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,     0,   133,   134,     0,     0,   135,   136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   137,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   146,   147,   148,
     149,     0,     0,     0,   150,   151,   152,   359,     0,     0,
       2,     0,     3,     4,     0,   309,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,    10,    11,     0,
      13,     0,   159,   160,     0,    14,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,    18,    19,     0,     0,     0,     0,     0,    21,   506,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    30,    31,    32,     0,     0,
      33,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,    38,     0,     0,     0,   507,   508,
       0,     0,    39,    40,    41,     0,     0,     0,     0,    44,
       0,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,   311,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,   509,     0,
     510,   511,    82,    83,    84,    85,   512,    87,    88,    89,
      90,     0,   513,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,     0,   133,   134,     0,     0,
     135,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,   147,   148,   149,     0,     0,     0,   150,   151,   152,
     520,     0,     0,     2,     0,     3,     4,     0,   309,     0,
       0,     0,     0,     0,     0,     0,     6,     7,     8,     9,
      10,    11,     0,    13,     0,   159,   160,     0,    14,     0,
       0,     0,     0,    15,     0,     0,     0,     0,    16,     0,
       0,     0,     0,     0,    18,    19,     0,     0,     0,     0,
       0,    21,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,    31,
      32,     0,     0,    33,     0,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     442,     0,     0,     0,    37,     0,     0,    38,     0,     0,
       0,     0,     0,     0,     0,    39,    40,    41,     0,     0,
       0,     0,    44,     0,    45,     0,   285,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    47,
      48,    49,    50,    51,    52,   311,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,     0,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,    91,     0,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,     0,   133,
     134,     0,     0,   135,   136,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   137,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   146,   147,   148,   149,     0,     0,     0,
     150,   151,   152,   359,     0,     0,     2,     0,     3,     4,
       0,   309,     0,     0,     0,     0,     0,     0,     0,     6,
       7,     8,     9,    10,    11,     0,    13,     0,   159,   160,
       0,    14,     0,     0,     0,     0,    15,     0,     0,     0,
       0,    16,     0,     0,     0,     0,     0,    18,    19,     0,
       0,     0,     0,     0,    21,    22,     0,     0,     0,    23,
       0,     0,     0,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,    31,    32,     0,     0,    33,     0,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,     0,
      38,     0,     0,     0,     0,     0,     0,     0,    39,    40,
      41,     0,     0,     0,     0,    44,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    46,    47,    48,    49,    50,    51,    52,   311,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,     0,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,     0,   133,   134,     0,     0,   135,   136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   137,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   146,   147,   148,   149,
       0,     0,     0,   150,   151,   152,   359,   565,     0,     2,
       0,     3,     4,     0,   309,     0,     0,     0,     0,     0,
       0,     0,     6,     7,     8,     9,    10,    11,     0,    13,
       0,   159,   160,     0,    14,     0,     0,     0,     0,    15,
       0,     0,     0,     0,    16,     0,     0,     0,     0,     0,
      18,    19,     0,     0,     0,     0,     0,    21,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,    31,    32,     0,     0,    33,
       0,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      37,     0,     0,    38,     0,     0,     0,     0,     0,     0,
       0,    39,    40,    41,     0,     0,     0,     0,    44,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,    47,    48,    49,    50,    51,
      52,   311,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       0,    91,     0,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,     0,   133,   134,     0,     0,   135,
     136,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   137,   138,   139,   140,   141,
     142,   143,   144,   145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   146,
     147,   148,   149,     0,     0,     0,   150,   151,   152,   359,
     581,     0,     2,     0,     3,     4,     0,   309,     0,     0,
       0,     0,     0,     0,     0,     6,     7,     8,     9,    10,
      11,     0,    13,     0,   159,   160,     0,    14,     0,     0,
       0,     0,    15,     0,     0,     0,     0,    16,     0,     0,
       0,     0,     0,    18,    19,     0,     0,     0,     0,     0,
      21,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,    32,
       0,     0,    33,     0,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    37,     0,     0,    38,     0,     0,     0,
       0,     0,     0,     0,    39,    40,    41,     0,     0,     0,
       0,    44,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,    47,    48,
      49,    50,    51,    52,   311,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,     0,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,     0,    91,     0,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,     0,   133,   134,
       0,     0,   135,   136,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   137,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   146,   147,   148,   149,     0,     0,     0,   150,
     151,   152,   359,     0,     0,     2,     0,     3,     4,     0,
     309,     0,     0,     0,     0,     0,     0,     0,     6,     7,
       8,     9,    10,    11,     0,    13,     0,   159,   160,     0,
      14,     0,     0,     0,     0,    15,     0,     0,     0,     0,
      16,     0,     0,     0,     0,     0,    18,    19,     0,     0,
       0,     0,     0,    21,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    26,     0,     0,
       0,     0,     0,   643,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      30,    31,    32,     0,     0,    33,     0,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    37,     0,     0,    38,
       0,     0,     0,     0,     0,     0,     0,    39,    40,    41,
       0,     0,     0,     0,    44,     0,    45,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      46,    47,    48,    49,    50,    51,    52,   311,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,     0,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     0,    91,     0,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
       0,   133,   134,     0,     0,   135,   136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   137,   138,   139,   140,   141,   142,   143,   144,   145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   146,   147,   148,   149,     0,
       0,     0,   150,   151,   152,   359,     0,     0,     2,     0,
       3,     4,     0,   309,     0,     0,     0,     0,     0,     0,
       0,     6,     7,     8,     9,    10,    11,     0,    13,     0,
     159,   160,     0,    14,     0,     0,     0,     0,    15,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,    18,
      19,     0,     0,     0,     0,     0,    21,    22,     0,     0,
       0,   963,     0,     0,     0,     0,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    30,    31,    32,     0,     0,    33,     0,
      34,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    37,
       0,     0,    38,     0,     0,     0,     0,     0,     0,     0,
      39,    40,    41,     0,     0,     0,     0,    44,     0,    45,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    46,    47,    48,    49,    50,    51,    52,
     311,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,     0,
      91,     0,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,     0,   133,   134,     0,     0,   135,   136,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   137,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   146,   147,
     148,   149,     0,     0,     0,   150,   151,   152,   359,     0,
       0,     2,     0,     3,     4,     0,   309,     0,     0,     0,
       0,     0,     0,     0,     6,     7,     8,     9,    10,    11,
       0,    13,     0,   159,   160,     0,    14,     0,     0,     0,
       0,    15,     0,     0,     0,     0,    16,     0,     0,     0,
       0,     0,    18,    19,     0,     0,     0,     0,     0,    21,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    30,    31,    32,     0,
       0,    33,     0,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    37,     0,     0,    38,     0,     0,     0,     0,
       0,     0,     0,    39,    40,    41,     0,     0,     0,     0,
      44,     0,    45,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,    47,    48,    49,
      50,    51,    52,   311,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     0,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,     0,   133,   134,     0,
       0,   135,   136,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   137,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   146,   147,   148,   149,     0,     0,     0,   150,   151,
     152,   359,     0,     0,     2,     0,     3,     4,     0,   309,
       0,     0,     0,     0,     0,     0,     0,     0,     7,     8,
       9,    10,    11,     0,    13,     0,   159,   160,     0,    14,
       0,     0,     0,     0,    15,     0,     0,     0,     0,    16,
       0,     0,     0,     0,     0,     0,    19,     0,     0,     0,
       0,     0,    21,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      31,    32,     0,     0,    33,     0,    34,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    37,     0,     0,    38,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    41,     0,
       0,     0,     0,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
      47,    48,    49,    50,    51,    52,   311,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
       0,    68,     0,     0,     0,    72,    73,    74,    75,    76,
      77,    78,    79,     0,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,     0,    91,     0,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,     0,
     133,   134,     0,     0,   135,   136,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     137,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   146,   147,   148,   149,     0,     0,
       0,   150,   151,   152,   359,     0,     0,     2,     0,     3,
       4,     0,   309,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     8,     9,    10,    11,     0,    13,     0,   159,
     160,     0,    14,     0,     0,     0,     0,    15,     0,     0,
       0,     0,    16,     0,     0,     0,     0,     0,     0,    19,
       0,     0,     0,     0,     0,    21,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,     0,    33,     0,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    37,     0,
       0,    38,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,     0,     0,     0,    45,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,    47,    48,    49,    50,    51,    52,   311,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,     0,    68,     0,     0,     0,    72,    73,
      74,    75,    76,    77,    78,    79,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,    91,
       0,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,     0,   133,   134,     0,     0,   135,   136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   734,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   146,   147,   148,
     149,     0,     0,   735,   150,   151,   152,     0,     0,     0,
       0,     0,     0,     0,   736,     0,     0,   737,   738,     0,
       0,     0,     0,     0,   739,     0,     0,     0,     0,     0,
       0,   740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   741,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   742,     0,   743,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     744,     0,     0,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,   746,   747,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   309,     0,     0,     0,
       0,     0,     0,     0,   748,     0,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,    14,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,    21,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    37,     0,     0,    38,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   749,   750,     0,     0,   751,   752,     0,   753,
     754,   755,   756,     0,   757,   758,    46,     0,    48,   447,
       0,    51,    52,   311,    54,    55,    56,    57,    58,    59,
     448,    61,    62,    63,    64,    65,    66,     0,    68,     0,
       0,     0,    72,    73,    74,    75,    76,    77,   449,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     0,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   309,   133,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,     0,     0,     0,     0,    14,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,    21,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    37,     0,     0,    38,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,     0,    48,     0,
       0,    51,    52,   311,    54,    55,    56,    57,    58,    59,
       0,    61,    62,    63,    64,    65,    66,     0,    68,     0,
       0,     0,    72,    73,    74,    75,    76,    77,     0,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     0,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,     0,   133
};

static const yytype_int16 yycheck[] =
{
       0,     1,     1,    43,   186,   368,    25,   134,   174,   301,
     301,   301,     1,    29,   284,   523,   493,    28,   807,   174,
     314,   631,     4,    42,     4,   398,   399,     5,   317,   402,
     174,   404,   174,   174,   368,    11,   742,   851,   355,   356,
     746,   747,   748,   753,   754,     3,   827,   718,   365,   366,
     756,    62,   925,     4,   343,   928,     4,    74,    79,   186,
      26,     5,     4,   989,     4,    71,     5,     4,   102,    74,
     758,     4,     4,     4,     3,   855,     4,   331,   464,   333,
     915,     5,    74,     5,   604,   458,   738,   376,   799,    65,
     405,   743,   142,    11,   244,     5,    26,  1080,   362,     4,
      26,    26,    37,    62,    42,     5,   121,     4,   244,    26,
       4,   258,   121,    43,     4,    60,     4,    66,     5,    28,
       4,     4,    33,     3,   121,     3,  1052,    74,   318,   634,
      26,   465,     5,    26,    26,    26,    83,    96,     5,    32,
    1273,    26,    72,   140,    79,   650,     3,    65,    26,     4,
      61,     0,     1,    62,    89,    25,  1029,    40,   305,   667,
     143,  1294,  1145,   313,    25,     3,     3,    37,    37,     3,
     296,   441,    25,   467,   133,   105,  1049,   313,   314,     6,
      33,    71,   131,   108,    37,   311,    13,   481,   154,   134,
     896,   897,   374,     5,   464,     7,   378,     3,     3,   165,
     494,    40,   132,   909,     3,   578,   460,    74,    61,    79,
      79,    66,     3,   158,    84,   153,  1142,   183,   408,    89,
      89,    25,     6,    84,   154,   542,    79,   938,   154,    13,
     941,    84,   282,   113,    74,   165,    89,   154,    51,   165,
    1075,   423,   142,   258,   498,    84,  1229,   374,   165,   258,
     520,   378,   442,   183,   569,   907,    26,   183,  1184,   139,
     257,   154,   154,   154,    77,   529,   183,   143,   141,  1083,
     656,     3,   165,   165,   165,    84,   131,  1058,     3,   319,
     320,     6,   322,     3,   284,   284,  1066,     3,    13,   323,
     183,   183,   183,  1003,     3,   284,   423,  1007,   632,   138,
     244,     3,   323,  1013,   425,   244,   323,   428,   429,   308,
     604,    26,  1022,   324,   354,   273,   610,   323,   323,   308,
     244,  1135,   244,   686,   832,   996,   315,   700,   317,   702,
     703,   323,   942,   706,   244,  1208,   709,  1025,     5,   816,
       7,   323,   636,   323,   273,   323,  1219,   323,   277,   338,
     870,   871,   686,   342,   343,   344,   375,   244,   324,     3,
     526,   360,   351,   352,   353,   728,   355,   356,   357,   358,
     359,   526,   323,   392,   663,   323,   365,   366,   695,   419,
     369,   323,   526,   323,   526,   526,   323,   376,  1261,   555,
     323,   323,   323,  1103,   728,   323,    83,   437,   324,   526,
    1106,   690,   719,   321,   322,   323,   324,   325,   313,   398,
     399,   400,   401,   402,   403,   404,   313,   406,   407,   313,
    1209,   410,  1211,  1212,  1213,   313,   313,   314,   417,   313,
     323,   471,   421,   324,  1044,   284,   273,  1047,    26,   273,
     277,    55,   441,   277,    32,   315,   316,   317,   318,   319,
     320,    28,   441,   930,   315,   316,   317,   318,   319,   320,
       4,   795,   315,   316,   317,   318,   319,   320,   273,   458,
       3,     6,   277,     8,     9,     3,   315,   316,   317,   318,
     319,   320,   273,    60,   323,     3,   277,   300,     8,     4,
       5,   673,     7,   324,   325,   308,     3,   486,   321,   322,
     749,   750,   491,   797,    11,   687,   315,   316,   317,   318,
     319,   320,   248,   249,   323,    19,  1126,    21,    22,    26,
      24,     3,    66,   817,   250,   251,   252,   526,    19,    11,
     301,   520,   303,   110,   523,   301,   113,   303,    50,     3,
     722,    85,     4,     5,    26,     7,   673,     3,   548,   146,
     147,   148,   149,   542,    55,     3,    47,   134,     3,   136,
     687,     3,    75,    75,     3,   605,   606,   607,    81,    81,
     184,     0,   186,   187,    86,     7,   870,   871,   192,   321,
     322,   158,    94,   131,   198,     4,     5,   131,     7,   578,
      20,    21,    22,    23,    24,   722,     4,     5,     3,   639,
      91,     4,     5,   314,     7,     6,   113,     8,     9,     4,
       5,   600,   631,   602,   987,   988,   401,   616,   403,    20,
      21,    22,    23,    24,   873,    25,   146,   147,   148,   149,
     924,   925,   139,   882,   928,   998,    37,   128,   129,   888,
     290,   291,   313,    43,   135,     3,   635,   160,   160,     3,
      51,   900,   641,     3,   643,   168,   168,   304,   305,    59,
       4,     5,     3,     7,   998,   831,    96,    68,   938,   658,
     659,   660,     3,   662,   663,   664,   831,   843,   667,     3,
     696,   172,     3,   184,   285,   186,   187,   831,     3,   831,
     831,   192,   285,     4,     5,    96,     7,   198,     4,     5,
     827,   690,     3,    50,   831,   105,   695,   137,   697,   698,
     110,   700,     3,   702,   703,     4,     5,   706,     7,     3,
     709,     4,     5,     3,     6,    34,     8,     9,    75,   130,
     719,    60,   132,   323,    81,  1029,   137,   321,    20,    21,
      22,    23,    24,     3,   174,   175,   176,    94,    44,     4,
       5,     3,  1115,   100,     4,  1049,     4,     5,    85,     7,
    1052,  1052,  1052,     4,     5,    85,     7,  1016,  1141,    51,
    1019,   320,    50,    10,  1063,    14,    15,    16,    17,    18,
     799,   110,   296,   297,   113,   145,    68,    50,   788,     4,
       5,   138,     4,     5,    50,   977,    12,    75,    20,    21,
      22,    23,    24,    81,    12,   134,    19,   136,    86,   260,
     261,    83,    75,   160,    96,   831,    94,    26,    81,    75,
      26,   168,     3,    86,   100,    81,   815,     4,     5,   158,
     819,    94,   258,   259,     4,     5,     4,     5,    94,    21,
       4,     5,   106,   832,    26,   598,   599,     5,   130,   114,
     977,   598,   599,   411,   412,   137,   159,   160,   413,   414,
      42,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     248,    53,   492,   493,    56,    57,     4,     3,    28,     3,
       3,    63,   160,     4,     4,    90,     3,    32,    70,     5,
     168,  1254,  1184,  1184,  1184,    13,   138,   160,    13,     4,
      82,   302,     3,   141,   160,   168,     5,    74,   138,     4,
       3,    74,   168,    95,  1208,    97,    26,    26,    74,   938,
      74,   920,   941,   942,     3,  1219,    74,   109,    74,  1292,
       6,  1058,     8,     9,   116,    74,    74,   245,     4,   249,
     122,   123,   314,     4,    20,    21,    22,    23,    24,     4,
       4,   113,     5,     5,     4,    26,     5,     5,     4,     3,
      32,    26,     4,    99,     5,   126,    13,  1261,   320,     4,
      40,   153,   245,    65,   306,     4,     4,    74,   967,   241,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    23,
      13,    13,     3,   104,     3,     3,     3,   986,   987,   988,
       4,     4,   991,    42,     4,     3,    87,    87,     3,    99,
     150,   100,     5,    77,     4,     4,    26,    19,   323,    62,
     302,     5,     5,    40,   102,  1044,     5,    23,  1047,   274,
     274,   292,    77,   292,   274,    23,    23,    23,   274,   126,
     114,     3,   142,     4,   103,    26,    86,     3,    86,    26,
       4,    78,     4,    74,  1053,    40,     5,    12,     3,   122,
       4,     4,   122,     4,   274,    43,    26,     5,   126,   254,
      76,    86,    12,   307,  1063,     5,  1116,     5,     4,     3,
      96,    23,   144,   101,     5,   258,   303,   144,   101,   271,
     272,    71,   303,   275,   276,   298,   278,   279,   280,   281,
       4,   283,   284,     4,     3,   110,   253,  1126,     3,     5,
      32,   248,   309,   314,    32,     3,     3,    23,   310,   299,
       3,    26,   256,   258,    26,    23,    26,   310,     7,   924,
      69,  1032,  1051,   312,   472,  1038,   817,  1058,   974,   632,
     795,   602,  1295,   808,  1170,    12,   635,   546,   174,   174,
     385,  1222,  1141,     3,   386,   686,     6,   686,     8,     9,
    1223,    11,  1161,  1142,  1080,  1229,  1206,   946,   998,    19,
      20,    21,    22,    23,    24,   597,    26,   376,   606,  1178,
     409,    31,   825,   787,   317,   418,    36,   887,  1115,   529,
     263,    41,   831,   364,   527,  1239,  1171,    47,    48,    -1,
      -1,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1217,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    -1,  1244,    96,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,
     120,    -1,    -1,  1273,    -1,    -1,    -1,    -1,   128,   129,
     130,    -1,    -1,    -1,    -1,   135,    -1,   137,    -1,    -1,
      -1,    -1,    -1,    -1,  1294,    -1,    -1,    -1,    -1,    -1,
      -1,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,   287,   288,   289,
      -1,    -1,    -1,   293,   294,   295,    -1,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,   321,   322,    -1,   324,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,   134,   135,
      -1,   137,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,   134,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,   134,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,   245,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    -1,   113,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,   134,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    37,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    89,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,    -1,   135,
      -1,   137,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,   132,    -1,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,   127,   128,   129,   130,    -1,    -1,    -1,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
       3,    -1,    -1,     6,    -1,     8,     9,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    -1,   321,   322,    -1,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    47,    48,    -1,    -1,    -1,    -1,
      -1,    54,    55,    -1,    -1,    -1,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    -1,    -1,    96,    -1,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   117,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   128,   129,   130,    -1,    -1,
      -1,    -1,   135,    -1,   137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,   287,   288,   289,    -1,    -1,    -1,
     293,   294,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,     6,    -1,     8,
       9,    -1,    11,    -1,    -1,    -1,    -1,    -1,   321,   322,
      19,    20,    21,    22,    23,    24,    -1,    26,    -1,    28,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    47,    48,
      -1,    -1,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    -1,    -1,    96,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,
      -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,
     129,   130,    -1,    -1,    -1,    -1,   135,    -1,   137,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,   288,
     289,    -1,    -1,    -1,   293,   294,   295,     3,    -1,    -1,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    -1,   321,   322,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,   120,    -1,    -1,    -1,   124,   125,
      -1,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,   135,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,    -1,   198,    -1,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   287,   288,   289,    -1,    -1,    -1,   293,   294,   295,
       3,    -1,    -1,     6,    -1,     8,     9,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    -1,   321,   322,    -1,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    47,    48,    -1,    -1,    -1,    -1,
      -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    -1,    -1,    96,    -1,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,    -1,   117,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   128,   129,   130,    -1,    -1,
      -1,    -1,   135,    -1,   137,    -1,   139,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,    -1,    -1,   246,   247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,   287,   288,   289,    -1,    -1,    -1,
     293,   294,   295,     3,    -1,    -1,     6,    -1,     8,     9,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    -1,   321,   322,
      -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    47,    48,    -1,
      -1,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    -1,    -1,    96,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,   129,
     130,    -1,    -1,    -1,    -1,   135,    -1,   137,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,    -1,   198,    -1,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,   287,   288,   289,
      -1,    -1,    -1,   293,   294,   295,     3,     4,    -1,     6,
      -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      -1,   321,   322,    -1,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      47,    48,    -1,    -1,    -1,    -1,    -1,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    -1,    -1,    96,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     117,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   128,   129,   130,    -1,    -1,    -1,    -1,   135,    -1,
     137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
      -1,   198,    -1,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,    -1,   242,   243,    -1,    -1,   246,
     247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,
     287,   288,   289,    -1,    -1,    -1,   293,   294,   295,     3,
       4,    -1,     6,    -1,     8,     9,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    -1,   321,   322,    -1,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,
      -1,    -1,    -1,    47,    48,    -1,    -1,    -1,    -1,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      -1,    -1,    96,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,   120,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   128,   129,   130,    -1,    -1,    -1,
      -1,   135,    -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,   198,    -1,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
      -1,    -1,   246,   247,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   286,   287,   288,   289,    -1,    -1,    -1,   293,
     294,   295,     3,    -1,    -1,     6,    -1,     8,     9,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    -1,   321,   322,    -1,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    47,    48,    -1,    -1,
      -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    -1,    -1,    96,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,   129,   130,
      -1,    -1,    -1,    -1,   135,    -1,   137,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,    -1,   198,    -1,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
      -1,   242,   243,    -1,    -1,   246,   247,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   286,   287,   288,   289,    -1,
      -1,    -1,   293,   294,   295,     3,    -1,    -1,     6,    -1,
       8,     9,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    -1,
     321,   322,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    47,
      48,    -1,    -1,    -1,    -1,    -1,    54,    55,    -1,    -1,
      -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    -1,    -1,    96,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     128,   129,   130,    -1,    -1,    -1,    -1,   135,    -1,   137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,    -1,   242,   243,    -1,    -1,   246,   247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,
     288,   289,    -1,    -1,    -1,   293,   294,   295,     3,    -1,
      -1,     6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    -1,   321,   322,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    -1,    47,    48,    -1,    -1,    -1,    -1,    -1,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    -1,
      -1,    96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,
     135,    -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242,   243,    -1,
      -1,   246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   287,   288,   289,    -1,    -1,    -1,   293,   294,
     295,     3,    -1,    -1,     6,    -1,     8,     9,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    -1,    26,    -1,   321,   322,    -1,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    93,    -1,    -1,    96,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
      -1,   173,    -1,    -1,    -1,   177,   178,   179,   180,   181,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,    -1,   198,    -1,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,    -1,
     242,   243,    -1,    -1,   246,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,   287,   288,   289,    -1,    -1,
      -1,   293,   294,   295,     3,    -1,    -1,     6,    -1,     8,
       9,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    -1,    26,    -1,   321,
     322,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    -1,    96,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,
      -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,    -1,   173,    -1,    -1,    -1,   177,   178,
     179,   180,   181,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,    -1,   198,
      -1,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,   287,   288,
     289,    -1,    -1,    42,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,    -1,    -1,    56,    57,    -1,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   271,   272,    -1,    -1,   275,   276,    -1,   278,
     279,   280,   281,    -1,   283,   284,   151,    -1,   153,   154,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,    -1,   173,    -1,
      -1,    -1,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    11,   242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,    -1,    -1,   120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,   153,    -1,
      -1,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,   171,    -1,   173,    -1,
      -1,    -1,   177,   178,   179,   180,   181,   182,    -1,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,    -1,   198,    -1,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,    -1,   242
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     3,     6,     8,     9,    11,    19,    20,    21,    22,
      23,    24,    25,    26,    31,    36,    41,    45,    47,    48,
      49,    54,    55,    59,    60,    67,    68,    69,    76,    84,
      91,    92,    93,    96,    98,   111,   113,   117,   120,   128,
     129,   130,   132,   134,   135,   137,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   198,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   242,   243,   246,   247,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   286,   287,   288,   289,
     293,   294,   295,   315,   316,   317,   318,   319,   320,   321,
     322,   329,   330,   331,   332,   343,   346,   357,   358,   359,
     360,   361,   362,   363,   366,   367,   368,   369,   374,   379,
     404,   406,   407,   408,   409,   411,   412,   413,   414,   415,
     416,   417,   419,   420,   422,   423,   424,   425,   427,   428,
     429,   433,   435,   436,   437,   438,   439,   440,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   475,   476,   481,   482,   484,   522,
     523,   524,   525,   528,   530,   531,   532,   548,   551,   552,
     553,   554,   555,   556,   557,   558,   561,   562,   563,   575,
     576,   577,   578,   579,   581,   582,   583,   584,   588,   590,
     591,   592,   593,   594,   595,   603,   629,   630,   631,   632,
     633,   634,   646,   649,     3,   139,   330,   364,   378,   379,
     408,   541,   542,   543,   545,   547,   575,    26,    26,     8,
     146,   147,   148,   149,   515,   516,   520,   521,     3,    11,
      25,   158,   404,     6,    13,     3,   143,     3,     3,   121,
     140,   257,    74,     3,   429,    26,   645,    28,    60,   110,
     113,   134,   136,   158,   348,   349,   350,   357,     3,   143,
      28,    62,   370,     3,     3,   429,    26,   599,   600,   601,
     602,     3,     3,     3,    83,     3,     3,     3,     3,     3,
     248,   367,   639,   640,   644,     3,     3,     3,     3,     3,
     553,   553,     0,     7,    37,    79,    89,   131,   412,   413,
     415,   416,   419,   422,   424,   314,   313,    28,    31,   117,
     366,   367,   426,    19,    21,    22,    24,     3,     3,     3,
       3,     3,     3,     3,     3,   285,     3,     3,     3,     3,
       3,   324,   325,   321,   322,    34,   559,   323,   321,    44,
     580,     3,   545,     3,     4,    85,     4,     4,    66,   131,
       4,    10,   320,    26,   447,   522,   532,   145,    12,    12,
      19,     3,   113,   379,   408,    26,    26,   154,   165,   183,
     324,   604,   629,   549,   575,   549,   576,   324,   370,   599,
     599,    26,   669,   599,     3,    83,   106,     3,   345,   345,
     345,   100,     5,    62,    96,   133,   575,   324,   380,   430,
     431,   575,   598,   575,   576,    39,    74,    88,   127,   575,
     596,   597,     6,    13,   114,   575,   575,   575,   599,   572,
     575,   572,   575,   585,   586,   587,    55,   124,   125,   184,
     186,   187,   192,   198,   441,   442,   443,   564,   575,   575,
       3,   575,   408,   249,   640,   641,   248,   635,   636,   639,
     572,   575,   572,   575,     4,   433,   470,   471,   472,   646,
     575,   366,     3,   421,   429,   552,   576,    28,   546,   366,
     406,   407,   429,     4,   573,   575,   642,   643,   569,   573,
     573,   574,   574,   570,   573,     4,   574,   571,   573,     3,
      26,   487,   488,   489,   495,   477,   575,   575,   370,   529,
     556,     4,   527,   572,   554,   554,   555,   555,    90,   560,
     575,   581,   599,   575,     4,   365,   366,   546,   546,   546,
       3,   599,   370,    13,    13,    32,     5,   138,     4,   573,
       3,   345,   250,   251,   252,   651,   141,   377,   400,   547,
     375,   376,   432,   646,    26,   342,   629,   599,   350,    74,
       4,    74,    83,   393,   394,     5,    32,   434,   629,   138,
     575,    74,     4,    74,   575,    26,   601,    26,   601,   602,
     371,   372,   629,     4,     4,     4,   345,     4,     5,     7,
      79,     4,    74,    74,    74,   102,   353,   244,   575,   642,
     245,   367,   410,   412,   413,   415,   419,   422,   637,   638,
     641,   636,     4,     4,     4,     4,     5,   314,   572,    11,
      65,   418,   418,   379,     4,    40,    84,   138,   412,     4,
       5,     4,     5,     7,     4,     4,     5,     4,     4,     5,
     487,   496,   499,     5,   473,     4,   573,     4,     4,    40,
       4,     4,     5,   542,   544,   378,   543,   378,     3,   517,
     380,    26,    26,   604,    21,    42,    53,    56,    57,    63,
      70,    82,    95,    97,   109,   116,   122,   123,   153,   271,
     272,   275,   276,   278,   279,   280,   281,   283,   284,   550,
     599,   605,   608,   609,   616,   617,   618,   619,   620,   621,
     623,   624,   625,   626,   628,   550,   599,     4,    43,    72,
     105,   132,   333,   334,   335,   338,   340,   629,    32,    99,
      60,   134,   158,   652,   408,     5,     4,     5,   126,     3,
      11,   395,   399,   429,   537,   538,   539,   599,   375,   377,
     431,   629,   599,   575,   575,    74,    13,     5,   377,   320,
     547,   575,   575,   575,   575,   576,   575,    40,     4,   642,
     366,     5,   244,   245,   470,   471,   485,   366,     4,    65,
     576,   572,   357,   575,   575,   573,   573,   573,   573,   573,
     306,   497,   500,    23,   478,     4,   290,   291,   474,   480,
       4,   241,   526,   526,   572,   366,   433,   518,   519,   646,
      13,    13,     3,   273,   277,   610,   611,     3,   622,   622,
     104,     3,   273,   277,   610,   622,   610,   610,   273,   277,
     610,   611,   611,     3,   612,   613,    42,   153,   612,   612,
     273,   277,   610,    55,   184,   186,   187,   192,   198,   564,
     565,   567,   568,     4,    42,   606,   580,   607,     4,     4,
       3,    87,    87,     4,     5,     3,   605,   379,    99,   653,
     100,   376,   629,    26,   108,   351,   352,   648,     3,   399,
     539,   150,     5,    50,    75,    81,    94,   160,   168,   533,
     536,    32,   396,   647,   396,   398,   393,    77,   401,     4,
     575,    26,   372,    59,   373,   575,     4,    71,   589,   589,
       4,   354,   355,   367,   409,   357,   367,   412,   413,   415,
     419,   422,   638,   642,     4,    19,   412,     5,     5,    40,
     353,     5,   474,   292,   292,    77,     4,     4,     5,   604,
     604,    23,   611,   274,    23,    23,   611,   274,   142,   282,
     627,   627,   611,   274,    23,   614,   273,   277,   610,   273,
     610,   611,   274,   622,   610,   126,   114,   607,   408,     3,
     334,   342,   336,   142,   344,   342,   654,   602,     5,   142,
     347,     4,   539,   399,    86,   536,   103,    86,    26,     3,
     341,    26,    40,    78,   403,   575,     4,     4,     5,    33,
      61,   356,   356,    89,   366,    74,   483,   486,    12,   575,
     573,   573,    26,   501,   502,   603,   304,   305,   498,   504,
     505,   479,   575,     3,   526,   519,     4,   612,     4,     5,
       4,   612,   122,   122,   612,    14,    15,    16,    17,    18,
     615,     4,   611,   274,   611,   612,   192,   564,   566,    26,
       4,   342,     4,    25,    43,    59,   110,   338,   339,    43,
     254,   650,   352,    76,    12,   399,    86,   399,   342,   341,
     402,   447,   603,   408,   307,   490,   491,   355,   296,   297,
     474,     5,     5,   607,     4,    37,    51,   302,   445,   506,
     507,   508,   509,   353,    23,   144,   144,   612,   610,     4,
      96,     3,    96,   137,   337,   433,   558,   599,   101,   260,
     261,   662,   663,    71,   655,   656,   101,   399,   100,   138,
     534,   535,   540,     4,     5,   487,   492,   493,   494,   353,
     573,   502,   302,   445,   507,   510,   512,   513,   258,   303,
     303,   298,   503,   514,     4,     4,   110,   408,     3,   121,
     258,   397,   121,   397,   663,   253,   248,   658,   408,     3,
     447,   603,     5,    32,   309,   390,   392,   301,   301,   314,
      51,    77,   300,   308,   599,     4,   342,   396,   396,   396,
     396,   258,   259,   657,     3,   405,   255,   330,   659,   661,
     342,   493,   495,    23,   310,   381,   382,   511,   512,   258,
     299,     3,     4,    26,   665,   666,    26,   668,   664,   666,
      26,   667,   408,   256,     4,   310,   391,   388,   433,    69,
     386,   387,   342,     4,   660,   661,    23,   258,   305,   385,
     296,   311,   384,     4,     7,   383,   389,   433,   245,   661,
     385,   312
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   328,   329,   329,   330,   330,   331,   331,   331,   331,
     332,   333,   333,   334,   334,   335,   336,   336,   337,   338,
     338,   339,   339,   339,   339,   339,   339,   339,   339,   339,
     339,   340,   340,   340,   340,   341,   341,   342,   342,   343,
     344,   344,   345,   345,   346,   347,   347,   348,   348,   349,
     349,   350,   350,   350,   350,   350,   350,   351,   351,   352,
     352,   353,   353,   354,   354,   355,   355,   356,   356,   356,
     357,   357,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   359,   359,   360,   361,   362,   363,   364,   365,   365,
     366,   367,   367,   368,   369,   370,   370,   370,   371,   371,
     372,   373,   373,   374,   375,   375,   376,   377,   377,   378,
     379,   380,   380,   381,   381,   382,   383,   383,   384,   384,
     385,   385,   386,   386,   387,   388,   389,   390,   390,   391,
     391,   392,   393,   394,   395,   395,   396,   396,   397,   397,
     398,   398,   399,   399,   399,   399,   399,   400,   401,   401,
     402,   402,   402,   402,   403,   403,   404,   404,   404,   405,
     406,   406,   407,   407,   408,   408,   409,   409,   409,   409,
     409,   409,   409,   409,   410,   411,   411,   412,   412,   412,
     412,   412,   412,   412,   412,   413,   414,   414,   415,   416,
     417,   417,   417,   417,   418,   418,   418,   419,   419,   420,
     420,   421,   421,   422,   423,   423,   424,   425,   425,   426,
     426,   426,   427,   428,   429,   430,   430,   431,   432,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   434,   434,
     434,   435,   435,   436,   436,   436,   437,   437,   438,   439,
     440,   440,   440,   441,   441,   442,   442,   442,   443,   443,
     444,   445,   445,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   448,   448,
     449,   449,   449,   450,   450,   451,   451,   451,   451,   452,
     452,   453,   454,   454,   454,   454,   455,   455,   455,   455,
     455,   455,   455,   456,   456,   456,   457,   458,   459,   459,
     459,   459,   459,   460,   460,   460,   461,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   461,
     462,   462,   463,   464,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   464,   464,   464,   464,   464,
     464,   465,   465,   465,   466,   466,   467,   468,   468,   468,
     468,   468,   468,   468,   469,   470,   471,   472,   472,   473,
     473,   473,   474,   474,   475,   476,   476,   477,   478,   479,
     480,   480,   481,   482,   482,   483,   483,   484,   485,   485,
     486,   486,   487,   488,   488,   489,   490,   490,   491,   492,
     492,   493,   494,   495,   496,   496,   497,   497,   498,   498,
     499,   500,   501,   501,   502,   503,   503,   504,   505,   505,
     506,   506,   507,   507,   507,   508,   509,   510,   511,   512,
     512,   512,   513,   514,   514,   514,   514,   515,   515,   516,
     517,   517,   518,   518,   519,   519,   519,   520,   520,   521,
     521,   521,   522,   522,   522,   522,   522,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   524,   524,   525,   525,   526,   526,   527,   528,   529,
     530,   530,   531,   532,   532,   532,   532,   533,   533,   533,
     534,   535,   535,   536,   536,   536,   536,   537,   538,   538,
     538,   539,   540,   541,   541,   542,   542,   543,   543,   544,
     545,   545,   545,   546,   546,   547,   548,   549,   550,   550,
     551,   552,   552,   552,   552,   552,   552,   552,   552,   553,
     553,   554,   554,   554,   555,   555,   555,   556,   556,   556,
     557,   558,   558,   558,   559,   560,   561,   561,   562,   563,
     564,   564,   564,   564,   564,   565,   566,   566,   567,   567,
     568,   568,   569,   570,   571,   572,   572,   572,   573,   573,
     573,   573,   574,   574,   574,   575,   575,   575,   576,   577,
     577,   578,   578,   579,   579,   580,   581,   581,   582,   582,
     583,   584,   585,   586,   587,   588,   588,   588,   588,   588,
     589,   589,   590,   590,   591,   591,   592,   593,   593,   594,
     595,   596,   596,   596,   596,   596,   597,   597,   597,   598,
     599,   599,   599,   600,   600,   601,   602,   603,   603,   603,
     603,   603,   604,   604,   605,   606,   606,   607,   607,   608,
     608,   608,   608,   608,   608,   608,   609,   609,   609,   609,
     609,   609,   610,   610,   611,   612,   612,   613,   614,   615,
     615,   615,   615,   615,   615,   616,   616,   616,   617,   617,
     617,   617,   617,   617,   617,   618,   618,   618,   619,   619,
     619,   619,   620,   620,   621,   621,   622,   622,   622,   623,
     623,   623,   623,   623,   623,   623,   624,   624,   624,   624,
     624,   625,   626,   626,   626,   627,   627,   627,   628,   629,
     629,   629,   629,   630,   630,   631,   631,   631,   632,   632,
     633,   634,   635,   635,   636,   637,   637,   638,   638,   638,
     638,   638,   638,   639,   639,   640,   641,   641,   642,   643,
     644,   645,   646,   646,   646,   647,   647,   648,   330,   330,
     649,   650,   650,   651,   651,   651,   652,   652,   652,   653,
     653,   654,   655,   656,   656,   657,   657,   658,   658,   659,
     659,   660,   660,   661,   662,   662,   663,   663,   663,   663,
     664,   665,   666,   667,   668,   669
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       6,     1,     3,     1,     1,     3,     0,     2,     1,     1,
       2,     2,     1,     2,     2,     2,     2,     1,     4,     2,
       5,     4,     7,    10,     4,     0,     3,     3,     1,     7,
       0,     3,     0,     3,     7,     0,     3,     2,     1,     1,
       3,     1,     2,     1,     2,     2,     1,     1,     3,     1,
       1,     0,     3,     1,     3,     2,     2,     0,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     4,     2,     4,     4,     5,     4,     1,     3,
       1,     1,     1,     2,     6,     0,     1,     1,     1,     3,
       3,     1,     1,     5,     1,     3,     1,     0,     1,     1,
       4,     1,     1,     0,     1,     3,     0,     1,     1,     1,
       1,     1,     0,     1,     5,     1,     1,     0,     1,     0,
       2,     3,     9,     2,     1,     3,     0,     1,     0,     1,
       0,     3,     2,     3,     1,     4,     3,     2,     0,     3,
       1,     1,     3,     3,     0,     2,     1,     3,     1,     3,
       1,     2,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     3,     2,     1,     1,     1,
       1,     1,     1,     4,     2,     5,     2,     1,     4,     4,
       2,     2,     1,     1,     0,     2,     4,     3,     3,     2,
       1,     1,     3,     3,     2,     1,     3,     2,     1,     1,
       1,     1,     2,     2,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     0,     2,
       1,     6,     4,     1,     1,     1,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     4,     4,     4,     4,     4,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     1,
       1,     1,     1,     1,     4,     1,     1,     1,     1,     0,
       2,     4,     0,     1,     6,     1,     1,     1,     1,     1,
       2,     2,     5,     1,     1,     0,     1,     8,     1,     1,
       2,     2,     1,     1,     1,     1,     0,     1,     2,     3,
       1,     3,     1,     6,     0,     1,     0,     1,     0,     1,
       1,     3,     3,     1,     2,     0,     1,     3,     1,     1,
       1,     1,     2,     1,     2,     2,     4,     1,     1,     1,
       2,     1,     2,     3,     2,     2,     3,     0,     2,     4,
       0,     3,     1,     3,     0,     1,     1,     2,     2,     1,
       1,     1,     5,     4,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     7,     0,     5,     1,     5,     1,
       1,     1,     5,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     0,     1,     1,     2,     4,     5,     5,
       1,     1,     4,     1,     1,     1,     3,     1,     4,     1,
       1,     4,     4,     0,     1,     1,     1,     1,     1,     1,
       6,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     2,     2,     1,     3,     3,     1,     3,     3,
       1,     1,     1,     1,     2,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     2,     2,
       3,     1,     3,     5,     7,     1,     3,     3,     1,     3,
       5,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     2,     1,     2,     1,     1,
       1,     7,     1,     1,     0,     1,     1,     1,     1,     1,
       0,     2,     7,     4,     1,     1,     4,     6,     6,     6,
       4,     4,     3,     3,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     3,     3,     3,     1,     1,     3,     5,
       7,     7,     1,     1,     1,     0,     3,     0,     1,     3,
       2,     1,     1,     1,     1,     1,     2,     2,     3,     3,
       2,     1,     0,     1,     3,     0,     1,     3,     2,     0,
       1,     1,     1,     1,     1,     4,     4,     2,     3,     3,
       2,     4,     4,     3,     1,     5,     4,     2,     2,     3,
       2,     1,     4,     2,     1,     1,     0,     3,     5,     2,
       2,     2,     1,     1,     1,     1,     4,     1,     1,     1,
       2,     1,     1,     3,     3,     0,     3,     3,     2,     1,
       1,     1,     1,     1,     1,     4,     4,     4,     1,     1,
       5,     4,     1,     2,     4,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     2,     4,     0,     2,     1,     1,
       1,     1,     2,     1,     3,     0,     2,     1,     1,     3,
       9,     0,     2,     1,     1,     2,     1,     1,     2,     0,
       2,     1,     3,     0,     3,     1,     1,     0,     2,     1,
       5,     1,     3,     1,     1,     2,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1
};


/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none).  */
static const yytype_int8 yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     1,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,     2,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM.  */
static const yytype_int8 yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0
};

/* YYIMMEDIATE[RULE-NUM] -- True iff rule #RULE-NUM is not to be deferred, as
   in the case of predicates.  */
static const yybool yyimmediate[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const yytype_int8 yyconflp[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    15,
       0,     0,     0,     0,     0,     0,     0,     0,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,     0,    35,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      37,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      11,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     7,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    51,     0,
       0,     0,     0,    53,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    21,
      23,     0,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    55,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short yyconfl[] =
{
       0,    71,     0,    71,     0,    71,     0,   575,     0,   578,
       0,   503,     0,   503,     0,   748,     0,    91,     0,   184,
       0,   462,     0,   463,     0,   515,     0,    42,     0,   565,
       0,   727,     0,   729,     0,   731,     0,   732,     0,   730,
       0,   176,     0,   571,     0,   571,     0,   497,     0,   497,
       0,   498,     0,   498,     0,   129,     0
};



YYSTYPE yylval;

int yynerrs;
int yychar;

enum { YYENOMEM = -2 };

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)                              \
  do {                                          \
    YYRESULTTAG yychk_flag = YYE;               \
    if (yychk_flag != yyok)                     \
      return yychk_flag;                        \
  } while (0)

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call yyexpandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data.  */
#define YYHEADROOM 2

#ifndef YYSTACKEXPANDABLE
#  define YYSTACKEXPANDABLE 1
#endif

#if YYSTACKEXPANDABLE
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyexpandGLRStack (Yystack);                       \
  } while (0)
#else
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyMemoryExhausted (Yystack);                      \
  } while (0)
#endif

/** State numbers. */
typedef int yy_state_t;

/** Rule numbers. */
typedef int yyRuleNum;

/** Item references. */
typedef short yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yyGLRStateSet yyGLRStateSet;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;

struct yyGLRState {
  /** Type tag: always true.  */
  yybool yyisState;
  /** Type tag for yysemantics.  If true, yysval applies, otherwise
   *  yyfirstVal applies.  */
  yybool yyresolved;
  /** Number of corresponding LALR(1) machine state.  */
  yy_state_t yylrState;
  /** Preceding state in this stack */
  yyGLRState* yypred;
  /** Source position of the last token produced by my symbol */
  YYPTRDIFF_T yyposn;
  union {
    /** First in a chain of alternative reductions producing the
     *  nonterminal corresponding to this state, threaded through
     *  yynext.  */
    yySemanticOption* yyfirstVal;
    /** Semantic value for this state.  */
    YYSTYPE yysval;
  } yysemantics;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  /** During nondeterministic operation, yylookaheadNeeds tracks which
   *  stacks have actually needed the current lookahead.  During deterministic
   *  operation, yylookaheadNeeds[0] is not maintained since it would merely
   *  duplicate yychar != YYEMPTY.  */
  yybool* yylookaheadNeeds;
  YYPTRDIFF_T yysize;
  YYPTRDIFF_T yycapacity;
};

struct yySemanticOption {
  /** Type tag: always false.  */
  yybool yyisState;
  /** Rule number for this reduction */
  yyRuleNum yyrule;
  /** The last RHS state in the list of states to be reduced.  */
  yyGLRState* yystate;
  /** The lookahead for this reduction.  */
  int yyrawchar;
  YYSTYPE yyval;
  /** Next sibling in chain of options.  To facilitate merging,
   *  options are chained in decreasing order by address.  */
  yySemanticOption* yynext;
};

/** Type of the items in the GLR stack.  The yyisState field
 *  indicates which item of the union is valid.  */
union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrState;


  YYJMP_BUF yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  YYPTRDIFF_T yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

#if YYSTACKEXPANDABLE
static void yyexpandGLRStack (yyGLRStack* yystackp);
#endif

_Noreturn static void
yyFail (yyGLRStack* yystackp, const char* yymsg)
{
  if (yymsg != YY_NULLPTR)
    yyerror (yymsg);
  YYLONGJMP (yystackp->yyexception_buffer, 1);
}

_Noreturn static void
yyMemoryExhausted (yyGLRStack* yystackp)
{
  YYLONGJMP (yystackp->yyexception_buffer, 2);
}

/** Accessing symbol of state YYSTATE.  */
static inline yysymbol_kind_t
yy_accessing_symbol (yy_state_t yystate)
{
  return YY_CAST (yysymbol_kind_t, yystos[yystate]);
}

#if YYDEBUG || 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "'('", "')'", "','",
  "':'", "';'", "'?'", "'['", "']'", "'{'", "'}'", "'.'", "'K'", "'M'",
  "'G'", "'T'", "'P'", "SQL_TOKEN_STRING", "SQL_TOKEN_ACCESS_DATE",
  "SQL_TOKEN_INT", "SQL_TOKEN_REAL_NUM", "SQL_TOKEN_INTNUM",
  "SQL_TOKEN_APPROXNUM", "SQL_TOKEN_NOT", "SQL_TOKEN_NAME",
  "SQL_TOKEN_UMINUS", "SQL_TOKEN_ALL", "SQL_TOKEN_ALTER",
  "SQL_TOKEN_AMMSC", "SQL_TOKEN_ANY", "SQL_TOKEN_AS", "SQL_TOKEN_ASC",
  "SQL_TOKEN_AT", "SQL_TOKEN_AUTHORIZATION", "SQL_TOKEN_AVG",
  "SQL_TOKEN_BETWEEN", "SQL_TOKEN_BIT", "SQL_TOKEN_BOTH", "SQL_TOKEN_BY",
  "SQL_TOKEN_CAST", "SQL_TOKEN_CHARACTER", "SQL_TOKEN_CHECK",
  "SQL_TOKEN_COLLATE", "SQL_TOKEN_COMMIT", "SQL_TOKEN_CONTINUE",
  "SQL_TOKEN_CONVERT", "SQL_TOKEN_COUNT", "SQL_TOKEN_CREATE",
  "SQL_TOKEN_CROSS", "SQL_TOKEN_CURRENT", "SQL_TOKEN_CURSOR",
  "SQL_TOKEN_DATE", "SQL_TOKEN_DATEVALUE", "SQL_TOKEN_DAY",
  "SQL_TOKEN_DEC", "SQL_TOKEN_DECIMAL", "SQL_TOKEN_DECLARE",
  "SQL_TOKEN_DEFAULT", "SQL_TOKEN_DELETE", "SQL_TOKEN_DESC",
  "SQL_TOKEN_DISTINCT", "SQL_TOKEN_DOUBLE", "SQL_TOKEN_DROP",
  "SQL_TOKEN_ESCAPE", "SQL_TOKEN_EXCEPT", "SQL_TOKEN_EXISTS",
  "SQL_TOKEN_FALSE", "SQL_TOKEN_FETCH", "SQL_TOKEN_FLOAT", "SQL_TOKEN_FOR",
  "SQL_TOKEN_FOREIGN", "SQL_TOKEN_FOUND", "SQL_TOKEN_FROM",
  "SQL_TOKEN_FULL", "SQL_TOKEN_GRANT", "SQL_TOKEN_GROUP",
  "SQL_TOKEN_HAVING", "SQL_TOKEN_IN", "SQL_TOKEN_INDICATOR",
  "SQL_TOKEN_INNER", "SQL_TOKEN_INTEGER", "SQL_TOKEN_INTO", "SQL_TOKEN_IS",
  "SQL_TOKEN_INTERSECT", "SQL_TOKEN_JOIN", "SQL_TOKEN_KEY",
  "SQL_TOKEN_LEADING", "SQL_TOKEN_LIKE", "SQL_TOKEN_LOCAL",
  "SQL_TOKEN_LOWER", "SQL_TOKEN_MAX", "SQL_TOKEN_MIN", "SQL_TOKEN_NATURAL",
  "SQL_TOKEN_NCHAR", "SQL_TOKEN_NULL", "SQL_TOKEN_NUMERIC",
  "SQL_TOKEN_OCTET_LENGTH", "SQL_TOKEN_OF", "SQL_TOKEN_ON",
  "SQL_TOKEN_OPTION", "SQL_TOKEN_ORDER", "SQL_TOKEN_OUTER",
  "SQL_TOKEN_PRECISION", "SQL_TOKEN_PRIMARY", "SQL_TOKEN_PRIVILEGES",
  "SQL_TOKEN_PROCEDURE", "SQL_TOKEN_PUBLIC", "SQL_TOKEN_REAL",
  "SQL_TOKEN_REFERENCES", "SQL_TOKEN_ROLLBACK", "SQL_TOKEN_SCHEMA",
  "SQL_TOKEN_SELECT", "SQL_TOKEN_SET", "SQL_TOKEN_SIZE",
  "SQL_TOKEN_SMALLINT", "SQL_TOKEN_SOME", "SQL_TOKEN_SQLCODE",
  "SQL_TOKEN_SQLERROR", "SQL_TOKEN_SUM", "SQL_TOKEN_TABLE",
  "SQL_TOKEN_TIME", "SQL_TOKEN_TIMESTAMP", "SQL_TOKEN_TIMEZONE_HOUR",
  "SQL_TOKEN_TIMEZONE_MINUTE", "SQL_TOKEN_TO", "SQL_TOKEN_TRAILING",
  "SQL_TOKEN_TRANSLATE", "SQL_TOKEN_TRIM", "SQL_TOKEN_TRUE",
  "SQL_TOKEN_UNION", "SQL_TOKEN_UNIQUE", "SQL_TOKEN_UNKNOWN",
  "SQL_TOKEN_UPDATE", "SQL_TOKEN_UPPER", "SQL_TOKEN_USAGE",
  "SQL_TOKEN_USER", "SQL_TOKEN_USING", "SQL_TOKEN_VALUES",
  "SQL_TOKEN_VIEW", "SQL_TOKEN_WHERE", "SQL_TOKEN_WITH", "SQL_TOKEN_WORK",
  "SQL_TOKEN_ZONE", "SQL_TOKEN_CALL", "SQL_TOKEN_D", "SQL_TOKEN_FN",
  "SQL_TOKEN_T", "SQL_TOKEN_TS", "SQL_TOKEN_OJ", "SQL_TOKEN_ASCII",
  "SQL_TOKEN_BIT_LENGTH", "SQL_TOKEN_CHAR", "SQL_TOKEN_CHAR_LENGTH",
  "SQL_TOKEN_SQL_TOKEN_INTNUM", "SQL_TOKEN_CONCAT", "SQL_TOKEN_DIFFERENCE",
  "SQL_TOKEN_INSERT", "SQL_TOKEN_LCASE", "SQL_TOKEN_LEFT",
  "SQL_TOKEN_LENGTH", "SQL_TOKEN_LOCATE", "SQL_TOKEN_LOCATE_2",
  "SQL_TOKEN_LTRIM", "SQL_TOKEN_POSITION", "SQL_TOKEN_REPEAT",
  "SQL_TOKEN_REPLACE", "SQL_TOKEN_RIGHT", "SQL_TOKEN_RTRIM",
  "SQL_TOKEN_SOUNDEX", "SQL_TOKEN_SPACE", "SQL_TOKEN_SUBSTRING",
  "SQL_TOKEN_UCASE", "SQL_TOKEN_CURRENT_DATE", "SQL_TOKEN_CURRENT_TIME",
  "SQL_TOKEN_CURRENT_TIMESTAMP", "SQL_TOKEN_CURDATE", "SQL_TOKEN_CURTIME",
  "SQL_TOKEN_DAYNAME", "SQL_TOKEN_DAYOFMONTH", "SQL_TOKEN_DAYOFWEEK",
  "SQL_TOKEN_DAYOFYEAR", "SQL_TOKEN_EXTRACT", "SQL_TOKEN_HOUR",
  "SQL_TOKEN_MILLISECOND", "SQL_TOKEN_MINUTE", "SQL_TOKEN_MONTH",
  "SQL_TOKEN_MONTHNAME", "SQL_TOKEN_NOW", "SQL_TOKEN_QUARTER",
  "SQL_TOKEN_DATEDIFF", "SQL_TOKEN_SECOND", "SQL_TOKEN_TIMESTAMPADD",
  "SQL_TOKEN_TIMESTAMPDIFF", "SQL_TOKEN_TIMEVALUE", "SQL_TOKEN_WEEK",
  "SQL_TOKEN_WEEKDAY", "SQL_TOKEN_YEAR", "SQL_TOKEN_YEARDAY",
  "SQL_TOKEN_ABS", "SQL_TOKEN_ACOS", "SQL_TOKEN_ASIN", "SQL_TOKEN_ATAN",
  "SQL_TOKEN_ATAN2", "SQL_TOKEN_CEILING", "SQL_TOKEN_COS", "SQL_TOKEN_COT",
  "SQL_TOKEN_DEGREES", "SQL_TOKEN_EXP", "SQL_TOKEN_FLOOR",
  "SQL_TOKEN_LOGF", "SQL_TOKEN_LOG", "SQL_TOKEN_LN", "SQL_TOKEN_LOG10",
  "SQL_TOKEN_MOD", "SQL_TOKEN_PI", "SQL_TOKEN_POWER", "SQL_TOKEN_RADIANS",
  "SQL_TOKEN_RAND", "SQL_TOKEN_ROUNDMAGIC", "SQL_TOKEN_ROUND",
  "SQL_TOKEN_SIGN", "SQL_TOKEN_SIN", "SQL_TOKEN_SQRT", "SQL_TOKEN_TAN",
  "SQL_TOKEN_TRUNCATE", "SQL_TOKEN_EVERY", "SQL_TOKEN_INTERSECTION",
  "SQL_TOKEN_FUSION", "SQL_TOKEN_COLLECT", "SQL_TOKEN_VAR_POP",
  "SQL_TOKEN_VAR_SAMP", "SQL_TOKEN_STDDEV_SAMP", "SQL_TOKEN_STDDEV_POP",
  "SQL_TOKEN_RANK", "SQL_TOKEN_DENSE_RANK", "SQL_TOKEN_PERCENT_RANK",
  "SQL_TOKEN_CUME_DIST", "SQL_TOKEN_PERCENTILE_CONT",
  "SQL_TOKEN_PERCENTILE_DISC", "SQL_TOKEN_WITHIN", "SQL_TOKEN_ARRAY_AGG",
  "SQL_TOKEN_CASE", "SQL_TOKEN_THEN", "SQL_TOKEN_END", "SQL_TOKEN_NULLIF",
  "SQL_TOKEN_COALESCE", "SQL_TOKEN_WHEN", "SQL_TOKEN_ELSE",
  "SQL_TOKEN_BEFORE", "SQL_TOKEN_AFTER", "SQL_TOKEN_INSTEAD",
  "SQL_TOKEN_EACH", "SQL_TOKEN_REFERENCING", "SQL_TOKEN_BEGIN",
  "SQL_TOKEN_ATOMIC", "SQL_TOKEN_TRIGGER", "SQL_TOKEN_ROW",
  "SQL_TOKEN_STATEMENT", "SQL_TOKEN_NEW", "SQL_TOKEN_OLD",
  "SQL_TOKEN_VALUE", "SQL_TOKEN_CURRENT_CATALOG",
  "SQL_TOKEN_CURRENT_DEFAULT_TRANSFORM_GROUP", "SQL_TOKEN_CURRENT_PATH",
  "SQL_TOKEN_CURRENT_ROLE", "SQL_TOKEN_CURRENT_SCHEMA",
  "SQL_TOKEN_CURRENT_USER", "SQL_TOKEN_SESSION_USER",
  "SQL_TOKEN_SYSTEM_USER", "SQL_TOKEN_VARCHAR", "SQL_TOKEN_VARBINARY",
  "SQL_TOKEN_VARYING", "SQL_TOKEN_OBJECT", "SQL_TOKEN_NCLOB",
  "SQL_TOKEN_NATIONAL", "SQL_TOKEN_LARGE", "SQL_TOKEN_CLOB",
  "SQL_TOKEN_BLOB", "SQL_TOKEN_BIGINT", "SQL_TOKEN_BINARY",
  "SQL_TOKEN_WITHOUT", "SQL_TOKEN_BOOLEAN", "SQL_TOKEN_INTERVAL",
  "SQL_TOKEN_OVER", "SQL_TOKEN_ROW_NUMBER", "SQL_TOKEN_NTILE",
  "SQL_TOKEN_LEAD", "SQL_TOKEN_LAG", "SQL_TOKEN_RESPECT",
  "SQL_TOKEN_IGNORE", "SQL_TOKEN_NULLS", "SQL_TOKEN_FIRST_VALUE",
  "SQL_TOKEN_LAST_VALUE", "SQL_TOKEN_NTH_VALUE", "SQL_TOKEN_FIRST",
  "SQL_TOKEN_LAST", "SQL_TOKEN_EXCLUDE", "SQL_TOKEN_OTHERS",
  "SQL_TOKEN_TIES", "SQL_TOKEN_FOLLOWING", "SQL_TOKEN_UNBOUNDED",
  "SQL_TOKEN_PRECEDING", "SQL_TOKEN_RANGE", "SQL_TOKEN_ROWS",
  "SQL_TOKEN_PARTITION", "SQL_TOKEN_WINDOW", "SQL_TOKEN_NO",
  "SQL_TOKEN_LIMIT", "SQL_TOKEN_OFFSET", "SQL_TOKEN_NEXT",
  "SQL_TOKEN_ONLY", "SQL_TOKEN_OR", "SQL_TOKEN_AND", "SQL_LESSEQ",
  "SQL_GREATEQ", "SQL_NOTEQUAL", "SQL_LESS", "SQL_GREAT", "SQL_EQUAL",
  "'+'", "'-'", "SQL_CONCAT", "'*'", "'/'", "'='",
  "SQL_TOKEN_INVALIDSYMBOL", "$accept", "sql_single_statement", "sql",
  "schema_element", "base_table_def", "base_table_element_commalist",
  "base_table_element", "column_def", "column_def_opt_list", "nil_fkt",
  "unique_spec", "column_def_opt", "table_constraint_def",
  "op_column_commalist", "column_commalist", "view_def",
  "opt_with_check_option", "opt_column_commalist", "privilege_def",
  "opt_with_grant_option", "privileges", "operation_commalist",
  "operation", "grantee_commalist", "grantee", "opt_order_by_clause",
  "ordering_spec_commalist", "ordering_spec", "opt_asc_desc", "sql_not",
  "manipulative_statement", "union_statement", "commit_statement",
  "delete_statement_searched", "fetch_statement", "insert_statement",
  "values_or_query_spec", "table_value_const_list",
  "row_value_constructor", "row_value_constructor_elem",
  "rollback_statement", "select_statement_into", "opt_all_distinct",
  "assignment_commalist", "assignment", "update_source",
  "update_statement_searched", "target_commalist", "target",
  "opt_where_clause", "query_term", "select_statement", "selection",
  "opt_result_offset_clause", "result_offset_clause",
  "opt_fetch_first_row_count", "first_or_next", "row_or_rows",
  "opt_fetch_first_clause", "fetch_first_clause", "offset_row_count",
  "fetch_first_row_count", "opt_limit_offset_clause", "opt_offset",
  "limit_offset_clause", "table_exp", "from_clause", "table_ref_commalist",
  "opt_as", "opt_row", "table_primary_as_range_column", "table_ref",
  "where_clause", "opt_group_by_clause", "column_ref_commalist",
  "opt_having_clause", "boolean_primary",
  "parenthesized_boolean_value_expression", "boolean_factor",
  "boolean_term", "search_condition", "predicate",
  "comparison_predicate_part_2", "comparison_predicate", "comparison",
  "between_predicate_part_2", "between_predicate",
  "character_like_predicate_part_2", "other_like_predicate_part_2",
  "like_predicate", "opt_escape", "null_predicate_part_2", "test_for_null",
  "in_predicate_value", "in_predicate_part_2", "in_predicate",
  "quantified_comparison_predicate_part_2", "all_or_any_predicate",
  "any_all_some", "existence_test", "unique_test", "subquery",
  "scalar_exp_commalist", "select_sublist", "parameter_ref", "literal",
  "as_clause", "position_exp", "num_value_fct", "char_length_exp",
  "octet_length_exp", "bit_length_exp", "length_exp", "datetime_field",
  "extract_field", "time_zone_field", "extract_exp", "unsigned_value_spec",
  "general_value_spec", "set_fct_spec", "function_name0", "function_name1",
  "function_name2", "function_name12", "function_name23", "function_name3",
  "function_name", "string_function_1Argument",
  "string_function_2Argument", "string_function_3Argument",
  "string_function_4Argument", "string_function",
  "date_function_0Argument", "date_function_1Argument", "date_function",
  "numeric_function_0Argument", "numeric_function_1Argument",
  "numeric_function_2Argument", "numeric_function", "window_function",
  "window_function_type", "ntile_function",
  "dynamic_parameter_specification", "simple_value_specification",
  "number_of_tiles", "opt_lead_or_lag_function", "opt_null_treatment",
  "lead_or_lag_function", "lead_or_lag", "lead_or_lag_extent", "offset",
  "default_expression", "null_treatment", "first_or_last_value_function",
  "first_or_last_value", "opt_from_first_or_last", "nth_value_function",
  "nth_row", "from_first_or_last", "window_name",
  "window_name_or_specification", "in_line_window_specification",
  "opt_window_clause", "window_clause", "window_definition_list",
  "window_definition", "new_window_name", "window_specification",
  "opt_existing_window_name", "opt_window_partition_clause",
  "opt_window_frame_clause", "existing_window_name",
  "window_partition_clause", "window_partition_column_reference_list",
  "window_partition_column_reference", "opt_window_frame_exclusion",
  "window_frame_clause", "window_frame_units", "window_frame_extent",
  "window_frame_start", "window_frame_preceding", "window_frame_between",
  "window_frame_bound_1", "window_frame_bound_2", "window_frame_bound",
  "window_frame_following", "window_frame_exclusion", "op_parameter",
  "odbc_call_spec", "op_odbc_call_parameter", "odbc_parameter_commalist",
  "odbc_parameter", "odbc_fct_spec", "odbc_fct_type", "general_set_fct",
  "set_fct_type", "ordered_set_function", "hypothetical_set_function",
  "within_group_specification",
  "hypothetical_set_function_value_expression_list",
  "inverse_distribution_function",
  "inverse_distribution_function_argument",
  "inverse_distribution_function_type", "array_aggregate_function",
  "rank_function_type", "outer_join_type", "join_condition", "join_spec",
  "join_type", "cross_union", "qualified_join", "joined_table",
  "named_columns_join", "simple_table", "non_join_query_primary",
  "non_join_query_term", "query_primary", "non_join_query_exp", "all",
  "query_exp", "scalar_subquery", "cast_operand", "cast_target",
  "cast_spec", "value_exp_primary", "num_primary", "factor", "term",
  "num_value_exp", "datetime_primary", "datetime_value_fct", "time_zone",
  "time_zone_specifier", "datetime_factor", "datetime_term",
  "datetime_value_exp", "non_second_datetime_field", "start_field",
  "end_field", "single_datetime_field", "interval_qualifier",
  "function_arg_commalist2", "function_arg_commalist3",
  "function_arg_commalist4", "value_exp_commalist", "function_arg",
  "function_args_commalist", "value_exp", "string_value_exp",
  "char_value_exp", "concatenation", "char_primary", "collate_clause",
  "char_factor", "string_value_fct", "bit_value_fct", "bit_substring_fct",
  "bit_value_exp", "bit_factor", "bit_primary", "char_value_fct",
  "for_length", "char_substring_fct", "upper_lower", "fold",
  "form_conversion", "char_translation", "trim_fct", "trim_operands",
  "trim_spec", "derived_column", "table_node", "catalog_name",
  "schema_name", "table_name", "column_ref", "column_val", "data_type",
  "opt_char_set_spec", "opt_collate_clause", "predefined_type",
  "character_string_type", "opt_paren_precision", "paren_char_length",
  "opt_paren_char_large_length", "paren_character_large_object_length",
  "large_object_length", "opt_multiplier", "character_large_object_type",
  "national_character_string_type", "national_character_large_object_type",
  "binary_string_type", "binary_large_object_string_type", "numeric_type",
  "opt_paren_precision_scale", "exact_numeric_type",
  "approximate_numeric_type", "boolean_type", "datetime_type",
  "opt_with_or_without_time_zone", "interval_type", "column",
  "case_expression", "case_abbreviation", "case_specification",
  "simple_case", "searched_case", "simple_when_clause_list",
  "simple_when_clause", "when_operand_list", "when_operand",
  "searched_when_clause_list", "searched_when_clause", "else_clause",
  "result", "result_expression", "case_operand", "cursor", "parameter",
  "range_variable", "user", "trigger_definition", "op_referencing",
  "trigger_action_time", "trigger_event", "op_trigger_columnlist",
  "trigger_column_list", "triggered_action", "op_triggered_action_for",
  "trigger_for", "triggered_when_clause", "triggered_SQL_statement",
  "SQL_procedure_statement_list", "SQL_procedure_statement",
  "transition_table_or_variable_list", "transition_table_or_variable",
  "old_transition_table_name", "new_transition_table_name",
  "transition_table_name", "old_transition_variable_name",
  "new_transition_variable_name", "trigger_name", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#if YYDEBUG

# ifndef YYFPRINTF
#  define YYFPRINTF fprintf
# endif

# define YY_FPRINTF                             \
  YY_IGNORE_USELESS_CAST_BEGIN YY_FPRINTF_

# define YY_FPRINTF_(Args)                      \
  do {                                          \
    YYFPRINTF Args;                             \
    YY_IGNORE_USELESS_CAST_END                  \
  } while (0)

# define YY_DPRINTF                             \
  YY_IGNORE_USELESS_CAST_BEGIN YY_DPRINTF_

# define YY_DPRINTF_(Args)                      \
  do {                                          \
    if (yydebug)                                \
      YYFPRINTF Args;                           \
    YY_IGNORE_USELESS_CAST_END                  \
  } while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif



/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                  \
  do {                                                                  \
    if (yydebug)                                                        \
      {                                                                 \
        YY_FPRINTF ((stderr, "%s ", Title));                            \
        yy_symbol_print (stderr, Kind, Value);        \
        YY_FPRINTF ((stderr, "\n"));                                    \
      }                                                                 \
  } while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

static void yypstack (yyGLRStack* yystackp, YYPTRDIFF_T yyk)
  YY_ATTRIBUTE_UNUSED;
static void yypdumpstack (yyGLRStack* yystackp)
  YY_ATTRIBUTE_UNUSED;

#else /* !YYDEBUG */

# define YY_DPRINTF(Args) do {} while (yyfalse)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)

#endif /* !YYDEBUG */



/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain.  */
static void yyfillin (yyGLRStackItem *, int, int) YY_ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  int i;
  yyGLRState *s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
#if YYDEBUG
      yyvsp[i].yystate.yylrState = s->yylrState;
#endif
      yyvsp[i].yystate.yyresolved = s->yyresolved;
      if (s->yyresolved)
        yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      else
        /* The effect of using yysval or yyloc (in an immediate rule) is
         * undefined.  */
        yyvsp[i].yystate.yysemantics.yyfirstVal = YY_NULLPTR;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}


/** If yychar is empty, fetch the next token.  */
static inline yysymbol_kind_t
yygetToken (int *yycharp)
{
  yysymbol_kind_t yytoken;
  if (*yycharp == YYEMPTY)
    {
      YY_DPRINTF ((stderr, "Reading a token\n"));
      *yycharp = yylex ();
    }
  if (*yycharp <= YYEOF)
    {
      *yycharp = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YY_DPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (*yycharp);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }
  return yytoken;
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
 * YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
 * For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     YY_ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$).  Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT.  */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, int yyrhslen, yyGLRStackItem* yyvsp,
              yyGLRStack* yystackp,
              YYSTYPE* yyvalp)
{
  yybool yynormal YY_ATTRIBUTE_UNUSED = yystackp->yysplitPoint == YY_NULLPTR;
  int yylow;
  YYUSE (yyvalp);
  YYUSE (yyrhslen);
# undef yyerrok
# define yyerrok (yystackp->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING() (yystackp->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, (N), yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)                                              \
  return yyerror (YY_("syntax error: cannot back up")),     \
         yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  switch (yyn)
    {
  case 2:
                { xxx_pGLOBAL_SQLPARSER->setParseTree( (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode) ); }
    break;

  case 3:
                { xxx_pGLOBAL_SQLPARSER->setParseTree( (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode) ); }
    break;

  case 5:
           {
                ((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	   }
    break;

  case 10:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 11:
                {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 12:
                {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 15:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
    break;

  case 16:
                                            {((*yyvalp).pParseNode) = SQL_NEW_LISTRULE;}
    break;

  case 17:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 20:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 21:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 23:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 24:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 25:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 26:
                        {
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
    break;

  case 28:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 29:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 30:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 31:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 32:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 33:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-9)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 34:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 35:
                    {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 36:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 37:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 38:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 39:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 40:
                                    {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 41:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 42:
                                    {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 43:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 44:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 45:
                                    {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 46:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 47:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 49:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 50:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 52:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 54:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 55:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 57:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 58:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 61:
                                    {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 62:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 63:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 64:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 65:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 66:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 67:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 70:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 80:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("{", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("}", SQLNodeType::Punctuation));
		}
    break;

  case 82:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 83:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 84:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 85:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 86:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 87:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 88:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 89:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 93:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 94:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)); }
    break;

  case 95:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 98:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 99:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 100:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 103:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 104:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 105:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 107:
                                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 109:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 110:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 111:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("*", SQLNodeType::Punctuation));
		}
    break;

  case 113:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 115:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 116:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 122:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 124:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 127:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 129:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 130:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 131:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 132:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 133:
                        { ((*yyvalp).pParseNode) = SQL_NEW_RULE;
			  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)); }
    break;

  case 134:
                        { ((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)); }
    break;

  case 135:
                        { (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			  ((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode); }
    break;

  case 136:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 138:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 140:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 141:
                {
		    ((*yyvalp).pParseNode) = SQL_NEW_RULE;
		    ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		    ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		    ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 142:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 143:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 145:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("{", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("}", SQLNodeType::Punctuation));
		}
    break;

  case 146:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 147:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 148:
                                 {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 149:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 150:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 151:
                {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 152:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 153:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 154:
                                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 155:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 157:
                { // boolean_primary: rule 2
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 158:
                {
                    if(xxx_pGLOBAL_SQLPARSER->inPredicateCheck())// boolean_primary: rule 3
                    {
                        ((*yyvalp).pParseNode) = SQL_NEW_RULE;
                        sal_Int16 nErg = 0;
                        if ( SQL_ISTOKEN( (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode), NULL))
                        {
                            OSQLParseNode* pColumnRef = newNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
                            pColumnRef->append(newNode(xxx_pGLOBAL_SQLPARSER->getFieldName(),SQLNodeType::Name));
                            OSQLParseNode* pTFN = new OSQLInternalNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::test_for_null));
                            pTFN->append(pColumnRef);

                            OSQLParseNode* pNPP2 = new OSQLInternalNode("", SQLNodeType::Rule, OSQLParser::RuleID(OSQLParseNode::null_predicate_part_2));
                            pNPP2->append(new OSQLInternalNode("", SQLNodeType::Keyword, SQL_TOKEN_IS));
                            pNPP2->append(new OSQLInternalNode("", SQLNodeType::Rule, OSQLParser::RuleID(OSQLParseNode::sql_not)));
                            pNPP2->append(new OSQLInternalNode("", SQLNodeType::Keyword, SQL_TOKEN_NULL));
                            pTFN->append(pNPP2);

                            ((*yyvalp).pParseNode)->append(pTFN);

                            nErg = 1;
                        }
                        else
                        {
                            nErg = xxx_pGLOBAL_SQLPARSER->buildComparisonRule(((*yyvalp).pParseNode),(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
                        }
                        if(nErg == 1)
                        {
                            OSQLParseNode* pTemp = ((*yyvalp).pParseNode);
                            ((*yyvalp).pParseNode) = pTemp->removeAt((sal_uInt32)0);
                            delete pTemp;
                        }
                        else
                        {
                            delete ((*yyvalp).pParseNode);
                            if(nErg)
                                YYERROR;
                            else
                                YYABORT;
                        }
                    }
                    else
                        YYERROR;
                }
    break;

  case 159:
        { // boolean_primary: rule 2
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 161:
                { // boolean_factor: rule 1
		    ((*yyvalp).pParseNode) = SQL_NEW_RULE;
		    ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		    ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 163:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // boolean_term: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 165:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // search_condition
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 174:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // comparison_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 175:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // comparison_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 176:
                {
			if(xxx_pGLOBAL_SQLPARSER->inPredicateCheck()) // comparison_predicate: rule 2
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				sal_Int16 nErg = xxx_pGLOBAL_SQLPARSER->buildPredicateRule(((*yyvalp).pParseNode),(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode),(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				if(nErg == 1)
				{
					OSQLParseNode* pTemp = ((*yyvalp).pParseNode);
					((*yyvalp).pParseNode) = pTemp->removeAt((sal_uInt32)0);
					delete pTemp;
				}
				else
				{
					delete ((*yyvalp).pParseNode);
					YYABORT;
				}
			}
			else
			{
				YYERROR;
			}
		}
    break;

  case 183:
                {
		  ((*yyvalp).pParseNode) = SQL_NEW_RULE;
		  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 184:
                {
		  ((*yyvalp).pParseNode) = SQL_NEW_RULE;
		  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		  ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 185:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck()) // between_predicate: rule 2
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;

				sal_Int16 nErg = xxx_pGLOBAL_SQLPARSER->buildPredicateRule(((*yyvalp).pParseNode),(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode),(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode),(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				if(nErg == 1)
				{
					OSQLParseNode* pTemp = ((*yyvalp).pParseNode);
					((*yyvalp).pParseNode) = pTemp->removeAt((sal_uInt32)0);
					OSQLParseNode* pColumnRef = ((*yyvalp).pParseNode)->removeAt((sal_uInt32)0);
					((*yyvalp).pParseNode)->insert(0,(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
					OSQLParseNode* pBetween_predicate = new OSQLInternalNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::between_predicate));
					pBetween_predicate->append(pColumnRef);
					pBetween_predicate->append(((*yyvalp).pParseNode));
					((*yyvalp).pParseNode) = pBetween_predicate;

					delete pTemp;
					delete (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode);
				}
				else
				{
					delete ((*yyvalp).pParseNode);
					YYABORT;
				}
			}
			else
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE; // between_predicate: rule 1
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
		}
    break;

  case 186:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // between_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 188:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // like_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 189:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // like_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 190:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // like_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 191:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;  // like_predicate: rule 3
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 192:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())  // like_predicate: rule 5
			{
				OSQLParseNode* pColumnRef = newNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
				pColumnRef->append(newNode(xxx_pGLOBAL_SQLPARSER->getFieldName(),SQLNodeType::Name));

				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append(pColumnRef);
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				OSQLParseNode* p2nd = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)->removeAt(2);
				OSQLParseNode* p3rd = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)->removeAt(2);
				if ( !xxx_pGLOBAL_SQLPARSER->buildLikeRule((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode),p2nd,p3rd) )
				{
					delete ((*yyvalp).pParseNode);
					YYABORT;
				}
				(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)->append(p3rd);
			}
			else
				YYERROR;
		}
    break;

  case 193:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck()) // like_predicate: rule 6
			{
				OSQLParseNode* pColumnRef = newNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
				pColumnRef->append(newNode(xxx_pGLOBAL_SQLPARSER->getFieldName(),SQLNodeType::Name));

				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append(pColumnRef);
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				OSQLParseNode* p2nd = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)->removeAt(2);
				OSQLParseNode* p3rd = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)->removeAt(2);
				if ( !xxx_pGLOBAL_SQLPARSER->buildLikeRule((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode),p2nd,p3rd) )
				{
					delete ((*yyvalp).pParseNode);
					YYABORT;
				}
				(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode)->append(p3rd);
			}
			else
				YYERROR;
		}
    break;

  case 194:
                                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 195:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 196:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("{", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("}", SQLNodeType::Punctuation));
		}
    break;

  case 197:
          {
		((*yyvalp).pParseNode) = SQL_NEW_RULE; // test_for_null: rule 1
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	  }
    break;

  case 198:
          {
		((*yyvalp).pParseNode) = SQL_NEW_RULE; // test_for_null: rule 1
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	  }
    break;

  case 199:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE; // test_for_null: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 200:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())// test_for_null: rule 2
			{
				OSQLParseNode* pColumnRef = newNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
				pColumnRef->append(newNode(xxx_pGLOBAL_SQLPARSER->getFieldName(),SQLNodeType::Name));

				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append(pColumnRef);
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
			else
				YYERROR;
		}
    break;

  case 201:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 202:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 203:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;// in_predicate: rule 1
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 204:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;// in_predicate: rule 1
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 205:
                {
			if ( xxx_pGLOBAL_SQLPARSER->inPredicateCheck() )// in_predicate: rule 2
			{
				OSQLParseNode* pColumnRef = newNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
				pColumnRef->append(newNode(xxx_pGLOBAL_SQLPARSER->getFieldName(),SQLNodeType::Name));

				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append(pColumnRef);
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
			else
				YYERROR;
		}
    break;

  case 206:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 207:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 208:
                {
			if(xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				OSQLParseNode* pColumnRef = newNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
				pColumnRef->append(newNode(xxx_pGLOBAL_SQLPARSER->getFieldName(),SQLNodeType::Name));

				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append(pColumnRef);
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
			else
				YYERROR;
		}
    break;

  case 212:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 213:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 214:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));}
    break;

  case 215:
                {
			((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 216:
                {
			(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);
		}
    break;

  case 224:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				OSQLParser::reduceLiteral(((*yyvalp).pParseNode), true);
			}
			else
				YYERROR;
		}
    break;

  case 225:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				OSQLParser::reduceLiteral(((*yyvalp).pParseNode), true);
			}
			else
				YYERROR;
		}
    break;

  case 226:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				OSQLParser::reduceLiteral(((*yyvalp).pParseNode), true);
			}
			else
				YYERROR;
		}
    break;

  case 227:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				OSQLParser::reduceLiteral(((*yyvalp).pParseNode), true);
			}
			else
				YYERROR;
		}
    break;

  case 228:
                            {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 229:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 231:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 232:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 236:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 237:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 238:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 239:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 240:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 241:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 242:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 243:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 244:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 248:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 249:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 250:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 268:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("{", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("}", SQLNodeType::Punctuation));
		}
    break;

  case 269:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 270:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 271:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 272:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 273:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 274:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 275:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 276:
                {
			if ( (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->count() == 1 || (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->count() == 2 )
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			}
			else
				YYERROR;
		}
    break;

  case 277:
                {
			if ( (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->count() == 2 || (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->count() == 3)
			{
				((*yyvalp).pParseNode) = SQL_NEW_RULE;
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
				((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			}
			else
				YYERROR;
		}
    break;

  case 356:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 357:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 358:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 364:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 369:
                         {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 370:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode(",", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 371:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode(",", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(",", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 372:
                                 {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 374:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 382:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 385:
                                 {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 387:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(",", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 390:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 391:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 396:
                                 {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 398:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 399:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 400:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 401:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 403:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 404:
                                 {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 406:
                         {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 408:
                         {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 411:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 412:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 413:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 414:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 415:
                         {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 417:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 422:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 424:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 425:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 426:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 430:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 432:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 433:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 434:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 435:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 436:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 437:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 438:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("?", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 439:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 440:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 441:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 442:
                {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 443:
                {
			(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);
		}
    break;

  case 444:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 447:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 448:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 452:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 453:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append(newNode("*", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 454:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 473:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 474:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 475:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
	}
    break;

  case 476:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 478:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 482:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 487:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 488:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 489:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 490:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 493:
                                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 494:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 496:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 497:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 498:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 499:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 502:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 506:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 508:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 511:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 512:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 513:
                   {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 520:
          {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 527:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 532:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("-", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 533:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("+", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 535:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("*", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 536:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("/", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 538:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("+", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 539:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("-", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 540:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 541:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 542:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 543:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 544:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 545:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 546:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 547:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 548:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 549:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 555:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 557:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 558:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 559:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 560:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 562:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 563:
                {
			((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 564:
                {
			((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 565:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 566:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 567:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);
			}
			else
				YYERROR;
		}
    break;

  case 569:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 570:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 571:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 572:
                        {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 573:
                        {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 574:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck())
			{
				(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
				((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);
			}
			else
				YYERROR;
		}
    break;

  case 577:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 581:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("+", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 582:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 585:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 587:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 590:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 591:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 592:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 593:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 594:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 597:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 598:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 599:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 600:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 601:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 602:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 603:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 606:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 607:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 608:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(",", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 609:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 610:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 611:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 612:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 613:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 614:
            {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 619:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 623:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 624:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(":", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 625:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 626:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 627:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 628:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
    break;

  case 629:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 630:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
    break;

  case 631:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(":", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(".", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			}
    break;

  case 632:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 633:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("*", SQLNodeType::Punctuation));
		}
    break;

  case 635:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 636:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 637:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 639:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 640:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 646:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 647:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 648:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 649:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 650:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 652:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 654:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 655:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 657:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
	}
    break;

  case 658:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 659:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 660:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("K", SQLNodeType::Punctuation));
		}
    break;

  case 661:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("M", SQLNodeType::Punctuation));
		}
    break;

  case 662:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("G", SQLNodeType::Punctuation));
		}
    break;

  case 663:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("T", SQLNodeType::Punctuation));
		}
    break;

  case 664:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("P", SQLNodeType::Punctuation));
		}
    break;

  case 665:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 666:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 667:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 668:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 669:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 670:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 671:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 672:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 673:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 675:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 676:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 677:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 678:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 679:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 680:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 682:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 683:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 686:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 687:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 688:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(",", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 689:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 690:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 691:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 696:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 700:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 703:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 704:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 705:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 706:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 707:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 708:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
	}
    break;

  case 710:
                {
			sal_uInt32 nNod = ((*yyvalp).pParseNode)->getRuleID();
			delete ((*yyvalp).pParseNode);
			((*yyvalp).pParseNode) = newNode(OSQLParser::TokenIDToStr(nNod), SQLNodeType::Name);
		}
    break;

  case 711:
                {
			sal_uInt32 nNod = ((*yyvalp).pParseNode)->getRuleID();
			delete ((*yyvalp).pParseNode);
			((*yyvalp).pParseNode) = newNode(OSQLParser::TokenIDToStr(nNod), SQLNodeType::Name);
		}
    break;

  case 712:
                {
			sal_uInt32 nNod = ((*yyvalp).pParseNode)->getRuleID();
			delete ((*yyvalp).pParseNode);
			((*yyvalp).pParseNode) = newNode(OSQLParser::TokenIDToStr(nNod), SQLNodeType::Name);
		}
    break;

  case 715:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 716:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 717:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("(", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
		}
    break;

  case 720:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 721:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 722:
                {
			((*yyvalp).pParseNode) = SQL_NEW_LISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 723:
                {
			(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode);
		}
    break;

  case 724:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 725:
                {((*yyvalp).pParseNode) = SQL_NEW_COMMALISTRULE;
		((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 726:
                {(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);}
    break;

  case 733:
                {
			((*yyvalp).pParseNode) = SQL_NEW_LISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 734:
                {
			(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode);
		}
    break;

  case 735:
        {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 736:
                {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 737:
                {
			((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 741:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 742:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode(":", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));}
    break;

  case 743:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE; // test
			((*yyvalp).pParseNode)->append(newNode("?", SQLNodeType::Punctuation));}
    break;

  case 744:
                        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
			((*yyvalp).pParseNode)->append(newNode("[", SQLNodeType::Punctuation));
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode)->append(newNode("]", SQLNodeType::Punctuation));}
    break;

  case 745:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;}
    break;

  case 746:
        {((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
        }
    break;

  case 748:
                {
			if (xxx_pGLOBAL_SQLPARSER->inPredicateCheck()) // sql: rule 1
			{
				((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode);
				if ( SQL_ISRULE(((*yyvalp).pParseNode),search_condition) )
				{
					((*yyvalp).pParseNode)->insert(0,newNode("(", SQLNodeType::Punctuation));
					((*yyvalp).pParseNode)->append(newNode(")", SQLNodeType::Punctuation));
				}
			}
			else
				YYERROR;
		}
    break;

  case 750:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 751:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
	}
    break;

  case 752:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 755:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 758:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 759:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
	}
    break;

  case 760:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 762:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 763:
                {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
		}
    break;

  case 764:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 767:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
	}
    break;

  case 768:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 770:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append(newNode(";", SQLNodeType::Punctuation));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 771:
                {
			((*yyvalp).pParseNode) = SQL_NEW_LISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 772:
                {
			(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode);
		}
    break;

  case 774:
                {
			((*yyvalp).pParseNode) = SQL_NEW_LISTRULE;
			((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
		}
    break;

  case 775:
                {
			(YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
			((*yyvalp).pParseNode) = (YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode);
		}
    break;

  case 776:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 777:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 778:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;

  case 779:
        {
		((*yyvalp).pParseNode) = SQL_NEW_RULE;
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.pParseNode));
        ((*yyvalp).pParseNode)->append((YY_CAST (yyGLRStackItem const *, yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.pParseNode));
    }
    break;



      default: break;
    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  YYUSE (yy0);
  YYUSE (yy1);

  switch (yyn)
    {

      default: break;
    }
}

                              /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}

/** Number of symbols composing the right hand side of rule #RULE.  */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

static void
yydestroyGLRState (char const *yymsg, yyGLRState *yys)
{
  if (yys->yyresolved)
    yydestruct (yymsg, yy_accessing_symbol (yys->yylrState),
                &yys->yysemantics.yysval);
  else
    {
#if YYDEBUG
      if (yydebug)
        {
          if (yys->yysemantics.yyfirstVal)
            YY_FPRINTF ((stderr, "%s unresolved", yymsg));
          else
            YY_FPRINTF ((stderr, "%s incomplete", yymsg));
          YY_SYMBOL_PRINT ("", yy_accessing_symbol (yys->yylrState), YY_NULLPTR, &yys->yyloc);
        }
#endif

      if (yys->yysemantics.yyfirstVal)
        {
          yySemanticOption *yyoption = yys->yysemantics.yyfirstVal;
          yyGLRState *yyrh;
          int yyn;
          for (yyrh = yyoption->yystate, yyn = yyrhsLength (yyoption->yyrule);
               yyn > 0;
               yyrh = yyrh->yypred, yyn -= 1)
            yydestroyGLRState (yymsg, yyrh);
        }
    }
}

/** Left-hand-side symbol for rule #YYRULE.  */
static inline yysymbol_kind_t
yylhsNonterm (yyRuleNum yyrule)
{
  return YY_CAST (yysymbol_kind_t, yyr1[yyrule]);
}

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

/** True iff LR state YYSTATE has only a default reduction (regardless
 *  of token).  */
static inline yybool
yyisDefaultedState (yy_state_t yystate)
{
  return yypact_value_is_default (yypact[yystate]);
}

/** The default reduction for YYSTATE, assuming it has one.  */
static inline yyRuleNum
yydefaultAction (yy_state_t yystate)
{
  return yydefact[yystate];
}

#define yytable_value_is_error(Yyn) \
  0

/** The action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *YYCONFLICTS to a pointer into yyconfl to a 0-terminated list
 *  of conflicting reductions.
 */
static inline int
yygetLRActions (yy_state_t yystate, yysymbol_kind_t yytoken, const short** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yytoken == YYSYMBOL_YYerror)
    {
      // This is the error token.
      *yyconflicts = yyconfl;
      return 0;
    }
  else if (yyisDefaultedState (yystate)
           || yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyconflicts = yyconfl;
      return -yydefact[yystate];
    }
  else if (! yytable_value_is_error (yytable[yyindex]))
    {
      *yyconflicts = yyconfl + yyconflp[yyindex];
      return yytable[yyindex];
    }
  else
    {
      *yyconflicts = yyconfl + yyconflp[yyindex];
      return 0;
    }
}

/** Compute post-reduction state.
 * \param yystate   the current state
 * \param yysym     the nonterminal to push on the stack
 */
static inline yy_state_t
yyLRgotoState (yy_state_t yystate, yysymbol_kind_t yysym)
{
  int yyr = yypgoto[yysym - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yysym - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

                                /* GLRStates */

/** Return a fresh GLRStackItem in YYSTACKP.  The item is an LR state
 *  if YYISSTATE, and otherwise a semantic option.  Callers should call
 *  YY_RESERVE_GLRSTACK afterwards to make sure there is sufficient
 *  headroom.  */

static inline yyGLRStackItem*
yynewGLRStackItem (yyGLRStack* yystackp, yybool yyisState)
{
  yyGLRStackItem* yynewItem = yystackp->yynextFree;
  yystackp->yyspaceLeft -= 1;
  yystackp->yynextFree += 1;
  yynewItem->yystate.yyisState = yyisState;
  return yynewItem;
}

/** Add a new semantic action that will execute the action for rule
 *  YYRULE on the semantic values in YYRHS to the list of
 *  alternative actions for YYSTATE.  Assumes that YYRHS comes from
 *  stack #YYK of *YYSTACKP. */
static void
yyaddDeferredAction (yyGLRStack* yystackp, YYPTRDIFF_T yyk, yyGLRState* yystate,
                     yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewOption =
    &yynewGLRStackItem (yystackp, yyfalse)->yyoption;
  YY_ASSERT (!yynewOption->yyisState);
  yynewOption->yystate = yyrhs;
  yynewOption->yyrule = yyrule;
  if (yystackp->yytops.yylookaheadNeeds[yyk])
    {
      yynewOption->yyrawchar = yychar;
      yynewOption->yyval = yylval;
    }
  else
    yynewOption->yyrawchar = YYEMPTY;
  yynewOption->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewOption;

  YY_RESERVE_GLRSTACK (yystackp);
}

                                /* GLRStacks */

/** Initialize YYSET to a singleton set containing an empty stack.  */
static yybool
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates
    = YY_CAST (yyGLRState**,
               YYMALLOC (YY_CAST (YYSIZE_T, yyset->yycapacity)
                         * sizeof yyset->yystates[0]));
  if (! yyset->yystates)
    return yyfalse;
  yyset->yystates[0] = YY_NULLPTR;
  yyset->yylookaheadNeeds
    = YY_CAST (yybool*,
               YYMALLOC (YY_CAST (YYSIZE_T, yyset->yycapacity)
                         * sizeof yyset->yylookaheadNeeds[0]));
  if (! yyset->yylookaheadNeeds)
    {
      YYFREE (yyset->yystates);
      return yyfalse;
    }
  memset (yyset->yylookaheadNeeds,
          0,
          YY_CAST (YYSIZE_T, yyset->yycapacity) * sizeof yyset->yylookaheadNeeds[0]);
  return yytrue;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
  YYFREE (yyset->yylookaheadNeeds);
}

/** Initialize *YYSTACKP to a single empty stack, with total maximum
 *  capacity for all stacks of YYSIZE.  */
static yybool
yyinitGLRStack (yyGLRStack* yystackp, YYPTRDIFF_T yysize)
{
  yystackp->yyerrState = 0;
  yynerrs = 0;
  yystackp->yyspaceLeft = yysize;
  yystackp->yyitems
    = YY_CAST (yyGLRStackItem*,
               YYMALLOC (YY_CAST (YYSIZE_T, yysize)
                         * sizeof yystackp->yynextFree[0]));
  if (!yystackp->yyitems)
    return yyfalse;
  yystackp->yynextFree = yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;
  return yyinitStateSet (&yystackp->yytops);
}


#if YYSTACKEXPANDABLE
# define YYRELOC(YYFROMITEMS, YYTOITEMS, YYX, YYTYPE)                   \
  &((YYTOITEMS)                                                         \
    - ((YYFROMITEMS) - YY_REINTERPRET_CAST (yyGLRStackItem*, (YYX))))->YYTYPE

/** If *YYSTACKP is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation.  */
static void
yyexpandGLRStack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yynewItems;
  yyGLRStackItem* yyp0, *yyp1;
  YYPTRDIFF_T yynewSize;
  YYPTRDIFF_T yyn;
  YYPTRDIFF_T yysize = yystackp->yynextFree - yystackp->yyitems;
  if (YYMAXDEPTH - YYHEADROOM < yysize)
    yyMemoryExhausted (yystackp);
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yynewItems
    = YY_CAST (yyGLRStackItem*,
               YYMALLOC (YY_CAST (YYSIZE_T, yynewSize)
                         * sizeof yynewItems[0]));
  if (! yynewItems)
    yyMemoryExhausted (yystackp);
  for (yyp0 = yystackp->yyitems, yyp1 = yynewItems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*YY_REINTERPRET_CAST (yybool *, yyp0))
        {
          yyGLRState* yys0 = &yyp0->yystate;
          yyGLRState* yys1 = &yyp1->yystate;
          if (yys0->yypred != YY_NULLPTR)
            yys1->yypred =
              YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
          if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != YY_NULLPTR)
            yys1->yysemantics.yyfirstVal =
              YYRELOC (yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
        }
      else
        {
          yySemanticOption* yyv0 = &yyp0->yyoption;
          yySemanticOption* yyv1 = &yyp1->yyoption;
          if (yyv0->yystate != YY_NULLPTR)
            yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
          if (yyv0->yynext != YY_NULLPTR)
            yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
        }
    }
  if (yystackp->yysplitPoint != YY_NULLPTR)
    yystackp->yysplitPoint = YYRELOC (yystackp->yyitems, yynewItems,
                                      yystackp->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystackp->yytops.yysize; yyn += 1)
    if (yystackp->yytops.yystates[yyn] != YY_NULLPTR)
      yystackp->yytops.yystates[yyn] =
        YYRELOC (yystackp->yyitems, yynewItems,
                 yystackp->yytops.yystates[yyn], yystate);
  YYFREE (yystackp->yyitems);
  yystackp->yyitems = yynewItems;
  yystackp->yynextFree = yynewItems + yysize;
  yystackp->yyspaceLeft = yynewSize - yysize;
}
#endif

static void
yyfreeGLRStack (yyGLRStack* yystackp)
{
  YYFREE (yystackp->yyitems);
  yyfreeStateSet (&yystackp->yytops);
}

/** Assuming that YYS is a GLRState somewhere on *YYSTACKP, update the
 *  splitpoint of *YYSTACKP, if needed, so that it is at least as deep as
 *  YYS.  */
static inline void
yyupdateSplit (yyGLRStack* yystackp, yyGLRState* yys)
{
  if (yystackp->yysplitPoint != YY_NULLPTR && yystackp->yysplitPoint > yys)
    yystackp->yysplitPoint = yys;
}

/** Invalidate stack #YYK in *YYSTACKP.  */
static inline void
yymarkStackDeleted (yyGLRStack* yystackp, YYPTRDIFF_T yyk)
{
  if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    yystackp->yylastDeleted = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yystates[yyk] = YY_NULLPTR;
}

/** Undelete the last stack in *YYSTACKP that was marked as deleted.  Can
    only be done once after a deletion, and only when all other stacks have
    been deleted.  */
static void
yyundeleteLastStack (yyGLRStack* yystackp)
{
  if (yystackp->yylastDeleted == YY_NULLPTR || yystackp->yytops.yysize != 0)
    return;
  yystackp->yytops.yystates[0] = yystackp->yylastDeleted;
  yystackp->yytops.yysize = 1;
  YY_DPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystackp->yylastDeleted = YY_NULLPTR;
}

static inline void
yyremoveDeletes (yyGLRStack* yystackp)
{
  YYPTRDIFF_T yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystackp->yytops.yysize)
    {
      if (yystackp->yytops.yystates[yyi] == YY_NULLPTR)
        {
          if (yyi == yyj)
            YY_DPRINTF ((stderr, "Removing dead stacks.\n"));
          yystackp->yytops.yysize -= 1;
        }
      else
        {
          yystackp->yytops.yystates[yyj] = yystackp->yytops.yystates[yyi];
          /* In the current implementation, it's unnecessary to copy
             yystackp->yytops.yylookaheadNeeds[yyi] since, after
             yyremoveDeletes returns, the parser immediately either enters
             deterministic operation or shifts a token.  However, it doesn't
             hurt, and the code might evolve to need it.  */
          yystackp->yytops.yylookaheadNeeds[yyj] =
            yystackp->yytops.yylookaheadNeeds[yyi];
          if (yyj != yyi)
            YY_DPRINTF ((stderr, "Rename stack %ld -> %ld.\n",
                        YY_CAST (long, yyi), YY_CAST (long, yyj)));
          yyj += 1;
        }
      yyi += 1;
    }
}

/** Shift to a new state on stack #YYK of *YYSTACKP, corresponding to LR
 * state YYLRSTATE, at input position YYPOSN, with (resolved) semantic
 * value *YYVALP and source location *YYLOCP.  */
static inline void
yyglrShift (yyGLRStack* yystackp, YYPTRDIFF_T yyk, yy_state_t yylrState,
            YYPTRDIFF_T yyposn,
            YYSTYPE* yyvalp)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yytrue;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yysval = *yyvalp;
  yystackp->yytops.yystates[yyk] = yynewState;

  YY_RESERVE_GLRSTACK (yystackp);
}

/** Shift stack #YYK of *YYSTACKP, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE.  */
static inline void
yyglrShiftDefer (yyGLRStack* yystackp, YYPTRDIFF_T yyk, yy_state_t yylrState,
                 YYPTRDIFF_T yyposn, yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;
  YY_ASSERT (yynewState->yyisState);

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yyfalse;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yyfirstVal = YY_NULLPTR;
  yystackp->yytops.yystates[yyk] = yynewState;

  /* Invokes YY_RESERVE_GLRSTACK.  */
  yyaddDeferredAction (yystackp, yyk, yynewState, yyrhs, yyrule);
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(Args)
#else
# define YY_REDUCE_PRINT(Args)          \
  do {                                  \
    if (yydebug)                        \
      yy_reduce_print Args;             \
  } while (0)

/*----------------------------------------------------------------------.
| Report that stack #YYK of *YYSTACKP is going to be reduced by YYRULE. |
`----------------------------------------------------------------------*/

static inline void
yy_reduce_print (yybool yynormal, yyGLRStackItem* yyvsp, YYPTRDIFF_T yyk,
                 yyRuleNum yyrule)
{
  int yynrhs = yyrhsLength (yyrule);
  int yyi;
  YY_FPRINTF ((stderr, "Reducing stack %ld by rule %d (line %d):\n",
               YY_CAST (long, yyk), yyrule - 1, yyrline[yyrule]));
  if (! yynormal)
    yyfillin (yyvsp, 1, -yynrhs);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YY_FPRINTF ((stderr, "   $%d = ", yyi + 1));
      yy_symbol_print (stderr,
                       yy_accessing_symbol (yyvsp[yyi - yynrhs + 1].yystate.yylrState),
                       &yyvsp[yyi - yynrhs + 1].yystate.yysemantics.yysval                       );
      if (!yyvsp[yyi - yynrhs + 1].yystate.yyresolved)
        YY_FPRINTF ((stderr, " (unresolved)"));
      YY_FPRINTF ((stderr, "\n"));
    }
}
#endif

/** Pop the symbols consumed by reduction #YYRULE from the top of stack
 *  #YYK of *YYSTACKP, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved.  Set *YYVALP to the resulting value,
 *  and *YYLOCP to the computed location (if any).  Return value is as
 *  for userAction.  */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystackp, YYPTRDIFF_T yyk, yyRuleNum yyrule,
            YYSTYPE* yyvalp)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      /* Standard special case: single stack.  */
      yyGLRStackItem* yyrhs
        = YY_REINTERPRET_CAST (yyGLRStackItem*, yystackp->yytops.yystates[yyk]);
      YY_ASSERT (yyk == 0);
      yystackp->yynextFree -= yynrhs;
      yystackp->yyspaceLeft += yynrhs;
      yystackp->yytops.yystates[0] = & yystackp->yynextFree[-1].yystate;
      YY_REDUCE_PRINT ((yytrue, yyrhs, yyk, yyrule));
      return yyuserAction (yyrule, yynrhs, yyrhs, yystackp,
                           yyvalp);
    }
  else
    {
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yyGLRState* yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
        = yystackp->yytops.yystates[yyk];
      int yyi;
      for (yyi = 0; yyi < yynrhs; yyi += 1)
        {
          yys = yys->yypred;
          YY_ASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yystackp->yytops.yystates[yyk] = yys;
      YY_REDUCE_PRINT ((yyfalse, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1, yyk, yyrule));
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp);
    }
}

/** Pop items off stack #YYK of *YYSTACKP according to grammar rule YYRULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with YYRULE and store its value with the
 *  newly pushed state, if YYFORCEEVAL or if *YYSTACKP is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #YYK from
 *  *YYSTACKP.  In this case, the semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystackp, YYPTRDIFF_T yyk, yyRuleNum yyrule,
             yybool yyforceEval)
{
  YYPTRDIFF_T yyposn = yystackp->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYSTYPE yysval;

      YYRESULTTAG yyflag = yydoAction (yystackp, yyk, yyrule, &yysval);
      if (yyflag == yyerr && yystackp->yysplitPoint != YY_NULLPTR)
        YY_DPRINTF ((stderr,
                     "Parse on stack %ld rejected by rule %d (line %d).\n",
                     YY_CAST (long, yyk), yyrule - 1, yyrline[yyrule - 1]));
      if (yyflag != yyok)
        return yyflag;
      YY_SYMBOL_PRINT ("-> $$ =", yylhsNonterm (yyrule), &yysval, &yyloc);
      yyglrShift (yystackp, yyk,
                  yyLRgotoState (yystackp->yytops.yystates[yyk]->yylrState,
                                 yylhsNonterm (yyrule)),
                  yyposn, &yysval);
    }
  else
    {
      YYPTRDIFF_T yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystackp->yytops.yystates[yyk];
      yy_state_t yynewLRState;

      for (yys = yystackp->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
           0 < yyn; yyn -= 1)
        {
          yys = yys->yypred;
          YY_ASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YY_DPRINTF ((stderr,
                   "Reduced stack %ld by rule %d (line %d); action deferred.  "
                   "Now in state %d.\n",
                   YY_CAST (long, yyk), yyrule - 1, yyrline[yyrule - 1],
                   yynewLRState));
      for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
        if (yyi != yyk && yystackp->yytops.yystates[yyi] != YY_NULLPTR)
          {
            yyGLRState *yysplit = yystackp->yysplitPoint;
            yyGLRState *yyp = yystackp->yytops.yystates[yyi];
            while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
              {
                if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
                  {
                    yyaddDeferredAction (yystackp, yyk, yyp, yys0, yyrule);
                    yymarkStackDeleted (yystackp, yyk);
                    YY_DPRINTF ((stderr, "Merging stack %ld into stack %ld.\n",
                                 YY_CAST (long, yyk), YY_CAST (long, yyi)));
                    return yyok;
                  }
                yyp = yyp->yypred;
              }
          }
      yystackp->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystackp, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static YYPTRDIFF_T
yysplitStack (yyGLRStack* yystackp, YYPTRDIFF_T yyk)
{
  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      YY_ASSERT (yyk == 0);
      yystackp->yysplitPoint = yystackp->yytops.yystates[yyk];
    }
  if (yystackp->yytops.yycapacity <= yystackp->yytops.yysize)
    {
      YYPTRDIFF_T state_size = YYSIZEOF (yystackp->yytops.yystates[0]);
      YYPTRDIFF_T half_max_capacity = YYSIZE_MAXIMUM / 2 / state_size;
      if (half_max_capacity < yystackp->yytops.yycapacity)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yycapacity *= 2;

      {
        yyGLRState** yynewStates
          = YY_CAST (yyGLRState**,
                     YYREALLOC (yystackp->yytops.yystates,
                                (YY_CAST (YYSIZE_T, yystackp->yytops.yycapacity)
                                 * sizeof yynewStates[0])));
        if (yynewStates == YY_NULLPTR)
          yyMemoryExhausted (yystackp);
        yystackp->yytops.yystates = yynewStates;
      }

      {
        yybool* yynewLookaheadNeeds
          = YY_CAST (yybool*,
                     YYREALLOC (yystackp->yytops.yylookaheadNeeds,
                                (YY_CAST (YYSIZE_T, yystackp->yytops.yycapacity)
                                 * sizeof yynewLookaheadNeeds[0])));
        if (yynewLookaheadNeeds == YY_NULLPTR)
          yyMemoryExhausted (yystackp);
        yystackp->yytops.yylookaheadNeeds = yynewLookaheadNeeds;
      }
    }
  yystackp->yytops.yystates[yystackp->yytops.yysize]
    = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yylookaheadNeeds[yystackp->yytops.yysize]
    = yystackp->yytops.yylookaheadNeeds[yyk];
  yystackp->yytops.yysize += 1;
  return yystackp->yytops.yysize - 1;
}

/** True iff YYY0 and YYY1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols.  */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
           yyn = yyrhsLength (yyy0->yyrule);
           yyn > 0;
           yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
        if (yys0->yyposn != yys1->yyposn)
          return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (YYY0,YYY1), destructively merge the
 *  alternative semantic values for the RHS-symbols of YYY1 and YYY0.  */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       0 < yyn;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    {
      if (yys0 == yys1)
        break;
      else if (yys0->yyresolved)
        {
          yys1->yyresolved = yytrue;
          yys1->yysemantics.yysval = yys0->yysemantics.yysval;
        }
      else if (yys1->yyresolved)
        {
          yys0->yyresolved = yytrue;
          yys0->yysemantics.yysval = yys1->yysemantics.yysval;
        }
      else
        {
          yySemanticOption** yyz0p = &yys0->yysemantics.yyfirstVal;
          yySemanticOption* yyz1 = yys1->yysemantics.yyfirstVal;
          while (yytrue)
            {
              if (yyz1 == *yyz0p || yyz1 == YY_NULLPTR)
                break;
              else if (*yyz0p == YY_NULLPTR)
                {
                  *yyz0p = yyz1;
                  break;
                }
              else if (*yyz0p < yyz1)
                {
                  yySemanticOption* yyz = *yyz0p;
                  *yyz0p = yyz1;
                  yyz1 = yyz1->yynext;
                  (*yyz0p)->yynext = yyz;
                }
              yyz0p = &(*yyz0p)->yynext;
            }
          yys1->yysemantics.yyfirstVal = yys0->yysemantics.yyfirstVal;
        }
    }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred.  */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
        return 0;
      else
        return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yyGLRState* yys,
                                   yyGLRStack* yystackp);


/** Resolve the previous YYN states starting at and including state YYS
 *  on *YYSTACKP. If result != yyok, some states may have been left
 *  unresolved possibly with empty semantic option chains.  Regardless
 *  of whether result = yyok, each state has been left with consistent
 *  data so that yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn,
                 yyGLRStack* yystackp)
{
  if (0 < yyn)
    {
      YY_ASSERT (yys->yypred);
      YYCHK (yyresolveStates (yys->yypred, yyn-1, yystackp));
      if (! yys->yyresolved)
        YYCHK (yyresolveValue (yys, yystackp));
    }
  return yyok;
}

/** Resolve the states for the RHS of YYOPT on *YYSTACKP, perform its
 *  user action, and return the semantic value and location in *YYVALP
 *  and *YYLOCP.  Regardless of whether result = yyok, all RHS states
 *  have been destroyed (assuming the user action destroys all RHS
 *  semantic values if invoked).  */
static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystackp,
                 YYSTYPE* yyvalp)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs = yyrhsLength (yyopt->yyrule);
  YYRESULTTAG yyflag =
    yyresolveStates (yyopt->yystate, yynrhs, yystackp);
  if (yyflag != yyok)
    {
      yyGLRState *yys;
      for (yys = yyopt->yystate; yynrhs > 0; yys = yys->yypred, yynrhs -= 1)
        yydestroyGLRState ("Cleanup: popping", yys);
      return yyflag;
    }

  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  {
    int yychar_current = yychar;
    YYSTYPE yylval_current = yylval;
    yychar = yyopt->yyrawchar;
    yylval = yyopt->yyval;
    yyflag = yyuserAction (yyopt->yyrule, yynrhs,
                           yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp);
    yychar = yychar_current;
    yylval = yylval_current;
  }
  return yyflag;
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[1 + YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == YY_NULLPTR)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YY_FPRINTF ((stderr, "%*s%s -> <Rule %d, empty>\n",
                 yyindent, "", yysymbol_name (yylhsNonterm (yyx->yyrule)),
                 yyx->yyrule - 1));
  else
    YY_FPRINTF ((stderr, "%*s%s -> <Rule %d, tokens %ld .. %ld>\n",
                 yyindent, "", yysymbol_name (yylhsNonterm (yyx->yyrule)),
                 yyx->yyrule - 1, YY_CAST (long, yys->yyposn + 1),
                 YY_CAST (long, yyx->yystate->yyposn)));
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
        {
          if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
            YY_FPRINTF ((stderr, "%*s%s <empty>\n", yyindent+2, "",
                         yysymbol_name (yy_accessing_symbol (yystates[yyi]->yylrState))));
          else
            YY_FPRINTF ((stderr, "%*s%s <tokens %ld .. %ld>\n", yyindent+2, "",
                         yysymbol_name (yy_accessing_symbol (yystates[yyi]->yylrState)),
                         YY_CAST (long, yystates[yyi-1]->yyposn + 1),
                         YY_CAST (long, yystates[yyi]->yyposn)));
        }
      else
        yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static YYRESULTTAG
yyreportAmbiguity (yySemanticOption* yyx0,
                   yySemanticOption* yyx1)
{
  YYUSE (yyx0);
  YYUSE (yyx1);

#if YYDEBUG
  YY_FPRINTF ((stderr, "Ambiguity detected.\n"));
  YY_FPRINTF ((stderr, "Option 1,\n"));
  yyreportTree (yyx0, 2);
  YY_FPRINTF ((stderr, "\nOption 2,\n"));
  yyreportTree (yyx1, 2);
  YY_FPRINTF ((stderr, "\n"));
#endif

  yyerror (YY_("syntax is ambiguous"));
  return yyabort;
}

/** Resolve the ambiguity represented in state YYS in *YYSTACKP,
 *  perform the indicated actions, and set the semantic value of YYS.
 *  If result != yyok, the chain of semantic options in YYS has been
 *  cleared instead or it has been left unmodified except that
 *  redundant options may have been removed.  Regardless of whether
 *  result = yyok, YYS has been left with consistent data so that
 *  yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveValue (yyGLRState* yys, yyGLRStack* yystackp)
{
  yySemanticOption* yyoptionList = yys->yysemantics.yyfirstVal;
  yySemanticOption* yybest = yyoptionList;
  yySemanticOption** yypp;
  yybool yymerge = yyfalse;
  YYSTYPE yysval;
  YYRESULTTAG yyflag;

  for (yypp = &yyoptionList->yynext; *yypp != YY_NULLPTR; )
    {
      yySemanticOption* yyp = *yypp;

      if (yyidenticalOptions (yybest, yyp))
        {
          yymergeOptionSets (yybest, yyp);
          *yypp = yyp->yynext;
        }
      else
        {
          switch (yypreference (yybest, yyp))
            {
            case 0:
              return yyreportAmbiguity (yybest, yyp);
              break;
            case 1:
              yymerge = yytrue;
              break;
            case 2:
              break;
            case 3:
              yybest = yyp;
              yymerge = yyfalse;
              break;
            default:
              /* This cannot happen so it is not worth a YY_ASSERT (yyfalse),
                 but some compilers complain if the default case is
                 omitted.  */
              break;
            }
          yypp = &yyp->yynext;
        }
    }

  if (yymerge)
    {
      yySemanticOption* yyp;
      int yyprec = yydprec[yybest->yyrule];
      yyflag = yyresolveAction (yybest, yystackp, &yysval);
      if (yyflag == yyok)
        for (yyp = yybest->yynext; yyp != YY_NULLPTR; yyp = yyp->yynext)
          {
            if (yyprec == yydprec[yyp->yyrule])
              {
                YYSTYPE yysval_other;
                yyflag = yyresolveAction (yyp, yystackp, &yysval_other);
                if (yyflag != yyok)
                  {
                    yydestruct ("Cleanup: discarding incompletely merged value for",
                                yy_accessing_symbol (yys->yylrState),
                                &yysval);
                    break;
                  }
                yyuserMerge (yymerger[yyp->yyrule], &yysval, &yysval_other);
              }
          }
    }
  else
    yyflag = yyresolveAction (yybest, yystackp, &yysval);

  if (yyflag == yyok)
    {
      yys->yyresolved = yytrue;
      yys->yysemantics.yysval = yysval;
    }
  else
    yys->yysemantics.yyfirstVal = YY_NULLPTR;
  return yyflag;
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystackp)
{
  if (yystackp->yysplitPoint != YY_NULLPTR)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystackp->yytops.yystates[0];
           yys != yystackp->yysplitPoint;
           yys = yys->yypred, yyn += 1)
        continue;
      YYCHK (yyresolveStates (yystackp->yytops.yystates[0], yyn, yystackp
                             ));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystackp)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystackp->yytops.yysize != 1 || yystackp->yysplitPoint == YY_NULLPTR)
    return;

  for (yyp = yystackp->yytops.yystates[0], yyq = yyp->yypred, yyr = YY_NULLPTR;
       yyp != yystackp->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystackp->yyspaceLeft += yystackp->yynextFree - yystackp->yyitems;
  yystackp->yynextFree = YY_REINTERPRET_CAST (yyGLRStackItem*, yystackp->yysplitPoint) + 1;
  yystackp->yyspaceLeft -= yystackp->yynextFree - yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;

  while (yyr != YY_NULLPTR)
    {
      yystackp->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystackp->yynextFree->yystate.yypred = &yystackp->yynextFree[-1].yystate;
      yystackp->yytops.yystates[0] = &yystackp->yynextFree->yystate;
      yystackp->yynextFree += 1;
      yystackp->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystackp, YYPTRDIFF_T yyk,
                   YYPTRDIFF_T yyposn)
{
  while (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    {
      yy_state_t yystate = yystackp->yytops.yystates[yyk]->yylrState;
      YY_DPRINTF ((stderr, "Stack %ld Entering state %d\n",
                   YY_CAST (long, yyk), yystate));

      YY_ASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
        {
          YYRESULTTAG yyflag;
          yyRuleNum yyrule = yydefaultAction (yystate);
          if (yyrule == 0)
            {
              YY_DPRINTF ((stderr, "Stack %ld dies.\n", YY_CAST (long, yyk)));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          yyflag = yyglrReduce (yystackp, yyk, yyrule, yyimmediate[yyrule]);
          if (yyflag == yyerr)
            {
              YY_DPRINTF ((stderr,
                           "Stack %ld dies "
                           "(predicate failure or explicit user error).\n",
                           YY_CAST (long, yyk)));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          if (yyflag != yyok)
            return yyflag;
        }
      else
        {
          yysymbol_kind_t yytoken = yygetToken (&yychar);
          const short* yyconflicts;
          const int yyaction = yygetLRActions (yystate, yytoken, &yyconflicts);
          yystackp->yytops.yylookaheadNeeds[yyk] = yytrue;

          for (/* nothing */; *yyconflicts; yyconflicts += 1)
            {
              YYRESULTTAG yyflag;
              YYPTRDIFF_T yynewStack = yysplitStack (yystackp, yyk);
              YY_DPRINTF ((stderr, "Splitting off stack %ld from %ld.\n",
                           YY_CAST (long, yynewStack), YY_CAST (long, yyk)));
              yyflag = yyglrReduce (yystackp, yynewStack,
                                    *yyconflicts,
                                    yyimmediate[*yyconflicts]);
              if (yyflag == yyok)
                YYCHK (yyprocessOneStack (yystackp, yynewStack,
                                          yyposn));
              else if (yyflag == yyerr)
                {
                  YY_DPRINTF ((stderr, "Stack %ld dies.\n", YY_CAST (long, yynewStack)));
                  yymarkStackDeleted (yystackp, yynewStack);
                }
              else
                return yyflag;
            }

          if (yyisShiftAction (yyaction))
            break;
          else if (yyisErrorAction (yyaction))
            {
              YY_DPRINTF ((stderr, "Stack %ld dies.\n", YY_CAST (long, yyk)));
              yymarkStackDeleted (yystackp, yyk);
              break;
            }
          else
            {
              YYRESULTTAG yyflag = yyglrReduce (yystackp, yyk, -yyaction,
                                                yyimmediate[-yyaction]);
              if (yyflag == yyerr)
                {
                  YY_DPRINTF ((stderr,
                               "Stack %ld dies "
                               "(predicate failure or explicit user error).\n",
                               YY_CAST (long, yyk)));
                  yymarkStackDeleted (yystackp, yyk);
                  break;
                }
              else if (yyflag != yyok)
                return yyflag;
            }
        }
    }
  return yyok;
}






static void
yyreportSyntaxError (yyGLRStack* yystackp)
{
  if (yystackp->yyerrState != 0)
    return;
  yyerror (YY_("syntax error"));
  yynerrs += 1;
}

/* Recover from a syntax error on *YYSTACKP, assuming that *YYSTACKP->YYTOKENP,
   yylval, and yylloc are the syntactic category, semantic value, and location
   of the lookahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystackp)
{
  if (yystackp->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
        yysymbol_kind_t yytoken;
        int yyj;
        if (yychar == YYEOF)
          yyFail (yystackp, YY_NULLPTR);
        if (yychar != YYEMPTY)
          {
            yytoken = YYTRANSLATE (yychar);
            yydestruct ("Error: discarding",
                        yytoken, &yylval);
            yychar = YYEMPTY;
          }
        yytoken = yygetToken (&yychar);
        yyj = yypact[yystackp->yytops.yystates[0]->yylrState];
        if (yypact_value_is_default (yyj))
          return;
        yyj += yytoken;
        if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != yytoken)
          {
            if (yydefact[yystackp->yytops.yystates[0]->yylrState] != 0)
              return;
          }
        else if (! yytable_value_is_error (yytable[yyj]))
          return;
      }

  /* Reduce to one stack.  */
  {
    YYPTRDIFF_T yyk;
    for (yyk = 0; yyk < yystackp->yytops.yysize; yyk += 1)
      if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
        break;
    if (yyk >= yystackp->yytops.yysize)
      yyFail (yystackp, YY_NULLPTR);
    for (yyk += 1; yyk < yystackp->yytops.yysize; yyk += 1)
      yymarkStackDeleted (yystackp, yyk);
    yyremoveDeletes (yystackp);
    yycompressStack (yystackp);
  }

  /* Pop stack until we find a state that shifts the error token.  */
  yystackp->yyerrState = 3;
  while (yystackp->yytops.yystates[0] != YY_NULLPTR)
    {
      yyGLRState *yys = yystackp->yytops.yystates[0];
      int yyj = yypact[yys->yylrState];
      if (! yypact_value_is_default (yyj))
        {
          yyj += YYSYMBOL_YYerror;
          if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYSYMBOL_YYerror
              && yyisShiftAction (yytable[yyj]))
            {
              /* Shift the error token.  */
              int yyaction = yytable[yyj];
              YY_SYMBOL_PRINT ("Shifting", yy_accessing_symbol (yyaction),
                               &yylval, &yyerrloc);
              yyglrShift (yystackp, 0, yyaction,
                          yys->yyposn, &yylval);
              yys = yystackp->yytops.yystates[0];
              break;
            }
        }
      if (yys->yypred != YY_NULLPTR)
        yydestroyGLRState ("Error: popping", yys);
      yystackp->yytops.yystates[0] = yys->yypred;
      yystackp->yynextFree -= 1;
      yystackp->yyspaceLeft += 1;
    }
  if (yystackp->yytops.yystates[0] == YY_NULLPTR)
    yyFail (yystackp, YY_NULLPTR);
}

#define YYCHK1(YYE)                                                          \
  do {                                                                       \
    switch (YYE) {                                                           \
    case yyok:                                                               \
      break;                                                                 \
    case yyabort:                                                            \
      goto yyabortlab;                                                       \
    case yyaccept:                                                           \
      goto yyacceptlab;                                                      \
    case yyerr:                                                              \
      goto yyuser_error;                                                     \
    default:                                                                 \
      goto yybuglab;                                                         \
    }                                                                        \
  } while (0)

/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
  int yyresult;
  yyGLRStack yystack;
  yyGLRStack* const yystackp = &yystack;
  YYPTRDIFF_T yyposn;

  YY_DPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY;
  yylval = yyval_default;

  if (! yyinitGLRStack (yystackp, YYINITDEPTH))
    goto yyexhaustedlab;
  switch (YYSETJMP (yystack.yyexception_buffer))
    {
    case 0: break;
    case 1: goto yyabortlab;
    case 2: goto yyexhaustedlab;
    default: goto yybuglab;
    }
  yyglrShift (&yystack, 0, 0, 0, &yylval);
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
         specialized to deterministic operation (single stack, no
         potential ambiguity).  */
      /* Standard mode. */
      while (yytrue)
        {
          yy_state_t yystate = yystack.yytops.yystates[0]->yylrState;
          YY_DPRINTF ((stderr, "Entering state %d\n", yystate));
          if (yystate == YYFINAL)
            goto yyacceptlab;
          if (yyisDefaultedState (yystate))
            {
              yyRuleNum yyrule = yydefaultAction (yystate);
              if (yyrule == 0)
                {
                  yyreportSyntaxError (&yystack);
                  goto yyuser_error;
                }
              YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue));
            }
          else
            {
              yysymbol_kind_t yytoken = yygetToken (&yychar);
              const short* yyconflicts;
              int yyaction = yygetLRActions (yystate, yytoken, &yyconflicts);
              if (*yyconflicts)
                /* Enter nondeterministic mode.  */
                break;
              if (yyisShiftAction (yyaction))
                {
                  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
                  yychar = YYEMPTY;
                  yyposn += 1;
                  yyglrShift (&yystack, 0, yyaction, yyposn, &yylval);
                  if (0 < yystack.yyerrState)
                    yystack.yyerrState -= 1;
                }
              else if (yyisErrorAction (yyaction))
                {
                  /* Issue an error message unless the scanner already
                     did. */
                  if (yychar != YYerror)
                    yyreportSyntaxError (&yystack);
                  goto yyuser_error;
                }
              else
                YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue));
            }
        }

      /* Nondeterministic mode. */
      while (yytrue)
        {
          yysymbol_kind_t yytoken_to_shift;
          YYPTRDIFF_T yys;

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            yystackp->yytops.yylookaheadNeeds[yys] = yychar != YYEMPTY;

          /* yyprocessOneStack returns one of three things:

              - An error flag.  If the caller is yyprocessOneStack, it
                immediately returns as well.  When the caller is finally
                yyparse, it jumps to an error label via YYCHK1.

              - yyok, but yyprocessOneStack has invoked yymarkStackDeleted
                (&yystack, yys), which sets the top state of yys to NULL.  Thus,
                yyparse's following invocation of yyremoveDeletes will remove
                the stack.

              - yyok, when ready to shift a token.

             Except in the first case, yyparse will invoke yyremoveDeletes and
             then shift the next token onto all remaining stacks.  This
             synchronization of the shift (that is, after all preceding
             reductions on all stacks) helps prevent double destructor calls
             on yylval in the event of memory exhaustion.  */

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn));
          yyremoveDeletes (&yystack);
          if (yystack.yytops.yysize == 0)
            {
              yyundeleteLastStack (&yystack);
              if (yystack.yytops.yysize == 0)
                yyFail (&yystack, YY_("syntax error"));
              YYCHK1 (yyresolveStack (&yystack));
              YY_DPRINTF ((stderr, "Returning to deterministic operation.\n"));
              yyreportSyntaxError (&yystack);
              goto yyuser_error;
            }

          /* If any yyglrShift call fails, it will fail after shifting.  Thus,
             a copy of yylval will already be on stack 0 in the event of a
             failure in the following loop.  Thus, yychar is set to YYEMPTY
             before the loop to make sure the user destructor for yylval isn't
             called twice.  */
          yytoken_to_shift = YYTRANSLATE (yychar);
          yychar = YYEMPTY;
          yyposn += 1;
          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            {
              yy_state_t yystate = yystack.yytops.yystates[yys]->yylrState;
              const short* yyconflicts;
              int yyaction = yygetLRActions (yystate, yytoken_to_shift,
                              &yyconflicts);
              /* Note that yyconflicts were handled by yyprocessOneStack.  */
              YY_DPRINTF ((stderr, "On stack %ld, ", YY_CAST (long, yys)));
              YY_SYMBOL_PRINT ("shifting", yytoken_to_shift, &yylval, &yylloc);
              yyglrShift (&yystack, yys, yyaction, yyposn,
                          &yylval);
              YY_DPRINTF ((stderr, "Stack %ld now in state #%d\n",
                           YY_CAST (long, yys),
                           yystack.yytops.yystates[yys]->yylrState));
            }

          if (yystack.yytops.yysize == 1)
            {
              YYCHK1 (yyresolveStack (&yystack));
              YY_DPRINTF ((stderr, "Returning to deterministic operation.\n"));
              yycompressStack (&yystack);
              break;
            }
        }
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }

 yyacceptlab:
  yyresult = 0;
  goto yyreturn;

 yybuglab:
  YY_ASSERT (yyfalse);
  goto yyabortlab;

 yyabortlab:
  yyresult = 1;
  goto yyreturn;

 yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;

 yyreturn:
  if (yychar != YYEMPTY)
    yydestruct ("Cleanup: discarding lookahead",
                YYTRANSLATE (yychar), &yylval);

  /* If the stack is well-formed, pop the stack until it is empty,
     destroying its entries as we go.  But free the stack regardless
     of whether it is well-formed.  */
  if (yystack.yyitems)
    {
      yyGLRState** yystates = yystack.yytops.yystates;
      if (yystates)
        {
          YYPTRDIFF_T yysize = yystack.yytops.yysize;
          YYPTRDIFF_T yyk;
          for (yyk = 0; yyk < yysize; yyk += 1)
            if (yystates[yyk])
              {
                while (yystates[yyk])
                  {
                    yyGLRState *yys = yystates[yyk];
                    if (yys->yypred != YY_NULLPTR)
                      yydestroyGLRState ("Cleanup: popping", yys);
                    yystates[yyk] = yys->yypred;
                    yystack.yynextFree -= 1;
                    yystack.yyspaceLeft += 1;
                  }
                break;
              }
        }
      yyfreeGLRStack (&yystack);
    }

  return yyresult;
}

/* DEBUGGING ONLY */
#if YYDEBUG
static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      YY_FPRINTF ((stderr, " -> "));
    }
  YY_FPRINTF ((stderr, "%d@%ld", yys->yylrState, YY_CAST (long, yys->yyposn)));
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == YY_NULLPTR)
    YY_FPRINTF ((stderr, "<null>"));
  else
    yy_yypstack (yyst);
  YY_FPRINTF ((stderr, "\n"));
}

static void
yypstack (yyGLRStack* yystackp, YYPTRDIFF_T yyk)
{
  yypstates (yystackp->yytops.yystates[yyk]);
}

static void
yypdumpstack (yyGLRStack* yystackp)
{
#define YYINDEX(YYX)                                                    \
  YY_CAST (long,                                                        \
           ((YYX)                                                       \
            ? YY_REINTERPRET_CAST (yyGLRStackItem*, (YYX)) - yystackp->yyitems \
            : -1))

  yyGLRStackItem* yyp;
  for (yyp = yystackp->yyitems; yyp < yystackp->yynextFree; yyp += 1)
    {
      YY_FPRINTF ((stderr, "%3ld. ",
                   YY_CAST (long, yyp - yystackp->yyitems)));
      if (*YY_REINTERPRET_CAST (yybool *, yyp))
        {
          YY_ASSERT (yyp->yystate.yyisState);
          YY_ASSERT (yyp->yyoption.yyisState);
          YY_FPRINTF ((stderr, "Res: %d, LR State: %d, posn: %ld, pred: %ld",
                       yyp->yystate.yyresolved, yyp->yystate.yylrState,
                       YY_CAST (long, yyp->yystate.yyposn),
                       YYINDEX (yyp->yystate.yypred)));
          if (! yyp->yystate.yyresolved)
            YY_FPRINTF ((stderr, ", firstVal: %ld",
                         YYINDEX (yyp->yystate.yysemantics.yyfirstVal)));
        }
      else
        {
          YY_ASSERT (!yyp->yystate.yyisState);
          YY_ASSERT (!yyp->yyoption.yyisState);
          YY_FPRINTF ((stderr, "Option. rule: %d, state: %ld, next: %ld",
                       yyp->yyoption.yyrule - 1,
                       YYINDEX (yyp->yyoption.yystate),
                       YYINDEX (yyp->yyoption.yynext)));
        }
      YY_FPRINTF ((stderr, "\n"));
    }

  YY_FPRINTF ((stderr, "Tops:"));
  {
    YYPTRDIFF_T yyi;
    for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
      YY_FPRINTF ((stderr, "%ld: %ld; ", YY_CAST (long, yyi),
                   YYINDEX (yystackp->yytops.yystates[yyi])));
    YY_FPRINTF ((stderr, "\n"));
  }
#undef YYINDEX
}
#endif

#undef yylval
#undef yychar
#undef yynerrs

/* Substitute the variable and function names.  */
#define yyparse SQLyyparse
#define yylex   SQLyylex
#define yyerror SQLyyerror
#define yylval  SQLyylval
#define yychar  SQLyychar
#define yydebug SQLyydebug
#define yynerrs SQLyynerrs




#if defined _MSC_VER
#pragma warning(pop)
#endif

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::i18n;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::util;
using namespace ::osl;
using namespace ::dbtools;

connectivity::OSQLParser* xxx_pGLOBAL_SQLPARSER;

connectivity::OSQLInternalNode* newNode(const char* pNewValue,
        const connectivity::SQLNodeType eNodeType,
        const sal_uInt32 nNodeID)
{
    return new connectivity::OSQLInternalNode(pNewValue, eNodeType, nNodeID);
}

connectivity::OSQLInternalNode* newNode(const OString& _newValue,
        const connectivity::SQLNodeType eNodeType,
        const sal_uInt32 nNodeID)
{
    return new connectivity::OSQLInternalNode(_newValue, eNodeType, nNodeID);
}

connectivity::OSQLInternalNode* newNode(const OUString& _newValue,
        const connectivity::SQLNodeType eNodeType,
        const sal_uInt32 nNodeID)
{
    return new connectivity::OSQLInternalNode(_newValue, eNodeType, nNodeID);
}

OParseContext::OParseContext()
{
}


OParseContext::~OParseContext()
{
}


OUString OParseContext::getErrorMessage(ErrorCode _eCode) const
{
    OUString aMsg;
    switch (_eCode)
    {
        case ErrorCode::General:              aMsg = "Syntax error in SQL expression"; break;
        case ErrorCode::ValueNoLike:          aMsg = "The value #1 can not be used with LIKE."; break;
        case ErrorCode::FieldNoLike:          aMsg = "LIKE can not be used with this field."; break;
        case ErrorCode::InvalidCompare:       aMsg = "The entered criterion can not be compared with this field."; break;
        case ErrorCode::InvalidIntCompare:    aMsg = "The field can not be compared with a number."; break;
        case ErrorCode::InvalidDateCompare:   aMsg = "The field can not be compared with a date."; break;
        case ErrorCode::InvalidRealCompare:   aMsg = "The field can not be compared with a floating point number."; break;
        case ErrorCode::InvalidTableNosuch:   aMsg = "The database does not contain a table named \"#\"."; break;
        case ErrorCode::InvalidTableOrQuery:  aMsg = "The database does contain neither a table nor a query named \"#\"."; break;
        case ErrorCode::InvalidColumn:        aMsg = "The column \"#1\" is unknown in the table \"#2\"."; break;
        case ErrorCode::InvalidTableExist:    aMsg = "The database already contains a table or view with name \"#\"."; break;
        case ErrorCode::InvalidQueryExist:    aMsg = "The database already contains a query with name \"#\"."; break;
        default:
            OSL_FAIL( "OParseContext::getErrorMessage: unknown error code!" );
            break;
    }
    return aMsg;
}


OString OParseContext::getIntlKeywordAscii(InternationalKeyCode _eKey) const
{
	OString aKeyword;
	switch (_eKey)
	{
		case InternationalKeyCode::Like:		aKeyword = "LIKE"; break;
		case InternationalKeyCode::Not:		aKeyword = "NOT"; break;
		case InternationalKeyCode::Null:		aKeyword = "NULL"; break;
		case InternationalKeyCode::True:		aKeyword = "True"; break;
		case InternationalKeyCode::False:		aKeyword = "False"; break;
		case InternationalKeyCode::Is:		aKeyword = "IS"; break;
		case InternationalKeyCode::Between:	aKeyword = "BETWEEN"; break;
		case InternationalKeyCode::Or:		aKeyword = "OR"; break;
		case InternationalKeyCode::And:		aKeyword = "AND"; break;
		case InternationalKeyCode::Avg:		aKeyword = "AVG"; break;
		case InternationalKeyCode::Count:		aKeyword = "COUNT"; break;
		case InternationalKeyCode::Max:		aKeyword = "MAX"; break;
		case InternationalKeyCode::Min:		aKeyword = "MIN"; break;
		case InternationalKeyCode::Sum:		aKeyword = "SUM"; break;
        case InternationalKeyCode::Every:     aKeyword = "EVERY"; break;
        case InternationalKeyCode::Any:       aKeyword = "ANY"; break;
        case InternationalKeyCode::Some:      aKeyword = "SOME"; break;
        case InternationalKeyCode::StdDevPop: aKeyword = "STDDEV_POP"; break;
        case InternationalKeyCode::StdDevSamp: aKeyword = "STDDEV_SAMP"; break;
        case InternationalKeyCode::VarSamp:  aKeyword = "VAR_SAMP"; break;
        case InternationalKeyCode::VarPop:   aKeyword = "VAR_POP"; break;
        case InternationalKeyCode::Collect:   aKeyword = "COLLECT"; break;
        case InternationalKeyCode::Fusion:    aKeyword = "FUSION"; break;
        case InternationalKeyCode::Intersection:aKeyword = "INTERSECTION"; break;
        case InternationalKeyCode::None:      break;
        default:
            OSL_FAIL( "OParseContext::getIntlKeywordAscii: unknown key!" );
            break;
	}
	return aKeyword;
}


IParseContext::InternationalKeyCode OParseContext::getIntlKeyCode(const OString& rToken) const
{
	static IParseContext::InternationalKeyCode Intl_TokenID[] =
	{
		InternationalKeyCode::Like, InternationalKeyCode::Not, InternationalKeyCode::Null, InternationalKeyCode::True,
		InternationalKeyCode::False, InternationalKeyCode::Is, InternationalKeyCode::Between, InternationalKeyCode::Or,
		InternationalKeyCode::And, InternationalKeyCode::Avg, InternationalKeyCode::Count, InternationalKeyCode::Max,
		InternationalKeyCode::Min, InternationalKeyCode::Sum, InternationalKeyCode::Every,InternationalKeyCode::Any,InternationalKeyCode::Some,
        InternationalKeyCode::StdDevPop,InternationalKeyCode::StdDevSamp,InternationalKeyCode::VarSamp,
        InternationalKeyCode::VarPop,InternationalKeyCode::Collect,InternationalKeyCode::Fusion,InternationalKeyCode::Intersection
	};

	sal_uInt32 nCount = SAL_N_ELEMENTS( Intl_TokenID );
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		OString aKey = getIntlKeywordAscii(Intl_TokenID[i]);
		if (rToken.equalsIgnoreAsciiCase(aKey))
			return Intl_TokenID[i];
	}

	return InternationalKeyCode::None;
}


static Locale& impl_getLocaleInstance( )
{
	static Locale s_aLocale( "en", "US", "" );
	return s_aLocale;
}


Locale OParseContext::getPreferredLocale( ) const
{
	return getDefaultLocale();
}


const Locale& OParseContext::getDefaultLocale()
{
	return impl_getLocaleInstance();
}

// The (unfortunately global) yylval for the handing over of
// values from the Scanner to the Parser. The global variable
// is only used for a short term, the Parser reads the variable
// immediately after the call of the Scanner into a same named own
// member variable.


OUString ConvertLikeToken(const OSQLParseNode* pTokenNode, const OSQLParseNode* pEscapeNode, bool bInternational)
{
	OUStringBuffer aMatchStr(0);
	if (pTokenNode->isToken())
	{
		sal_Unicode cEscape = 0;
		if (pEscapeNode->count())
			cEscape = pEscapeNode->getChild(1)->getTokenValue().toChar();

		// Change place holder
		aMatchStr = pTokenNode->getTokenValue();
		const sal_Int32 nLen = aMatchStr.getLength();
		OUStringBuffer sSearch,sReplace;
		if ( bInternational )
		{
		    sSearch.append("%_");
		    sReplace.append("*?");
		}
		else
		{
		    sSearch.append("*?");
		    sReplace.append("%_");
		}

		bool wasEscape = false;
		for (sal_Int32 i = 0; i < nLen; i++)
		{
			const sal_Unicode c = aMatchStr[i];
			// SQL standard requires the escape to be followed
			// by a meta-character ('%', '_' or itself), else error
			// We are more lenient here and let it escape anything.
			// Especially since some databases (e.g. Microsoft SQL Server)
			// have more meta-characters than the standard, such as e.g. '[' and ']'
			if (wasEscape)
			{
				wasEscape=false;
				continue;
			}
			if (c == cEscape)
			{
				wasEscape=true;
				continue;
			}
			int match = -1;
			if (c == sSearch[0])
				match=0;
			else if (c == sSearch[1])
				match=1;

			if (match != -1)
			{
				aMatchStr[i] = sReplace[match];
			}
		}
	}
	return aMatchStr.makeStringAndClear();
}

sal_uInt32			    OSQLParser::s_nRuleIDs[OSQLParseNode::rule_count + 1];
OSQLParser::RuleIDMap   OSQLParser::s_aReverseRuleIDLookup;
OParseContext		    OSQLParser::s_aDefaultContext;

sal_Int32			OSQLParser::s_nRefCount	= 0;
//	::osl::Mutex		OSQLParser::s_aMutex;
OSQLScanner*		OSQLParser::s_pScanner = nullptr;
OSQLParseNodesGarbageCollector*		OSQLParser::s_pGarbageCollector = nullptr;
css::uno::Reference< css::i18n::XLocaleData4>  OSQLParser::s_xLocaleData = nullptr;

void setParser(OSQLParser* _pParser)
{
	xxx_pGLOBAL_SQLPARSER = _pParser;
}

void OSQLParser::setParseTree(OSQLParseNode* pNewParseTree)
{
	::osl::MutexGuard aGuard(getMutex());
	m_pParseTree.reset(pNewParseTree);
}


/** Delete all comments in a query.

    See also getComment()/concatComment() implementation for
    OQueryController::translateStatement().
 */
static OUString delComment( const OUString& rQuery )
{
    // First a quick search if there is any "--" or "//" or "/*", if not then the whole
    // copying loop is pointless.
    if (rQuery.indexOf("--") < 0 && rQuery.indexOf("//") < 0 &&
            rQuery.indexOf("/*") < 0)
        return rQuery;

    const sal_Unicode* pCopy = rQuery.getStr();
    sal_Int32 nQueryLen = rQuery.getLength();
    bool bIsText1  = false;     // "text"
    bool bIsText2  = false;     // 'text'
    bool bComment2 = false;     // /* comment */
    bool bComment  = false;     // -- or // comment
    OUStringBuffer aBuf(nQueryLen);
    for (sal_Int32 i=0; i < nQueryLen; ++i)
    {
        if (bComment2)
        {
            if ((i+1) < nQueryLen)
            {
                if (pCopy[i]=='*' && pCopy[i+1]=='/')
                {
                    bComment2 = false;
                    ++i;
                }
            }
            else
            {
                // comment can't close anymore, actually an error, but...
            }
            continue;
        }
        if (pCopy[i] == '\n')
            bComment = false;
        else if (!bComment)
        {
            if (pCopy[i] == '\"' && !bIsText2)
                bIsText1 = !bIsText1;
            else if (pCopy[i] == '\'' && !bIsText1)
                bIsText2 = !bIsText2;
            if (!bIsText1 && !bIsText2 && (i+1) < nQueryLen)
            {
                if ((pCopy[i]=='-' && pCopy[i+1]=='-') || (pCopy[i]=='/' && pCopy[i+1]=='/'))
                    bComment = true;
                else if ((pCopy[i]=='/' && pCopy[i+1]=='*'))
                    bComment2 = true;
            }
        }
        if (!bComment && !bComment2)
            aBuf.append( &pCopy[i], 1);
    }
    return aBuf.makeStringAndClear();
}

std::unique_ptr<OSQLParseNode> OSQLParser::parseTree(OUString& rErrorMessage,
                                     const OUString& rStatement,
                                     bool bInternational)
{


	// Guard the parsing
	::osl::MutexGuard aGuard(getMutex());
	// must be reset
	setParser(this);

	// delete comments before parsing
	OUString sTemp = delComment(rStatement);

	// defines how to scan
	s_pScanner->SetRule(OSQLScanner::GetSQLRule()); // initial
	s_pScanner->prepareScan(sTemp, m_pContext, bInternational);

	SQLyylval.pParseNode = nullptr;
	//	SQLyypvt = NULL;
	m_pParseTree = nullptr;
	m_sErrorMessage = "";

    // start parsing
	if (SQLyyparse() != 0)
	{
		// only set the error message, if it's not already set
		if (m_sErrorMessage.isEmpty())
			m_sErrorMessage = s_pScanner->getErrorMessage();
		if (m_sErrorMessage.isEmpty())
			m_sErrorMessage = m_pContext->getErrorMessage(IParseContext::ErrorCode::General);

		rErrorMessage = m_sErrorMessage;

		// clear the garbage collector
		(*s_pGarbageCollector)->clearAndDelete();
		m_pParseTree.release(); // because the garbage collector deleted it
		return nullptr;
	}
	else
	{
		(*s_pGarbageCollector)->clear();

        // return result:
        // to work around a bug in MKS YACC return the member m_pParseTree
        // instead of Sdbyyval.pParseNode

        SAL_WARN_IF(!m_pParseTree, "connectivity.parse",
            "OSQLParser: Parser did not create ParseTree");
		return std::move(m_pParseTree);
	}
}

OString OSQLParser::TokenIDToStr(sal_uInt32 nTokenID, const IParseContext* pContext)
{
	OString aStr;
	if (pContext)
	{
		IParseContext::InternationalKeyCode eKeyCode = IParseContext::InternationalKeyCode::None;
		switch( nTokenID )
		{
			case SQL_TOKEN_LIKE: eKeyCode = IParseContext::InternationalKeyCode::Like; break;
			case SQL_TOKEN_NOT: eKeyCode = IParseContext::InternationalKeyCode::Not; break;
			case SQL_TOKEN_NULL: eKeyCode = IParseContext::InternationalKeyCode::Null; break;
			case SQL_TOKEN_TRUE: eKeyCode = IParseContext::InternationalKeyCode::True; break;
			case SQL_TOKEN_FALSE: eKeyCode = IParseContext::InternationalKeyCode::False; break;
			case SQL_TOKEN_IS: eKeyCode = IParseContext::InternationalKeyCode::Is; break;
			case SQL_TOKEN_BETWEEN: eKeyCode = IParseContext::InternationalKeyCode::Between; break;
			case SQL_TOKEN_OR: eKeyCode = IParseContext::InternationalKeyCode::Or; break;
			case SQL_TOKEN_AND: eKeyCode = IParseContext::InternationalKeyCode::And; break;
			case SQL_TOKEN_AVG: eKeyCode = IParseContext::InternationalKeyCode::Avg; break;
			case SQL_TOKEN_COUNT: eKeyCode = IParseContext::InternationalKeyCode::Count; break;
			case SQL_TOKEN_MAX: eKeyCode = IParseContext::InternationalKeyCode::Max; break;
			case SQL_TOKEN_MIN: eKeyCode = IParseContext::InternationalKeyCode::Min; break;
			case SQL_TOKEN_SUM: eKeyCode = IParseContext::InternationalKeyCode::Sum; break;
		}
		if ( eKeyCode != IParseContext::InternationalKeyCode::None )
		    aStr = pContext->getIntlKeywordAscii(eKeyCode);
	}

	if (aStr.isEmpty())
	{
		aStr = yytname[YYTRANSLATE(nTokenID)];
		if(aStr.startsWith("SQL_TOKEN_"))
			aStr = aStr.copy(10);
		switch( nTokenID )
		{
			case SQL_TOKEN_OJ:
			case SQL_TOKEN_TS:
			case SQL_TOKEN_T:
			case SQL_TOKEN_D:
				aStr = aStr.toAsciiLowerCase();
		}
	}
	return aStr;
}

#if OSL_DEBUG_LEVEL > 0
OUString OSQLParser::RuleIDToStr(sal_uInt32 nRuleID)
{
	OSL_ENSURE(nRuleID < SAL_N_ELEMENTS(yytname), "OSQLParser::RuleIDToStr: Invalid nRuleId!");
	return OUString::createFromAscii(yytname[nRuleID]);
}
#endif


sal_uInt32 OSQLParser::StrToRuleID(const OString & rValue)
{
	// Search for the given name in yytname and return the index
	// (or UNKNOWN_RULE, if not found)
	static sal_uInt32 nLen = SAL_N_ELEMENTS(yytname);
	for (sal_uInt32 i = YYTRANSLATE(SQL_TOKEN_INVALIDSYMBOL); i < (nLen-1); i++)
	{
		if (rValue == yytname[i])
			return i;
	}

	// Not found
	return OSQLParseNode::UNKNOWN_RULE;
}


OSQLParseNode::Rule OSQLParser::RuleIDToRule( sal_uInt32 _nRule )
{
    OSQLParser::RuleIDMap::const_iterator i (s_aReverseRuleIDLookup.find(_nRule));
    if (i == s_aReverseRuleIDLookup.end())
    {
        SAL_INFO("connectivity.parse",
		 "connectivity::OSQLParser::RuleIDToRule cannot reverse-lookup rule. "
		 "Reverse mapping incomplete? "
		 "_nRule='" << _nRule << "' "
		 "yytname[_nRule]='" << yytname[_nRule] << "'");
        return OSQLParseNode::UNKNOWN_RULE;
    }
    else
        return i->second;
}


sal_uInt32 OSQLParser::RuleID(OSQLParseNode::Rule eRule)
{
	return s_nRuleIDs[(sal_uInt16)eRule];
}

sal_Int16 OSQLParser::buildNode(OSQLParseNode*& pAppend,OSQLParseNode* pCompare,OSQLParseNode* pLiteral,OSQLParseNode* pLiteral2)
{
	OSQLParseNode* pColumnRef = new OSQLInternalNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::column_ref));
	pColumnRef->append(new OSQLInternalNode(m_sFieldName,SQLNodeType::Name));
	OSQLParseNode* pComp = nullptr;
	if ( SQL_ISTOKEN( pCompare, BETWEEN) && pLiteral2 )
		pComp = new OSQLInternalNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::between_predicate_part_2));
	else
		pComp = new OSQLInternalNode("", SQLNodeType::Rule,OSQLParser::RuleID(OSQLParseNode::comparison_predicate));

	pComp->append(pColumnRef);
	pComp->append(pCompare);
	pComp->append(pLiteral);
	if ( pLiteral2 )
	{
		pComp->append(new OSQLInternalNode("", SQLNodeType::Keyword,SQL_TOKEN_AND));
		pComp->append(pLiteral2);
	}
	pAppend->append(pComp);
	return 1;
}

sal_Int16 OSQLParser::buildStringNodes(OSQLParseNode*& pLiteral)
{
	if(!pLiteral)
		return 1;

	if(SQL_ISRULE(pLiteral,set_fct_spec) || SQL_ISRULE(pLiteral,general_set_fct) || SQL_ISRULE(pLiteral,column_ref)
		|| SQL_ISRULE(pLiteral,subquery))
		return 1; // here I have a function that I can't transform into a string

	if(pLiteral->getNodeType() == SQLNodeType::IntNum || pLiteral->getNodeType() == SQLNodeType::ApproxNum || pLiteral->getNodeType() == SQLNodeType::AccessDate)
	{
		OSQLParseNode* pParent = pLiteral->getParent();

		OSQLParseNode* pNewNode = new OSQLInternalNode(pLiteral->getTokenValue(), SQLNodeType::String);
		pParent->replace(pLiteral, pNewNode);
		delete pLiteral;
		pLiteral = nullptr;
		return 1;
	}

	for(size_t i=0;i<pLiteral->count();++i)
	{
		OSQLParseNode* pChild = pLiteral->getChild(i);
		buildStringNodes(pChild);
	}
	if(SQL_ISRULE(pLiteral,term) || SQL_ISRULE(pLiteral,value_exp_primary))
	{
		m_sErrorMessage = m_pContext->getErrorMessage(IParseContext::ErrorCode::InvalidCompare);
		return 0;
	}
	return 1;
}

sal_Int16 OSQLParser::buildComparisonRule(OSQLParseNode*& pAppend,OSQLParseNode* pLiteral)
{
    OSQLParseNode* pComp = new OSQLInternalNode("=", SQLNodeType::Equal);
    return buildPredicateRule(pAppend,pLiteral,pComp);
}



void OSQLParser::reduceLiteral(OSQLParseNode*& pLiteral, bool bAppendBlank)
{
	OSL_ENSURE(pLiteral->isRule(), "This is no Rule");
	OSL_ENSURE(pLiteral->count() == 2, "OSQLParser::ReduceLiteral() Invalid count");
	OSQLParseNode* pTemp = pLiteral;
	OUStringBuffer aValue(pLiteral->getChild(0)->getTokenValue());
	if (bAppendBlank)
	{
		aValue.append(" ");
	}

	aValue.append(pLiteral->getChild(1)->getTokenValue());

	pLiteral = new OSQLInternalNode(aValue.makeStringAndClear(),SQLNodeType::String);
	delete pTemp;
}


void OSQLParser::error(const char *fmt)
{
	if(m_sErrorMessage.isEmpty())
	{
		OUString sStr(fmt,strlen(fmt),RTL_TEXTENCODING_UTF8);
		OUString sSQL_TOKEN("SQL_TOKEN_");

		sal_Int32 nPos1 = sStr.indexOf(sSQL_TOKEN);
		if(nPos1 != -1)
		{
			OUString sFirst  = sStr.copy(0,nPos1);
			sal_Int32 nPos2 = sStr.indexOf(sSQL_TOKEN,nPos1+1);
			if(nPos2 != -1)
			{
				OUString sSecond = sStr.copy(nPos1+sSQL_TOKEN.getLength(),nPos2-nPos1-sSQL_TOKEN.getLength());
				sFirst  += sSecond;
				sFirst  += sStr.copy(nPos2+sSQL_TOKEN.getLength());
			}
			else
				sFirst += sStr.copy(nPos1+sSQL_TOKEN.getLength());

			m_sErrorMessage = sFirst;
		}
		else
			m_sErrorMessage = sStr;

		OUString aError = s_pScanner->getErrorMessage();
		if(!aError.isEmpty())
		{
			m_sErrorMessage += ", ";
			m_sErrorMessage += aError;
		}
	}
}

int OSQLParser::SQLlex()
{
	return OSQLScanner::SQLlex();
}
